/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/array.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/array.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: array.pmc 21147 2007-09-08 21:36:34Z paultcochrane $

=head1 NAME

src/pmc/array.pmc - Array PMC

=head1 DESCRIPTION

These are the vtable functions for the Array base class.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

/*

=item C<static PMC *undef(PARROT_INTERP)>

Returns a C<Undef> PMC.

=cut

*/

static PMC *undef(PARROT_INTERP) {
    return pmc_new(interp, enum_class_Undef);
}

/*

=item C<static PMC *retval(PARROT_INTERP, void *ret)>

Processes C<*ret>, returning the appropriate PMC, or raising an
exception if necessary.

=cut

*/

static PMC *retval(PARROT_INTERP, void *ret) {
    PMC *value;

    if (ret == 0)
        real_exception(interp, NULL, E_IndexError,
            "Array index out of bounds!");

    /* XXX getting non existent value, exception or undef?
     * current is for perlarray */
    if (ret == (void *)-1)
        value = undef(interp);
    else {
        value = *(PMC **)ret;

        /* XXX same here */
        if (!value)
            value = undef(interp);
    }

    return value;
}

/*

=item C<static PMC
*Parrot_Array_set_pmc_ptr(PARROT_INTERP, List *list, INTVAL key)>

Returns a pointer to the element at index C<key> of C<*list>. If
this element was previously empty, then this function also creates
and assigns an "undef" PMC to that element.

=cut

*/

static PMC *Parrot_Array_set_pmc_ptr(PARROT_INTERP, List *list, INTVAL key) {
    void * const ret = list_get(interp, list, key, enum_type_PMC);
    PMC  *value;

    if (ret == 0)
        real_exception(interp, NULL, E_IndexError,
            "Array index out of bounds!");

    /* assign into a sparse or not yet set value */
    if (ret == (void *)-1 || *(PMC **)ret == 0) {
        value = undef(interp);
        list_assign(interp, list, key, value, enum_type_PMC);
    }
    else
        value = *(PMC **)ret;

    return value;
}
#line 115 "./src/pmc/array.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_array.h"
#include "pmc_default.h"
#include "array.str"
INTVAL
Parrot_Array_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1158 "./src/pmc/array.pmc"

    INTVAL j, n;

    if (value->vtable->base_type != enum_class_Array)
        return 0;

    n = Parrot_Array_elements(interp, pmc);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        PMC * const item1 = Parrot_Array_get_pmc_keyed_int(interp, pmc, j);
        PMC * const item2 = VTABLE_get_pmc_keyed_int(interp, value, j);

        if (item1 != item2)
            if (!mmd_dispatch_i_pp(interp, item1, item2, MMD_EQ))
                return 0;
    }

    return 1;
#line 147 "./src/pmc/array.c"
}
void
Parrot_Array_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 176 "./src/pmc/array.pmc"

    const INTVAL size = VTABLE_elements(interp,other);
    INTVAL       i;

    VTABLE_set_integer_native(interp, pmc, size);
    for (i = 0; i < size; i++) {
        PMC * const elem = VTABLE_get_pmc_keyed_int(interp, other, i);
        VTABLE_set_pmc_keyed_int(interp, pmc, i, elem);
    }
#line 162 "./src/pmc/array.c"
}
PMC  *
Parrot_Array_clone(PARROT_INTERP, PMC *pmc)
{
#line 226 "./src/pmc/array.pmc"

    List       *l    = list_clone(interp, (List *)PMC_data(pmc));
    PMC * const dest = pmc_new_noinit(interp, pmc->vtable->base_type);

    PObj_custom_mark_SET(dest);

    PMC_data(dest) = l;
    l->container   = dest;

    return dest;
#line 178 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1055 "./src/pmc/array.pmc"

    PMC *box;

    const INTVAL ix      = key_integer(interp, key);
    PMC * const  nextkey = key_next(interp, key);

    if (!nextkey)
        return Parrot_Array_defined_keyed_int(interp, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        return 0;

    return VTABLE_defined_keyed(interp, box, nextkey);
#line 199 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 1029 "./src/pmc/array.pmc"

    PMC  *value;
    void * const ret =
        list_get(interp, (List *)PMC_data(pmc), key, enum_type_PMC);

    if (ret == 0 || ret == (void *) -1)
        return 0;

    value = *(PMC **)ret;

    if (!value)
        return 0;

    return VTABLE_defined(interp, value);
#line 219 "./src/pmc/array.c"
}
void
Parrot_Array_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1143 "./src/pmc/array.pmc"

    const INTVAL ix = key_integer(interp, key);
    list_splice(interp, (List *)PMC_data(pmc), NULL, ix, 1);
#line 228 "./src/pmc/array.c"
}
void
Parrot_Array_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 1129 "./src/pmc/array.pmc"

    list_splice(interp, (List *)PMC_data(pmc), NULL, key, 1);
#line 236 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_elements(PARROT_INTERP, PMC *pmc)
{
#line 277 "./src/pmc/array.pmc"

    return ((List *) PMC_data(pmc))->length;
#line 244 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1102 "./src/pmc/array.pmc"

    PMC *box;

    const INTVAL ix      = key_integer(interp, key);
    PMC * const  nextkey = key_next(interp, key);

    if (!nextkey)
        return Parrot_Array_exists_keyed_int(interp, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        return 0;

    return VTABLE_exists_keyed(interp, box, nextkey);
#line 265 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 1082 "./src/pmc/array.pmc"

    void * ret = list_get(interp,
        (List *)PMC_data(pmc), key, enum_type_PMC);

    if (ret == 0 || ret == (void *)-1)
        return 0;

    return !PMC_IS_NULL(*(PMC **)ret);
#line 279 "./src/pmc/array.c"
}
void
Parrot_Array_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1247 "./src/pmc/array.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, VTABLE_elements(interp, pmc));
#line 289 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 262 "./src/pmc/array.pmc"

    const INTVAL size = VTABLE_elements(interp, pmc);
    return (INTVAL)(size != 0);
#line 298 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 248 "./src/pmc/array.pmc"

    return VTABLE_elements(interp, pmc);
#line 306 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 350 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return 0;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return Parrot_Array_get_integer_keyed_int(interp, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_integer_keyed(interp, box, nextkey);
#line 331 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 320 "./src/pmc/array.pmc"

    PMC * const value = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    return VTABLE_get_integer(interp, value);
#line 341 "./src/pmc/array.c"
}
PMC  *
Parrot_Array_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 1207 "./src/pmc/array.pmc"

    PMC * const iter     = pmc_new_init(interp, enum_class_Iterator, pmc);
    PMC * const key      = pmc_new(interp, enum_class_Key);
    PMC_struct_val(iter) = key;
    PObj_get_FLAGS(key) |= KEY_integer_FLAG;
    PMC_int_val(key)     = 0;

    if (!((List *)PMC_data(pmc))->length)
        PMC_int_val(key) = -1;

    return iter;
#line 358 "./src/pmc/array.c"
}
FLOATVAL
Parrot_Array_get_number(PARROT_INTERP, PMC *pmc)
{
#line 291 "./src/pmc/array.pmc"

    INTVAL e = VTABLE_elements(interp, pmc);
    return (FLOATVAL)e;
#line 367 "./src/pmc/array.c"
}
FLOATVAL
Parrot_Array_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 397 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC *nextkey, *box;

    if (!key)
        return (FLOATVAL)0;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return Parrot_Array_get_number_keyed_int(interp, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_number_keyed(interp, box, nextkey);
#line 392 "./src/pmc/array.c"
}
FLOATVAL
Parrot_Array_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 381 "./src/pmc/array.pmc"

    PMC * const value = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    return VTABLE_get_number(interp, value);
#line 402 "./src/pmc/array.c"
}
PMC  *
Parrot_Array_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 491 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return 0;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_pmc_keyed(interp, box, nextkey);
#line 427 "./src/pmc/array.c"
}
PMC  *
Parrot_Array_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 475 "./src/pmc/array.pmc"


    return retval(interp,
        list_get(interp, (List *)PMC_data(pmc), key, enum_type_PMC));
#line 437 "./src/pmc/array.c"
}
STRING  *
Parrot_Array_get_string(PARROT_INTERP, PMC *pmc)
{
#line 306 "./src/pmc/array.pmc"

    return Parrot_sprintf_c(interp, "array[%p]", pmc);
#line 445 "./src/pmc/array.c"
}
STRING  *
Parrot_Array_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 444 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return 0;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return Parrot_Array_get_string_keyed_int(interp, pmc, ix);

    box = Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_string_keyed(interp, box, nextkey);
#line 470 "./src/pmc/array.c"
}
STRING  *
Parrot_Array_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 428 "./src/pmc/array.pmc"

    PMC * const value = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    return VTABLE_get_string(interp, value);
#line 480 "./src/pmc/array.c"
}
void
Parrot_Array_init(PARROT_INTERP, PMC *pmc)
{
#line 143 "./src/pmc/array.pmc"

    list_pmc_new(interp, pmc);
    PObj_custom_mark_SET(pmc);
#line 489 "./src/pmc/array.c"
}
void
Parrot_Array_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 161 "./src/pmc/array.pmc"

    list_pmc_new_init(interp, pmc, init);
    PObj_custom_mark_SET(pmc);
#line 498 "./src/pmc/array.c"
}
void
Parrot_Array_mark(PARROT_INTERP, PMC *pmc)
{
#line 212 "./src/pmc/array.pmc"

    list_mark(interp, (List *)PMC_data(pmc));
#line 506 "./src/pmc/array.c"
}
FLOATVAL
Parrot_Array_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 901 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_number(interp, ptr);
#line 515 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 886 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_integer(interp, ptr);
#line 524 "./src/pmc/array.c"
}
PMC  *
Parrot_Array_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 931 "./src/pmc/array.pmc"

    return retval(interp,
        list_pop(interp, (List *)PMC_data(pmc), enum_type_PMC));
#line 533 "./src/pmc/array.c"
}
STRING  *
Parrot_Array_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 916 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_string(interp, ptr);
#line 542 "./src/pmc/array.c"
}
void
Parrot_Array_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 771 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_number_keyed_int(interp, pmc, nextix, value);
#line 551 "./src/pmc/array.c"
}
void
Parrot_Array_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 755 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_integer_keyed_int(interp, pmc, nextix, value);
#line 560 "./src/pmc/array.c"
}
void
Parrot_Array_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 803 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_pmc_keyed_int(interp, pmc, nextix, value);
#line 569 "./src/pmc/array.c"
}
void
Parrot_Array_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 787 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_string_keyed_int(interp, pmc, nextix, value);
#line 578 "./src/pmc/array.c"
}
void
Parrot_Array_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 567 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_integer_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_keyed(interp, box, nextkey, value);
#line 606 "./src/pmc/array.c"
}
void
Parrot_Array_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 550 "./src/pmc/array.pmc"

    PMC * const ptr =
        Parrot_Array_set_pmc_ptr(interp, (List *)PMC_data(pmc), key);

    VTABLE_set_integer_native(interp, ptr, value);
#line 617 "./src/pmc/array.c"
}
void
Parrot_Array_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 522 "./src/pmc/array.pmc"

    list_set_length(interp, (List *)PMC_data(pmc), size);
#line 625 "./src/pmc/array.c"
}
void
Parrot_Array_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 535 "./src/pmc/array.pmc"

    const INTVAL size = VTABLE_elements(interp, value);
    list_set_length(interp, (List *)PMC_data(pmc), size);
#line 634 "./src/pmc/array.c"
}
void
Parrot_Array_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 618 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        Parrot_Array_set_number_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_keyed(interp, box, nextkey, value);
#line 662 "./src/pmc/array.c"
}
void
Parrot_Array_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 601 "./src/pmc/array.pmc"

    PMC * const ptr =
        Parrot_Array_set_pmc_ptr(interp, (List *)PMC_data(pmc), key);

    VTABLE_set_number_native(interp, ptr, value);
#line 673 "./src/pmc/array.c"
}
void
Parrot_Array_set_pmc(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 198 "./src/pmc/array.pmc"

    VTABLE_assign_pmc(interp, pmc, other);
#line 681 "./src/pmc/array.c"
}
void
Parrot_Array_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 724 "./src/pmc/array.pmc"

    PMC *box;

    const INTVAL ix      = key_integer(interp, key);
    PMC * const  nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_pmc_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_pmc_keyed(interp, box, nextkey, value);
#line 705 "./src/pmc/array.c"
}
void
Parrot_Array_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *src)
{
#line 703 "./src/pmc/array.pmc"

    const INTVAL length = ((List *)PMC_data(pmc))->length;

    if (idx >= length || -idx > length)
        real_exception(interp, NULL, E_IndexError,
            "Array index out of bounds!");

    list_assign(interp, (List *)PMC_data(pmc), idx,
        (void *)src, enum_type_PMC);
#line 720 "./src/pmc/array.c"
}
void
Parrot_Array_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 669 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_string_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = Parrot_Array_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_keyed(interp, box, nextkey, value);
#line 748 "./src/pmc/array.c"
}
void
Parrot_Array_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 652 "./src/pmc/array.pmc"

    PMC * const ptr =
        Parrot_Array_set_pmc_ptr(interp, (List *)PMC_data(pmc), key);

    VTABLE_set_string_native(interp, ptr, value);
#line 759 "./src/pmc/array.c"
}
PMC  *
Parrot_Array_share_ro(PARROT_INTERP, PMC *pmc)
{
#line 1281 "./src/pmc/array.pmc"

    PMC *_true, *ret;

    /* prevent infinite recursion */
    if (PObj_is_PMC_shared_TEST(pmc))
        real_exception(interp, NULL, INVALID_OPERATION, "share_ro on "
                       "something that already is shared");

    _true = pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, _true, 1);

    ret   = pt_shared_fixup(interp, pmc);

    /* first set readonly */
    VTABLE_setprop(interp, ret, const_string(interp, "_ro"), _true);

    /* XXX do something that deals better with sparse lists */
    {
        INTVAL i;
        const INTVAL max = VTABLE_elements(interp, ret);

        for (i = 0; i < max; ++i) {
            PMC * const value =
                (PMC *)list_get(interp, PMC_data_typed(ret, List *),
                             i, enum_type_PMC);

            if (!PMC_IS_NULL(value)) {
                /* XXX do we need to clone first? */
                PMC * const new_value = VTABLE_share_ro(interp, value);

                if (new_value != value)
                    list_assign(interp, PMC_data_typed(ret, List *),
                        i, new_value, enum_type_PMC);
            }
        }
    }

    /* XXX FIXME workaround lack of metadata sharing */
    PMC_metadata(pmc) = NULL;

    return ret;
#line 806 "./src/pmc/array.c"
}
FLOATVAL
Parrot_Array_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 961 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_number(interp, ptr);
#line 815 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 946 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_integer(interp, ptr);
#line 824 "./src/pmc/array.c"
}
PMC  *
Parrot_Array_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 991 "./src/pmc/array.pmc"

    return retval(interp,
        list_shift(interp, (List *)PMC_data(pmc), enum_type_PMC));
#line 833 "./src/pmc/array.c"
}
STRING  *
Parrot_Array_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 976 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_string(interp, ptr);
#line 842 "./src/pmc/array.c"
}
PMC  *
Parrot_Array_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL f)
{
#line 1197 "./src/pmc/array.pmc"

    if (f == 0) {
        PMC * const iter = pmc_new_init(interp, enum_class_Iterator, pmc);
        PMC_struct_val(iter) = key;
        return iter;
    }

    real_exception(interp, NULL, E_TypeError, "Array: Unknown slice type");
#line 856 "./src/pmc/array.c"
}
void
Parrot_Array_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
#line 1010 "./src/pmc/array.pmc"

    if (pmc->vtable->base_type != value->vtable->base_type)
        real_exception(interp, NULL, E_TypeError,
            "Type mismatch in splice");

    list_splice(interp, (List *)PMC_data(pmc),
        (List *)PMC_data(value), offset, count);
#line 869 "./src/pmc/array.c"
}
void
Parrot_Array_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1263 "./src/pmc/array.pmc"

    IMAGE_IO * const io = info->image_io;

    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL) {
        VTABLE_set_integer_native(interp, pmc, VTABLE_shift_integer(interp, io));
}
#line 882 "./src/pmc/array.c"
}
INTVAL
Parrot_Array_type_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 334 "./src/pmc/array.pmc"

    PMC * const value = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    return VTABLE_type(interp, value);
#line 892 "./src/pmc/array.c"
}
void
Parrot_Array_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 837 "./src/pmc/array.pmc"

    PMC * const val = undef(interp);

    list_unshift(interp, (List *)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_number_native(interp, val, value);
#line 903 "./src/pmc/array.c"
}
void
Parrot_Array_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 819 "./src/pmc/array.pmc"

    PMC * const val = undef(interp);

    list_unshift(interp, (List *)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_integer_native(interp, val, value);
#line 914 "./src/pmc/array.c"
}
void
Parrot_Array_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 872 "./src/pmc/array.pmc"

    list_unshift(interp, (List *)PMC_data(pmc), value, enum_type_PMC);
#line 922 "./src/pmc/array.c"
}
void
Parrot_Array_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 855 "./src/pmc/array.pmc"

    PMC * const val = undef(interp);
    list_unshift(interp, (List *)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_string_native(interp, val, value);
#line 932 "./src/pmc/array.c"
}
void
Parrot_Array_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1232 "./src/pmc/array.pmc"

    list_visit(interp, (List *)PMC_data(pmc), info);
    Parrot_default_visit(interp, pmc, info);
#line 941 "./src/pmc/array.c"
}
void
Parrot_Array_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Array");
}
void
Parrot_Array_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Array");
}
void
Parrot_Array_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Array");
}
void
Parrot_Array_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Array");
}
void
Parrot_Array_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Array");
}
void
Parrot_Array_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Array");
}
void
Parrot_Array_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Array");
}
void
Parrot_Array_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Array");
}
void
Parrot_Array_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Array");
}
void
Parrot_Array_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Array");
}
void
Parrot_Array_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Array");
}
PMC *
Parrot_Array_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Array_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Array");
}
void
Parrot_Array_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Array");
}
void
Parrot_Array_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Array");
}
void
Parrot_Array_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Array");
}
void
Parrot_Array_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Array");
}
void
Parrot_Array_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Array");
}
void
Parrot_Array_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Array");
}
FLOATVAL
Parrot_Array_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Array");
}
INTVAL
Parrot_Array_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Array");
}
PMC *
Parrot_Array_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Array");
}
STRING *
Parrot_Array_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Array");
}
void
Parrot_Array_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Array");
}
void
Parrot_Array_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Array");
}
void
Parrot_Array_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Array");
}
void
Parrot_Array_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Array");
}
void
Parrot_Array_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Array");
}
void
Parrot_Array_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Array");
}
void
Parrot_Array_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Array");
}
void
Parrot_Array_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Array");
}
void
Parrot_Array_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Array");
}
void
Parrot_Array_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Array");
}
void
Parrot_Array_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Array");
}
void
Parrot_Array_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Array");
}
void
Parrot_Array_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Array");
}
void
Parrot_Array_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Array");
}
void
Parrot_Array_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Array");
}
void
Parrot_Array_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Array");
}
void
Parrot_Array_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Array");
}
void
Parrot_Array_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Array");
}
void
Parrot_Array_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Array");
}
void
Parrot_Array_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Array");
}
void
Parrot_Array_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Array");
}
void
Parrot_Array_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Array");
}
void
Parrot_Array_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Array");
}
void
Parrot_Array_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Array");
}
void
Parrot_Array_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Array");
}
void
Parrot_Array_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Array");
}
void
Parrot_Array_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Array");
}
void
Parrot_Array_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Array");
}
void
Parrot_Array_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Array");
}
void
Parrot_Array_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Array");
}
void
Parrot_Array_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Array");
}
void
Parrot_Array_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Array");
}
void
Parrot_Array_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Array");
}
void
Parrot_Array_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Array");
}
void
Parrot_Array_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Array");
}
void
Parrot_Array_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Array");
}
void
Parrot_Array_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Array");
}
void
Parrot_Array_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Array");
}
FLOATVAL
Parrot_Array_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Array");
}
INTVAL
Parrot_Array_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Array");
}
PMC *
Parrot_Array_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Array");
}
STRING *
Parrot_Array_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Array");
}
void
Parrot_Array_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Array");
}
void
Parrot_Array_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Array");
}
void
Parrot_Array_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Array");
}
void
Parrot_Array_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Array");
}
void
Parrot_Array_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Array");
}
void
Parrot_Array_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Array");
}
void
Parrot_Array_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Array");
}
void
Parrot_Array_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_Array, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_Array_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Array_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_Array_defined_keyed,
        Parrot_Array_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Array_delete_keyed,
        Parrot_Array_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_Array_elements,
        Parrot_Array_exists_keyed,
        Parrot_Array_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Array_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Array_get_bool,
        Parrot_default_get_class,
        Parrot_Array_get_integer,
        Parrot_Array_get_integer_keyed,
        Parrot_Array_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Array_get_iter,
        Parrot_Array_get_number,
        Parrot_Array_get_number_keyed,
        Parrot_Array_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Array_get_pmc_keyed,
        Parrot_Array_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Array_get_string,
        Parrot_Array_get_string_keyed,
        Parrot_Array_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Array_init,
        Parrot_Array_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Array_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Array_pop_float,
        Parrot_Array_pop_integer,
        Parrot_Array_pop_pmc,
        Parrot_Array_pop_string,
        Parrot_Array_push_float,
        Parrot_Array_push_integer,
        Parrot_Array_push_pmc,
        Parrot_Array_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_Array_set_integer_keyed,
        Parrot_Array_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Array_set_integer_native,
        Parrot_Array_set_integer_same,
        Parrot_Array_set_number_keyed,
        Parrot_Array_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Array_set_pmc,
        Parrot_Array_set_pmc_keyed,
        Parrot_Array_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Array_set_string_keyed,
        Parrot_Array_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_Array_share_ro,
        Parrot_Array_shift_float,
        Parrot_Array_shift_integer,
        Parrot_Array_shift_pmc,
        Parrot_Array_shift_string,
        Parrot_Array_slice,
        Parrot_Array_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Array_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Array_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Array_unshift_float,
        Parrot_Array_unshift_integer,
        Parrot_Array_unshift_pmc,
        Parrot_Array_unshift_string,
        Parrot_Array_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_Array, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Array_ro_add_attribute,
        Parrot_Array_ro_add_method,
        Parrot_Array_ro_add_parent,
        Parrot_Array_ro_add_role,
        Parrot_Array_ro_add_vtable_override,
        Parrot_Array_ro_assign_pmc,
        Parrot_Array_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Array_clone,
        Parrot_default_clone_pmc,
        Parrot_Array_ro_decrement,
        Parrot_default_defined,
        Parrot_Array_defined_keyed,
        Parrot_Array_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Array_ro_delete_keyed,
        Parrot_Array_ro_delete_keyed_int,
        Parrot_Array_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_Array_elements,
        Parrot_Array_exists_keyed,
        Parrot_Array_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Array_ro_find_method,
        Parrot_Array_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Array_get_bool,
        Parrot_default_get_class,
        Parrot_Array_get_integer,
        Parrot_Array_get_integer_keyed,
        Parrot_Array_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Array_get_iter,
        Parrot_Array_get_number,
        Parrot_Array_get_number_keyed,
        Parrot_Array_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Array_get_pmc_keyed,
        Parrot_Array_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Array_get_string,
        Parrot_Array_get_string_keyed,
        Parrot_Array_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Array_ro_i_absolute,
        Parrot_Array_ro_i_bitwise_not,
        Parrot_Array_ro_i_bitwise_nots,
        Parrot_Array_ro_i_logical_not,
        Parrot_Array_ro_i_neg,
        Parrot_Array_ro_increment,
        Parrot_Array_init,
        Parrot_Array_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Array_mark,
        Parrot_Array_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Array_ro_pop_float,
        Parrot_Array_ro_pop_integer,
        Parrot_Array_ro_pop_pmc,
        Parrot_Array_ro_pop_string,
        Parrot_Array_ro_push_float,
        Parrot_Array_ro_push_integer,
        Parrot_Array_ro_push_pmc,
        Parrot_Array_ro_push_string,
        Parrot_Array_ro_remove_attribute,
        Parrot_Array_ro_remove_method,
        Parrot_Array_ro_remove_parent,
        Parrot_Array_ro_remove_role,
        Parrot_Array_ro_remove_vtable_override,
        Parrot_Array_ro_set_attr,
        Parrot_Array_ro_set_attr_str,
        Parrot_Array_ro_set_bignum_int,
        Parrot_Array_ro_set_bignum_num,
        Parrot_Array_ro_set_bignum_str,
        Parrot_Array_ro_set_bool,
        Parrot_Array_ro_set_integer_keyed,
        Parrot_Array_ro_set_integer_keyed_int,
        Parrot_Array_ro_set_integer_keyed_str,
        Parrot_Array_ro_set_integer_native,
        Parrot_Array_ro_set_integer_same,
        Parrot_Array_ro_set_number_keyed,
        Parrot_Array_ro_set_number_keyed_int,
        Parrot_Array_ro_set_number_keyed_str,
        Parrot_Array_ro_set_number_native,
        Parrot_Array_ro_set_number_same,
        Parrot_Array_ro_set_pmc,
        Parrot_Array_ro_set_pmc_keyed,
        Parrot_Array_ro_set_pmc_keyed_int,
        Parrot_Array_ro_set_pmc_keyed_str,
        Parrot_Array_ro_set_pointer,
        Parrot_Array_ro_set_pointer_keyed,
        Parrot_Array_ro_set_pointer_keyed_int,
        Parrot_Array_ro_set_pointer_keyed_str,
        Parrot_Array_ro_set_string_keyed,
        Parrot_Array_ro_set_string_keyed_int,
        Parrot_Array_ro_set_string_keyed_str,
        Parrot_Array_ro_set_string_native,
        Parrot_Array_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_Array_share_ro,
        Parrot_Array_ro_shift_float,
        Parrot_Array_ro_shift_integer,
        Parrot_Array_ro_shift_pmc,
        Parrot_Array_ro_shift_string,
        Parrot_Array_slice,
        Parrot_Array_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Array_ro_thaw,
        Parrot_Array_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Array_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Array_ro_unshift_float,
        Parrot_Array_ro_unshift_integer,
        Parrot_Array_ro_unshift_pmc,
        Parrot_Array_ro_unshift_string,
        Parrot_Array_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_Array_is_equal }
    };
    /* Dynamic PMCs need the runtime type which is passed in entry to class_init. */
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Array");
        vt_clone->isa_str = CONST_STRING(interp, "Array");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
            /* class_init_code; called for side effects */
            Small_Object_Pool *List_chunks =
                make_bufferlike_pool(interp, sizeof (List_chunk));
            Small_Object_Pool *Lists       =
                make_bufferlike_pool(interp, sizeof (List));
        
            /* XXX until there's a function to allocate a pool in an arena */
            UNUSED(List_chunks);
            UNUSED(Lists);

        }
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_Array_class_init */
#line 1322 "./src/pmc/array.pmc"


/*

=back

=head1 SEE ALSO

F<src/list.c>, F<include/parrot/list.h>

=head1 TODO

Create global immutable undef object.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
