/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/bigint.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/bigint.pmc"
/*
Copyright (C) 2004-2007, The Perl Foundation.
$Id: bigint.pmc 21096 2007-09-05 23:05:07Z chromatic $

=head1 NAME

src/pmc/bigint.pmc - BigInt PMC class

=head1 DESCRIPTION

C<BigInt> provides arbitrary precision integer mathematic functions.

=head2 Functions

=over 4

=item C<static void bigint_set_long(Interp*, PMC *, long value)>

=item C<static void bigint_set_double(Interp*, PMC *, double value)>

=cut

*/

#include "parrot/parrot.h"

/* TODO split that out into a separate file */

#ifdef S_SPLINT_S
#  undef PARROT_HAS_GMP /* splint barfs on the gmp.h header */
#endif /* S_SPLINT_S */

#ifdef PARROT_HAS_GMP
#  include <gmp.h>
typedef struct BIGINT {
    mpz_t b;
} BIGINT;

#  define BN(x) ((BIGINT *)PMC_struct_val(x))->b

static void
bigint_init(PARROT_INTERP, PMC *self) {
    PMC_struct_val(self) = malloc(sizeof (BIGINT));
    mpz_init(BN(self));
}
static void
bigint_clear(PARROT_INTERP, PMC *self) {
    mpz_clear(BN(self));
}

static void
bigint_set(PARROT_INTERP, PMC *dest, PMC *src) {
    mpz_set(BN(dest), BN(src));
}

static void
bigint_set_long(PARROT_INTERP, PMC *self, long value) {
    mpz_set_si(BN(self), value);
}

static void
bigint_set_double(PARROT_INTERP, PMC *self, double value) {
    mpz_set_d(BN(self), value);
}

static void
bigint_set_str(PARROT_INTERP, PMC *self, char *value, int base) {
    mpz_set_str(BN(self), value, base);
}

static BIGNUM*
bigint_get_self(PARROT_INTERP, PMC *self) {
    return PMC_struct_val(self);
}

static void
bigint_set_self(PARROT_INTERP, PMC *self, BIGNUM *value) {
    mpz_set(BN(self), (mpz_srcptr)value);
}

static long
bigint_get_long(PARROT_INTERP, PMC *self) {
    if (mpz_fits_slong_p(BN(self)))
        return mpz_get_si(BN(self));
    real_exception(interp, NULL, 1, "bigint_get_long: number too big");
    return 0;
}

static int
bigint_get_bool(PARROT_INTERP, PMC *self) {
    if (mpz_sgn(BN(self)) != 0)
        return 1;
    else
        return 0;
}
static char *
bigint_get_string(PARROT_INTERP, PMC *self, int base) {
    size_t n = mpz_sizeinbase(BN(self), base) + 2;
    char  *s = (char *)mem_sys_allocate(n);
    return mpz_get_str(s, base, BN(self));
}

static double
bigint_get_double(PARROT_INTERP, PMC *self) {
    return mpz_get_d(BN(self));
}

static void
bigint_add_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    mpz_add(BN(dest), BN(self), BN(value));
}

static void
bigint_add_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    if (value < 0)
        mpz_sub_ui(BN(dest), BN(self), -value);
    else
        mpz_add_ui(BN(dest), BN(self), value);
}

static void
bigint_sub_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    mpz_sub(BN(dest), BN(self), BN(value));
}

static void
bigint_sub_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    if (value < 0)
        mpz_add_ui(BN(dest), BN(self), -value);
    else
        mpz_sub_ui(BN(dest), BN(self), value);
}

static void
bigint_mul_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    mpz_mul(BN(dest), BN(self), BN(value));
}

static void
bigint_mul_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    mpz_mul_si(BN(dest), BN(self), value);
}

static void
bigint_pow_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    mpz_pow_ui(BN(dest), BN(self), value);
}

static void
int_check_divide_zero(PARROT_INTERP, INTVAL value) {
    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                       "Divide by zero");
}

static void
bigint_check_divide_zero(PARROT_INTERP, PMC *value) {
    /* Throw an exception if we are dividing by zero. */
    if (mpz_cmp_si(BN(value), 0) == 0)
        real_exception(interp, NULL, E_ZeroDivisionError, "Divide by zero");
}

static void
bigint_div_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    bigint_check_divide_zero(interp, value);
    /* this is mpz_fdiv_q */
    mpz_div(BN(dest), BN(self), BN(value));
}

static void
bigint_div_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    int_check_divide_zero(interp, value);

    /* this is mpz_fdiv_q */
    if (value < 0) {
        mpz_div_ui(BN(dest), BN(self), -value);
        mpz_neg(BN(dest), BN(dest));
    }
    else
        mpz_div_ui(BN(dest), BN(self), value);
}

static void
bigint_fdiv_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    bigint_check_divide_zero(interp, value);
    mpz_fdiv_q(BN(dest), BN(self), BN(value));
}

static void
bigint_fdiv_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpz_fdiv_q_ui(BN(dest), BN(self), -value);
        mpz_neg(BN(dest), BN(dest));
    }
    else
        mpz_fdiv_q_ui(BN(dest), BN(self), value);
}

static void
bigint_mod_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    bigint_check_divide_zero(interp, value);
    mpz_mod(BN(dest), BN(self), BN(value));
}

static void
bigint_mod_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpz_mod_ui(BN(dest), BN(self), -value);
    }
    else
        mpz_mod_ui(BN(dest), BN(self), value);
}

static INTVAL
bigint_cmp(PARROT_INTERP, PMC *self, PMC *value) {
    return mpz_cmp(BN(self), BN(value));
}

static INTVAL
bigint_cmp_int(PARROT_INTERP, PMC *self, INTVAL value) {
    return mpz_cmp_si(BN(self), value);
}

static void
bigint_abs(PARROT_INTERP, PMC *self, PMC *dest) {
    VTABLE_morph(interp, dest, enum_class_BigInt);
    mpz_abs(BN(dest), BN(self));
}

static void
bigint_neg(PARROT_INTERP, PMC *self, PMC *dest) {
    VTABLE_morph(interp, dest, enum_class_BigInt);
    mpz_neg(BN(dest), BN(self));
}

static void
bigint_bitwise_shl_bigint_int(PARROT_INTERP, PMC *self,
                              INTVAL value, PMC *dest)
{
    /* The third args to mpz_mul_2exp and mpz_tdiv_q_2exp are unsigned, so we
       need to do something sensible with negative values. */
    if (value >= 0)
        mpz_mul_2exp(BN(dest), BN(self), value);
    else
        mpz_tdiv_q_2exp(BN(dest), BN(self), -value);
}

static void
bigint_bitwise_shr_bigint_int(PARROT_INTERP, PMC *self,
                              INTVAL value, PMC *dest)
{
    /* The third args to mpz_mul_2exp and mpz_tdiv_q_2exp are unsigned, so we
       need to do something sensible with negative values. */
    if (value >= 0)
        mpz_tdiv_q_2exp(BN(dest), BN(self), value);
    else
        mpz_mul_2exp(BN(dest), BN(self), -value);
}

#else /* ifdef PARROT_HAS_GMP */

static void
bigint_init(PARROT_INTERP, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_clear(PARROT_INTERP, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_set_long(PARROT_INTERP, PMC *self, long value) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_set(PARROT_INTERP, PMC *dest, PMC *src) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_set_double(PARROT_INTERP, PMC *self, double value) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_set_str(PARROT_INTERP, PMC *self, char *value, int base) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_set_self(PARROT_INTERP, PMC *self, BIGNUM *value) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static BIGNUM*
bigint_get_self(PARROT_INTERP, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static char *
bigint_get_string(PARROT_INTERP, PMC *self, int base) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static long
bigint_get_long(PARROT_INTERP, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static long
bigint_get_bool(PARROT_INTERP, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static double
bigint_get_double(PARROT_INTERP, PMC *self) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_add_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_add_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_sub_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_sub_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_mul_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_mul_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_pow_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_div_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_div_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_fdiv_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_fdiv_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_mod_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_mod_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static INTVAL
bigint_cmp(PARROT_INTERP, PMC *self, PMC *value) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static INTVAL
bigint_cmp_int(PARROT_INTERP, PMC *self, INTVAL value) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_abs(PARROT_INTERP, PMC *self, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_neg(PARROT_INTERP, PMC *self, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shl_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shl_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shr_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shr_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest)
{
    real_exception(interp, NULL, E_LibraryNotLoadedError,
        "no bigint lib loaded");
}

#endif /* ifdef PARROT_HAS_GMP */
#line 481 "./src/pmc/bigint.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_bigint.h"
#include "pmc_default.h"
#include "bigint.str"
PMC  *
Parrot_BigInt_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 750 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp add");
#line 494 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_add_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 734 "./src/pmc/bigint.pmc"

            if (dest)
                VTABLE_morph(interp, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interp, pmc->vtable->base_type);

            bigint_add_bigint(interp, pmc, value, dest);
            return dest;
#line 508 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 742 "./src/pmc/bigint.pmc"

            if (dest)
                VTABLE_morph(interp, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interp, pmc->vtable->base_type);

            bigint_add_bigint_int(interp, pmc, PMC_int_val(value), dest);
            return dest;
#line 522 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 758 "./src/pmc/bigint.pmc"

    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_add_bigint_int(interp, pmc, value, dest);
    return dest;
#line 536 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 772 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp add");
#line 544 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_add_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 768 "./src/pmc/bigint.pmc"

            bigint_add_bigint(interp, pmc, value, pmc);
#line 552 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 770 "./src/pmc/bigint.pmc"

            bigint_add_bigint_int(interp, pmc, PMC_int_val(value), pmc);
#line 560 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 780 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, pmc, value, pmc);
#line 568 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 784 "./src/pmc/bigint.pmc"

    real_exception(interp, NULL, E_NotImplementedError, "unimp add");
#line 576 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 805 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp sub");
#line 584 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_subtract_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 789 "./src/pmc/bigint.pmc"

            if (dest)
                VTABLE_morph(interp, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interp, pmc->vtable->base_type);

            bigint_sub_bigint(interp, pmc, value, dest);
            return dest;
#line 598 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 797 "./src/pmc/bigint.pmc"

            if (dest)
                VTABLE_morph(interp, dest, pmc->vtable->base_type);
            else
                dest = pmc_new(interp, pmc->vtable->base_type);

            bigint_sub_bigint_int(interp, pmc, PMC_int_val(value), dest);
            return dest;
#line 612 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 813 "./src/pmc/bigint.pmc"

    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_sub_bigint_int(interp, pmc, value, dest);
    return dest;
#line 626 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 827 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp sub");
#line 634 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_subtract_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 823 "./src/pmc/bigint.pmc"

            bigint_sub_bigint(interp, pmc, value, pmc);
#line 642 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 825 "./src/pmc/bigint.pmc"

            bigint_sub_bigint_int(interp, pmc, PMC_int_val(value), pmc);
#line 650 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 835 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, pmc, value, pmc);
#line 658 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 839 "./src/pmc/bigint.pmc"

    real_exception(interp, NULL, E_NotImplementedError, "unimp sub");
#line 666 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 860 "./src/pmc/bigint.pmc"

         real_exception(interp, NULL, E_NotImplementedError, "unimp mul");
#line 674 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 844 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_mul_bigint(interp, pmc, value, dest);
        return dest;
#line 688 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 852 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_mul_bigint_int(interp, pmc, PMC_int_val(value), dest);
        return dest;
#line 702 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 868 "./src/pmc/bigint.pmc"

    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_mul_bigint_int(interp, pmc, value, dest);
    return dest;
#line 716 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 882 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp mul");
#line 724 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 878 "./src/pmc/bigint.pmc"

            bigint_mul_bigint(interp, pmc, value, pmc);
#line 732 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 880 "./src/pmc/bigint.pmc"

            bigint_mul_bigint_int(interp, pmc, PMC_int_val(value), pmc);
#line 740 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 890 "./src/pmc/bigint.pmc"

    bigint_mul_bigint_int(interp, pmc, value, pmc);
#line 748 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 894 "./src/pmc/bigint.pmc"

    real_exception(interp, NULL, E_NotImplementedError, "unimp mul");
#line 756 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 938 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp div");
#line 764 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 914 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_div_bigint(interp, pmc, value, dest);
#if 0
        /* to downgrade or not that's the question */
        if (mpz_fits_slong_p(BN(dest))) {
            long iresult = mpz_get_si(BN(dest));
            VTABLE_morph(interp, dest, enum_class_Integer);
            VTABLE_set_integer_native(interp, dest, iresult);
        }
#endif
        return dest;
#line 786 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 930 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_div_bigint_int(interp, pmc, PMC_int_val(value), dest);
        return dest;
#line 800 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 946 "./src/pmc/bigint.pmc"

    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_div_bigint_int(interp, pmc, value, dest);
    return dest;
#line 814 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 960 "./src/pmc/bigint.pmc"

         real_exception(interp, NULL, E_NotImplementedError, "unimp fdiv");
#line 822 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 956 "./src/pmc/bigint.pmc"

        bigint_div_bigint(interp, pmc, value, pmc);
#line 830 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 958 "./src/pmc/bigint.pmc"

        bigint_div_bigint_int(interp, pmc, PMC_int_val(value), pmc);
#line 838 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 968 "./src/pmc/bigint.pmc"

    bigint_div_bigint_int(interp, pmc, value, pmc);
#line 846 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 987 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp fdiv");
#line 854 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 972 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_fdiv_bigint(interp, pmc, value, dest);
        return dest;
#line 868 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_floor_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 980 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);
        bigint_fdiv_bigint_int(interp, pmc, PMC_int_val(value), dest);
        return dest;
#line 881 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 995 "./src/pmc/bigint.pmc"

    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_fdiv_bigint_int(interp, pmc, value, dest);
    return dest;
#line 895 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1009 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp fdiv");
#line 903 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1005 "./src/pmc/bigint.pmc"

        bigint_fdiv_bigint(interp, pmc, value, pmc);
#line 911 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_floor_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1007 "./src/pmc/bigint.pmc"

        bigint_fdiv_bigint_int(interp, pmc, PMC_int_val(value), pmc);
#line 919 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1017 "./src/pmc/bigint.pmc"

    bigint_fdiv_bigint_int(interp, pmc, value, pmc);
#line 927 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1037 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp mod");
#line 935 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1021 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_mod_bigint(interp, pmc, value, dest);
        return dest;
#line 949 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_modulus_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1029 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_mod_bigint_int(interp, pmc, PMC_int_val(value), dest);
        return dest;
#line 963 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1061 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp mod");
#line 971 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1057 "./src/pmc/bigint.pmc"

            bigint_mod_bigint(interp, pmc, value, pmc);
#line 979 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_modulus_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1059 "./src/pmc/bigint.pmc"

            bigint_mod_bigint_int(interp, pmc, PMC_int_val(value), pmc);
#line 987 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_cmodulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1049 "./src/pmc/bigint.pmc"

            return Parrot_BigInt_modulus(interp, pmc, value, dest);
#line 995 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_cmodulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1045 "./src/pmc/bigint.pmc"

            return Parrot_BigInt_modulus_BigInt(interp, pmc, value, dest);
#line 1003 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_cmodulus_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1047 "./src/pmc/bigint.pmc"

            return Parrot_BigInt_modulus_Integer(interp, pmc, value, dest);
#line 1011 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_cmodulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1073 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp cmod");
#line 1019 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_cmodulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1069 "./src/pmc/bigint.pmc"

            bigint_mod_bigint(interp, pmc, value, pmc);
#line 1027 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_cmodulus_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1071 "./src/pmc/bigint.pmc"

            bigint_mod_bigint_int(interp, pmc, PMC_int_val(value), pmc);
#line 1035 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 908 "./src/pmc/bigint.pmc"

    /* XXX only Integer RHS currently */
    INTVAL r = VTABLE_get_integer(interp, value);
    return Parrot_BigInt_pow_int(interp, pmc, r, dest);
#line 1045 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 898 "./src/pmc/bigint.pmc"

    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_pow_bigint_int(interp, pmc, value, dest);
    return dest;
#line 1059 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1192 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp shl");
#line 1067 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_bitwise_shl_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1173 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_bitwise_shl_bigint_int(interp, pmc,
                                      VTABLE_get_integer(interp, value),
                                      dest);
        return dest;
#line 1083 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_bitwise_shl_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1183 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_bitwise_shl_bigint_int(interp, pmc, PMC_int_val(value),
                                      dest);
        return dest;
#line 1098 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1200 "./src/pmc/bigint.pmc"

    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_bitwise_shl_bigint_int(interp, pmc, value, dest);
    return dest;
#line 1112 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1218 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp shl");
#line 1120 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_bitwise_shl_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1211 "./src/pmc/bigint.pmc"

        bigint_bitwise_shl_bigint_int(interp, pmc,
                                      VTABLE_get_integer(interp, value),
                                      pmc);
#line 1130 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_bitwise_shl_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1215 "./src/pmc/bigint.pmc"

        bigint_bitwise_shl_bigint_int(interp, pmc, PMC_int_val(value),
                                      pmc);
#line 1139 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1226 "./src/pmc/bigint.pmc"

    bigint_bitwise_shl_bigint_int(interp, pmc, value, pmc);
#line 1147 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1267 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp shr");
#line 1155 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_bitwise_shr_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1248 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_bitwise_shr_bigint_int(interp, pmc,
                                      VTABLE_get_integer(interp, value),
                                      dest);
        return dest;
#line 1171 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_bitwise_shr_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1258 "./src/pmc/bigint.pmc"

        if (dest)
            VTABLE_morph(interp, dest, pmc->vtable->base_type);
        else
            dest = pmc_new(interp, pmc->vtable->base_type);

        bigint_bitwise_shr_bigint_int(interp, pmc, PMC_int_val(value),
                                      dest);
        return dest;
#line 1186 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1275 "./src/pmc/bigint.pmc"

    if (dest)
        VTABLE_morph(interp, dest, pmc->vtable->base_type);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_bitwise_shr_bigint_int(interp, pmc, value, dest);
    return dest;
#line 1200 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1293 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp shr");
#line 1208 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_bitwise_shr_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1286 "./src/pmc/bigint.pmc"

        bigint_bitwise_shr_bigint_int(interp, pmc,
                                      VTABLE_get_integer(interp, value),
                                      pmc);
#line 1218 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_bitwise_shr_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1290 "./src/pmc/bigint.pmc"

        bigint_bitwise_shr_bigint_int(interp, pmc, PMC_int_val(value),
                                      pmc);
#line 1227 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1301 "./src/pmc/bigint.pmc"

    bigint_bitwise_shr_bigint_int(interp, pmc, value, pmc);
#line 1235 "./src/pmc/bigint.c"
}
INTVAL
Parrot_BigInt_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1098 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp eq");
#line 1243 "./src/pmc/bigint.c"
}
INTVAL
Parrot_BigInt_is_equal_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1094 "./src/pmc/bigint.pmc"

    return bigint_cmp(interp, pmc, value) == 0;
#line 1251 "./src/pmc/bigint.c"
}
INTVAL
Parrot_BigInt_is_equal_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1096 "./src/pmc/bigint.pmc"

    return bigint_cmp_int(interp, pmc, PMC_int_val(value)) == 0;
#line 1259 "./src/pmc/bigint.c"
}
INTVAL
Parrot_BigInt_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1086 "./src/pmc/bigint.pmc"

        real_exception(interp, NULL, E_NotImplementedError, "unimp cmp");
#line 1267 "./src/pmc/bigint.c"
}
INTVAL
Parrot_BigInt_cmp_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1082 "./src/pmc/bigint.pmc"

    return bigint_cmp(interp, pmc, value);
#line 1275 "./src/pmc/bigint.c"
}
INTVAL
Parrot_BigInt_cmp_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1084 "./src/pmc/bigint.pmc"

    return bigint_cmp_int(interp, pmc, PMC_int_val(value));
#line 1283 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1118 "./src/pmc/bigint.pmc"

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_abs(interp, pmc, dest);
    return dest;
#line 1295 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_clone(PARROT_INTERP, PMC *pmc)
{
#line 536 "./src/pmc/bigint.pmc"

    PMC *res = pmc_new(interp, pmc->vtable->base_type);
    bigint_set(interp, res, pmc);
    return res;
#line 1305 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_decrement(PARROT_INTERP, PMC *pmc)
{
#line 730 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, pmc, 1, pmc);
#line 1313 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_destroy(PARROT_INTERP, PMC *pmc)
{
#line 542 "./src/pmc/bigint.pmc"

    bigint_clear(interp, pmc);
    mem_sys_free(PMC_struct_val(pmc));
#line 1322 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_get_bignum(PARROT_INTERP, PMC *pmc)
{
#line 651 "./src/pmc/bigint.pmc"

    return pmc;
#line 1330 "./src/pmc/bigint.c"
}
INTVAL
Parrot_BigInt_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 665 "./src/pmc/bigint.pmc"

    return bigint_get_bool(interp, pmc);
#line 1338 "./src/pmc/bigint.c"
}
INTVAL
Parrot_BigInt_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 637 "./src/pmc/bigint.pmc"

    return bigint_get_long(interp, pmc);
#line 1346 "./src/pmc/bigint.c"
}
FLOATVAL
Parrot_BigInt_get_number(PARROT_INTERP, PMC *pmc)
{
#line 623 "./src/pmc/bigint.pmc"

    return bigint_get_double(interp, pmc);
#line 1354 "./src/pmc/bigint.c"
}
STRING  *
Parrot_BigInt_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 702 "./src/pmc/bigint.pmc"

    STRING *s = Parrot_BigInt_get_string(interp, pmc);
    return string_append(interp, s, const_string(interp, "L"));
#line 1363 "./src/pmc/bigint.c"
}
STRING  *
Parrot_BigInt_get_string(PARROT_INTERP, PMC *pmc)
{
#line 688 "./src/pmc/bigint.pmc"

    char   *s  = bigint_get_string(interp, pmc, 10);
    STRING *ps = string_from_cstring(interp, s, 0);
    mem_sys_free(s);
    return ps;
#line 1374 "./src/pmc/bigint.c"
}
STRING  *
Parrot_BigInt_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base)
{
#line 695 "./src/pmc/bigint.pmc"

    char   *s  = bigint_get_string(interp, pmc, base);
    STRING *ps = string_from_cstring(interp, s, 0);
    mem_sys_free(s);
    return ps;
#line 1385 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 1126 "./src/pmc/bigint.pmc"

    bigint_abs(interp, pmc, pmc);
#line 1393 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 1151 "./src/pmc/bigint.pmc"

    bigint_neg(interp, pmc, pmc);
#line 1401 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_increment(PARROT_INTERP, PMC *pmc)
{
#line 716 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, pmc, 1, pmc);
#line 1409 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_init(PARROT_INTERP, PMC *pmc)
{
#line 531 "./src/pmc/bigint.pmc"

    bigint_init(interp, pmc);
    PObj_active_destroy_SET(pmc);
#line 1418 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_instantiate(PARROT_INTERP, PMC *pmc, PMC *sig)
{
#line 504 "./src/pmc/bigint.pmc"

    return PMCNULL;

    /* TODO -- actually build this thing */
#if 0
    int argcP = REG_INT(interp, 3);
    int base;
    PMC *res;
    STRING *num;

    res = pmc_new(interp, enum_class_BigInt);
    if (!argcP) {
        return res;
    }
    base = 10;
    if (argcP == 2)
        base = VTABLE_get_integer(interp, REG_PMC(interp, 6));
    num = VTABLE_get_string(interp, REG_PMC(interp, 5));
    VTABLE_set_string_keyed_int(interp, res, base, num);
    return res;
#endif
#line 1445 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_morph(PARROT_INTERP, PMC *pmc, INTVAL new_type)
{
#line 527 "./src/pmc/bigint.pmc"

    pmc_reuse(interp, pmc, new_type, 0);
#line 1453 "./src/pmc/bigint.c"
}
PMC  *
Parrot_BigInt_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1143 "./src/pmc/bigint.pmc"

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_neg(interp, pmc, dest);
    return dest;
#line 1465 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 555 "./src/pmc/bigint.pmc"

    bigint_set_long(interp, pmc, (long)value);
#line 1473 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 569 "./src/pmc/bigint.pmc"

    bigint_set_double(interp, pmc, (double)value);
#line 1481 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 609 "./src/pmc/bigint.pmc"

    bigint_set_self(interp, pmc, bigint_get_self(interp, value));
#line 1489 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base, STRING *value)
{
#line 594 "./src/pmc/bigint.pmc"

    char *s = string_to_cstring(interp, value);
    bigint_set_str(interp, pmc, s, base);
    string_cstring_free(s);
#line 1499 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 588 "./src/pmc/bigint.pmc"

    char *s = string_to_cstring(interp, value);
    bigint_set_str(interp, pmc, s, 10);
    string_cstring_free(s);
#line 1509 "./src/pmc/bigint.c"
}
STRING  *
Parrot_BigInt_nci_version(PARROT_INTERP, PMC *pmc)
{
#line 486 "./src/pmc/bigint.pmc"

#ifdef PARROT_HAS_GMP
    return string_from_cstring(interp, gmp_version, 0);
#else
    return const_string(interp, "0.0.0");
#endif
#line 1521 "./src/pmc/bigint.c"
}
void
Parrot_BigInt_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of BigInt");
}
PMC *
Parrot_BigInt_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_BigInt_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of BigInt");
}
FLOATVAL
Parrot_BigInt_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of BigInt");
}
INTVAL
Parrot_BigInt_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of BigInt");
}
PMC *
Parrot_BigInt_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of BigInt");
}
STRING *
Parrot_BigInt_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of BigInt");
}
FLOATVAL
Parrot_BigInt_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of BigInt");
}
INTVAL
Parrot_BigInt_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of BigInt");
}
PMC *
Parrot_BigInt_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of BigInt");
}
STRING *
Parrot_BigInt_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of BigInt");
}
void
Parrot_BigInt_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of BigInt");
}
void
Parrot_BigInt_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_BigInt, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_BigInt_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_BigInt_clone,
        Parrot_default_clone_pmc,
        Parrot_BigInt_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_BigInt_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_BigInt_get_bignum,
        Parrot_BigInt_get_bool,
        Parrot_default_get_class,
        Parrot_BigInt_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_BigInt_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_BigInt_get_repr,
        Parrot_BigInt_get_string,
        Parrot_default_get_string_keyed,
        Parrot_BigInt_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_BigInt_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_BigInt_i_neg,
        Parrot_BigInt_increment,
        Parrot_BigInt_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_BigInt_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_BigInt_morph,
        Parrot_default_name,
        Parrot_BigInt_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_BigInt_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_BigInt_set_number_native,
        Parrot_default_set_number_same,
        Parrot_BigInt_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_BigInt_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_BigInt_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_BigInt, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_BigInt_absolute,
        Parrot_BigInt_ro_add_attribute,
        Parrot_BigInt_ro_add_method,
        Parrot_BigInt_ro_add_parent,
        Parrot_BigInt_ro_add_role,
        Parrot_BigInt_ro_add_vtable_override,
        Parrot_BigInt_ro_assign_pmc,
        Parrot_BigInt_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_BigInt_clone,
        Parrot_default_clone_pmc,
        Parrot_BigInt_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_BigInt_ro_delete_keyed,
        Parrot_BigInt_ro_delete_keyed_int,
        Parrot_BigInt_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_BigInt_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_BigInt_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_BigInt_get_bignum,
        Parrot_BigInt_get_bool,
        Parrot_default_get_class,
        Parrot_BigInt_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_BigInt_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_BigInt_get_repr,
        Parrot_BigInt_get_string,
        Parrot_default_get_string_keyed,
        Parrot_BigInt_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_BigInt_ro_i_absolute,
        Parrot_BigInt_ro_i_bitwise_not,
        Parrot_BigInt_ro_i_bitwise_nots,
        Parrot_BigInt_ro_i_logical_not,
        Parrot_BigInt_ro_i_neg,
        Parrot_BigInt_ro_increment,
        Parrot_BigInt_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_BigInt_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_BigInt_ro_morph,
        Parrot_default_name,
        Parrot_BigInt_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_BigInt_ro_pop_float,
        Parrot_BigInt_ro_pop_integer,
        Parrot_BigInt_ro_pop_pmc,
        Parrot_BigInt_ro_pop_string,
        Parrot_BigInt_ro_push_float,
        Parrot_BigInt_ro_push_integer,
        Parrot_BigInt_ro_push_pmc,
        Parrot_BigInt_ro_push_string,
        Parrot_BigInt_ro_remove_attribute,
        Parrot_BigInt_ro_remove_method,
        Parrot_BigInt_ro_remove_parent,
        Parrot_BigInt_ro_remove_role,
        Parrot_BigInt_ro_remove_vtable_override,
        Parrot_BigInt_ro_set_attr,
        Parrot_BigInt_ro_set_attr_str,
        Parrot_BigInt_ro_set_bignum_int,
        Parrot_BigInt_ro_set_bignum_num,
        Parrot_BigInt_ro_set_bignum_str,
        Parrot_BigInt_ro_set_bool,
        Parrot_BigInt_ro_set_integer_keyed,
        Parrot_BigInt_ro_set_integer_keyed_int,
        Parrot_BigInt_ro_set_integer_keyed_str,
        Parrot_BigInt_ro_set_integer_native,
        Parrot_BigInt_ro_set_integer_same,
        Parrot_BigInt_ro_set_number_keyed,
        Parrot_BigInt_ro_set_number_keyed_int,
        Parrot_BigInt_ro_set_number_keyed_str,
        Parrot_BigInt_ro_set_number_native,
        Parrot_BigInt_ro_set_number_same,
        Parrot_BigInt_ro_set_pmc,
        Parrot_BigInt_ro_set_pmc_keyed,
        Parrot_BigInt_ro_set_pmc_keyed_int,
        Parrot_BigInt_ro_set_pmc_keyed_str,
        Parrot_BigInt_ro_set_pointer,
        Parrot_BigInt_ro_set_pointer_keyed,
        Parrot_BigInt_ro_set_pointer_keyed_int,
        Parrot_BigInt_ro_set_pointer_keyed_str,
        Parrot_BigInt_ro_set_string_keyed,
        Parrot_BigInt_ro_set_string_keyed_int,
        Parrot_BigInt_ro_set_string_keyed_str,
        Parrot_BigInt_ro_set_string_native,
        Parrot_BigInt_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_BigInt_ro_shift_float,
        Parrot_BigInt_ro_shift_integer,
        Parrot_BigInt_ro_shift_pmc,
        Parrot_BigInt_ro_shift_string,
        Parrot_default_slice,
        Parrot_BigInt_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_BigInt_ro_thaw,
        Parrot_BigInt_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_BigInt_ro_unshift_float,
        Parrot_BigInt_ro_unshift_integer,
        Parrot_BigInt_ro_unshift_pmc,
        Parrot_BigInt_ro_unshift_string,
        Parrot_default_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_ADD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_add },
        { MMD_ADD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_add_BigInt },
        { MMD_ADD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_add_Integer },
        { MMD_ADD, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_add_int },
        { MMD_I_ADD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_add },
        { MMD_I_ADD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_add_BigInt },
        { MMD_I_ADD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_add_Integer },
        { MMD_I_ADD, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_add_int },
        { MMD_I_ADD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_BigInt_i_add_float },
        { MMD_SUBTRACT, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_subtract },
        { MMD_SUBTRACT, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_subtract_BigInt },
        { MMD_SUBTRACT, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_subtract_Integer },
        { MMD_SUBTRACT, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_subtract },
        { MMD_I_SUBTRACT, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_subtract_BigInt },
        { MMD_I_SUBTRACT, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_subtract_Integer },
        { MMD_I_SUBTRACT, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_BigInt_i_subtract_float },
        { MMD_MULTIPLY, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_multiply },
        { MMD_MULTIPLY, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_multiply_BigInt },
        { MMD_MULTIPLY, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_multiply_Integer },
        { MMD_MULTIPLY, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_multiply },
        { MMD_I_MULTIPLY, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_multiply_BigInt },
        { MMD_I_MULTIPLY, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_multiply_Integer },
        { MMD_I_MULTIPLY, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_BigInt_i_multiply_float },
        { MMD_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_divide },
        { MMD_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_divide_BigInt },
        { MMD_DIVIDE, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_divide_Integer },
        { MMD_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_divide_int },
        { MMD_I_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_divide },
        { MMD_I_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_divide_BigInt },
        { MMD_I_DIVIDE, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_divide_Integer },
        { MMD_I_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_divide_int },
        { MMD_FLOOR_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_floor_divide },
        { MMD_FLOOR_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_floor_divide_BigInt },
        { MMD_FLOOR_DIVIDE, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_floor_divide_Integer },
        { MMD_FLOOR_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_floor_divide_int },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_floor_divide },
        { MMD_I_FLOOR_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_floor_divide_BigInt },
        { MMD_I_FLOOR_DIVIDE, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_floor_divide_Integer },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_floor_divide_int },
        { MMD_MOD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_modulus },
        { MMD_MOD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_modulus_BigInt },
        { MMD_MOD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_modulus_Integer },
        { MMD_I_MOD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_modulus },
        { MMD_I_MOD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_modulus_BigInt },
        { MMD_I_MOD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_modulus_Integer },
        { MMD_CMOD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_cmodulus },
        { MMD_CMOD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_cmodulus_BigInt },
        { MMD_CMOD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_cmodulus_Integer },
        { MMD_I_CMOD, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_cmodulus },
        { MMD_I_CMOD, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_cmodulus_BigInt },
        { MMD_I_CMOD, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_cmodulus_Integer },
        { MMD_POW, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_pow },
        { MMD_POW, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_pow_int },
        { MMD_BSL, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_bitwise_shl },
        { MMD_BSL, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_bitwise_shl_BigInt },
        { MMD_BSL, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_bitwise_shl_Integer },
        { MMD_BSL, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_bitwise_shl_int },
        { MMD_I_BSL, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_bitwise_shl },
        { MMD_I_BSL, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_bitwise_shl_BigInt },
        { MMD_I_BSL, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_bitwise_shl_Integer },
        { MMD_I_BSL, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_bitwise_shl_int },
        { MMD_BSR, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_bitwise_shr },
        { MMD_BSR, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_bitwise_shr_BigInt },
        { MMD_BSR, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_bitwise_shr_Integer },
        { MMD_BSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_bitwise_shr_int },
        { MMD_I_BSR, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_i_bitwise_shr },
        { MMD_I_BSR, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_i_bitwise_shr_BigInt },
        { MMD_I_BSR, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_i_bitwise_shr_Integer },
        { MMD_I_BSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_BigInt_i_bitwise_shr_int },
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_is_equal },
        { MMD_EQ, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_is_equal_BigInt },
        { MMD_EQ, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_is_equal_Integer },
        { MMD_CMP, 0, enum_type_PMC, (funcptr_t) Parrot_BigInt_cmp },
        { MMD_CMP, 0, enum_class_BigInt, (funcptr_t) Parrot_BigInt_cmp_BigInt },
        { MMD_CMP, 0, enum_class_Integer, (funcptr_t) Parrot_BigInt_cmp_Integer }
    };
    /* Dynamic PMCs need the runtime type which is passed in entry to class_init. */
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "BigInt");
        vt_clone->isa_str = CONST_STRING(interp, "BigInt");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_BigInt_nci_version), "version", "SJO");
        /* class_init */
        {
        
        }
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_BigInt_class_init */
#line 1303 "./src/pmc/bigint.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
