/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/class.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/class.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: class.pmc 21875 2007-10-05 06:33:39Z paultcochrane $

=head1 NAME

src/pmc/class.pmc - defines a class

=head1 DESCRIPTION

This class implements the Class PMC, as outlined in
F<docs/pdds/pdd15_objects.pod>.

Class is not derived from any other PMC.

=head2 Structure

The Role PMC structure (C<Parrot_Role>) consists of five items:

=over 4

=item C<name>

The name of the class -- a STRING.
An empty STRING is allocated during initialization.

=item C<namespace>

The namespace the class is associated with, if any.
A Null PMC is allocated during initialization.

=item C<instantiated>

A flag denoting whether this class has been instantiated since last modification.
A native integer with value zero is allocated during initialization.

=item C<parents>

An array of immediate parent classes.
An empty ResizablePMCArray PMC is allocated during initialization.

=item C<all_parents>

A cached array of ourself and all parent classes, in MRO order.
A ResizablePMCArray PMC is allocated during initialization,
and is populated with the current class.

=item C<roles>

An array of the roles this class has been composed from.
An empty ResizablePMCArray PMC is allocated during initialization.

=item C<methods>

A directory of method names and method bodies this class provides.
An empty Hash PMC is allocated during initialization.

=item C<vtable_overrides>

A directory of vtable method names and method bodies this class overrides.
An empty Hash PMC is allocated during initialization.

=item C<attrib_metadata>

A directory of attribute names and attribute metadata this class contains.
An empty Hash PMC is allocated during initialization.

=item C<attrib_index>

A lookup table for attributes in this class and parents.
A Null PMC is allocated during initialization.

=item C<attrib_cache>

A cache of visible attribute names to attribute indexes.
A Null PMC is allocated during initialization.

=item C<resolve_method>

A list of method names the class provides used for name conflict resolution.
An empty ResizablePMCArray PMC is allocated during initialization.

=cut

*/

#define PARROT_IN_OBJECTS_C /* To get the vtable.h imports we want. */
#include "parrot/parrot.h"
#include "pmc_namespace.h"
#include "classobject.h"

/* This function builds the attribute index (table to map class name and
 * attribute name to an index) for the current class. */
static void
build_attrib_index(PARROT_INTERP, PMC *self)
{
    Parrot_Class * const _class      = PARROT_CLASS(self);
    int                  cur_index   = 0;
    PMC * const          table       = pmc_new(interp, enum_class_Hash);
    STRING       * const class_str   = string_from_cstring(interp, "Class", 5);
    const int            num_classes =
        VTABLE_elements(interp, _class->all_parents);
    int                  i;

    /* We will go over the list of all parents to construct the table. */
    for (i = 0; i < num_classes; i++) {
       /* Get the class and check it's from this class universe (if not we
        * don't know how it stores its attributes, so we'll have to delegate
        * the lookup). */
        PMC *cur_class = VTABLE_get_pmc_keyed_int(interp, _class->all_parents,
            i);

        if (VTABLE_isa(interp, cur_class, class_str)) {
            /* The the attribute metadata hash. */
            Parrot_Class *class_info = PARROT_CLASS(cur_class);
            PMC          *attribs    = class_info->attrib_metadata;
            PMC          *iter       = VTABLE_get_iter(interp, attribs);

            /* Build a string representing the fully qualified class name. */
            /* Retrieve the fully qualified class name for the class. */
            STRING *fq_class         = VTABLE_get_string(interp, cur_class);

            /* Iterate over the attributes. */
            while (VTABLE_get_bool(interp, iter)) {
                /* Get attribute. */
                PMC    *cur_attrib  = VTABLE_get_pmc_keyed_str(interp, attribs,
                    VTABLE_shift_string(interp, iter));
                STRING *full_key    = string_copy(interp, fq_class);

                /* Get attribute name and append it to the key. */
                STRING *attrib_name = VTABLE_get_string_keyed_str(
                    interp, cur_attrib, string_from_cstring(interp, "name", 4));

                full_key = string_append(interp, full_key, attrib_name);

                /* Insert into hash, along with index. */
                VTABLE_set_integer_keyed_str(interp, table, full_key, cur_index);
                cur_index++;
            }
        }
    }

    /* Store built table and invalidate cache. */
    _class->attrib_index = table;
    _class->attrib_cache = pmc_new(interp, enum_class_Hash);
}

/*
 * This function throws an exception if a PMC or class with the same name
 * already exists in the global type registry. The global type registry will go
 * away eventually, but this allows the new object metamodel to interact with
 * the old one until it does.
 */

static void
fail_if_type_exists(PARROT_INTERP, PMC *name)
{
    INTVAL      type;

    PMC * const classname_hash = interp->class_hash;
    PMC * const type_pmc       = (PMC *)VTABLE_get_pointer_keyed(interp,
                                        classname_hash, name);
    if (PMC_IS_NULL(type_pmc) ||
            type_pmc->vtable->base_type == enum_class_NameSpace)
        type = 0;
    else
        type = VTABLE_get_integer(interp, type_pmc);

    if (type > enum_type_undef) {
        /* RT#46091 get printable name */
        real_exception(interp, NULL, INVALID_OPERATION,
                "Class %Ss already registered!\n",
                VTABLE_get_string(interp, name));
    }

    if (type < enum_type_undef)
        real_exception(interp, NULL, INVALID_OPERATION,
                "native type with name '%s' already exists - "
                "can't register Class", data_types[type].name);
}

/* This function registers a type in the global registry, first checking if it
 * already exists. The global type registry will go away eventually, but this
 * allows the new object metamodel to interact with the old one until it does.
 */
static INTVAL
register_type(PARROT_INTERP, PMC *name) {
    INTVAL  type;
    PMC    *classname_hash, *item;

    if (PMC_IS_NULL(name))
        real_exception(interp, NULL, INVALID_OPERATION,
                "Can't register type without a name!\n");

    /* First check if the type already exists */
    fail_if_type_exists(interp, name);

    /* Type doesn't exist, so go ahead and register it. Lock interpreter so
     * pt_shared_fixup() can safely do a type lookup. */
    LOCK_INTERPRETER(interp);
    classname_hash = interp->class_hash;
    type           = interp->n_vtable_max++;

    /* Have we overflowed the table? */
    if (type >= interp->n_vtable_alloced)
        parrot_realloc_vtables(interp);

    /* set entry in name->type hash */
    item              = pmc_new(interp, enum_class_Integer);
    PMC_int_val(item) = type;

    VTABLE_set_pmc_keyed(interp, classname_hash, name, item);
    UNLOCK_INTERPRETER(interp);

    return type;
}


/* Takes a hash and initializes the class based on it. */
static void
init_class_from_hash(PARROT_INTERP, PMC *self, PMC *info)
{
    Parrot_Class *_class      = PARROT_CLASS(self);
    STRING       *name_str    = string_from_cstring(interp, "name",        4);
    STRING       *parents_str = string_from_cstring(interp, "parents",     7);
    STRING       *methods_str = string_from_cstring(interp, "methods",     7);
    STRING       *roles_str   = string_from_cstring(interp, "roles",       5);
    STRING       *attrs_str   = string_from_cstring(interp, "attributes", 10);
    PMC          *old_ns;
    INTVAL        i, type_num;

    /* Ensure we actually have some initialization info. */
    if (PMC_IS_NULL(info))
        return;

    /* Take a copy of the current namespace the class is attached to. */
    old_ns = _class->_namespace;

    /* Check if we have a name/namespace. */
    if (VTABLE_exists_keyed_str(interp, info, name_str)) {

        STRING *new_name;
        PMC    *new_namespace;
        PMC    *name_arg = VTABLE_get_pmc_keyed_str(interp, info, name_str);
        VTABLE *new_vtable;

        /* If we were passed a namespace PMC, set the namespace attribute
         * directly. Otherwise, lookup or create the appropriate namespace. */
        if (VTABLE_isa(interp, name_arg,
                    string_from_literal(interp, "NameSpace")))
            new_namespace = name_arg;
        else
            new_namespace = Parrot_make_namespace_autobase(interp, name_arg);

        if (PMC_IS_NULL(new_namespace))
            real_exception(interp, NULL, INVALID_OPERATION,
                "Failed to set namespace for class.");

        /* Set the name of the class to the name of the innermost namespace
         * associated with the class.
         */
        new_name = VTABLE_get_string(interp, new_namespace);

        if (STRING_IS_NULL(new_name) || STRING_IS_EMPTY(new_name))
              real_exception(interp, NULL, INVALID_OPERATION,
                "Failed to set name for class.");

        _class->_namespace = new_namespace;
        _class->name       = new_name;

        /* Register a type number for the class. */
        type_num = register_type(interp, name_arg);

        /* Link the type number with the class's vtable. */
        new_vtable = Parrot_clone_vtable(interp, self->vtable);
        new_vtable->base_type     = type_num;
        new_vtable->pmc_class     = self;

        /* Store the class's vtable in the global table */
        interp->vtables[type_num] = new_vtable;
    }

    /* If we were attached to a namespace and are now attached to a new one,
     * need to unset ourselves in the old namespace. */
    if (!PMC_IS_NULL(old_ns) && _class->_namespace != old_ns)
        Parrot_PCCINVOKE(interp, old_ns,
            string_from_literal(interp, "set_class"), "P->", PMCNULL);

    /* Link namespace to this class, if there is one. */
    if (!PMC_IS_NULL(_class->_namespace))
        Parrot_PCCINVOKE(interp, _class->_namespace,
            string_from_literal(interp, "set_class"), "P->", self);

    /* Initialize resolve_method. */
    if (VTABLE_exists_keyed_str(interp, info,
        string_from_literal(interp, "resolve_method"))) {
        /* Set it. */
        _class->resolve_method = VTABLE_get_pmc_keyed_str(interp, info,
            string_from_literal(interp, "resolve_method"));
    }

    /* Initialize parents, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, parents_str)) {
        /* Loop over parents array and add them. */
        PMC * const parent_list = VTABLE_get_pmc_keyed_str(interp, info,
            parents_str);
        const int  parent_count = VTABLE_elements(interp, parent_list);

        for (i = 0; i < parent_count; i++)
            VTABLE_add_parent(interp, self,
                VTABLE_get_pmc_keyed_int(interp, parent_list, i));
    }

    /* Initialize roles, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, roles_str)) {
        /* Loop over roles array and compose them. */
        PMC * const role_list  = VTABLE_get_pmc_keyed_str(interp, info,
            roles_str);
        const int   role_count = VTABLE_elements(interp, role_list);

        for (i = 0; i < role_count; i++)
            VTABLE_add_role(interp, self,
                VTABLE_get_pmc_keyed_int(interp, role_list, i));
    }

    /* Initialize attributes, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, attrs_str)) {
        /* Loop over attributes array and add them. */
        PMC * const attrs_name_list = VTABLE_get_pmc_keyed_str(interp, info,
            attrs_str);
        const int   attrib_count    = VTABLE_elements(interp, attrs_name_list);

        for (i = 0; i < attrib_count; i++) {
            STRING * const attr_name = VTABLE_get_string_keyed_int(interp,
                attrs_name_list, i);
            VTABLE_add_attribute(interp, self, attr_name, PMCNULL);
        }
    }

    /* Initialize methods. */
    if (VTABLE_exists_keyed_str(interp, info, methods_str)) {
        /* Get the methods hash. */
        PMC * const methods = VTABLE_get_pmc_keyed_str(interp, info,
            methods_str);

        /* Iterate over the list of methods. */
        PMC * const iter    = VTABLE_get_iter(interp, methods);

        while (VTABLE_get_bool(interp, iter)) {
            /* Add the method. */
            STRING * const method_name = VTABLE_shift_string(interp, iter);
            PMC    * const method_pmc  = VTABLE_get_pmc_keyed_str(interp,
                methods, method_name);
            VTABLE_add_method(interp, self, method_name, method_pmc);
        }
    }
}

static PMC *
find_vtable_override(PARROT_INTERP, PMC *parrot_class, STRING *name)
{
    Parrot_Class * const _class = PARROT_CLASS(parrot_class);

    /* Walk and search for the vtable method. */
    const int num_classes       = VTABLE_elements(interp, _class->all_parents);
    const int all_in_universe   = !PObj_HasAlienParents_TEST(parrot_class);
    /* xxx this isn't used yet
    const int alien_parents_pos = VTABLE_elements(interp,
        _class->attrib_metadata);
    */

    int i;

    for (i = 0; i < num_classes; i++) {
        /* Get the class. */
        PMC * const cur_class =
            VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);

        /* If it's from this universe or the class doesn't inherit from
         * anything outside of it... */
        if (all_in_universe || VTABLE_isa(interp, cur_class,
                string_from_literal(interp, "Class"))) {
            const Parrot_Class * const class_info = PARROT_CLASS(cur_class);
            if (VTABLE_exists_keyed_str(interp, class_info->vtable_overrides,
                    name)) {
                /* Found it; call. */
                PMC * const meth = VTABLE_get_pmc_keyed_str(interp,
                    class_info->vtable_overrides, name);
                return meth;
            }
        }
        else {
            /* This is the case where a parent is of a type other than Class,
             * but PMCProxy doesn't handle vtable overrides correctly yet. Will
             * have to come back and add it later. */
        }
    }
    return PMCNULL;
}


/*

=back

=head2 Functions

=over 4

=cut

*/
#line 427 "./src/pmc/class.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_class.h"
#include "pmc_default.h"
#include "class.str"
void
Parrot_Class_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
#line 637 "./src/pmc/class.pmc"

    Parrot_Class * const _class        = PARROT_CLASS(pmc);
    PMC          * const new_attribute = pmc_new(interp, enum_class_Hash);

    /* If we've been instantiated already, need a new class. */
    if (_class->instantiated) {
        /* RT#46093 Unimplemented! */
        real_exception(interp, NULL, E_NotImplementedError,
            "Modifications to already instantiated classes not allowed yet.");
    }

    /* If we already have an attribute of this name, it's an error. */
    if (VTABLE_exists_keyed_str(interp, _class->attrib_metadata, name))
        real_exception(interp, NULL, INVALID_OPERATION,
            "Attribute '%s' already exists.",
            string_to_cstring(interp, name));

    /* Set name and type. */
    VTABLE_set_string_keyed_str(interp, new_attribute, CONST_STRING(interp, "name"), name);

    if (!PMC_IS_NULL(type))
        VTABLE_set_pmc_keyed_str(interp, new_attribute, CONST_STRING(interp, "type"), type);

    /* Enter the attribute in the attributes array. */
    VTABLE_set_pmc_keyed_str(interp, _class->attrib_metadata, name,
        new_attribute);
#line 465 "./src/pmc/class.c"
}
void
Parrot_Class_add_method(PARROT_INTERP, PMC *pmc, STRING *name, PMC *sub)
{
#line 674 "./src/pmc/class.pmc"

    Parrot_Class * const _class = PARROT_CLASS(pmc);

    /* If we have already added a method with this name... */
    if (VTABLE_exists_keyed_str(interp, _class->methods, name)) {
        /* RT46095 Need to handle multi methods here. */
        real_exception(interp, NULL, E_NotImplementedError,
            "A method of this name already exists. It may have been supplied by a role.");
    }

    /* Enter it into the table. */
    VTABLE_set_pmc_keyed_str(interp, _class->methods, name, sub);
#line 483 "./src/pmc/class.c"
}
void
Parrot_Class_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 737 "./src/pmc/class.pmc"

    Parrot_Class * const _class = PARROT_CLASS(pmc);

    /* If we've been instantiated already, need a new class. */
    if (_class->instantiated) {
        /* RT46097 Unimplemented! */
        real_exception(interp, NULL, E_NotImplementedError,
            "Modifications to already instantiated classes not allowed yet.");
        return;
    }

    /* Ensure it really is a class. */
    if (!PObj_is_class_TEST(parent)) {
        real_exception(interp, NULL, E_TypeError, "Parent isn't a Class.");
        return;
    }

    /* RT46099 Check we don't already have this parent. */

    /* Add to the list of our immediate parents. */
    VTABLE_push_pmc(interp, _class->parents, parent);
#line 510 "./src/pmc/class.c"
}
void
Parrot_Class_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
#line 770 "./src/pmc/class.pmc"

    Parrot_Class * const _class = PARROT_CLASS(pmc);

    /* Do the composition. */
    Parrot_ComposeRole(interp, role, PMCNULL, 0, PMCNULL, 0,
                       _class->methods, _class->roles);
#line 522 "./src/pmc/class.c"
}
void
Parrot_Class_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *name, PMC *sub)
{
#line 697 "./src/pmc/class.pmc"

    Parrot_Class * const _class = PARROT_CLASS(pmc);
    char *c_name = string_to_cstring(interp, name);
    int found = 0;
    int i;

    /* If we have already added a vtable override with this name... */
    if (VTABLE_exists_keyed_str(interp, _class->vtable_overrides, name)) {
        real_exception(interp, NULL, E_NotImplementedError,
            "A vtable override of this name already exists."
            "It may have been supplied by a role.");
    }

    /* Check name is a valid vtable method name. */
    for (i = PARROT_VTABLE_LOW; i < NUM_VTABLE_FUNCTIONS; i++) {
        if (strcmp(c_name, Parrot_vtable_slot_names[i] + 2) == 0) {
            found = 1;
            break;
        }
    }

    string_cstring_free(c_name);

    if (!found)
        real_exception(interp, NULL, METH_NOT_FOUND,
            "'%S' is not a valid vtable function name.", name);

    /* Add it to vtable methods list. */
    VTABLE_set_pmc_keyed_str(interp, _class->vtable_overrides, name, sub);
#line 557 "./src/pmc/class.c"
}
PMC  *
Parrot_Class_clone(PARROT_INTERP, PMC *pmc)
{
#line 912 "./src/pmc/class.pmc"

    Parrot_Class *_class = PARROT_CLASS(pmc);

    /* Create the new class PMC, of the same type of this one (we may
     * have been subclassed). */
    PMC          *copy  = pmc_new(interp, pmc->vtable->base_type);

    /* Clone parents, roles, methods, attributes and resolve data. We do
     * not copy name/namespace related stuff (need anonymous clone) or
     * stuff that gets computed on the first instantiation. */

    Parrot_Class *new_class    = PARROT_CLASS(copy);

    new_class->parents         = VTABLE_clone(interp, _class->parents);
    new_class->roles           = VTABLE_clone(interp, _class->roles);
    new_class->methods         = VTABLE_clone(interp, _class->methods);
    new_class->vtable_overrides  = VTABLE_clone(interp,
                                              _class->vtable_overrides);
    new_class->attrib_metadata = VTABLE_clone(interp,
                                              _class->attrib_metadata);
    new_class->resolve_method  = VTABLE_clone(interp,
                                              _class->resolve_method);

    /* Return cloned class. */
    return copy;
#line 588 "./src/pmc/class.c"
}
PMC  *
Parrot_Class_clone_pmc(PARROT_INTERP, PMC *pmc, PMC *args)
{
#line 952 "./src/pmc/class.pmc"

    /* Do the standard clone. */
    PMC *copy = VTABLE_clone(interp, pmc);

    init_class_from_hash(interp, copy, args);

    return copy;
#line 601 "./src/pmc/class.c"
}
void
Parrot_Class_destroy(PARROT_INTERP, PMC *pmc)
{
#line 551 "./src/pmc/class.pmc"

    mem_sys_free(PMC_data(pmc));
#line 609 "./src/pmc/class.c"
}
STRING  *
Parrot_Class_get_string(PARROT_INTERP, PMC *pmc)
{
#line 565 "./src/pmc/class.pmc"

    Parrot_Class * const  _class    = PARROT_CLASS(pmc);
    PMC                  *_namespace = _class->_namespace;
    PMC                  *names;

    if (!PMC_IS_NULL(_namespace)) {
        /* Call the 'get_name' method on the class's associated namespace
         * to retrieve a fully qualified list of names, then join the list
         * with a semicolon.
         */
        names = Parrot_NameSpace_nci_get_name(interp, _namespace);

        if (!PMC_IS_NULL(names))
            /* remove the HLL namespace name */
            VTABLE_shift_string(interp, names);
            return string_join(interp, CONST_STRING(interp, ";"), names);
    }

    /* Otherwise, copy the stored string name of the class. */
    return string_copy(interp, _class->name);
#line 635 "./src/pmc/class.c"
}
void
Parrot_Class_init(PARROT_INTERP, PMC *pmc)
{
#line 434 "./src/pmc/class.pmc"

    Parrot_Class *_class    = mem_allocate_zeroed_typed(Parrot_Class);

    /* Set flags for custom DOD mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);

    /* Set up the object. */
    PMC_data(pmc)          = _class;
    _class->name            = CONST_STRING(interp, "");
    _class->_namespace      = PMCNULL;
    _class->instantiated    = 0;
    _class->parents         = pmc_new(interp, enum_class_ResizablePMCArray);
    _class->all_parents     = pmc_new(interp, enum_class_ResizablePMCArray);
    _class->roles           = pmc_new(interp, enum_class_ResizablePMCArray);
    _class->methods         = pmc_new(interp, enum_class_Hash);
    _class->vtable_overrides  = pmc_new(interp, enum_class_Hash);
    _class->attrib_metadata = pmc_new(interp, enum_class_Hash);
    _class->attrib_index    = PMCNULL;
    _class->attrib_cache    = PMCNULL;
    _class->resolve_method  = pmc_new(interp, enum_class_ResizablePMCArray);

    /* We put ourself on the all parents list. */
    VTABLE_push_pmc(interp, _class->all_parents, pmc);

    /* We are a class. */
    PObj_is_class_SET(pmc);
#line 668 "./src/pmc/class.c"
}
void
Parrot_Class_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init_data)
{
#line 463 "./src/pmc/class.pmc"

    PMC           *arg;
    const INTVAL   arg_type = VTABLE_type(interp, init_data);
    STRING * const name_str = CONST_STRING(interp, "name");

    /* Set up the object. */
    Parrot_Class_init(interp, pmc);

    /* fast attempt to determine init_data type */
    switch (arg_type) {
        case enum_class_String:
        case enum_class_Key:
        case enum_class_NameSpace:
            arg = pmc_new(interp, enum_class_Hash);
            VTABLE_set_pmc_keyed_str(interp, arg, name_str, init_data);
            break;

        case enum_class_Hash:
            arg = init_data;
            break;

        /* slow attempt to determine init_data type */
        default:
            if (VTABLE_isa(interp, init_data, CONST_STRING(interp, "String"))) {
                arg = pmc_new(interp, enum_class_Hash);
                VTABLE_set_pmc_keyed_str(interp, arg, name_str, init_data);
            }
            else if (VTABLE_isa(interp, init_data, CONST_STRING(interp, "Key"))) {
                arg = pmc_new(interp, enum_class_Hash);
                VTABLE_set_pmc_keyed_str(interp, arg, name_str, init_data);
            }

            if (VTABLE_isa(interp, init_data, CONST_STRING(interp, "Hash"))) {
                arg = init_data;
            }
            else {
                arg = pmc_new(interp, enum_class_Hash);
                VTABLE_set_pmc_keyed_str(interp, arg, name_str, init_data);
            }
            break;
    }

    /* Initialize the class with the supplied data. */
    init_class_from_hash(interp, pmc, arg);
#line 718 "./src/pmc/class.c"
}
PMC  *
Parrot_Class_inspect(PARROT_INTERP, PMC *pmc)
{
#line 869 "./src/pmc/class.pmc"

    /* Create a hash, then use inspect_str to get all of the data to
     * fill it up with. */
    PMC    *metadata    = pmc_new(interp, enum_class_Hash);
    STRING *name_str    = CONST_STRING(interp, "name");
    STRING *ns_str      = CONST_STRING(interp, "namespace");
    STRING *attrs_str   = CONST_STRING(interp, "attributes");
    STRING *meths_str   = CONST_STRING(interp, "methods");
    STRING *parents_str = CONST_STRING(interp, "parents");
    STRING *roles_str   = CONST_STRING(interp, "roles");

    VTABLE_set_pmc_keyed_str(interp, metadata, name_str,
        VTABLE_inspect_str(interp, pmc, name_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, ns_str,
        VTABLE_inspect_str(interp, pmc, ns_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, attrs_str,
        VTABLE_inspect_str(interp, pmc, attrs_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, meths_str,
        VTABLE_inspect_str(interp, pmc, meths_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, parents_str,
        VTABLE_inspect_str(interp, pmc, parents_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, roles_str,
        VTABLE_inspect_str(interp, pmc, roles_str));

    return metadata;
#line 754 "./src/pmc/class.c"
}
PMC  *
Parrot_Class_inspect_str(PARROT_INTERP, PMC *pmc, STRING *what)
{
#line 818 "./src/pmc/class.pmc"

    Parrot_Class *_class = PARROT_CLASS(pmc);

    /* What should we return? */
    PMC          *found  = PMCNULL;

    if (string_equal(interp, what, CONST_STRING(interp, "name")) == 0) {
        found = pmc_new(interp, enum_class_String);
        VTABLE_set_string_native(interp, found, _class->name);
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "namespace")) == 0) {
        /* Should not clone this. */
        return _class->_namespace;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "attributes")) == 0) {
        found = _class->attrib_metadata;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "methods")) == 0) {
        found = _class->methods;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "vtable_overrides")) == 0) {
        found = _class->vtable_overrides;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "parents")) == 0) {
        found = _class->parents;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "all_parents")) == 0) {
        found = _class->all_parents;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "roles")) == 0) {
        found = _class->roles;
    }
    else {
        real_exception(interp, NULL, INVALID_OPERATION,
            "Unknown introspection value '%S'", what);
    }

    /* Clone and return. */
    return PMC_IS_NULL(found) ? PMCNULL : VTABLE_clone(interp, found);
#line 799 "./src/pmc/class.c"
}
PMC  *
Parrot_Class_instantiate(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 971 "./src/pmc/class.pmc"

    Parrot_Object *obj_guts  = NULL;
    Parrot_Class  *_class    = PARROT_CLASS(pmc);
    STRING * const class_str = string_from_cstring(interp, "Class", 5);
    PMC           *iter, *object;

    int            i, mro_length;

    object = PMCNULL;

    /* If we've not been instantiated before... */
    if (!_class->instantiated) {
        int resolve_count;

        /* Pull in methods from the namespace, if any. */
        if (!PMC_IS_NULL(_class->_namespace)) {
            PMC *methods, *vtable_overrides;
            PMC *ns = _class->_namespace;

            /* Import any methods. */
            #line 551 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /*BEGIN PCCINVOKE ns */
    {
      INTVAL   n_regs_used[]    = { 0, 0, 0, 1 };
      opcode_t arg_indexes[]    = { 0 };
      opcode_t result_indexes[] = { 0 };
      PMC* _type                = pmc_new(interp, enum_class_FixedIntegerArray);

      PMC* args_sig         = Parrot_FixedIntegerArray_new_from_string(interp,
            _type, string_from_literal(interp, "(2)"), 0);
      PMC* results_sig      = Parrot_FixedIntegerArray_new_from_string(interp,
            _type, string_from_literal(interp, "(2)"), 0);
      PMC* ret_cont         = new_ret_continuation_pmc(interp, NULL);

      parrot_context_t *ctx = Parrot_push_context(interp, n_regs_used);
      PMC* pccinvoke_meth;

      opcode_t* save_current_args = interp->current_args;
      PMC* save_args_signature    = interp->args_signature;
      PMC* save_current_object    = interp->current_object;

      interp->current_args        = arg_indexes;
      interp->args_signature      = args_sig;
      ctx->current_results        = result_indexes;
      ctx->results_signature      = results_sig;

#line 852 "./src/pmc/class.pmc"


    CTX_REG_PMC(ctx, 0) = ns;

#line 571 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

      interp->current_object       = ns;
      interp->current_cont         = NEED_CONTINUATION;
      ctx->current_cont            = ret_cont;
      PMC_cont(ret_cont)->from_ctx = ctx;

      pccinvoke_meth = VTABLE_find_method(interp, ns, string_from_literal(interp, "get_associated_methods"));
      if (PMC_IS_NULL(pccinvoke_meth))
          real_exception(interp, NULL, METH_NOT_FOUND,
            "Method '%Ss' not found", string_from_literal(interp, "get_associated_methods"));
      else
          VTABLE_invoke(interp, pccinvoke_meth, NULL);

#line 871 "./src/pmc/class.pmc"
    methods = CTX_REG_PMC(ctx, 0);

#line 587 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

      PObj_live_CLEAR(_type);
      PObj_live_CLEAR(args_sig);
      PObj_live_CLEAR(results_sig);
      Parrot_pop_context(interp);

      interp->current_args   = save_current_args;
      interp->args_signature = save_args_signature;
      interp->current_object = save_current_object;
    }
    /*END PCCINVOKE string_from_literal(interp, "get_associated_methods") */
#line 992 "./src/pmc/class.pmc"

            if (!PMC_IS_NULL(methods)) {
                PMC *iter = VTABLE_get_iter(interp, methods);
                while (VTABLE_get_bool(interp, iter)) {
                    STRING *meth_name = VTABLE_shift_string(interp, iter);
                    PMC *meth_sub = VTABLE_get_pmc_keyed_str(interp, methods,
                        meth_name);
                    VTABLE_add_method(interp, pmc, meth_name, meth_sub);
                }
            }

            /* Import any vtable methods. */
            #line 551 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /*BEGIN PCCINVOKE ns */
    {
      INTVAL   n_regs_used[]    = { 0, 0, 0, 1 };
      opcode_t arg_indexes[]    = { 0 };
      opcode_t result_indexes[] = { 0 };
      PMC* _type                = pmc_new(interp, enum_class_FixedIntegerArray);

      PMC* args_sig         = Parrot_FixedIntegerArray_new_from_string(interp,
            _type, string_from_literal(interp, "(2)"), 0);
      PMC* results_sig      = Parrot_FixedIntegerArray_new_from_string(interp,
            _type, string_from_literal(interp, "(2)"), 0);
      PMC* ret_cont         = new_ret_continuation_pmc(interp, NULL);

      parrot_context_t *ctx = Parrot_push_context(interp, n_regs_used);
      PMC* pccinvoke_meth;

      opcode_t* save_current_args = interp->current_args;
      PMC* save_args_signature    = interp->args_signature;
      PMC* save_current_object    = interp->current_object;

      interp->current_args        = arg_indexes;
      interp->args_signature      = args_sig;
      ctx->current_results        = result_indexes;
      ctx->results_signature      = results_sig;

#line 926 "./src/pmc/class.pmc"


    CTX_REG_PMC(ctx, 0) = ns;

#line 571 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

      interp->current_object       = ns;
      interp->current_cont         = NEED_CONTINUATION;
      ctx->current_cont            = ret_cont;
      PMC_cont(ret_cont)->from_ctx = ctx;

      pccinvoke_meth = VTABLE_find_method(interp, ns, string_from_literal(interp, "get_associated_vtable_methods"));
      if (PMC_IS_NULL(pccinvoke_meth))
          real_exception(interp, NULL, METH_NOT_FOUND,
            "Method '%Ss' not found", string_from_literal(interp, "get_associated_vtable_methods"));
      else
          VTABLE_invoke(interp, pccinvoke_meth, NULL);

#line 945 "./src/pmc/class.pmc"
    vtable_overrides = CTX_REG_PMC(ctx, 0);

#line 587 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

      PObj_live_CLEAR(_type);
      PObj_live_CLEAR(args_sig);
      PObj_live_CLEAR(results_sig);
      Parrot_pop_context(interp);

      interp->current_args   = save_current_args;
      interp->args_signature = save_args_signature;
      interp->current_object = save_current_object;
    }
    /*END PCCINVOKE string_from_literal(interp, "get_associated_vtable_methods") */
#line 1005 "./src/pmc/class.pmc"

            if (!PMC_IS_NULL(vtable_overrides)) {
                PMC *iter = VTABLE_get_iter(interp, vtable_overrides);
                while (VTABLE_get_bool(interp, iter)) {
                    STRING *vtable_index_str = VTABLE_shift_string(interp, iter);
                    PMC *vtable_sub = VTABLE_get_pmc_keyed_str(interp, vtable_overrides,
                        vtable_index_str);
                    /* Look up the name of the vtable function from the index. */
                    INTVAL vtable_index = string_to_int(interp, vtable_index_str);
                    const char * const meth_c = Parrot_vtable_slot_names[vtable_index];
                    STRING *vtable_name = string_from_cstring(interp, meth_c, 0);

                    /* Strip leading underscores in the vtable name */
                    if (string_str_index(interp, vtable_name,
                        CONST_STRING(interp, "__"), 0) == 0) {
                        vtable_name = string_substr(interp, vtable_name, 2,
                            string_length(interp, vtable_name) - 2, NULL, 0);
                    }

                    VTABLE_add_vtable_override(interp, pmc, vtable_name, vtable_sub);
                }
            }
        }

        /* Check that we have all methods listed in resolve list. */
        resolve_count = VTABLE_elements(interp, _class->resolve_method);
        for (i = 0; i < resolve_count; i++) {
            STRING *check_meth = VTABLE_get_string_keyed_int(interp,
                _class->resolve_method, i);
            if (!VTABLE_exists_keyed_str(interp, _class->methods, check_meth)) {
                real_exception(interp, NULL, METH_NOT_FOUND,
                    "The method '%S' was named in the resolve list, but not supplied",
                    check_meth);
            }
        }

        /* Build full parents list.
         * RT#46101 Need pluggable MRO, for now always do C3. */
        _class->all_parents = Parrot_ComputeMRO_C3(interp, pmc);

        build_attrib_index(interp, pmc);

        if (PMC_IS_NULL(_class->attrib_index))
            return object;

        /* See if we have any parents from other universes and if so set a
         * flag stating so. */
        mro_length = VTABLE_elements(interp, _class->all_parents);

        for (i = 0; i < mro_length; i++) {
            PMC * const class_check = VTABLE_get_pmc_keyed_int(interp,
                _class->all_parents, i);
            if (!VTABLE_isa(interp, class_check, class_str)) {
                /* Found one; that's enough. */
                PObj_HasAlienParents_SET(pmc);
                break;
            }
        }
    }

    /* Set instantiated flag. */
    _class->instantiated = 1;

    /* Create object. */
    object = pmc_new_noinit(interp, enum_class_Object);

    /* Set custom DOD mark and destroy on the object. */
    PObj_custom_mark_SET(object);
    PObj_active_destroy_SET(object);

    /* Initialize the object's underlying structure, pointing it to this
     * class. */
    obj_guts               = mem_allocate_zeroed_typed(Parrot_Object);
    obj_guts->_class       = pmc;
    obj_guts->attrib_store = pmc_new(interp, enum_class_ResizablePMCArray);
    PMC_data(object)       = obj_guts;

    if (!PMC_IS_NULL(init)) {
        /* Initialize attributes with the supplied values. */
        iter = VTABLE_get_iter(interp, init);

        while (VTABLE_get_bool(interp, iter)) {
            /* Get name and value. */
            STRING * const attr_name  = VTABLE_shift_string(interp, iter);
            PMC    * const attr_value = VTABLE_get_pmc_keyed_str(interp, init,
                attr_name);

            /* Set the attribute. */
            VTABLE_set_attr_str(interp, object, attr_name, attr_value);
        }
    }

    /* If we have parents that are out of this class universe, find them
     * in the MRO and create instances of them. */
    if (PObj_HasAlienParents_TEST(pmc)) {
        mro_length = VTABLE_elements(interp, _class->all_parents);

        for (i = 0; i < mro_length; i++) {
            PMC * const class_check = VTABLE_get_pmc_keyed_int(interp,
                _class->all_parents, i);

            if (!VTABLE_isa(interp, class_check, class_str)) {
                /* From another universe. Create instance... */
                PMC *parent_ins;
                int  position;

                parent_ins = VTABLE_instantiate(interp, class_check, PMCNULL);

                /* Associate it with this class as the real self. */
                parent_ins->real_self = object;

                /* ...and tack on end of the attribute store (after all the
                 * slots for attributes). */
                position = VTABLE_elements(interp, obj_guts->attrib_store);
                VTABLE_set_pmc_keyed_int(interp, obj_guts->attrib_store,
                    position, parent_ins);
            }
        }
    }

    /* Check for overrides on the init or init_pmc vtable function and call
     * them if they exist */
    if (PMC_IS_NULL(init)) {
        STRING *name = string_from_literal(interp, "init");
        PMC *meth = find_vtable_override(interp, pmc, name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth,
                    object, name, "v");
        }
    }
    else {
        STRING *name = string_from_literal(interp, "init_pmc");
        PMC *meth = find_vtable_override(interp, pmc, name);
        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth,
                    object, name, "vP", init);
        }
    }

    return object;
#line 1101 "./src/pmc/class.c"
}
INTVAL
Parrot_Class_isa(PARROT_INTERP, PMC *pmc, STRING *classname)
{
#line 1158 "./src/pmc/class.pmc"

    Parrot_Class *_class      = PARROT_CLASS(pmc);
    INTVAL        i, num_classes;

    if (Parrot_default_isa(interp, pmc, classname))
        return 1;

    /* Check if the passed name is the same as the stored short name. */
    if (string_equal(interp, classname, _class->name) == 0)
        return 1;

    /* Check if the passed name is the same as the fully qualified name. */
    if (string_equal(interp, classname, VTABLE_get_string(interp, pmc)) == 0)
        return 1;

    /* Iterate over all the parents and check if they respond true
     * for 'isa' on the classname.
     */
    num_classes = VTABLE_elements(interp, _class->parents);
    for (i = 0; i < num_classes; i++) {
        PMC *cur_class = VTABLE_get_pmc_keyed_int(interp, _class->parents, i);
        if (VTABLE_isa(interp, cur_class, classname))
            return 1;
    }

    return 0;
#line 1133 "./src/pmc/class.c"
}
void
Parrot_Class_mark(PARROT_INTERP, PMC *pmc)
{
#line 597 "./src/pmc/class.pmc"

    Parrot_Class * const _class = PARROT_CLASS(pmc);
    if (_class->name)
        pobject_lives(interp, (PObj*)_class->name);
    if (_class->_namespace)
        pobject_lives(interp, (PObj*)_class->_namespace);
    if (_class->parents)
        pobject_lives(interp, (PObj*)_class->parents);
    if (_class->all_parents)
        pobject_lives(interp, (PObj*)_class->all_parents);
    if (_class->roles)
        pobject_lives(interp, (PObj*)_class->roles);
    if (_class->methods)
        pobject_lives(interp, (PObj*)_class->methods);
    if (_class->vtable_overrides)
        pobject_lives(interp, (PObj*)_class->vtable_overrides);
    if (_class->attrib_metadata)
        pobject_lives(interp, (PObj*)_class->attrib_metadata);
    if (_class->attrib_index)
        pobject_lives(interp, (PObj*)_class->attrib_index);
    if (_class->attrib_cache)
        pobject_lives(interp, (PObj*)_class->attrib_cache);
    if (_class->resolve_method)
        pobject_lives(interp, (PObj*)_class->resolve_method);
#line 1163 "./src/pmc/class.c"
}
PMC  *
Parrot_Class_subclass(PARROT_INTERP, PMC *pmc, PMC *name)
{
#line 519 "./src/pmc/class.pmc"

    PMC *child_class;

    /* Create a new class. Set the classname, if we have one. */
    if (PMC_IS_NULL(name)) {
        child_class = pmc_new(interp, enum_class_Class);
    }
    else {
        PMC *naming_hash = pmc_new(interp, enum_class_Hash);
        VTABLE_set_pmc_keyed_str(interp, naming_hash, CONST_STRING(interp, "name"), name);
        child_class      = pmc_new_init(interp, enum_class_Class,
            naming_hash);
    }

    /* Make the new class a subclass of the current class */
    VTABLE_add_parent(interp, child_class, pmc);

    return child_class;
#line 1187 "./src/pmc/class.c"
}
void
Parrot_Class_nci_name(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t param_indexes[] = { 0, 0, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 129, 256)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1223 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1240 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* name = CTX_REG_STR(ctx, 0);
    INTVAL has_name = CTX_REG_INT(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1201 "./src/pmc/class.pmc"

    Parrot_Class *_class   = PARROT_CLASS(pmc);
    STRING       *ret_name = NULL;

    if (has_name) {
        /* We'll build a hash just containing the name, then give this to
         * init_class_from_hash - saves some code duplication. */
        PMC *naming_hash = pmc_new(interp, enum_class_Hash);

        VTABLE_set_string_keyed_str(interp, naming_hash, CONST_STRING(interp, "name"), name);
        init_class_from_hash(interp, pmc, naming_hash);
    }

    ret_name = _class->name;
    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN STRING *ret_name */
    /*BEGIN GENERATED ACCESSORS */
#line 1268 "./src/pmc/class.pmc"
    CTX_REG_STR(ctx, 0) = ret_name;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(1)"), 0);
    goto name_returns;
    /*END PCCRETURN STRING *ret_name */
    }
#line 1215 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
name_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 1311 "./src/pmc/class.c"
}
void
Parrot_Class_nci_pmc_namespace(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 0, 2 };
    opcode_t param_indexes[] = { 0, 1, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 130, 256)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1347 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1364 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    PMC* _namespace = CTX_REG_PMC(ctx, 1);
    INTVAL has_name = CTX_REG_INT(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1227 "./src/pmc/class.pmc"

    Parrot_Class *_class        = PARROT_CLASS(pmc);
    PMC          *ret_namespace = _class->_namespace;
    UNUSED(_namespace);
    UNUSED(has_name);
    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret_namespace */
    /*BEGIN GENERATED ACCESSORS */
#line 1383 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = ret_namespace;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto pmc_namespace_returns;
    /*END PCCRETURN PMC *ret_namespace */
    }
#line 1232 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
pmc_namespace_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 1426 "./src/pmc/class.c"
}
void
Parrot_Class_nci_resolve_method(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 0, 2 };
    opcode_t param_indexes[] = { 0, 1, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 130, 256)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1462 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1479 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    PMC* resolve_list = CTX_REG_PMC(ctx, 1);
    INTVAL has_list = CTX_REG_INT(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1246 "./src/pmc/class.pmc"

    Parrot_Class *_class   = PARROT_CLASS(pmc);
    PMC          *ret_list = NULL;

    /* Store list. */
    if (has_list)
        _class->resolve_method = resolve_list;

    ret_list = _class->resolve_method;
    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret_list */
    /*BEGIN GENERATED ACCESSORS */
#line 1502 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = ret_list;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto resolve_method_returns;
    /*END PCCRETURN PMC *ret_list */
    }
#line 1255 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
resolve_method_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 1545 "./src/pmc/class.c"
}
void
Parrot_Class_nci_new(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t param_indexes[] = { 0, 1 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 546)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1581 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1598 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    PMC* args = CTX_REG_PMC(ctx, 1);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1268 "./src/pmc/class.pmc"

    PMC *obj = VTABLE_instantiate(interp, pmc, args);
    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *obj */
    /*BEGIN GENERATED ACCESSORS */
#line 1613 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = obj;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto new_returns;
    /*END PCCRETURN PMC *obj */
    }
#line 1270 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
new_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 1656 "./src/pmc/class.c"
}
void
Parrot_Class_nci_attributes(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1692 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1709 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1283 "./src/pmc/class.pmc"

    PMC *ret_attrib_metadata = pmc->real_self->vtable->inspect_str(interp, pmc->real_self, CONST_STRING(interp, "attributes"));

    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret_attrib_metadata */
    /*BEGIN GENERATED ACCESSORS */
#line 1724 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = ret_attrib_metadata;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto attributes_returns;
    /*END PCCRETURN PMC *ret_attrib_metadata */
    }
#line 1287 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
attributes_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 1767 "./src/pmc/class.c"
}
void
Parrot_Class_nci_add_attribute(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 2 };
    opcode_t param_indexes[] = { 0, 0, 1, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 1, 130, 256)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1803 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1820 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* attribute_name = CTX_REG_STR(ctx, 0);
    PMC* attribute_type = CTX_REG_PMC(ctx, 1);
    INTVAL has_type = CTX_REG_INT(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1300 "./src/pmc/class.pmc"

    PMC *type = has_type ? attribute_type : PMCNULL;
    pmc->real_self->vtable->add_attribute(interp, pmc->real_self, attribute_name, type);
#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 1849 "./src/pmc/class.c"
}
void
Parrot_Class_nci_methods(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1885 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1902 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1314 "./src/pmc/class.pmc"

    PMC *ret_methods = pmc->real_self->vtable->inspect_str(interp, pmc->real_self, CONST_STRING(interp, "methods"));

    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret_methods */
    /*BEGIN GENERATED ACCESSORS */
#line 1917 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = ret_methods;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto methods_returns;
    /*END PCCRETURN PMC *ret_methods */
    }
#line 1317 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
methods_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 1960 "./src/pmc/class.c"
}
void
Parrot_Class_nci_add_method(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 4, 0, 3, 2 };
    opcode_t param_indexes[] = { 0, 0, 1, 1, 0, 1, 2, 2, 3 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 1, 2, 513, 128, 256, 513, 128, 256)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1996 "./src/pmc/class.pmc"
    CTX_REG_STR(ctx, 1) = string_from_literal(interp, "vtable");
    CTX_REG_STR(ctx, 2) = string_from_literal(interp, "anon");

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2015 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* name = CTX_REG_STR(ctx, 0);
    PMC* sub = CTX_REG_PMC(ctx, 1);
    INTVAL vtable = CTX_REG_INT(ctx, 0);
    INTVAL has_vtable = CTX_REG_INT(ctx, 1);
    INTVAL anon = CTX_REG_INT(ctx, 2);
    INTVAL has_anon = CTX_REG_INT(ctx, 3);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1335 "./src/pmc/class.pmc"

    /* If it's a vtable method... */
    if (has_vtable && vtable) {
        VTABLE_add_vtable_override(interp, pmc, name, sub);
    }

    /* Provided it's not anonymous, add it to the methods list. */
    if (!has_anon || !anon)
        pmc->real_self->vtable->add_method(interp, pmc->real_self, name, sub);
#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 2053 "./src/pmc/class.c"
}
void
Parrot_Class_nci_find_method(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t param_indexes[] = { 0, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 1)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2089 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2106 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* name = CTX_REG_STR(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1354 "./src/pmc/class.pmc"

    Parrot_Class * const  _class    = PARROT_CLASS(pmc);
    PMC                  *_namespace = _class->_namespace;
    int num_classes, i;

    if (! PMC_IS_NULL(_namespace)
        &&  VTABLE_exists_keyed_str(interp, _namespace, name)) {
        PMC *ret = VTABLE_get_pmc_keyed_str(interp, _namespace, name);
        #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret */
    /*BEGIN GENERATED ACCESSORS */
#line 2127 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = ret;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto find_method_returns;
    /*END PCCRETURN PMC *ret */
    }
#line 1362 "./src/pmc/class.pmc"

    }

    /* Walk and search. One day, we'll use the cache first. */
    num_classes = VTABLE_elements(interp, _class->all_parents);

    for (i = 0; i < num_classes; i++) {
        /* Get the class and see if it has the method. */
        PMC * const cur_class =
            VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);
        const Parrot_Class * const class_info = PARROT_CLASS(cur_class);

        /* Found it! */
        if (VTABLE_exists_keyed_str(interp, class_info->methods, name)) {
            PMC *ret = VTABLE_get_pmc_keyed_str(interp, class_info->methods,
                name);
            #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret */
    /*BEGIN GENERATED ACCESSORS */
#line 2162 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = ret;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto find_method_returns;
    /*END PCCRETURN PMC *ret */
    }
#line 1378 "./src/pmc/class.pmc"

        }
    }

    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 2185 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = PMCNULL;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto find_method_returns;
    /*END PCCRETURN PMC *PMCNULL */
    }
#line 1382 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
find_method_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 2228 "./src/pmc/class.c"
}
void
Parrot_Class_nci_parents(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2264 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2281 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1394 "./src/pmc/class.pmc"

    PMC *ret_parents = pmc->real_self->vtable->inspect_str(interp, pmc->real_self, CONST_STRING(interp, "parents"));

    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret_parents */
    /*BEGIN GENERATED ACCESSORS */
#line 2296 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = ret_parents;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto parents_returns;
    /*END PCCRETURN PMC *ret_parents */
    }
#line 1397 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
parents_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 2339 "./src/pmc/class.c"
}
void
Parrot_Class_nci_add_parent(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t param_indexes[] = { 0, 1 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 2)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2375 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2392 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    PMC* parent = CTX_REG_PMC(ctx, 1);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1409 "./src/pmc/class.pmc"

    pmc->real_self->vtable->add_parent(interp, pmc->real_self, parent);
#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 2418 "./src/pmc/class.c"
}
void
Parrot_Class_nci_roles(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2454 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2471 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1422 "./src/pmc/class.pmc"

    PMC *ret_roles = pmc->real_self->vtable->inspect_str(interp, pmc->real_self, CONST_STRING(interp, "roles"));

    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret_roles */
    /*BEGIN GENERATED ACCESSORS */
#line 2486 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = ret_roles;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto roles_returns;
    /*END PCCRETURN PMC *ret_roles */
    }
#line 1425 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
roles_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 2529 "./src/pmc/class.c"
}
void
Parrot_Class_nci_add_role(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 2, 0, 2, 4 };
    opcode_t param_indexes[] = { 0, 1, 0, 2, 0, 1, 3, 1 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 2, 513, 130, 256, 513, 130, 256)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2565 "./src/pmc/class.pmc"
    CTX_REG_STR(ctx, 0) = string_from_literal(interp, "exclude_method");
    CTX_REG_STR(ctx, 1) = string_from_literal(interp, "alias_method");

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2584 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    PMC* role = CTX_REG_PMC(ctx, 1);
    PMC* exclude_method = CTX_REG_PMC(ctx, 2);
    INTVAL has_exclude_method = CTX_REG_INT(ctx, 0);
    PMC* alias_method = CTX_REG_PMC(ctx, 3);
    INTVAL has_alias_method = CTX_REG_INT(ctx, 1);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1442 "./src/pmc/class.pmc"


    Parrot_Class *_class = PARROT_CLASS(pmc);

    /* Add everything on the resolve list to the exclude list; if we have
     * no exclude list, pass along the resolve list in its place if it has
     * any methods listed in it. */
    if (!has_exclude_method) {
        if (VTABLE_elements(interp, _class->resolve_method) != 0) {
            exclude_method     = _class->resolve_method;
            has_exclude_method = 1;
        }
    }
    else {
        int resolve_count = VTABLE_elements(interp, _class->resolve_method);
        int i;

        for (i = 0; i < resolve_count; i++) {
            STRING *meth_name = VTABLE_get_string_keyed_int(interp,
                _class->resolve_method, i);
            VTABLE_push_string(interp, exclude_method, meth_name);
        }
    }

    /* Do the composition. */
    Parrot_ComposeRole(interp, role, exclude_method, has_exclude_method,
                       alias_method, has_alias_method,
                       _class->methods, _class->roles);
#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 2640 "./src/pmc/class.c"
}
void
Parrot_Class_nci_inspect(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t param_indexes[] = { 0, 0, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 129, 256)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2676 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2693 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* what = CTX_REG_STR(ctx, 0);
    INTVAL has_what = CTX_REG_INT(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1482 "./src/pmc/class.pmc"

    PMC *found;

    /* Just delegate to the appropriate vtable method. */
    if (has_what)
        found = pmc->real_self->vtable->inspect_str(interp, pmc->real_self, what);
    else
        found = pmc->real_self->vtable->inspect(interp, pmc->real_self);

    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *found */
    /*BEGIN GENERATED ACCESSORS */
#line 2716 "./src/pmc/class.pmc"
    CTX_REG_PMC(ctx, 0) = found;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto inspect_returns;
    /*END PCCRETURN PMC *found */
    }
#line 1491 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
inspect_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 2759 "./src/pmc/class.c"
}
void
Parrot_Class_nci_isa(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t param_indexes[] = { 0, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 1)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2795 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2812 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* class_name = CTX_REG_STR(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1504 "./src/pmc/class.pmc"

    INTVAL isa = pmc->real_self->vtable->isa(interp, pmc->real_self, class_name);

    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN INTVAL isa */
    /*BEGIN GENERATED ACCESSORS */
#line 2828 "./src/pmc/class.pmc"
    CTX_REG_INT(ctx, 0) = isa;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(0)"), 0);
    goto isa_returns;
    /*END PCCRETURN INTVAL isa */
    }
#line 1507 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
isa_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 2871 "./src/pmc/class.c"
}
void
Parrot_Class_nci_does(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t param_indexes[] = { 0, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 1)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2907 "./src/pmc/class.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2924 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* role_name = CTX_REG_STR(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1520 "./src/pmc/class.pmc"

    INTVAL i, role_count, isa;
    PMC *role_list = (PMC_data_typed(pmc, Parrot_Class *))->roles;

    if (!role_list)
        #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN INTVAL 0 */
    /*BEGIN GENERATED ACCESSORS */
#line 2942 "./src/pmc/class.pmc"
    CTX_REG_INT(ctx, 0) = 0;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(0)"), 0);
    goto does_returns;
    /*END PCCRETURN INTVAL 0 */
    }
#line 1525 "./src/pmc/class.pmc"


    role_count = VTABLE_elements(interp, role_list);

    for (i = 0; i < role_count; i++) {
        INTVAL  role_does;
        PMC    *role       = VTABLE_get_pmc_keyed_int(interp, role_list, i);

        #line 551 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /*BEGIN PCCINVOKE role */
    {
      INTVAL   n_regs_used[]    = { 1, 0, 1, 1 };
      opcode_t arg_indexes[]    = { 0, 0 };
      opcode_t result_indexes[] = { 0 };
      PMC* _type                = pmc_new(interp, enum_class_FixedIntegerArray);

      PMC* args_sig         = Parrot_FixedIntegerArray_new_from_string(interp,
            _type, string_from_literal(interp, "(2, 1)"), 0);
      PMC* results_sig      = Parrot_FixedIntegerArray_new_from_string(interp,
            _type, string_from_literal(interp, "(0)"), 0);
      PMC* ret_cont         = new_ret_continuation_pmc(interp, NULL);

      parrot_context_t *ctx = Parrot_push_context(interp, n_regs_used);
      PMC* pccinvoke_meth;

      opcode_t* save_current_args = interp->current_args;
      PMC* save_args_signature    = interp->args_signature;
      PMC* save_current_object    = interp->current_object;

      interp->current_args        = arg_indexes;
      interp->args_signature      = args_sig;
      ctx->current_results        = result_indexes;
      ctx->results_signature      = results_sig;

#line 2992 "./src/pmc/class.pmc"


    CTX_REG_PMC(ctx, 0) = role;
    CTX_REG_STR(ctx, 0) = role_name;

#line 571 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

      interp->current_object       = role;
      interp->current_cont         = NEED_CONTINUATION;
      ctx->current_cont            = ret_cont;
      PMC_cont(ret_cont)->from_ctx = ctx;

      pccinvoke_meth = VTABLE_find_method(interp, role, string_from_literal(interp, "does"));
      if (PMC_IS_NULL(pccinvoke_meth))
          real_exception(interp, NULL, METH_NOT_FOUND,
            "Method '%Ss' not found", string_from_literal(interp, "does"));
      else
          VTABLE_invoke(interp, pccinvoke_meth, NULL);

#line 3012 "./src/pmc/class.pmc"
    role_does = CTX_REG_INT(ctx, 0);

#line 587 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

      PObj_live_CLEAR(_type);
      PObj_live_CLEAR(args_sig);
      PObj_live_CLEAR(results_sig);
      Parrot_pop_context(interp);

      interp->current_args   = save_current_args;
      interp->args_signature = save_args_signature;
      interp->current_object = save_current_object;
    }
    /*END PCCINVOKE string_from_literal(interp, "does") */
#line 1534 "./src/pmc/class.pmc"


        if (role_does)
            #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN INTVAL 1 */
    /*BEGIN GENERATED ACCESSORS */
#line 3035 "./src/pmc/class.pmc"
    CTX_REG_INT(ctx, 0) = 1;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(0)"), 0);
    goto does_returns;
    /*END PCCRETURN INTVAL 1 */
    }
#line 1537 "./src/pmc/class.pmc"

    }

    #line 551 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /*BEGIN PCCINVOKE pmc */
    {
      INTVAL   n_regs_used[]    = { 1, 0, 1, 1 };
      opcode_t arg_indexes[]    = { 0, 0 };
      opcode_t result_indexes[] = { 0 };
      PMC* _type                = pmc_new(interp, enum_class_FixedIntegerArray);

      PMC* args_sig         = Parrot_FixedIntegerArray_new_from_string(interp,
            _type, string_from_literal(interp, "(2, 1)"), 0);
      PMC* results_sig      = Parrot_FixedIntegerArray_new_from_string(interp,
            _type, string_from_literal(interp, "(0)"), 0);
      PMC* ret_cont         = new_ret_continuation_pmc(interp, NULL);

      parrot_context_t *ctx = Parrot_push_context(interp, n_regs_used);
      PMC* pccinvoke_meth;

      opcode_t* save_current_args = interp->current_args;
      PMC* save_args_signature    = interp->args_signature;
      PMC* save_current_object    = interp->current_object;

      interp->current_args        = arg_indexes;
      interp->args_signature      = args_sig;
      ctx->current_results        = result_indexes;
      ctx->results_signature      = results_sig;

#line 3080 "./src/pmc/class.pmc"


    CTX_REG_PMC(ctx, 0) = pmc;
    CTX_REG_STR(ctx, 0) = role_name;

#line 571 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

      interp->current_object       = pmc;
      interp->current_cont         = NEED_CONTINUATION;
      ctx->current_cont            = ret_cont;
      PMC_cont(ret_cont)->from_ctx = ctx;

      pccinvoke_meth = VTABLE_find_method(interp, pmc, string_from_literal(interp, "isa"));
      if (PMC_IS_NULL(pccinvoke_meth))
          real_exception(interp, NULL, METH_NOT_FOUND,
            "Method '%Ss' not found", string_from_literal(interp, "isa"));
      else
          VTABLE_invoke(interp, pccinvoke_meth, NULL);

#line 3100 "./src/pmc/class.pmc"
    isa = CTX_REG_INT(ctx, 0);

#line 587 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

      PObj_live_CLEAR(_type);
      PObj_live_CLEAR(args_sig);
      PObj_live_CLEAR(results_sig);
      Parrot_pop_context(interp);

      interp->current_args   = save_current_args;
      interp->args_signature = save_args_signature;
      interp->current_object = save_current_object;
    }
    /*END PCCINVOKE string_from_literal(interp, "isa") */
#line 1540 "./src/pmc/class.pmc"


    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN INTVAL isa */
    /*BEGIN GENERATED ACCESSORS */
#line 3122 "./src/pmc/class.pmc"
    CTX_REG_INT(ctx, 0) = isa;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(0)"), 0);
    goto does_returns;
    /*END PCCRETURN INTVAL isa */
    }
#line 1542 "./src/pmc/class.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
does_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 3165 "./src/pmc/class.c"
}
void
Parrot_Class_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Class");
}
void
Parrot_Class_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Class");
}
void
Parrot_Class_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Class");
}
void
Parrot_Class_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Class");
}
void
Parrot_Class_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Class");
}
void
Parrot_Class_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Class");
}
void
Parrot_Class_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Class");
}
void
Parrot_Class_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Class");
}
void
Parrot_Class_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Class");
}
void
Parrot_Class_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Class");
}
void
Parrot_Class_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Class");
}
PMC *
Parrot_Class_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Class_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Class");
}
void
Parrot_Class_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Class");
}
void
Parrot_Class_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Class");
}
void
Parrot_Class_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Class");
}
void
Parrot_Class_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Class");
}
void
Parrot_Class_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Class");
}
void
Parrot_Class_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Class");
}
FLOATVAL
Parrot_Class_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Class");
}
INTVAL
Parrot_Class_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Class");
}
PMC *
Parrot_Class_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Class");
}
STRING *
Parrot_Class_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Class");
}
void
Parrot_Class_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Class");
}
void
Parrot_Class_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Class");
}
void
Parrot_Class_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Class");
}
void
Parrot_Class_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Class");
}
void
Parrot_Class_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Class");
}
void
Parrot_Class_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Class");
}
void
Parrot_Class_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Class");
}
void
Parrot_Class_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Class");
}
void
Parrot_Class_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Class");
}
void
Parrot_Class_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Class");
}
void
Parrot_Class_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Class");
}
void
Parrot_Class_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Class");
}
void
Parrot_Class_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Class");
}
void
Parrot_Class_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Class");
}
void
Parrot_Class_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Class");
}
void
Parrot_Class_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Class");
}
void
Parrot_Class_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Class");
}
void
Parrot_Class_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Class");
}
void
Parrot_Class_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Class");
}
void
Parrot_Class_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Class");
}
void
Parrot_Class_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Class");
}
void
Parrot_Class_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Class");
}
void
Parrot_Class_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Class");
}
void
Parrot_Class_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Class");
}
void
Parrot_Class_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Class");
}
void
Parrot_Class_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Class");
}
void
Parrot_Class_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Class");
}
void
Parrot_Class_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Class");
}
void
Parrot_Class_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Class");
}
void
Parrot_Class_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Class");
}
void
Parrot_Class_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Class");
}
void
Parrot_Class_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Class");
}
void
Parrot_Class_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Class");
}
void
Parrot_Class_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Class");
}
void
Parrot_Class_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Class");
}
void
Parrot_Class_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Class");
}
void
Parrot_Class_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Class");
}
void
Parrot_Class_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Class");
}
FLOATVAL
Parrot_Class_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Class");
}
INTVAL
Parrot_Class_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Class");
}
PMC *
Parrot_Class_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Class");
}
STRING *
Parrot_Class_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Class");
}
void
Parrot_Class_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Class");
}
void
Parrot_Class_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Class");
}
void
Parrot_Class_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Class");
}
void
Parrot_Class_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Class");
}
void
Parrot_Class_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Class");
}
void
Parrot_Class_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Class");
}
void
Parrot_Class_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Class");
}
void
Parrot_Class_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_Class, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Class_add_attribute,
        Parrot_Class_add_method,
        Parrot_Class_add_parent,
        Parrot_Class_add_role,
        Parrot_Class_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Class_clone,
        Parrot_Class_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Class_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Class_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Class_init,
        Parrot_Class_init_pmc,
        Parrot_Class_inspect,
        Parrot_Class_inspect_str,
        Parrot_Class_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_Class_isa,
        Parrot_default_logical_not,
        Parrot_Class_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_Class_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_Class, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Class_ro_add_attribute,
        Parrot_Class_ro_add_method,
        Parrot_Class_ro_add_parent,
        Parrot_Class_ro_add_role,
        Parrot_Class_ro_add_vtable_override,
        Parrot_Class_ro_assign_pmc,
        Parrot_Class_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Class_clone,
        Parrot_Class_clone_pmc,
        Parrot_Class_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Class_ro_delete_keyed,
        Parrot_Class_ro_delete_keyed_int,
        Parrot_Class_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Class_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Class_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Class_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Class_ro_i_absolute,
        Parrot_Class_ro_i_bitwise_not,
        Parrot_Class_ro_i_bitwise_nots,
        Parrot_Class_ro_i_logical_not,
        Parrot_Class_ro_i_neg,
        Parrot_Class_ro_increment,
        Parrot_Class_init,
        Parrot_Class_init_pmc,
        Parrot_Class_inspect,
        Parrot_Class_inspect_str,
        Parrot_Class_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_Class_isa,
        Parrot_default_logical_not,
        Parrot_Class_mark,
        Parrot_Class_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Class_ro_pop_float,
        Parrot_Class_ro_pop_integer,
        Parrot_Class_ro_pop_pmc,
        Parrot_Class_ro_pop_string,
        Parrot_Class_ro_push_float,
        Parrot_Class_ro_push_integer,
        Parrot_Class_ro_push_pmc,
        Parrot_Class_ro_push_string,
        Parrot_Class_ro_remove_attribute,
        Parrot_Class_ro_remove_method,
        Parrot_Class_ro_remove_parent,
        Parrot_Class_ro_remove_role,
        Parrot_Class_ro_remove_vtable_override,
        Parrot_Class_ro_set_attr,
        Parrot_Class_ro_set_attr_str,
        Parrot_Class_ro_set_bignum_int,
        Parrot_Class_ro_set_bignum_num,
        Parrot_Class_ro_set_bignum_str,
        Parrot_Class_ro_set_bool,
        Parrot_Class_ro_set_integer_keyed,
        Parrot_Class_ro_set_integer_keyed_int,
        Parrot_Class_ro_set_integer_keyed_str,
        Parrot_Class_ro_set_integer_native,
        Parrot_Class_ro_set_integer_same,
        Parrot_Class_ro_set_number_keyed,
        Parrot_Class_ro_set_number_keyed_int,
        Parrot_Class_ro_set_number_keyed_str,
        Parrot_Class_ro_set_number_native,
        Parrot_Class_ro_set_number_same,
        Parrot_Class_ro_set_pmc,
        Parrot_Class_ro_set_pmc_keyed,
        Parrot_Class_ro_set_pmc_keyed_int,
        Parrot_Class_ro_set_pmc_keyed_str,
        Parrot_Class_ro_set_pointer,
        Parrot_Class_ro_set_pointer_keyed,
        Parrot_Class_ro_set_pointer_keyed_int,
        Parrot_Class_ro_set_pointer_keyed_str,
        Parrot_Class_ro_set_string_keyed,
        Parrot_Class_ro_set_string_keyed_int,
        Parrot_Class_ro_set_string_keyed_str,
        Parrot_Class_ro_set_string_native,
        Parrot_Class_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Class_ro_shift_float,
        Parrot_Class_ro_shift_integer,
        Parrot_Class_ro_shift_pmc,
        Parrot_Class_ro_shift_string,
        Parrot_default_slice,
        Parrot_Class_ro_splice,
        Parrot_Class_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Class_ro_thaw,
        Parrot_Class_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Class_ro_unshift_float,
        Parrot_Class_ro_unshift_integer,
        Parrot_Class_ro_unshift_pmc,
        Parrot_Class_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Class");
        vt_clone->isa_str = CONST_STRING(interp, "Class");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_name), "name");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_pmc_namespace), "pmc_namespace");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_resolve_method), "resolve_method");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_new), "new");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_attributes), "attributes");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_add_attribute), "add_attribute");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_methods), "methods");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_add_method), "add_method");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_find_method), "find_method");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_parents), "parents");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_add_parent), "add_parent");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_roles), "roles");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_add_role), "add_role");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_inspect), "inspect");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_isa), "isa");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_does), "does");
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_Class_class_init */
#line 1543 "./src/pmc/class.pmc"
 /* END pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd15_objects.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
