/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/closure.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/closure.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: closure.pmc 20995 2007-09-02 05:17:03Z chromatic $

=head1 NAME

src/pmc/closure.pmc - Closure PMC

=head1 DESCRIPTION

This class implements a closure, i.e. a subroutine which take a context
structure.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 37 "./src/pmc/closure.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_closure.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "closure.str"
void
Parrot_Closure_destroy(PARROT_INTERP, PMC *pmc)
{
#line 213 "./src/pmc/closure.pmc"

    Parrot_sub *sub = PMC_sub(pmc);

#if CTX_LEAK_DEBUG
    if (Interp_debug_TEST(interp, PARROT_CTX_DESTROY_DEBUG_FLAG)) {
        fprintf(stderr, "[destroy closure %p, context %p with %d refs]\n",
                (void *)pmc, (void *)sub->outer_ctx,
                (sub->outer_ctx ? sub->outer_ctx->ref_count : 0));
    }
#endif

    if (sub->outer_ctx) {
        Parrot_free_context(interp, sub->outer_ctx, 0);
        sub->outer_ctx = NULL;
    }

    Parrot_Sub_destroy(interp, pmc);
#line 66 "./src/pmc/closure.c"
}
void
Parrot_Closure_init(PARROT_INTERP, PMC *pmc)
{
#line 36 "./src/pmc/closure.pmc"

    PMC_struct_val(pmc) = new_closure(interp);
    PMC_pmc_val(pmc)    = PMCNULL;
    PObj_custom_mark_destroy_SETALL(pmc);
#if 0
    if (Interp_flags_TEST(interp, PARROT_DEBUG_FLAG))
        printf("Address of base segment is %p\n",
                (PMC_sub(pmc))->seg->base.pf->base.data);
#endif
#line 81 "./src/pmc/closure.c"
}
opcode_t  *
Parrot_Closure_invoke(PARROT_INTERP, PMC *pmc, void *in_next)
{
#line 89 "./src/pmc/closure.pmc"

    Parrot_sub *sub       = PMC_sub(pmc);
    opcode_t   *next      = Parrot_Sub_invoke(interp, pmc, in_next);
    PMC        *outer_sub = sub->outer_sub;

    if (sub->outer_ctx) {
        /* during newclosure, outer's ctx was stored in sub->outer_ctx */
        sub->ctx->outer_ctx = sub->outer_ctx;
    }
    else if ((PObj_get_FLAGS(outer_sub) & SUB_FLAG_IS_OUTER) &&
        PMC_sub(outer_sub)->ctx) {
        /* the sub was invoked earlier - it still has the context
         * due to the SUB_FLAG_IS_OUTER flag */
        sub->outer_ctx = sub->ctx->outer_ctx = PMC_sub(outer_sub)->ctx;
    }
    else {
        /* closure is just invoked - located :outer's ctx */
        parrot_context_t *caller = sub->ctx->caller_ctx;
        while (caller) {
            if (caller->current_sub == outer_sub) {
                PMC *cont      = caller->current_cont;
                cont->vtable   = interp->vtables[enum_class_Continuation];
                sub->outer_ctx = sub->ctx->outer_ctx = caller;

                caller->ref_count++;
                return next;
            }

            caller = caller->caller_ctx;
        }
        if (!caller) {
            /* outer has never been invoked, we fake a subroutine call
             * which builds the LexPad and return immediately
             * this will usually just lead to a Null PMC access
             * exception */

            PMC *cont;
            interp->current_cont = NEED_CONTINUATION;

            (void)VTABLE_invoke(interp, sub->outer_sub, next);

            caller               = CONTEXT(interp->ctx);
            cont                 = caller->current_cont;
            cont->vtable         = interp->vtables[enum_class_Continuation];
            sub->outer_ctx       = sub->ctx->outer_ctx = caller;
            caller->ref_count++;

            (void)VTABLE_invoke(interp, cont, next);
        }
    }

    return next;
#line 139 "./src/pmc/closure.c"
}
void
Parrot_Closure_mark(PARROT_INTERP, PMC *pmc)
{
#line 57 "./src/pmc/closure.pmc"

    Parrot_sub *sub = PMC_sub(pmc);
    Parrot_Sub_mark(interp, pmc);

    if (sub->outer_sub)
        pobject_lives(interp, (PObj*)sub->outer_sub);

    if (sub->outer_ctx)
        mark_context(interp, sub->outer_ctx);
#line 154 "./src/pmc/closure.c"
}
void
Parrot_Closure_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 83 "./src/pmc/closure.pmc"

    Parrot_sub *sub  = PMC_sub(pmc);
    opcode_t   *addr = (opcode_t *)value;
    sub->start_offs  = addr -  sub->seg->base.data;
#line 164 "./src/pmc/closure.c"
}
void
Parrot_Closure_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 143 "./src/pmc/closure.pmc"

    Parrot_sub *sub = PMC_sub(pmc);
    opcode_t    i;
    PackFile_FixupTable *ft;
    PackFile_ConstTable *ct;

    /*
     * XXX TODO
     *
     * A Sub PMC is frozen/thawed per item, OTOH it can refer to other
     * subs via the outer_sub (:outer) syntax. This outer though, is created
     * independently when running from .pbc, which breaks referential
     * integrity.
     *
     * The only fix (except this ugly and slow code) is to freeze/thaw
     * a code segment as one structure, which will take care of all
     * refs and self-refs.
     *
     * TODO - intermediate step:
     *
     * Investigate if we can:
     * - freeze array of subs (instead of the useless fixup seg)
     * - do we need the Sub constant in the const seg as PMC constant?
     */

    if (PMC_IS_NULL(sub->outer_sub))
        return;

    ft = sub->seg->fixups;
    ct = sub->seg->const_table;

    for (i = 0; i < ft->fixup_count; i++) {
        switch (ft->fixups[i]->type) {
            opcode_t ci;
            PMC     *outer;
            case enum_fixup_sub:
                ci = ft->fixups[i]->offset;

                /* not yet thawed */
                if (ci < 0 || ci >= ct->const_count - 1)
                    return;

                /* same */
                if (ct->constants[ci]->type != PFC_PMC)
                    return;

                outer = ct->constants[ci]->u.key;

                if (PMC_IS_NULL(outer))
                    continue;

                if (0 == string_equal(interp, PMC_sub(outer)->name,
                            PMC_sub(sub->outer_sub)->name)) {
                    sub->outer_sub = outer;
                    break;
                }
        }
    }
#line 228 "./src/pmc/closure.c"
}
void
Parrot_Closure_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Closure");
}
void
Parrot_Closure_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Closure");
}
void
Parrot_Closure_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Closure");
}
void
Parrot_Closure_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Closure");
}
void
Parrot_Closure_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Closure");
}
void
Parrot_Closure_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Closure");
}
void
Parrot_Closure_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Closure");
}
void
Parrot_Closure_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Closure");
}
void
Parrot_Closure_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Closure");
}
void
Parrot_Closure_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Closure");
}
void
Parrot_Closure_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Closure");
}
PMC *
Parrot_Closure_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Closure_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Closure");
}
void
Parrot_Closure_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Closure");
}
void
Parrot_Closure_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Closure");
}
void
Parrot_Closure_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Closure");
}
void
Parrot_Closure_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Closure");
}
void
Parrot_Closure_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Closure");
}
void
Parrot_Closure_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Closure");
}
FLOATVAL
Parrot_Closure_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Closure");
}
INTVAL
Parrot_Closure_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Closure");
}
PMC *
Parrot_Closure_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Closure");
}
STRING *
Parrot_Closure_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Closure");
}
void
Parrot_Closure_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Closure");
}
void
Parrot_Closure_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Closure");
}
void
Parrot_Closure_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Closure");
}
void
Parrot_Closure_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Closure");
}
void
Parrot_Closure_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Closure");
}
void
Parrot_Closure_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Closure");
}
void
Parrot_Closure_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Closure");
}
void
Parrot_Closure_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Closure");
}
void
Parrot_Closure_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Closure");
}
void
Parrot_Closure_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Closure");
}
FLOATVAL
Parrot_Closure_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Closure");
}
INTVAL
Parrot_Closure_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Closure");
}
PMC *
Parrot_Closure_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Closure");
}
STRING *
Parrot_Closure_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Closure");
}
void
Parrot_Closure_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Closure");
}
void
Parrot_Closure_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Closure");
}
void
Parrot_Closure_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Closure");
}
void
Parrot_Closure_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Closure");
}
void
Parrot_Closure_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Closure");
}
void
Parrot_Closure_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Closure");
}
void
Parrot_Closure_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Closure");
}
void
Parrot_Closure_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_Closure, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_Sub_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Sub_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Closure_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Sub_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Sub_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Closure_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Closure_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Closure_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Sub_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Closure_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Sub_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Sub_thaw,
        Parrot_Closure_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Sub_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_Closure, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Closure_ro_add_attribute,
        Parrot_Closure_ro_add_method,
        Parrot_Closure_ro_add_parent,
        Parrot_Closure_ro_add_role,
        Parrot_Closure_ro_add_vtable_override,
        Parrot_Closure_ro_assign_pmc,
        Parrot_Closure_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Sub_clone,
        Parrot_default_clone_pmc,
        Parrot_Closure_ro_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Closure_ro_delete_keyed,
        Parrot_Closure_ro_delete_keyed_int,
        Parrot_Closure_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Closure_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Closure_ro_find_method,
        Parrot_Sub_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Sub_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Closure_ro_i_absolute,
        Parrot_Closure_ro_i_bitwise_not,
        Parrot_Closure_ro_i_bitwise_nots,
        Parrot_Closure_ro_i_logical_not,
        Parrot_Closure_ro_i_neg,
        Parrot_Closure_ro_increment,
        Parrot_Closure_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Closure_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Closure_mark,
        Parrot_Closure_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Closure_ro_pop_float,
        Parrot_Closure_ro_pop_integer,
        Parrot_Closure_ro_pop_pmc,
        Parrot_Closure_ro_pop_string,
        Parrot_Closure_ro_push_float,
        Parrot_Closure_ro_push_integer,
        Parrot_Closure_ro_push_pmc,
        Parrot_Closure_ro_push_string,
        Parrot_Closure_ro_remove_attribute,
        Parrot_Closure_ro_remove_method,
        Parrot_Closure_ro_remove_parent,
        Parrot_Closure_ro_remove_role,
        Parrot_Closure_ro_remove_vtable_override,
        Parrot_Closure_ro_set_attr,
        Parrot_Closure_ro_set_attr_str,
        Parrot_Closure_ro_set_bignum_int,
        Parrot_Closure_ro_set_bignum_num,
        Parrot_Closure_ro_set_bignum_str,
        Parrot_Closure_ro_set_bool,
        Parrot_Closure_ro_set_integer_keyed,
        Parrot_Closure_ro_set_integer_keyed_int,
        Parrot_Closure_ro_set_integer_keyed_str,
        Parrot_Closure_ro_set_integer_native,
        Parrot_Closure_ro_set_integer_same,
        Parrot_Closure_ro_set_number_keyed,
        Parrot_Closure_ro_set_number_keyed_int,
        Parrot_Closure_ro_set_number_keyed_str,
        Parrot_Closure_ro_set_number_native,
        Parrot_Closure_ro_set_number_same,
        Parrot_Closure_ro_set_pmc,
        Parrot_Closure_ro_set_pmc_keyed,
        Parrot_Closure_ro_set_pmc_keyed_int,
        Parrot_Closure_ro_set_pmc_keyed_str,
        Parrot_Closure_ro_set_pointer,
        Parrot_Closure_ro_set_pointer_keyed,
        Parrot_Closure_ro_set_pointer_keyed_int,
        Parrot_Closure_ro_set_pointer_keyed_str,
        Parrot_Closure_ro_set_string_keyed,
        Parrot_Closure_ro_set_string_keyed_int,
        Parrot_Closure_ro_set_string_keyed_str,
        Parrot_Closure_ro_set_string_native,
        Parrot_Closure_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Closure_ro_shift_float,
        Parrot_Closure_ro_shift_integer,
        Parrot_Closure_ro_shift_pmc,
        Parrot_Closure_ro_shift_string,
        Parrot_default_slice,
        Parrot_Closure_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Closure_ro_thaw,
        Parrot_Closure_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Closure_ro_unshift_float,
        Parrot_Closure_ro_unshift_integer,
        Parrot_Closure_ro_unshift_pmc,
        Parrot_Closure_ro_unshift_string,
        Parrot_Sub_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Closure");
        vt_clone->isa_str = CONST_STRING(interp, "Closure Sub");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_Closure_class_init */
#line 230 "./src/pmc/closure.pmc"


/*

=back

=head1 HISTORY

Initial version by Leo.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
