/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/continuation.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/continuation.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: continuation.pmc 21070 2007-09-04 07:08:50Z chromatic $

=head1 NAME

src/pmc/continuation.pmc - Continuation PMC

=head1 DESCRIPTION

A C<Continuation> has a copy of the interpreter's context at the location where
the Continuation was constructed.  See the L<Glossary|docs/glossary.pod> for
more information.

=head2 Functions

=over 4

=cut

*/


#include "parrot/parrot.h"
#include "parrot/oplib/ops.h"

/*

=back

=head2 Methods

=over 4

=cut

*/


/*
 * A Continuation (and RetContinuation, Exception_Handler) has in its
 * context a pointer to the register frame, which contains active objects.
 * Additionally ct->current_cont has the continuation of the caller.
 * To avoid deep recursion during marking of nested subroutines, we
 * need the next_for_GC pointer in the pmc_ext area.
 */
#line 61 "./src/pmc/continuation.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_continuation.h"
#include "pmc_default.h"
#include "continuation.str"
PMC  *
Parrot_Continuation_clone(PARROT_INTERP, PMC *pmc)
{
#line 128 "./src/pmc/continuation.pmc"

    Parrot_cont *cc_self = PMC_cont(pmc);
    Parrot_cont *cc      = new_continuation(interp, cc_self);
    PMC         *ret     = pmc_new_noinit(interp, enum_class_Continuation);

    PObj_custom_mark_destroy_SETALL(ret);
    cc->runloop_id       = cc_self->runloop_id;
    cc->dynamic_state    = cc_self->dynamic_state;
    PMC_struct_val(ret)  = cc;
    PMC_pmc_val(ret)     = PMC_pmc_val(pmc);

    return ret;
#line 84 "./src/pmc/continuation.c"
}
INTVAL
Parrot_Continuation_defined(PARROT_INTERP, PMC *pmc)
{
#line 208 "./src/pmc/continuation.pmc"

    return PMC_cont(pmc)->address != NULL;
#line 92 "./src/pmc/continuation.c"
}
void
Parrot_Continuation_destroy(PARROT_INTERP, PMC *pmc)
{
#line 102 "./src/pmc/continuation.pmc"

    Parrot_cont *cc = PMC_cont(pmc);
    if (cc) {
#if CTX_LEAK_DEBUG
        if (Interp_debug_TEST(interp, PARROT_CTX_DESTROY_DEBUG_FLAG)) {
            fprintf(stderr,
                    "[destroy cont    %p, to_ctx %p, from_ctx %p]\n",
                    (void *)pmc, (void *)cc->to_ctx, (void *)cc->from_ctx);
        }
#endif
        if (cc->from_ctx)
            Parrot_free_context(interp, cc->from_ctx, 0);
        mem_sys_free(cc);
        PMC_struct_val(pmc) = NULL;
    }
#line 113 "./src/pmc/continuation.c"
}
INTVAL
Parrot_Continuation_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 212 "./src/pmc/continuation.pmc"

    return PMC_cont(pmc)->address != NULL;
#line 121 "./src/pmc/continuation.c"
}
void  *
Parrot_Continuation_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 193 "./src/pmc/continuation.pmc"

    return PMC_cont(pmc)->address;
#line 129 "./src/pmc/continuation.c"
}
STRING  *
Parrot_Continuation_get_string(PARROT_INTERP, PMC *pmc)
{
#line 397 "./src/pmc/continuation.pmc"

    return Parrot_Context_infostr(interp, PMC_cont(pmc)->to_ctx);
#line 137 "./src/pmc/continuation.c"
}
void
Parrot_Continuation_init(PARROT_INTERP, PMC *pmc)
{
#line 60 "./src/pmc/continuation.pmc"

    PMC_struct_val(pmc) = new_continuation(interp, NULL);
    PMC_pmc_val(pmc)    = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
    /* PANIC("don't do that"); */
    /*
     * Whenever we create a continuation, all return continuations
     * up the call chain maybe reused due to invoking the
     * continuation. To avoid that all return continuations are
     * converted to true continuations.
     */
    invalidate_retc_context(interp, pmc);
#line 155 "./src/pmc/continuation.c"
}
opcode_t  *
Parrot_Continuation_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 227 "./src/pmc/continuation.pmc"

    Parrot_cont      *cc           = PMC_cont(pmc);
    Stack_Chunk_t    *stack_target = cc->dynamic_state;
    int               stack_delta  = 0;
    parrot_context_t *from_ctx     = CONTEXT(interp->ctx);
    parrot_context_t *to_ctx       = cc->to_ctx;
    opcode_t         *pc           = cc->address;
    Stack_Chunk_t    *corresponding_target;

    int exception_continuation_p
        = VTABLE_isa(interp, pmc,CONST_STRING(interp,"Exception_Handler"));
    int ret_continuation_p
        = VTABLE_isa(interp, pmc, CONST_STRING(interp, "RetContinuation"));

    if (interp->current_runloop_id != cc->runloop_id
        /* it's ok if we are exiting to "runloop 0"; there is no such
           runloop, but the only continuation that thinks it came from
           runloop 0 is for the return from the initial sub call. */
        && cc->runloop_id != 0
        /* since a RetContinuation [currently] only returns to the next
           outer frame, exiting to the inner run loop does the right thing,
           since it normally returns to the next outer runloop anyway.  */
        && ! ret_continuation_p) {
        fprintf(stderr, "[oops; continuation %p of type %d "
                "is trying to jump from runloop %d to runloop %d]\n",
                (void *) pmc, (int) pmc->vtable->base_type,
                interp->current_runloop_id, cc->runloop_id);
    }
#if CTX_LEAK_DEBUG
    if (Interp_debug_TEST(interp, PARROT_CTX_DESTROY_DEBUG_FLAG)) {
        fprintf(stderr,
                "[invoke cont    %p, to_ctx %p, from_ctx %p (refs %d)]\n",
                (void *) pmc, (void *) to_ctx, (void *) from_ctx, (int) from_ctx->ref_count);
    }
#endif
    if (! to_ctx)
        real_exception(interp, NULL, INVALID_OPERATION,
                       "Continuation invoked after deactivation.");

    /*
     * Rewind the dynamic environment.
     */
    if (interp->dynamic_env != stack_target) {
        /* compute the "stack delta", which is a measure of how much
           unwinding we have to do.  if negative, we have to pop that many
           entries; if positive, we are going back up the stack.
           [bug: this is not true rewinding.  -- rgr, 30-Sep-06.]
        */
        stack_delta
            = ((int) stack_height(interp, stack_target) -
               (int) stack_height(interp, interp->dynamic_env));
    }
    /* descend down the target stack until we get to the same depth. */
    corresponding_target = stack_target;
    while (stack_delta > 0) {
        corresponding_target = corresponding_target->prev;
        stack_delta--;
    }

    /* both stacks are now at the same depth.  pop from both until we reach
       their common ancestor. */
    while (interp->dynamic_env != corresponding_target) {
        PMC           *cleanup_sub = NULL;
        Stack_Entry_t *e;

        if (! interp->dynamic_env)
            real_exception(interp, NULL, 1, "Control stack damaged");

        e = stack_entry(interp, interp->dynamic_env, 0);

        if (!e)
            real_exception(interp, NULL, 1, "Control stack damaged");

        if (e->entry_type == STACK_ENTRY_ACTION) {
            /*
             * Disable automatic cleanup routine execution in stack_pop so
             * that we can run the action subroutine manually.  This is
             * because we have to run the sub AFTER it has been popped, lest
             * a new error in the sub cause an infinite loop when invoking
             * an error handler.
             */
            cleanup_sub = UVal_pmc(e->entry);
            e->cleanup  = STACK_CLEANUP_NULL;
        }

        (void)stack_pop(interp, &interp->dynamic_env,
                        NULL, NO_STACK_ENTRY_TYPE);

        /* Now it's safe to run. */
        if (cleanup_sub)
            Parrot_runops_fromc_args(interp, cleanup_sub,
                                     "vI", exception_continuation_p);

        /* Keep corresponding_target in sync.  If stack_delta is negative,
         * then dynamic_env is still above it; otherwise, we must step
         * corresponding_target backwards as well.
         */
        if (stack_delta < 0)
            stack_delta++;
        else
            corresponding_target = corresponding_target->prev;
    }

    /* run back up the target stack to our destination.  [when we support
       dynamic binding (e.g.), we will have to traverse back up, and will
       therefore need to keep track on the way down.  -- rgr, 30-Sep-06.] */
    interp->dynamic_env = stack_target;

    /* debug print before context is switched */
    if (Interp_trace_TEST(interp, PARROT_TRACE_SUB_CALL_FLAG)) {
        PMC *sub = to_ctx->current_sub;

        PIO_eprintf(interp, "# Back in sub '%Ss', env %p\n",
                    Parrot_full_sub_name(interp, sub),
                    interp->dynamic_env);
    }

    /* set context */
    CONTEXT(interp->ctx) = to_ctx;
    interp->ctx.bp       = to_ctx->bp;
    interp->ctx.bp_ps    = to_ctx->bp_ps;

    /* RetContinuation arg passing is handled elsewhere. */
    if (ret_continuation_p)
        return pc;

    /* pass args */
    if (cc->current_results) {
        /* where caller wants result */
        to_ctx->current_results = cc->current_results;
    }

    if (to_ctx->current_results && interp->current_args) {
        opcode_t *src_indexes, *dest_indexes;
        /*
         * the register pointer is already switched back
         * to the caller, therefore the registers of the
         * sub we are returning from aren't marked, if
         * inside argument passing a DOD run is triggered
         * therefore we have to block DOD
         */
        src_indexes          = interp->current_args;
        interp->current_args = NULL;
        dest_indexes         = to_ctx->current_results;

        Parrot_block_DOD(interp);
        parrot_pass_args(interp, from_ctx, to_ctx,
                         src_indexes, dest_indexes, PARROT_PASS_PARAMS);
        Parrot_unblock_DOD(interp);
    }

    /* switch segment */
    interp->current_args = NULL;

    if (interp->code != cc->seg)
        Parrot_switch_to_cs(interp, cc->seg, 1);

    return pc;
#line 319 "./src/pmc/continuation.c"
}
void
Parrot_Continuation_mark(PARROT_INTERP, PMC *pmc)
{
#line 84 "./src/pmc/continuation.pmc"

    Parrot_cont *cc = PMC_cont(pmc);
    if (cc->to_ctx)
        mark_context(interp, cc->to_ctx);
    if (cc->dynamic_state)
        mark_stack(interp, cc->dynamic_state);
#line 331 "./src/pmc/continuation.c"
}
void
Parrot_Continuation_set_pmc(PARROT_INTERP, PMC *pmc, PMC *src)
{
#line 151 "./src/pmc/continuation.pmc"

    Parrot_cont * const cc_self = PMC_cont(pmc);
    Parrot_cont * const cc_src  = PMC_cont(src);

    STRUCT_COPY(cc_self, cc_src);
    PMC_pmc_val(pmc) = PMC_pmc_val(src);
#line 343 "./src/pmc/continuation.c"
}
void
Parrot_Continuation_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 169 "./src/pmc/continuation.pmc"

    opcode_t    *pos  = (opcode_t *)value;
    Parrot_cont *cc   = PMC_cont(pmc);

    cc->address       = (opcode_t *)value;
    cc->dynamic_state = interp->dynamic_env;
    cc->runloop_id    = interp->current_runloop_id;

    if (pos && *pos == PARROT_OP_get_results_pc)
        cc->current_results = pos;
    else
        cc->current_results = NULL;
#line 361 "./src/pmc/continuation.c"
}
PMC  *
Parrot_Continuation_nci_caller(PARROT_INTERP, PMC *pmc)
{
#line 411 "./src/pmc/continuation.pmc"

    Parrot_cont *cc     = PMC_cont(pmc);
    PMC         *caller = cc->to_ctx->current_sub;

    if (!caller || !PMC_sub(caller)->seg)
        caller = pmc_new(interp, enum_class_Undef);

    return caller;
#line 375 "./src/pmc/continuation.c"
}
PMC  *
Parrot_Continuation_nci_continuation(PARROT_INTERP, PMC *pmc)
{
#line 430 "./src/pmc/continuation.pmc"

    Parrot_cont *cc   = PMC_cont(pmc);
    PMC         *cont = cc->to_ctx->current_cont;

    if (cont)
        return cont;

    return pmc_new(interp, enum_class_Undef);
#line 389 "./src/pmc/continuation.c"
}
void
Parrot_Continuation_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Continuation");
}
PMC *
Parrot_Continuation_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Continuation_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Continuation");
}
FLOATVAL
Parrot_Continuation_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Continuation");
}
INTVAL
Parrot_Continuation_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Continuation");
}
PMC *
Parrot_Continuation_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Continuation");
}
STRING *
Parrot_Continuation_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Continuation");
}
FLOATVAL
Parrot_Continuation_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Continuation");
}
INTVAL
Parrot_Continuation_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Continuation");
}
PMC *
Parrot_Continuation_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Continuation");
}
STRING *
Parrot_Continuation_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Continuation");
}
void
Parrot_Continuation_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Continuation");
}
void
Parrot_Continuation_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_Continuation, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Continuation_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_Continuation_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Continuation_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Continuation_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Continuation_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Continuation_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Continuation_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Continuation_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Continuation_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Continuation_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Continuation_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_Continuation, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Continuation_ro_add_attribute,
        Parrot_Continuation_ro_add_method,
        Parrot_Continuation_ro_add_parent,
        Parrot_Continuation_ro_add_role,
        Parrot_Continuation_ro_add_vtable_override,
        Parrot_Continuation_ro_assign_pmc,
        Parrot_Continuation_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Continuation_clone,
        Parrot_default_clone_pmc,
        Parrot_Continuation_ro_decrement,
        Parrot_Continuation_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Continuation_ro_delete_keyed,
        Parrot_Continuation_ro_delete_keyed_int,
        Parrot_Continuation_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Continuation_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Continuation_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Continuation_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Continuation_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Continuation_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Continuation_ro_i_absolute,
        Parrot_Continuation_ro_i_bitwise_not,
        Parrot_Continuation_ro_i_bitwise_nots,
        Parrot_Continuation_ro_i_logical_not,
        Parrot_Continuation_ro_i_neg,
        Parrot_Continuation_ro_increment,
        Parrot_Continuation_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Continuation_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Continuation_mark,
        Parrot_Continuation_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Continuation_ro_pop_float,
        Parrot_Continuation_ro_pop_integer,
        Parrot_Continuation_ro_pop_pmc,
        Parrot_Continuation_ro_pop_string,
        Parrot_Continuation_ro_push_float,
        Parrot_Continuation_ro_push_integer,
        Parrot_Continuation_ro_push_pmc,
        Parrot_Continuation_ro_push_string,
        Parrot_Continuation_ro_remove_attribute,
        Parrot_Continuation_ro_remove_method,
        Parrot_Continuation_ro_remove_parent,
        Parrot_Continuation_ro_remove_role,
        Parrot_Continuation_ro_remove_vtable_override,
        Parrot_Continuation_ro_set_attr,
        Parrot_Continuation_ro_set_attr_str,
        Parrot_Continuation_ro_set_bignum_int,
        Parrot_Continuation_ro_set_bignum_num,
        Parrot_Continuation_ro_set_bignum_str,
        Parrot_Continuation_ro_set_bool,
        Parrot_Continuation_ro_set_integer_keyed,
        Parrot_Continuation_ro_set_integer_keyed_int,
        Parrot_Continuation_ro_set_integer_keyed_str,
        Parrot_Continuation_ro_set_integer_native,
        Parrot_Continuation_ro_set_integer_same,
        Parrot_Continuation_ro_set_number_keyed,
        Parrot_Continuation_ro_set_number_keyed_int,
        Parrot_Continuation_ro_set_number_keyed_str,
        Parrot_Continuation_ro_set_number_native,
        Parrot_Continuation_ro_set_number_same,
        Parrot_Continuation_ro_set_pmc,
        Parrot_Continuation_ro_set_pmc_keyed,
        Parrot_Continuation_ro_set_pmc_keyed_int,
        Parrot_Continuation_ro_set_pmc_keyed_str,
        Parrot_Continuation_ro_set_pointer,
        Parrot_Continuation_ro_set_pointer_keyed,
        Parrot_Continuation_ro_set_pointer_keyed_int,
        Parrot_Continuation_ro_set_pointer_keyed_str,
        Parrot_Continuation_ro_set_string_keyed,
        Parrot_Continuation_ro_set_string_keyed_int,
        Parrot_Continuation_ro_set_string_keyed_str,
        Parrot_Continuation_ro_set_string_native,
        Parrot_Continuation_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Continuation_ro_shift_float,
        Parrot_Continuation_ro_shift_integer,
        Parrot_Continuation_ro_shift_pmc,
        Parrot_Continuation_ro_shift_string,
        Parrot_default_slice,
        Parrot_Continuation_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Continuation_ro_thaw,
        Parrot_Continuation_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Continuation_ro_unshift_float,
        Parrot_Continuation_ro_unshift_integer,
        Parrot_Continuation_ro_unshift_pmc,
        Parrot_Continuation_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Continuation");
        vt_clone->isa_str = CONST_STRING(interp, "Continuation");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_Continuation_nci_caller), "caller", "PJO");
        register_nci_method(interp, entry,
                F2DPTR(Parrot_Continuation_nci_continuation), "continuation", "PJO");
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_Continuation_class_init */
#line 438 "./src/pmc/continuation.pmc"


/*

=back

=head1 HISTORY

Initial revision by sean 2002/08/04.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
