/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/default.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/default.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: default.pmc 21488 2007-09-22 17:05:10Z paultcochrane $

=head1 NAME

src/pmc/default.pmc - Abstract root class

=head1 DESCRIPTION

These are the vtable functions for the default PMC class.

All methods which are not defined here get a default implementation
generated from F<vtable.tbl> by F<tools/build/pmc2c.pl>.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#define INT2KEY(i,k) key_new_integer((i), (k))

/* undef 'interface', because msvc is craptastic */
#undef interface

/*

=item C<static const char *caller(PARROT_INTERP, PMC *pmc)>

Returns a C string for the name of C<*pmc>.

=cut

*/

static const char *
caller(PARROT_INTERP, PMC *pmc /*NULLOK*/)
{
    return pmc && pmc->vtable && pmc->vtable->whoami ?
        VTABLE_name(interp, pmc)->strstart : "(null)";
}

/*

=item C<static void cant_do_method(PARROT_INTERP, PMC *pmc,
                                   const char *methname)>

Throws an exception "$methname() not implemented in class '$class'", used by
all unimplemented messages.

=cut

*/

static void
cant_do_method(PARROT_INTERP, PMC *pmc /*NULLOK*/, const char *methname)
{
    real_exception(interp, NULL, ILL_INHERIT,
                       "%s() not implemented in class '%s'", methname,
                       caller(interp, pmc));
}

/*

=item C<static INTVAL
check_set_std_props(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)>

Called from C<setprop()>.

Returns a true value if C<setprop()> can avoid actually setting a property
in the prophash. If it returns true, the property setting will be reflected
in a future call to C<propagate_std_props()>

=cut

*/

static INTVAL
check_set_std_props(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    /* the quick hack below cannot be used because the string could
       be constructed in an interpreter that is later destroyed */
#if  0
    /* XXX
     * a quick hack, to prevent freeing that string during DOD
     * triggered in t/pmc/pmc_62.t when configured with --gc=libc
     */
    static STRING *ro;
    if (!ro)
        ro = string_make(interp, "_ro", 3, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG);
    if (!string_compare(interp, key, ro)) {
#else

    /*
     * s2 in string_compare is freed here
     */
    if (!string_compare(interp, key, string_from_cstring(interp, "_ro", 3))) {
#endif
        /* pmc should set/clear readonly */
        const INTVAL on = VTABLE_get_bool(interp, value);

        /* morph to Const/normal class or readonly class */
        /* XXX warn when this fails? */
        if (on && (pmc->vtable->flags & VTABLE_HAS_CONST_TOO))
            pmc->vtable = interp->vtables[pmc->vtable->base_type + 1];
        else if (!on && (pmc->vtable->flags & (VTABLE_IS_CONST_FLAG)))
            VTABLE_morph(interp, pmc, pmc->vtable->base_type - 1);
        else if (on && (pmc->vtable->flags & VTABLE_HAS_READONLY_FLAG))
            pmc->vtable = pmc->vtable->ro_variant_vtable;
        else if (!on && (pmc->vtable->flags & VTABLE_IS_READONLY_FLAG)
                && pmc->vtable->ro_variant_vtable)
            pmc->vtable = pmc->vtable->ro_variant_vtable;
        else
            return 0;

        return 1;
    }

    return 0;
}

/*

=item C<static void
propagate_std_props(PARROT_INTERP, PMC *self, PMC *prop_hash)>

Set pending standard properties in C<prop_hash>.

=cut

*/

static void
propagate_std_props(PARROT_INTERP, PMC *self, PMC *prop_hash) {
    if (self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG)){
        PMC * const pmc_true  = pmc_new(interp, enum_class_Integer);
        PMC_int_val(pmc_true) = 1;
        VTABLE_set_pmc_keyed_str(interp, prop_hash,
            string_from_cstring(interp, "_ro", 3), pmc_true);
    }
}

/*

=item C<static INTVAL
has_pending_std_props(PMC *self)>

Returns true if propagate_std_props() would create a non-empty prophash.

=cut

*/

static INTVAL
has_pending_std_props(PMC *self) {
    if (self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG))
        return 1;
    else
        return 0;
}


/*

=item C<static PMC*
check_get_std_props(PARROT_INTERPeter, PMC *self, STRING *key)>

Checks if we can infer the value of C<key> property from C<self> without
looking at its prophash. Returns C<PMCNULL> if not, returns the value otherwise.

=cut
*/

static PMC*
check_get_std_props(PARROT_INTERP, PMC *self, STRING *key) {
    if ((self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG))
        &&!string_compare(interp, key, string_from_cstring(interp, "_ro", 3))) {
        PMC * const ret_val  = pmc_new(interp, enum_class_Integer);
        PMC_int_val(ret_val) = 1;
        return ret_val;
    }
    else
        return PMCNULL;
}

/*

=item C<static PMC *
make_prop_hash(PARROT_INTERP, PMC *self)>

Create a property hash for C<self>. Returns the created hash. Inferred
properties will be added to the hash and it will be set as
C<PMC_metadata(self)>.

=cut

*/

static PMC*
make_prop_hash(PARROT_INTERP, PMC *self) {
    PMC *prop;

    if (!self->pmc_ext)
        add_pmc_ext(interp, self);

    PMC_metadata(self) = prop = pmc_new_noinit(interp, enum_class_Hash);
    DOD_WRITE_BARRIER(interp, self, NULL, prop);
    VTABLE_init(interp, prop);
    propagate_std_props(interp, self, prop);
    return prop;
}

/*

=item C<static INTVAL
does_isa(PARROT_INTERP, STRING *method, STRING *what)>

Compares C<*method> and C<*what>.
Returns true (1) if B<method> is found in B<what>, false (0) otherwise.

=cut

*/

static INTVAL
does_isa(PARROT_INTERP, const STRING *method, const STRING *what)
{
    INTVAL pos = 0;

    do {
        INTVAL len;

        pos = string_str_index(interp, what, method, pos);

        if (pos < 0)
            return 0;

        if (pos >= (INTVAL)string_length(interp, what))
            return 0;

        len = string_length(interp, method);

        if (pos && string_index(interp, what, pos - 1) != 32) {
            pos += len;
            continue;
        }

        if (pos+len < (INTVAL)string_length(interp, what) &&
            string_index(interp, what, pos + len) != 32) {
            pos += len;
            continue;
        }

        return 1;
    } while (1);
}
#line 277 "./src/pmc/default.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_default.h"
#include "pmc_default.h"
#include "default.str"
PMC *
Parrot_default_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "add");
    return PMCNULL;
}
PMC *
Parrot_default_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "add_int");
    return PMCNULL;
}
PMC *
Parrot_default_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "add_float");
    return PMCNULL;
}
void
Parrot_default_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_add");
    
}
void
Parrot_default_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_add_int");
    
}
void
Parrot_default_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_add_float");
    
}
PMC *
Parrot_default_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "subtract");
    return PMCNULL;
}
PMC *
Parrot_default_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "subtract_int");
    return PMCNULL;
}
PMC *
Parrot_default_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "subtract_float");
    return PMCNULL;
}
void
Parrot_default_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_subtract");
    
}
void
Parrot_default_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_subtract_int");
    
}
void
Parrot_default_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_subtract_float");
    
}
PMC *
Parrot_default_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "multiply");
    return PMCNULL;
}
PMC *
Parrot_default_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "multiply_int");
    return PMCNULL;
}
PMC *
Parrot_default_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "multiply_float");
    return PMCNULL;
}
void
Parrot_default_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_multiply");
    
}
void
Parrot_default_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_multiply_int");
    
}
void
Parrot_default_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_multiply_float");
    
}
PMC *
Parrot_default_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "divide");
    return PMCNULL;
}
PMC *
Parrot_default_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "divide_int");
    return PMCNULL;
}
PMC *
Parrot_default_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "divide_float");
    return PMCNULL;
}
void
Parrot_default_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_divide");
    
}
void
Parrot_default_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_divide_int");
    
}
void
Parrot_default_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_divide_float");
    
}
PMC *
Parrot_default_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "floor_divide");
    return PMCNULL;
}
PMC *
Parrot_default_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "floor_divide_int");
    return PMCNULL;
}
PMC *
Parrot_default_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "floor_divide_float");
    return PMCNULL;
}
void
Parrot_default_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_floor_divide");
    
}
void
Parrot_default_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_floor_divide_int");
    
}
void
Parrot_default_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_floor_divide_float");
    
}
PMC *
Parrot_default_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "modulus");
    return PMCNULL;
}
PMC *
Parrot_default_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "modulus_int");
    return PMCNULL;
}
PMC *
Parrot_default_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "modulus_float");
    return PMCNULL;
}
void
Parrot_default_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_modulus");
    
}
void
Parrot_default_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_modulus_int");
    
}
void
Parrot_default_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_modulus_float");
    
}
PMC *
Parrot_default_cmodulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "cmodulus");
    return PMCNULL;
}
PMC *
Parrot_default_cmodulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "cmodulus_int");
    return PMCNULL;
}
PMC *
Parrot_default_cmodulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "cmodulus_float");
    return PMCNULL;
}
void
Parrot_default_i_cmodulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_cmodulus");
    
}
void
Parrot_default_i_cmodulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_cmodulus_int");
    
}
void
Parrot_default_i_cmodulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_cmodulus_float");
    
}
PMC *
Parrot_default_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "pow");
    return PMCNULL;
}
PMC *
Parrot_default_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "pow_int");
    return PMCNULL;
}
PMC *
Parrot_default_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "pow_float");
    return PMCNULL;
}
void
Parrot_default_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_pow");
    
}
void
Parrot_default_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_pow_int");
    
}
void
Parrot_default_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "i_pow_float");
    
}
PMC *
Parrot_default_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_or");
    return PMCNULL;
}
PMC *
Parrot_default_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_or_int");
    return PMCNULL;
}
void
Parrot_default_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_bitwise_or");
    
}
void
Parrot_default_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_or_int");
    
}
PMC *
Parrot_default_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_and");
    return PMCNULL;
}
PMC *
Parrot_default_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_and_int");
    return PMCNULL;
}
void
Parrot_default_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_bitwise_and");
    
}
void
Parrot_default_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_and_int");
    
}
PMC *
Parrot_default_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_xor");
    return PMCNULL;
}
PMC *
Parrot_default_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_xor_int");
    return PMCNULL;
}
void
Parrot_default_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_bitwise_xor");
    
}
void
Parrot_default_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_xor_int");
    
}
PMC *
Parrot_default_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_ors");
    return PMCNULL;
}
PMC *
Parrot_default_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_ors_str");
    return PMCNULL;
}
void
Parrot_default_i_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_bitwise_ors");
    
}
void
Parrot_default_i_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "i_bitwise_ors_str");
    
}
PMC *
Parrot_default_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_ands");
    return PMCNULL;
}
PMC *
Parrot_default_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_ands_str");
    return PMCNULL;
}
void
Parrot_default_i_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_bitwise_ands");
    
}
void
Parrot_default_i_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "i_bitwise_ands_str");
    
}
PMC *
Parrot_default_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_xors");
    return PMCNULL;
}
PMC *
Parrot_default_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_xors_str");
    return PMCNULL;
}
void
Parrot_default_i_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_bitwise_xors");
    
}
void
Parrot_default_i_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "i_bitwise_xors_str");
    
}
PMC *
Parrot_default_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_shl");
    return PMCNULL;
}
PMC *
Parrot_default_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_shl_int");
    return PMCNULL;
}
void
Parrot_default_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_bitwise_shl");
    
}
void
Parrot_default_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_shl_int");
    
}
PMC *
Parrot_default_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_shr");
    return PMCNULL;
}
PMC *
Parrot_default_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_shr_int");
    return PMCNULL;
}
void
Parrot_default_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_bitwise_shr");
    
}
void
Parrot_default_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_shr_int");
    
}
PMC *
Parrot_default_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_lsr");
    return PMCNULL;
}
PMC *
Parrot_default_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_lsr_int");
    return PMCNULL;
}
void
Parrot_default_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_bitwise_lsr");
    
}
void
Parrot_default_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_bitwise_lsr_int");
    
}
INTVAL
Parrot_default_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 751 "./src/pmc/default.pmc"

    return (pmc->vtable         == value->vtable
        &&  PMC_struct_val(pmc) == PMC_struct_val(value)
        &&  PMC_data(pmc)       == PMC_data(value));
#line 796 "./src/pmc/default.c"
}
INTVAL
Parrot_default_is_equal_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 767 "./src/pmc/default.pmc"

    return (VTABLE_get_number(interp, pmc) ==
            VTABLE_get_number(interp, value));
#line 805 "./src/pmc/default.c"
}
INTVAL
Parrot_default_is_equal_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "is_equal_string");
    return (INTVAL)0;
}
INTVAL
Parrot_default_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "cmp");
    return (INTVAL)0;
}
INTVAL
Parrot_default_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "cmp_num");
    return (INTVAL)0;
}
INTVAL
Parrot_default_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "cmp_string");
    return (INTVAL)0;
}
PMC *
Parrot_default_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "logical_or");
    return PMCNULL;
}
PMC *
Parrot_default_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "logical_and");
    return PMCNULL;
}
PMC *
Parrot_default_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "logical_xor");
    return PMCNULL;
}
PMC *
Parrot_default_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "concatenate");
    return PMCNULL;
}
PMC *
Parrot_default_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
    cant_do_method(interp, pmc, "concatenate_str");
    return PMCNULL;
}
void
Parrot_default_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_concatenate");
    
}
void
Parrot_default_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "i_concatenate_str");
    
}
PMC *
Parrot_default_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    cant_do_method(interp, pmc, "repeat");
    return PMCNULL;
}
PMC *
Parrot_default_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
    cant_do_method(interp, pmc, "repeat_int");
    return PMCNULL;
}
void
Parrot_default_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "i_repeat");
    
}
void
Parrot_default_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "i_repeat_int");
    
}
PMC *
Parrot_default_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    cant_do_method(interp, pmc, "absolute");
    return PMCNULL;
}
void
Parrot_default_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    cant_do_method(interp, pmc, "add_attribute");
    
}
void
Parrot_default_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
#line 492 "./src/pmc/default.pmc"

    VTABLE_set_pmc_keyed_str(interp, pmc->vtable->_namespace,
                             method_name, sub_pmc);
#line 916 "./src/pmc/default.c"
}
void
Parrot_default_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 998 "./src/pmc/default.pmc"

    Parrot_add_parent(interp, pmc, parent);
#line 924 "./src/pmc/default.c"
}
void
Parrot_default_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    cant_do_method(interp, pmc, "add_role");
    
}
void
Parrot_default_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    cant_do_method(interp, pmc, "add_vtable_override");
    
}
void
Parrot_default_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 634 "./src/pmc/default.pmc"

    STRING * const undef = string_from_cstring(interp, "Undef", 5);

    if (VTABLE_isa(interp, value, undef))
        pmc_reuse(interp, pmc, value->vtable->base_type, 0);
    else
        VTABLE_set_pmc(interp, pmc, value);
#line 949 "./src/pmc/default.c"
}
void
Parrot_default_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 643 "./src/pmc/default.pmc"

    VTABLE_set_string_native(interp, pmc, value);
#line 957 "./src/pmc/default.c"
}
PMC *
Parrot_default_bitwise_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_not");
    return PMCNULL;
}
PMC *
Parrot_default_bitwise_nots(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_nots");
    return PMCNULL;
}
INTVAL
Parrot_default_can(PARROT_INTERP, PMC *pmc, STRING *method)
{
#line 878 "./src/pmc/default.pmc"

    return !PMC_IS_NULL(VTABLE_find_method(interp, pmc, method));
#line 977 "./src/pmc/default.c"
}
INTVAL
Parrot_default_class_type(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "class_type");
    return (INTVAL)0;
}
PMC *
Parrot_default_clone(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "clone");
    return PMCNULL;
}
PMC *
Parrot_default_clone_pmc(PARROT_INTERP, PMC *pmc, PMC *args)
{
    cant_do_method(interp, pmc, "clone_pmc");
    return PMCNULL;
}
void
Parrot_default_decrement(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "decrement");
    
}
INTVAL
Parrot_default_defined(PARROT_INTERP, PMC *pmc)
{
#line 815 "./src/pmc/default.pmc"

    return 1;
#line 1009 "./src/pmc/default.c"
}
INTVAL
Parrot_default_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "defined_keyed");
    return (INTVAL)0;
}
INTVAL
Parrot_default_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 830 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_defined_keyed(interp, pmc, r_key);
#line 1024 "./src/pmc/default.c"
}
INTVAL
Parrot_default_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "defined_keyed_str");
    return (INTVAL)0;
}
void
Parrot_default_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "delete_keyed");
    
}
void
Parrot_default_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 845 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_delete_keyed(interp, pmc, r_key);
#line 1045 "./src/pmc/default.c"
}
void
Parrot_default_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "delete_keyed_str");
    
}
void
Parrot_default_delprop(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 390 "./src/pmc/default.pmc"

    if (pmc->pmc_ext && PMC_metadata(pmc))
        VTABLE_delete_keyed_str(interp, PMC_metadata(pmc), key);
#line 1060 "./src/pmc/default.c"
}
void
Parrot_default_destroy(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "destroy");
    
}
INTVAL
Parrot_default_does(PARROT_INTERP, PMC *pmc, STRING *_interface)
{
#line 894 "./src/pmc/default.pmc"

    return does_isa(interp, _interface, pmc->vtable->does_str);
#line 1074 "./src/pmc/default.c"
}
INTVAL
Parrot_default_elements(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "elements");
    return (INTVAL)0;
}
INTVAL
Parrot_default_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "exists_keyed");
    return (INTVAL)0;
}
INTVAL
Parrot_default_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 800 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_exists_keyed(interp, pmc, r_key);
#line 1095 "./src/pmc/default.c"
}
INTVAL
Parrot_default_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "exists_keyed_str");
    return (INTVAL)0;
}
PMC  *
Parrot_default_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
#line 488 "./src/pmc/default.pmc"

    return Parrot_find_method_with_cache(interp, pmc, method_name);
#line 1109 "./src/pmc/default.c"
}
void
Parrot_default_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1037 "./src/pmc/default.pmc"

    /* default - no action */
#line 1117 "./src/pmc/default.c"
}
PMC *
Parrot_default_get_attr(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
    cant_do_method(interp, pmc, "get_attr");
    return PMCNULL;
}
PMC  *
Parrot_default_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 947 "./src/pmc/default.pmc"

    PMC *p = NULL;

    /* let's look for props first
     * XXX do we need that in the default object system?
     */
    if (pmc->pmc_ext && PMC_metadata(pmc)) {
         const HashBucket * const b =
            parrot_hash_get_bucket(interp, (Hash *)PMC_metadata(pmc),name);

         if (b)
             p = (PMC *)b->value;
    }

    /* may be NCI? */
    if (PMC_IS_NULL(p))
        p = VTABLE_find_method(interp, pmc, name);

    if (PMC_IS_NULL(p)) {
        /* TODO AttributeError */
    }
    else if (VTABLE_isa(interp, p, CONST_STRING(interp, "NCI"))) {
        PMC * const bound_meth = VTABLE_clone(interp, p);
        bound_meth->vtable     = interp->vtables[enum_class_Bound_NCI];
        VTABLE_set_pmc(interp, bound_meth, pmc);

        return bound_meth;
    }
    else if (p->vtable->base_type == enum_class_MultiSub) {
        PMC * const bound_meth      = pmc_new(interp, enum_class_Bound_NCI);
        VTABLE_set_pmc(interp, bound_meth, pmc);
        PMC_struct_val(bound_meth)  = p;
        PObj_get_FLAGS(bound_meth) |= PObj_private0_FLAG;

        return bound_meth;
    }

    /* TODO bound user functions */
    return p;
#line 1168 "./src/pmc/default.c"
}
PMC *
Parrot_default_get_bignum(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_bignum");
    return PMCNULL;
}
INTVAL
Parrot_default_get_bool(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_bool");
    return (INTVAL)0;
}
PMC  *
Parrot_default_get_class(PARROT_INTERP, PMC *pmc)
{
#line 943 "./src/pmc/default.pmc"

    return pmc;
#line 1188 "./src/pmc/default.c"
}
INTVAL
Parrot_default_get_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_integer");
    return (INTVAL)0;
}
INTVAL
Parrot_default_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "get_integer_keyed");
    return (INTVAL)0;
}
INTVAL
Parrot_default_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 507 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_integer_keyed(interp, pmc, r_key);
#line 1209 "./src/pmc/default.c"
}
INTVAL
Parrot_default_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "get_integer_keyed_str");
    return (INTVAL)0;
}
PMC *
Parrot_default_get_iter(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_iter");
    return PMCNULL;
}
FLOATVAL
Parrot_default_get_number(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_number");
    return (FLOATVAL)0;
}
FLOATVAL
Parrot_default_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "get_number_keyed");
    return (FLOATVAL)0;
}
FLOATVAL
Parrot_default_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 523 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_number_keyed(interp, pmc, r_key);
#line 1242 "./src/pmc/default.c"
}
FLOATVAL
Parrot_default_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "get_number_keyed_str");
    return (FLOATVAL)0;
}
PMC *
Parrot_default_get_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_pmc");
    return PMCNULL;
}
PMC *
Parrot_default_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "get_pmc_keyed");
    return PMCNULL;
}
PMC  *
Parrot_default_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 589 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_pmc_keyed(interp, pmc, r_key);
#line 1269 "./src/pmc/default.c"
}
PMC *
Parrot_default_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "get_pmc_keyed_str");
    return PMCNULL;
}
void  *
Parrot_default_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 604 "./src/pmc/default.pmc"

    return pmc;
#line 1283 "./src/pmc/default.c"
}
void *
Parrot_default_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "get_pointer_keyed");
    return (void*)0;
}
void *
Parrot_default_get_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    cant_do_method(interp, pmc, "get_pointer_keyed_int");
    return (void*)0;
}
void *
Parrot_default_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "get_pointer_keyed_str");
    return (void*)0;
}
STRING *
Parrot_default_get_repr(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_repr");
    return (STRING*)0;
}
STRING *
Parrot_default_get_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_string");
    return (STRING*)0;
}
STRING *
Parrot_default_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "get_string_keyed");
    return (STRING*)0;
}
STRING  *
Parrot_default_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 540 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_string_keyed(interp, pmc, r_key);
#line 1328 "./src/pmc/default.c"
}
STRING *
Parrot_default_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "get_string_keyed_str");
    return (STRING*)0;
}
PMC  *
Parrot_default_getprop(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 347 "./src/pmc/default.pmc"

    if (pmc->pmc_ext && PMC_metadata(pmc))
        return VTABLE_get_pmc_keyed_str(interp, PMC_metadata(pmc), key);
    else
        return check_get_std_props(interp, pmc, key);
#line 1345 "./src/pmc/default.c"
}
PMC  *
Parrot_default_getprops(PARROT_INTERP, PMC *pmc)
{
#line 405 "./src/pmc/default.pmc"

    if (!pmc->pmc_ext)
        add_pmc_ext(interp, pmc);

    if (!PMC_metadata(pmc)) {
        if (has_pending_std_props(pmc))
            return make_prop_hash(interp, pmc);
        else
            return PMCNULL;
    }

    return PMC_metadata(pmc);
#line 1363 "./src/pmc/default.c"
}
INTVAL
Parrot_default_hash(PARROT_INTERP, PMC *pmc, size_t seed)
{
    cant_do_method(interp, pmc, "hash");
    return (INTVAL)0;
}
void
Parrot_default_i_absolute(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_absolute");
    
}
void
Parrot_default_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_bitwise_not");
    
}
void
Parrot_default_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_bitwise_nots");
    
}
void
Parrot_default_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_logical_not");
    
}
void
Parrot_default_i_neg(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_neg");
    
}
void
Parrot_default_increment(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "increment");
    
}
void
Parrot_default_init(PARROT_INTERP, PMC *pmc)
{
#line 282 "./src/pmc/default.pmc"

#line 1412 "./src/pmc/default.c"
}
void
Parrot_default_init_pmc(PARROT_INTERP, PMC *pmc, PMC *initializer)
{
#line 295 "./src/pmc/default.pmc"

    if (PMC_IS_NULL(initializer))
        VTABLE_init(interp, pmc);
    else
        real_exception(interp, NULL, ILL_INHERIT,
                   "init_pmc() not implemented in class '%s'",
                   caller(interp, pmc));
#line 1425 "./src/pmc/default.c"
}
PMC *
Parrot_default_inspect(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "inspect");
    return PMCNULL;
}
PMC *
Parrot_default_inspect_str(PARROT_INTERP, PMC *pmc, STRING *what)
{
    cant_do_method(interp, pmc, "inspect_str");
    return PMCNULL;
}
PMC  *
Parrot_default_instantiate(PARROT_INTERP, PMC *pmc, PMC *sig)
{
#line 315 "./src/pmc/default.pmc"

    const INTVAL type = pmc->vtable->base_type;
    PMC *const   ret  = pmc_new_noinit(interp, type);
    VTABLE_init(interp, ret);
    return ret;
#line 1448 "./src/pmc/default.c"
}
opcode_t *
Parrot_default_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
    cant_do_method(interp, pmc, "invoke");
    return (opcode_t*)0;
}
INTVAL
Parrot_default_is_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 618 "./src/pmc/default.pmc"

    return pmc == value;
#line 1462 "./src/pmc/default.c"
}
INTVAL
Parrot_default_isa(PARROT_INTERP, PMC *pmc, STRING *_class)
{
#line 910 "./src/pmc/default.pmc"

    /* TODO FIXME - walk mro */
    return does_isa(interp, _class, pmc->vtable->isa_str);
#line 1471 "./src/pmc/default.c"
}
PMC *
Parrot_default_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    cant_do_method(interp, pmc, "logical_not");
    return PMCNULL;
}
void
Parrot_default_mark(PARROT_INTERP, PMC *pmc)
{
#line 332 "./src/pmc/default.pmc"

    PANIC(interp, "custom_mark flag set but no custom mark routine defined");
#line 1485 "./src/pmc/default.c"
}
void
Parrot_default_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
#line 657 "./src/pmc/default.pmc"

    pmc_reuse(interp, pmc, type, 0);
#line 1493 "./src/pmc/default.c"
}
STRING  *
Parrot_default_name(PARROT_INTERP, PMC *pmc)
{
#line 459 "./src/pmc/default.pmc"

    return pmc->vtable->whoami;
#line 1501 "./src/pmc/default.c"
}
PMC *
Parrot_default_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    cant_do_method(interp, pmc, "neg");
    return PMCNULL;
}
PMC *
Parrot_default_new_from_string(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags)
{
    cant_do_method(interp, pmc, "new_from_string");
    return PMCNULL;
}
PMC *
Parrot_default_nextkey_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL what)
{
    cant_do_method(interp, pmc, "nextkey_keyed");
    return PMCNULL;
}
PMC  *
Parrot_default_nextkey_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL w)
{
#line 861 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_nextkey_keyed(interp, pmc, r_key, w);
#line 1528 "./src/pmc/default.c"
}
PMC *
Parrot_default_nextkey_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL what)
{
    cant_do_method(interp, pmc, "nextkey_keyed_str");
    return PMCNULL;
}
PMC  *
Parrot_default_pmc_namespace(PARROT_INTERP, PMC *pmc)
{
#line 483 "./src/pmc/default.pmc"

    return pmc->vtable->_namespace;
#line 1542 "./src/pmc/default.c"
}
FLOATVAL
Parrot_default_pop_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_float");
    return (FLOATVAL)0;
}
INTVAL
Parrot_default_pop_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_integer");
    return (INTVAL)0;
}
PMC *
Parrot_default_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_pmc");
    return PMCNULL;
}
STRING *
Parrot_default_pop_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_string");
    return (STRING*)0;
}
void
Parrot_default_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "push_float");
    
}
void
Parrot_default_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "push_integer");
    
}
void
Parrot_default_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "push_pmc");
    
}
void
Parrot_default_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "push_string");
    
}
void
Parrot_default_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    cant_do_method(interp, pmc, "remove_attribute");
    
}
void
Parrot_default_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    cant_do_method(interp, pmc, "remove_method");
    
}
void
Parrot_default_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    cant_do_method(interp, pmc, "remove_parent");
    
}
void
Parrot_default_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    cant_do_method(interp, pmc, "remove_role");
    
}
void
Parrot_default_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    cant_do_method(interp, pmc, "remove_vtable_override");
    
}
void
Parrot_default_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    cant_do_method(interp, pmc, "set_attr");
    
}
void
Parrot_default_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    cant_do_method(interp, pmc, "set_attr_str");
    
}
void
Parrot_default_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "set_bignum_int");
    
}
void
Parrot_default_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_bignum_num");
    
}
void
Parrot_default_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "set_bignum_str");
    
}
void
Parrot_default_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "set_bool");
    
}
void
Parrot_default_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    cant_do_method(interp, pmc, "set_integer_keyed");
    
}
void
Parrot_default_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 672 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_integer_keyed(interp, pmc, r_key, value);
#line 1671 "./src/pmc/default.c"
}
void
Parrot_default_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    cant_do_method(interp, pmc, "set_integer_keyed_str");
    
}
void
Parrot_default_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "set_integer_native");
    
}
void
Parrot_default_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "set_integer_same");
    
}
void
Parrot_default_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_number_keyed");
    
}
void
Parrot_default_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 688 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_number_keyed(interp, pmc, r_key, value);
#line 1704 "./src/pmc/default.c"
}
void
Parrot_default_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_number_keyed_str");
    
}
void
Parrot_default_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_number_native");
    
}
void
Parrot_default_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "set_number_same");
    
}
void
Parrot_default_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "set_pmc");
    
}
void
Parrot_default_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    cant_do_method(interp, pmc, "set_pmc_keyed");
    
}
void
Parrot_default_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
#line 736 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_pmc_keyed(interp, pmc, r_key, value);
#line 1743 "./src/pmc/default.c"
}
void
Parrot_default_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    cant_do_method(interp, pmc, "set_pmc_keyed_str");
    
}
void
Parrot_default_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    cant_do_method(interp, pmc, "set_pointer");
    
}
void
Parrot_default_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    cant_do_method(interp, pmc, "set_pointer_keyed");
    
}
void
Parrot_default_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    cant_do_method(interp, pmc, "set_pointer_keyed_int");
    
}
void
Parrot_default_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    cant_do_method(interp, pmc, "set_pointer_keyed_str");
    
}
void
Parrot_default_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    cant_do_method(interp, pmc, "set_string_keyed");
    
}
void
Parrot_default_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *string)
{
#line 704 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_string_keyed(interp, pmc, r_key, string);
#line 1788 "./src/pmc/default.c"
}
void
Parrot_default_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    cant_do_method(interp, pmc, "set_string_keyed_str");
    
}
void
Parrot_default_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "set_string_native");
    
}
void
Parrot_default_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "set_string_same");
    
}
void
Parrot_default_setprop(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 364 "./src/pmc/default.pmc"

    if (check_set_std_props(interp, pmc, key, value))
        return;

    if (pmc->pmc_ext && PMC_metadata(pmc)) {
        VTABLE_set_pmc_keyed_str(interp,
            PMC_metadata(pmc), key, value);
    }
    else {
        PMC * const prop = make_prop_hash(interp, pmc);

        /* XXX is this too late for --gc-debug? */
        VTABLE_set_pmc_keyed_str(interp, prop, key, value);
    }
#line 1826 "./src/pmc/default.c"
}
void
Parrot_default_share(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "share");
    
}
PMC *
Parrot_default_share_ro(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "share_ro");
    return PMCNULL;
}
FLOATVAL
Parrot_default_shift_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_float");
    return (FLOATVAL)0;
}
INTVAL
Parrot_default_shift_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_integer");
    return (INTVAL)0;
}
PMC *
Parrot_default_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_pmc");
    return PMCNULL;
}
STRING *
Parrot_default_shift_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_string");
    return (STRING*)0;
}
PMC *
Parrot_default_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL flag)
{
    cant_do_method(interp, pmc, "slice");
    return PMCNULL;
}
void
Parrot_default_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    cant_do_method(interp, pmc, "splice");
    
}
PMC  *
Parrot_default_subclass(PARROT_INTERP, PMC *pmc, PMC *name)
{
#line 926 "./src/pmc/default.pmc"

    return Parrot_single_subclass(interp, pmc, name);
#line 1882 "./src/pmc/default.c"
}
void
Parrot_default_substr(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length, PMC *dest)
{
    cant_do_method(interp, pmc, "substr");
    
}
STRING *
Parrot_default_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length)
{
    cant_do_method(interp, pmc, "substr_str");
    return (STRING*)0;
}
UINTVAL
Parrot_default_subtype(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    cant_do_method(interp, pmc, "subtype");
    return (UINTVAL)0;
}
void
Parrot_default_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1051 "./src/pmc/default.pmc"

    /* default - initialize the PMC */
    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        if (!pmc->pmc_ext)
            add_pmc_ext(interp, pmc);

        info->thaw_ptr  = &PMC_metadata(pmc);
        info->container = pmc;

        (info->visit_pmc_now)(interp, PMC_metadata(pmc), info);
    }
    else
        VTABLE_init(interp, pmc);
#line 1919 "./src/pmc/default.c"
}
void
Parrot_default_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1076 "./src/pmc/default.pmc"

    /* default - no action */
#line 1927 "./src/pmc/default.c"
}
INTVAL
Parrot_default_type(PARROT_INTERP, PMC *pmc)
{
#line 429 "./src/pmc/default.pmc"

    return pmc->vtable->base_type;
#line 1935 "./src/pmc/default.c"
}
INTVAL
Parrot_default_type_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "type_keyed");
    return (INTVAL)0;
}
INTVAL
Parrot_default_type_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 444 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_type_keyed(interp, pmc, r_key);
#line 1950 "./src/pmc/default.c"
}
INTVAL
Parrot_default_type_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "type_keyed_str");
    return (INTVAL)0;
}
void
Parrot_default_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "unshift_float");
    
}
void
Parrot_default_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "unshift_integer");
    
}
void
Parrot_default_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "unshift_pmc");
    
}
void
Parrot_default_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "unshift_string");
    
}
void
Parrot_default_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1012 "./src/pmc/default.pmc"

    /* default - mark prop hash */
    if (pmc->pmc_ext && PMC_metadata(pmc) &&
        info->extra_flags != EXTRA_IS_PROP_HASH) {
        info->extra_flags = EXTRA_IS_PROP_HASH;
        info->extra       = PMC_metadata(pmc);

        /* place escape mark */
        (info->visit_pmc_now)(interp, pmc, info);

        /* place and the prop hash */
        (info->visit_pmc_now)(interp, PMC_metadata(pmc), info);
    }
#line 1999 "./src/pmc/default.c"
}
#line 1078 "./src/pmc/default.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
