/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/exception.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/exception.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: exception.pmc 21061 2007-09-03 21:58:10Z chromatic $

=head1 NAME

src/pmc/exception.pmc - Exception PMC

=head1 DESCRIPTION

This is the exception base class.

As we are still lacking objects, this class is based on C<ResziablePMCArray>.
This will probably change.

Please note (#39744):

Keyed access to exception objects should be very forgiving of mistakes,
returning the equivalent of 'null' for invalid keys.

This issue *may* be revisited when exception objects get their new pdd23
interface.

An exception object has these attributes:

=over 4

=item 0 C<_message>

Textual representation of the exception.

=item 1 C<_type>

The exception type, (see F<include/parrot/exceptions.h>, F<except_type.pasm>).

=item 2 C<_severity>

The severity of the exception, (see F<src/exceptions.h>,
F<except_severity.pasm>).

=item 3 C<unused>

=item 4 C<unused>

=back

Optional:

=over 4

=item 5 C<_C_file>

The C code file in which the exception was raised.

=item 6 C<_C_line>

The line of C code on which the exception was raised.

=item 7 C<_P_file>

The PASM/PIR/Perl file in which the exception was raised.

=item 8 C<_P_line>

The line of PASM/PIR/Perl code on which the exception was raised.

=item 9, 10 C<unused>

Any information attached by the HL. This shouldn't start with an
underscore (that is reserved for Parrot's internal usage. These are
stored as properties.

Note: currently, HLL information must be indexed by number. Slots 9 and 10
are available for the HLL - This is subject to change.

=back

When an exception handler is called, the exception object is passed as
as the first argument, the message as the second argument of the call.
These arguments can be retrieved with the C<get_results> opcode.

This is experimental code. The C<enum_class> of the C<Exception> isn't
fixed. The interface isn't fixed.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 108 "./src/pmc/exception.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_exception.h"
#include "pmc_resizablepmcarray.h"
#include "pmc_fixedpmcarray.h"
#include "pmc_default.h"
#include "exception.str"
INTVAL
Parrot_Exception_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 262 "./src/pmc/exception.pmc"

    if (value->vtable->base_type == enum_class_Exception ||
            VTABLE_isa(interp, value, const_string(interp, "Exception"))) {
        /* TODO check parents */
        return 1;
    }

    return 0;
#line 129 "./src/pmc/exception.c"
}
INTVAL
Parrot_Exception_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 152 "./src/pmc/exception.pmc"

    STRING *s = key_string(interp, key);

    if (!string_compare(interp, s,
        string_from_literal(interp, "_type")))
        return VTABLE_get_integer_keyed_int(interp, pmc, 1);

    if (!string_compare(interp, s,
        string_from_literal(interp, "_severity")))
        return VTABLE_get_integer_keyed_int(interp, pmc, 2);

    return 0;
#line 147 "./src/pmc/exception.c"
}
PMC  *
Parrot_Exception_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 176 "./src/pmc/exception.pmc"

    STRING *s = key_string(interp, key);
    return VTABLE_getprop(interp, pmc, s);
#line 156 "./src/pmc/exception.c"
}
PMC  *
Parrot_Exception_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 192 "./src/pmc/exception.pmc"

    if (key <= -PMC_int_val(pmc))
        return PMCNULL;

    return Parrot_ResizablePMCArray_get_pmc_keyed_int(interp, pmc, key);
#line 167 "./src/pmc/exception.c"
}
STRING  *
Parrot_Exception_get_string(PARROT_INTERP, PMC *pmc)
{
#line 138 "./src/pmc/exception.pmc"

    return VTABLE_get_string_keyed_int(interp, pmc, 0);
#line 175 "./src/pmc/exception.c"
}
STRING  *
Parrot_Exception_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 128 "./src/pmc/exception.pmc"

    STRING *s = key_string(interp, key);

    if (!string_compare(interp, s,
        string_from_literal(interp, "_message")))
        return VTABLE_get_string_keyed_int(interp, pmc, 0);

    return 0;
#line 189 "./src/pmc/exception.c"
}
void
Parrot_Exception_init(PARROT_INTERP, PMC *pmc)
{
#line 107 "./src/pmc/exception.pmc"

    Parrot_FixedPMCArray_init(interp, pmc);
    /* pre-fill 11 slots with PMCNULL */
    VTABLE_set_integer_native(interp, pmc, 11);
#line 199 "./src/pmc/exception.c"
}
FLOATVAL
Parrot_Exception_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 338 "./src/pmc/exception.pmc"

    (void) Parrot_Exception_pop_pmc(interp, pmc);
    return 0.0;
#line 208 "./src/pmc/exception.c"
}
INTVAL
Parrot_Exception_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 343 "./src/pmc/exception.pmc"

    (void) Parrot_Exception_pop_pmc(interp, pmc);
    return 0;
#line 217 "./src/pmc/exception.c"
}
PMC  *
Parrot_Exception_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 333 "./src/pmc/exception.pmc"

    /* fprintf(stderr, "don't do that then\n"); XXX */
    return PMCNULL;
#line 226 "./src/pmc/exception.c"
}
STRING  *
Parrot_Exception_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 348 "./src/pmc/exception.pmc"

    (void) Parrot_Exception_pop_pmc(interp, pmc);
    return NULL;
#line 235 "./src/pmc/exception.c"
}
void
Parrot_Exception_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 321 "./src/pmc/exception.pmc"

    Parrot_Exception_push_pmc(interp, pmc, PMCNULL);
#line 243 "./src/pmc/exception.c"
}
void
Parrot_Exception_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 325 "./src/pmc/exception.pmc"

    Parrot_Exception_push_pmc(interp, pmc, PMCNULL);
#line 251 "./src/pmc/exception.c"
}
void
Parrot_Exception_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 317 "./src/pmc/exception.pmc"

    /* fprintf(stderr, "don't do that then\n"); XXX */
#line 259 "./src/pmc/exception.c"
}
void
Parrot_Exception_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 329 "./src/pmc/exception.pmc"

    Parrot_Exception_push_pmc(interp, pmc, PMCNULL);
#line 267 "./src/pmc/exception.c"
}
void
Parrot_Exception_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 227 "./src/pmc/exception.pmc"

    STRING *s = key_string(interp, key);

    if (!string_compare(interp, s,
        string_from_literal(interp, "_type")))
        VTABLE_set_integer_keyed_int(interp, pmc, 1, value);

    if (!string_compare(interp, s,
        string_from_literal(interp, "_severity")))
        VTABLE_set_integer_keyed_int(interp, pmc, 2, value);
#line 283 "./src/pmc/exception.c"
}
void
Parrot_Exception_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 249 "./src/pmc/exception.pmc"

    STRING *s = key_string(interp, key);
    VTABLE_setprop(interp, pmc, s, value);
#line 292 "./src/pmc/exception.c"
}
void
Parrot_Exception_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 209 "./src/pmc/exception.pmc"

    STRING *s = key_string(interp, key);

    if (!string_compare(interp, s,
        string_from_literal(interp, "_message")))
        VTABLE_set_string_keyed_int(interp, pmc, 0, value);
#line 304 "./src/pmc/exception.c"
}
FLOATVAL
Parrot_Exception_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 286 "./src/pmc/exception.pmc"

    (void) Parrot_Exception_shift_pmc(interp, pmc);
    return 0.0;
#line 313 "./src/pmc/exception.c"
}
INTVAL
Parrot_Exception_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 291 "./src/pmc/exception.pmc"

    (void) Parrot_Exception_shift_pmc(interp, pmc);
    return 0;
#line 322 "./src/pmc/exception.c"
}
PMC  *
Parrot_Exception_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 281 "./src/pmc/exception.pmc"

    /* fprintf(stderr, "don't do that then\n"); XXX */
    return PMCNULL;
#line 331 "./src/pmc/exception.c"
}
STRING  *
Parrot_Exception_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 296 "./src/pmc/exception.pmc"

    (void) Parrot_Exception_shift_pmc(interp, pmc);
    return NULL;
#line 340 "./src/pmc/exception.c"
}
void
Parrot_Exception_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 305 "./src/pmc/exception.pmc"

    Parrot_Exception_unshift_pmc(interp, pmc, NULL);
#line 348 "./src/pmc/exception.c"
}
void
Parrot_Exception_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 309 "./src/pmc/exception.pmc"

    Parrot_Exception_unshift_pmc(interp, pmc, NULL);
#line 356 "./src/pmc/exception.c"
}
void
Parrot_Exception_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 301 "./src/pmc/exception.pmc"

    /* fprintf(stderr, "don't do that then\n"); XXX */
#line 364 "./src/pmc/exception.c"
}
void
Parrot_Exception_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 313 "./src/pmc/exception.pmc"

    Parrot_Exception_unshift_pmc(interp, pmc, NULL);
#line 372 "./src/pmc/exception.c"
}
void
Parrot_Exception_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Exception");
}
void
Parrot_Exception_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Exception");
}
void
Parrot_Exception_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Exception");
}
void
Parrot_Exception_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Exception");
}
void
Parrot_Exception_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Exception");
}
void
Parrot_Exception_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Exception");
}
void
Parrot_Exception_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Exception");
}
void
Parrot_Exception_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Exception");
}
void
Parrot_Exception_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Exception");
}
void
Parrot_Exception_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Exception");
}
void
Parrot_Exception_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Exception");
}
PMC *
Parrot_Exception_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Exception_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Exception");
}
void
Parrot_Exception_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Exception");
}
void
Parrot_Exception_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Exception");
}
void
Parrot_Exception_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Exception");
}
void
Parrot_Exception_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Exception");
}
void
Parrot_Exception_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Exception");
}
void
Parrot_Exception_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Exception");
}
FLOATVAL
Parrot_Exception_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Exception");
}
INTVAL
Parrot_Exception_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Exception");
}
PMC *
Parrot_Exception_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Exception");
}
STRING *
Parrot_Exception_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Exception");
}
void
Parrot_Exception_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Exception");
}
void
Parrot_Exception_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Exception");
}
void
Parrot_Exception_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Exception");
}
void
Parrot_Exception_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Exception");
}
void
Parrot_Exception_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Exception");
}
void
Parrot_Exception_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Exception");
}
void
Parrot_Exception_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Exception");
}
void
Parrot_Exception_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Exception");
}
void
Parrot_Exception_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Exception");
}
void
Parrot_Exception_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Exception");
}
FLOATVAL
Parrot_Exception_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Exception");
}
INTVAL
Parrot_Exception_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Exception");
}
PMC *
Parrot_Exception_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Exception");
}
STRING *
Parrot_Exception_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Exception");
}
void
Parrot_Exception_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Exception");
}
void
Parrot_Exception_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Exception");
}
void
Parrot_Exception_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Exception");
}
void
Parrot_Exception_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Exception");
}
void
Parrot_Exception_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Exception");
}
void
Parrot_Exception_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Exception");
}
void
Parrot_Exception_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Exception");
}
void
Parrot_Exception_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_Exception, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizablePMCArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_ResizablePMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizablePMCArray_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_does,
        Parrot_FixedPMCArray_elements,
        Parrot_ResizablePMCArray_exists_keyed,
        Parrot_ResizablePMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_FixedPMCArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedPMCArray_get_integer,
        Parrot_Exception_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Exception_get_pmc_keyed,
        Parrot_Exception_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ResizablePMCArray_get_repr,
        Parrot_Exception_get_string,
        Parrot_Exception_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Exception_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedPMCArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Exception_pop_float,
        Parrot_Exception_pop_integer,
        Parrot_Exception_pop_pmc,
        Parrot_Exception_pop_string,
        Parrot_Exception_push_float,
        Parrot_Exception_push_integer,
        Parrot_Exception_push_pmc,
        Parrot_Exception_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_Exception_set_integer_keyed,
        Parrot_FixedPMCArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_ResizablePMCArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedPMCArray_set_number_keyed,
        Parrot_FixedPMCArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedPMCArray_set_pmc,
        Parrot_Exception_set_pmc_keyed,
        Parrot_ResizablePMCArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Exception_set_string_keyed,
        Parrot_FixedPMCArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Exception_shift_float,
        Parrot_Exception_shift_integer,
        Parrot_Exception_shift_pmc,
        Parrot_Exception_shift_string,
        Parrot_FixedPMCArray_slice,
        Parrot_ResizablePMCArray_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedPMCArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Exception_unshift_float,
        Parrot_Exception_unshift_integer,
        Parrot_Exception_unshift_pmc,
        Parrot_Exception_unshift_string,
        Parrot_FixedPMCArray_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_Exception, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Exception_ro_add_attribute,
        Parrot_Exception_ro_add_method,
        Parrot_Exception_ro_add_parent,
        Parrot_Exception_ro_add_role,
        Parrot_Exception_ro_add_vtable_override,
        Parrot_Exception_ro_assign_pmc,
        Parrot_Exception_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizablePMCArray_clone,
        Parrot_default_clone_pmc,
        Parrot_Exception_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_ResizablePMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Exception_ro_delete_keyed,
        Parrot_Exception_ro_delete_keyed_int,
        Parrot_Exception_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_does,
        Parrot_FixedPMCArray_elements,
        Parrot_ResizablePMCArray_exists_keyed,
        Parrot_ResizablePMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Exception_ro_find_method,
        Parrot_FixedPMCArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedPMCArray_get_integer,
        Parrot_Exception_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Exception_get_pmc_keyed,
        Parrot_Exception_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ResizablePMCArray_get_repr,
        Parrot_Exception_get_string,
        Parrot_Exception_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Exception_ro_i_absolute,
        Parrot_Exception_ro_i_bitwise_not,
        Parrot_Exception_ro_i_bitwise_nots,
        Parrot_Exception_ro_i_logical_not,
        Parrot_Exception_ro_i_neg,
        Parrot_Exception_ro_increment,
        Parrot_Exception_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_Exception_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Exception_ro_pop_float,
        Parrot_Exception_ro_pop_integer,
        Parrot_Exception_ro_pop_pmc,
        Parrot_Exception_ro_pop_string,
        Parrot_Exception_ro_push_float,
        Parrot_Exception_ro_push_integer,
        Parrot_Exception_ro_push_pmc,
        Parrot_Exception_ro_push_string,
        Parrot_Exception_ro_remove_attribute,
        Parrot_Exception_ro_remove_method,
        Parrot_Exception_ro_remove_parent,
        Parrot_Exception_ro_remove_role,
        Parrot_Exception_ro_remove_vtable_override,
        Parrot_Exception_ro_set_attr,
        Parrot_Exception_ro_set_attr_str,
        Parrot_Exception_ro_set_bignum_int,
        Parrot_Exception_ro_set_bignum_num,
        Parrot_Exception_ro_set_bignum_str,
        Parrot_Exception_ro_set_bool,
        Parrot_Exception_ro_set_integer_keyed,
        Parrot_Exception_ro_set_integer_keyed_int,
        Parrot_Exception_ro_set_integer_keyed_str,
        Parrot_Exception_ro_set_integer_native,
        Parrot_Exception_ro_set_integer_same,
        Parrot_Exception_ro_set_number_keyed,
        Parrot_Exception_ro_set_number_keyed_int,
        Parrot_Exception_ro_set_number_keyed_str,
        Parrot_Exception_ro_set_number_native,
        Parrot_Exception_ro_set_number_same,
        Parrot_Exception_ro_set_pmc,
        Parrot_Exception_ro_set_pmc_keyed,
        Parrot_Exception_ro_set_pmc_keyed_int,
        Parrot_Exception_ro_set_pmc_keyed_str,
        Parrot_Exception_ro_set_pointer,
        Parrot_Exception_ro_set_pointer_keyed,
        Parrot_Exception_ro_set_pointer_keyed_int,
        Parrot_Exception_ro_set_pointer_keyed_str,
        Parrot_Exception_ro_set_string_keyed,
        Parrot_Exception_ro_set_string_keyed_int,
        Parrot_Exception_ro_set_string_keyed_str,
        Parrot_Exception_ro_set_string_native,
        Parrot_Exception_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Exception_ro_shift_float,
        Parrot_Exception_ro_shift_integer,
        Parrot_Exception_ro_shift_pmc,
        Parrot_Exception_ro_shift_string,
        Parrot_FixedPMCArray_slice,
        Parrot_Exception_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Exception_ro_thaw,
        Parrot_Exception_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Exception_ro_unshift_float,
        Parrot_Exception_ro_unshift_integer,
        Parrot_Exception_ro_unshift_pmc,
        Parrot_Exception_ro_unshift_string,
        Parrot_FixedPMCArray_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_Exception_is_equal }
    };
    /* Dynamic PMCs need the runtime type which is passed in entry to class_init. */
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Exception");
        vt_clone->isa_str = CONST_STRING(interp, "Exception ResizablePMCArray FixedPMCArray");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
        }
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_Exception_class_init */
#line 351 "./src/pmc/exception.pmc"


/*

=back

=head1 HISTORY

Initial revision by leo 2003.07.10.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
