/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/fixedbooleanarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/fixedbooleanarray.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: fixedbooleanarray.pmc 21147 2007-09-08 21:36:34Z paultcochrane $

=head1 NAME

src/pmc/fixedbooleanarray.pmc - fixed size array for booleans only

=head1 DESCRIPTION

The C<FixedBooleanArray PMC> implements an array of fixed size, which
stores booleans.  It uses the C<Boolean PMC> for all conversions.  The
C<FixedBooleanArray PMC> is extended by the C<ResizableBooleanArray
PMC>.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"


/*
 * TODO merge this with functions from BigInt PMC
 */

#define BITS_PER_CHAR 8
#line 46 "./src/pmc/fixedbooleanarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedbooleanarray.h"
#include "pmc_default.h"
#include "fixedbooleanarray.str"
PMC  *
Parrot_FixedBooleanArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 102 "./src/pmc/fixedbooleanarray.pmc"

    PMC *dest          = pmc_new(interp, pmc->vtable->base_type);
    PMC_int_val(dest)  = PMC_int_val(pmc);
    PMC_int_val2(dest) = PMC_int_val2(pmc);

    if (PMC_data(pmc)) {
        PMC_data(dest) = malloc(PMC_int_val2(pmc) / BITS_PER_CHAR);
        mem_sys_memcopy(PMC_data(dest),
                    PMC_data(pmc), PMC_int_val2(pmc) / BITS_PER_CHAR);
    }
    else
        PMC_data(dest) = NULL;

    PObj_active_destroy_SET(dest);
    return dest;
#line 72 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_destroy(PARROT_INTERP, PMC *pmc)
{
#line 82 "./src/pmc/fixedbooleanarray.pmc"

    PMC_int_val(pmc)  = 0;
    PMC_int_val2(pmc) = 0;

    if (PMC_data(pmc)) {
        mem_sys_free(PMC_data(pmc));
        PMC_data(pmc) = NULL;
    }
#line 86 "./src/pmc/fixedbooleanarray.c"
}
INTVAL
Parrot_FixedBooleanArray_elements(PARROT_INTERP, PMC *pmc)
{
#line 141 "./src/pmc/fixedbooleanarray.pmc"

    return PMC_int_val(pmc);
#line 94 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 477 "./src/pmc/fixedbooleanarray.pmc"

    IMAGE_IO *io = info->image_io;
    STRING   *s  = string_from_cstring(interp,
                            PMC_data_typed(pmc, char *),
                            PMC_int_val2(pmc) / BITS_PER_CHAR);

    VTABLE_push_integer(interp, io, PMC_int_val(pmc));
    VTABLE_push_string(interp, io, s);
#line 108 "./src/pmc/fixedbooleanarray.c"
}
INTVAL
Parrot_FixedBooleanArray_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 129 "./src/pmc/fixedbooleanarray.pmc"

    return Parrot_FixedBooleanArray_elements(interp, pmc) ? 1 : 0;
#line 116 "./src/pmc/fixedbooleanarray.c"
}
INTVAL
Parrot_FixedBooleanArray_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 155 "./src/pmc/fixedbooleanarray.pmc"

    return Parrot_FixedBooleanArray_elements(interp, pmc);
#line 124 "./src/pmc/fixedbooleanarray.c"
}
INTVAL
Parrot_FixedBooleanArray_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 189 "./src/pmc/fixedbooleanarray.pmc"

    /* simple int keys only */
    INTVAL k = key_integer(interp, key);
    return Parrot_FixedBooleanArray_get_integer_keyed_int(interp, pmc, k);
#line 134 "./src/pmc/fixedbooleanarray.c"
}
INTVAL
Parrot_FixedBooleanArray_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 169 "./src/pmc/fixedbooleanarray.pmc"

    Parrot_UInt1 *sd = PMC_data_typed(pmc, Parrot_UInt1 *);

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedBooleanArray: index out of bounds!");

    return (sd[key / BITS_PER_CHAR] & (1 << (key % BITS_PER_CHAR))) ? 1 : 0;
#line 148 "./src/pmc/fixedbooleanarray.c"
}
FLOATVAL
Parrot_FixedBooleanArray_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 221 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL k = key_integer(interp, key);
    return VTABLE_get_number_keyed_int(interp, pmc, k);
#line 157 "./src/pmc/fixedbooleanarray.c"
}
FLOATVAL
Parrot_FixedBooleanArray_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 206 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL i = VTABLE_get_integer_keyed_int(interp, pmc, key);
    return (FLOATVAL)i;
#line 166 "./src/pmc/fixedbooleanarray.c"
}
PMC  *
Parrot_FixedBooleanArray_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 284 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL k = key_integer(interp, key);
    return VTABLE_get_pmc_keyed_int(interp, pmc, k);
#line 175 "./src/pmc/fixedbooleanarray.c"
}
PMC  *
Parrot_FixedBooleanArray_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 267 "./src/pmc/fixedbooleanarray.pmc"

    PMC   *ret = pmc_new(interp, enum_class_Boolean);
    INTVAL val = VTABLE_get_integer_keyed_int(interp, pmc, key);
    VTABLE_set_integer_native(interp, ret, val);
    return ret;
#line 186 "./src/pmc/fixedbooleanarray.c"
}
STRING  *
Parrot_FixedBooleanArray_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 251 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL k = key_integer(interp, key);
    return VTABLE_get_string_keyed_int(interp, pmc, k);
#line 195 "./src/pmc/fixedbooleanarray.c"
}
STRING  *
Parrot_FixedBooleanArray_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 236 "./src/pmc/fixedbooleanarray.pmc"

    PMC *val = VTABLE_get_pmc_keyed_int(interp, pmc, key);
    return VTABLE_get_string(interp, val);
#line 204 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_init(PARROT_INTERP, PMC *pmc)
{
#line 51 "./src/pmc/fixedbooleanarray.pmc"

    PMC_int_val(pmc)  = 0;
    PMC_int_val2(pmc) = 0;
    PMC_data(pmc)     = NULL;
    PObj_active_destroy_SET(pmc);
#line 215 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
#line 68 "./src/pmc/fixedbooleanarray.pmc"

    Parrot_default_morph(interp, pmc, type);
#line 223 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 457 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_integer_keyed_int(interp, pmc, nextix, value);
#line 232 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 343 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL k = key_integer(interp, key);
    VTABLE_set_integer_keyed_int(interp, pmc, k, value);
#line 241 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 320 "./src/pmc/fixedbooleanarray.pmc"

    Parrot_UInt1 *sd = PMC_data_typed(pmc, Parrot_UInt1 *);

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedBooleanArray: index out of bounds!");

    if (value)
        sd[key/BITS_PER_CHAR] |=  (1 << (key % BITS_PER_CHAR));
    else
        sd[key/BITS_PER_CHAR] &= ~(1 << (key % BITS_PER_CHAR));
#line 258 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 299 "./src/pmc/fixedbooleanarray.pmc"

    if (PMC_int_val(pmc) || size < 1)
        real_exception(interp, NULL, E_IndexError,
                "FixedBooleanArray: Can't resize!");

    PMC_int_val(pmc)  = size;
    PMC_int_val2(pmc) = (size / BITS_PER_CHAR + 1) * BITS_PER_CHAR;
    PMC_data(pmc)     =
        mem_sys_allocate_zeroed(PMC_int_val2(pmc) / BITS_PER_CHAR);
#line 273 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 374 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL k = key_integer(interp, key);
    VTABLE_set_number_keyed_int(interp, pmc, k, value);
#line 282 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 359 "./src/pmc/fixedbooleanarray.pmc"

    VTABLE_set_integer_keyed_int(interp, pmc, key, !FLOAT_IS_ZERO(value));
#line 290 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 441 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL k = key_integer(interp, key);
    VTABLE_set_pmc_keyed_int(interp, pmc, k, value);
#line 299 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *src)
{
#line 425 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL tempInt = VTABLE_get_integer(interp, src);
    VTABLE_set_integer_keyed_int(interp, pmc, key, tempInt);
#line 308 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 410 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL k = key_integer(interp, key);
    VTABLE_set_string_keyed_int(interp, pmc, k, value);
#line 317 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 389 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL tempInt;
    PMC   *tempPMC = pmc_new(interp, enum_class_Boolean);

    VTABLE_set_string_native(interp, tempPMC, value);
    tempInt = VTABLE_get_integer(interp, tempPMC);

    VTABLE_set_integer_keyed_int(interp, pmc, key, tempInt);
#line 331 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 496 "./src/pmc/fixedbooleanarray.pmc"

    IMAGE_IO *io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);

    if (info->extra_flags == EXTRA_IS_NULL) {
        INTVAL size       = VTABLE_shift_integer(interp, io);
        STRING *s         = VTABLE_shift_string(interp, io);
        PMC_int_val(pmc) = size;
        PMC_int_val2(pmc) = s->bufused * BITS_PER_CHAR;
        PMC_data(pmc)     = mem_sys_allocate_zeroed(s->bufused);
        mem_sys_memcopy(PMC_data(pmc), s->strstart, s->bufused);
    }
#line 349 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_nci_fill(PARROT_INTERP, PMC *pmc, INTVAL fill)
{
#line 521 "./src/pmc/fixedbooleanarray.pmc"

    Parrot_UInt1 *sd = PMC_data_typed(pmc, Parrot_UInt1 *);
    INTVAL        j  = PMC_int_val(pmc) / BITS_PER_CHAR + 1;

    if (fill)
        memset(sd, 0xff, j);
    else
        memset(sd, 0, j);
#line 363 "./src/pmc/fixedbooleanarray.c"
}
void
Parrot_FixedBooleanArray_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of FixedBooleanArray");
}
PMC *
Parrot_FixedBooleanArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_FixedBooleanArray_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of FixedBooleanArray");
}
FLOATVAL
Parrot_FixedBooleanArray_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of FixedBooleanArray");
}
INTVAL
Parrot_FixedBooleanArray_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of FixedBooleanArray");
}
PMC *
Parrot_FixedBooleanArray_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of FixedBooleanArray");
}
STRING *
Parrot_FixedBooleanArray_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of FixedBooleanArray");
}
FLOATVAL
Parrot_FixedBooleanArray_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of FixedBooleanArray");
}
INTVAL
Parrot_FixedBooleanArray_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of FixedBooleanArray");
}
PMC *
Parrot_FixedBooleanArray_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of FixedBooleanArray");
}
STRING *
Parrot_FixedBooleanArray_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of FixedBooleanArray");
}
void
Parrot_FixedBooleanArray_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_FixedBooleanArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedBooleanArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_does,
        Parrot_FixedBooleanArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_FixedBooleanArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_FixedBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedBooleanArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_FixedBooleanArray_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedBooleanArray_set_integer_keyed,
        Parrot_FixedBooleanArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_FixedBooleanArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedBooleanArray_set_number_keyed,
        Parrot_FixedBooleanArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedBooleanArray_set_pmc_keyed,
        Parrot_FixedBooleanArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedBooleanArray_set_string_keyed,
        Parrot_FixedBooleanArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedBooleanArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_FixedBooleanArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_FixedBooleanArray_ro_add_attribute,
        Parrot_FixedBooleanArray_ro_add_method,
        Parrot_FixedBooleanArray_ro_add_parent,
        Parrot_FixedBooleanArray_ro_add_role,
        Parrot_FixedBooleanArray_ro_add_vtable_override,
        Parrot_FixedBooleanArray_ro_assign_pmc,
        Parrot_FixedBooleanArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedBooleanArray_clone,
        Parrot_default_clone_pmc,
        Parrot_FixedBooleanArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_FixedBooleanArray_ro_delete_keyed,
        Parrot_FixedBooleanArray_ro_delete_keyed_int,
        Parrot_FixedBooleanArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_does,
        Parrot_FixedBooleanArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_FixedBooleanArray_ro_find_method,
        Parrot_FixedBooleanArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_FixedBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_FixedBooleanArray_ro_i_absolute,
        Parrot_FixedBooleanArray_ro_i_bitwise_not,
        Parrot_FixedBooleanArray_ro_i_bitwise_nots,
        Parrot_FixedBooleanArray_ro_i_logical_not,
        Parrot_FixedBooleanArray_ro_i_neg,
        Parrot_FixedBooleanArray_ro_increment,
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedBooleanArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_FixedBooleanArray_ro_pop_float,
        Parrot_FixedBooleanArray_ro_pop_integer,
        Parrot_FixedBooleanArray_ro_pop_pmc,
        Parrot_FixedBooleanArray_ro_pop_string,
        Parrot_FixedBooleanArray_ro_push_float,
        Parrot_FixedBooleanArray_ro_push_integer,
        Parrot_FixedBooleanArray_ro_push_pmc,
        Parrot_FixedBooleanArray_ro_push_string,
        Parrot_FixedBooleanArray_ro_remove_attribute,
        Parrot_FixedBooleanArray_ro_remove_method,
        Parrot_FixedBooleanArray_ro_remove_parent,
        Parrot_FixedBooleanArray_ro_remove_role,
        Parrot_FixedBooleanArray_ro_remove_vtable_override,
        Parrot_FixedBooleanArray_ro_set_attr,
        Parrot_FixedBooleanArray_ro_set_attr_str,
        Parrot_FixedBooleanArray_ro_set_bignum_int,
        Parrot_FixedBooleanArray_ro_set_bignum_num,
        Parrot_FixedBooleanArray_ro_set_bignum_str,
        Parrot_FixedBooleanArray_ro_set_bool,
        Parrot_FixedBooleanArray_ro_set_integer_keyed,
        Parrot_FixedBooleanArray_ro_set_integer_keyed_int,
        Parrot_FixedBooleanArray_ro_set_integer_keyed_str,
        Parrot_FixedBooleanArray_ro_set_integer_native,
        Parrot_FixedBooleanArray_ro_set_integer_same,
        Parrot_FixedBooleanArray_ro_set_number_keyed,
        Parrot_FixedBooleanArray_ro_set_number_keyed_int,
        Parrot_FixedBooleanArray_ro_set_number_keyed_str,
        Parrot_FixedBooleanArray_ro_set_number_native,
        Parrot_FixedBooleanArray_ro_set_number_same,
        Parrot_FixedBooleanArray_ro_set_pmc,
        Parrot_FixedBooleanArray_ro_set_pmc_keyed,
        Parrot_FixedBooleanArray_ro_set_pmc_keyed_int,
        Parrot_FixedBooleanArray_ro_set_pmc_keyed_str,
        Parrot_FixedBooleanArray_ro_set_pointer,
        Parrot_FixedBooleanArray_ro_set_pointer_keyed,
        Parrot_FixedBooleanArray_ro_set_pointer_keyed_int,
        Parrot_FixedBooleanArray_ro_set_pointer_keyed_str,
        Parrot_FixedBooleanArray_ro_set_string_keyed,
        Parrot_FixedBooleanArray_ro_set_string_keyed_int,
        Parrot_FixedBooleanArray_ro_set_string_keyed_str,
        Parrot_FixedBooleanArray_ro_set_string_native,
        Parrot_FixedBooleanArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_FixedBooleanArray_ro_shift_float,
        Parrot_FixedBooleanArray_ro_shift_integer,
        Parrot_FixedBooleanArray_ro_shift_pmc,
        Parrot_FixedBooleanArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_FixedBooleanArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedBooleanArray_ro_thaw,
        Parrot_FixedBooleanArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_FixedBooleanArray_ro_unshift_float,
        Parrot_FixedBooleanArray_ro_unshift_integer,
        Parrot_FixedBooleanArray_ro_unshift_pmc,
        Parrot_FixedBooleanArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "FixedBooleanArray");
        vt_clone->isa_str = CONST_STRING(interp, "FixedBooleanArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_FixedBooleanArray_nci_fill), "fill", "vJOI");
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_FixedBooleanArray_class_init */
#line 529 "./src/pmc/fixedbooleanarray.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version 2004.06.11 by Matt Fowles

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
