/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/fixedpmcarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/fixedpmcarray.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: fixedpmcarray.pmc 22047 2007-10-12 16:23:58Z paultcochrane $

=head1 NAME

src/pmc/fixedpmcarray.pmc - fixed size array for PMCs only

=head1 DESCRIPTION

This class, FixedPMCArray, implements an array of fixed size which stores PMCs.
It puts things into Integer, Float, or String PMCs as appropriate

=head2 Note

The flag C<PObj_private0_FLAG> is used in the C<NameSpace> PMC and should
never be set for user arrays.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

static void
swap(void **x, void **y)
{
    void *t = *x;
    *x = *y;
    *y = t;
}

typedef INTVAL (*sort_func_t)(PARROT_INTERP, void*, void*);

static INTVAL
COMPARE(PARROT_INTERP, void *a, void *b, PMC *cmp)
{
    if (PMC_IS_NULL(cmp))
        return mmd_dispatch_i_pp(interp, (PMC *)a, (PMC *)b, MMD_CMP);

    if (cmp->vtable->base_type == enum_class_NCI) {
        sort_func_t f = (sort_func_t)D2FPTR(PMC_struct_val(cmp));
        return f(interp, a, b);
    }

    return Parrot_runops_fromc_args_reti(interp, cmp, "IPP", a, b);
}

static void
quicksort(PARROT_INTERP, void **data, UINTVAL n, PMC *cmp)
{
    UINTVAL i, j, ln, rn;

    while (n > 1) {
        swap(&data[0], &data[n/2]);

        for (i = 0, j = n; ;) {
            do
                --j;
            while (COMPARE(interp, data[j], data[0], cmp) > 0);

            do
                ++i;
            while (i < j && COMPARE(interp, data[i], data[0], cmp) < 0);

            if (i >= j)
                break;

            swap(&data[i], &data[j]);
        }

        swap(&data[j], &data[0]);

        ln = j;
        rn = n - ++j;

        if (ln < rn) {
            quicksort(interp, data, ln, cmp);
            data += j;
            n = rn;
        }
        else {
            quicksort(interp, data + j, rn, cmp);
            n = ln;
        }
    }
}
#line 106 "./src/pmc/fixedpmcarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedpmcarray.h"
#include "pmc_default.h"
#include "fixedpmcarray.str"
INTVAL
Parrot_FixedPMCArray_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 646 "./src/pmc/fixedpmcarray.pmc"

    INTVAL j, n;

    if (value->vtable->base_type != enum_class_FixedPMCArray)
        return 0;

    n = Parrot_FixedPMCArray_elements(interp, pmc);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        PMC *item1 = Parrot_FixedPMCArray_get_pmc_keyed_int(interp, pmc, j);
        PMC *item2 = VTABLE_get_pmc_keyed_int(interp, value, j);

        if (item1 == item2)
            continue;

        if (!mmd_dispatch_i_pp(interp, item1, item2, MMD_EQ))
            return 0;
    }

    return 1;
#line 140 "./src/pmc/fixedpmcarray.c"
}
PMC  *
Parrot_FixedPMCArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 179 "./src/pmc/fixedpmcarray.pmc"

    PMC *dest   = pmc_new(interp, pmc->vtable->base_type);
    INTVAL size = PMC_int_val(pmc);

    if (size) {
        PMC_int_val(dest) = size;
        PMC_data(dest)    = mem_sys_allocate(size * sizeof (PMC*));
        mem_sys_memcopy(PMC_data(dest), PMC_data(pmc), size*sizeof (PMC*));
        PObj_data_is_PMC_array_SET(dest);
    }

    return dest;
#line 158 "./src/pmc/fixedpmcarray.c"
}
INTVAL
Parrot_FixedPMCArray_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 793 "./src/pmc/fixedpmcarray.pmc"

    PMC *val = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    if (PMC_IS_NULL(val))
        return 0;

    return VTABLE_defined(interp, val);
#line 171 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_destroy(PARROT_INTERP, PMC *pmc)
{
#line 161 "./src/pmc/fixedpmcarray.pmc"

    if (PMC_data(pmc)) {
        mem_sys_free(PMC_data(pmc));
        PMC_data(pmc) = NULL;
    }
    PMC_int_val(pmc) = 0;
#line 183 "./src/pmc/fixedpmcarray.c"
}
INTVAL
Parrot_FixedPMCArray_elements(PARROT_INTERP, PMC *pmc)
{
#line 216 "./src/pmc/fixedpmcarray.pmc"

    return PMC_int_val(pmc);
#line 191 "./src/pmc/fixedpmcarray.c"
}
INTVAL
Parrot_FixedPMCArray_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 732 "./src/pmc/fixedpmcarray.pmc"

    INTVAL ix = key_integer(interp, key);
    return Parrot_FixedPMCArray_exists_keyed_int(interp, pmc, ix);
#line 200 "./src/pmc/fixedpmcarray.c"
}
INTVAL
Parrot_FixedPMCArray_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 722 "./src/pmc/fixedpmcarray.pmc"

    PMC **data;
    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedPMCArray: index out of bounds!");

    data = (PMC**)PMC_data(pmc);
    return !PMC_IS_NULL(data[key]);
#line 214 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 770 "./src/pmc/fixedpmcarray.pmc"

    IMAGE_IO *io = info->image_io;
    Parrot_default_freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, VTABLE_elements(interp, pmc));
#line 224 "./src/pmc/fixedpmcarray.c"
}
INTVAL
Parrot_FixedPMCArray_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 203 "./src/pmc/fixedpmcarray.pmc"

    INTVAL size = VTABLE_elements(interp, pmc);
    return (INTVAL)(size != 0);
#line 233 "./src/pmc/fixedpmcarray.c"
}
INTVAL
Parrot_FixedPMCArray_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 230 "./src/pmc/fixedpmcarray.pmc"

    return VTABLE_elements(interp, pmc);
#line 241 "./src/pmc/fixedpmcarray.c"
}
INTVAL
Parrot_FixedPMCArray_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 299 "./src/pmc/fixedpmcarray.pmc"

    PMC *tempPMC = VTABLE_get_pmc_keyed(interp, pmc, key);
    return VTABLE_get_integer(interp, tempPMC);
#line 250 "./src/pmc/fixedpmcarray.c"
}
INTVAL
Parrot_FixedPMCArray_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 284 "./src/pmc/fixedpmcarray.pmc"

    PMC *tempPMC = VTABLE_get_pmc_keyed_int(interp, pmc, key);
    return VTABLE_get_integer(interp, tempPMC);
#line 259 "./src/pmc/fixedpmcarray.c"
}
PMC  *
Parrot_FixedPMCArray_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 698 "./src/pmc/fixedpmcarray.pmc"

    PMC *iter            = pmc_new_init(interp, enum_class_Iterator, pmc);
    PMC *key             = pmc_new(interp, enum_class_Key);
    PMC_struct_val(iter) = key;
    PObj_get_FLAGS(key) |= KEY_integer_FLAG;
    PMC_int_val(key)     = 0;

    if (PMC_int_val(pmc) == 0)
        PMC_int_val(key) = -1;

    return iter;
#line 276 "./src/pmc/fixedpmcarray.c"
}
FLOATVAL
Parrot_FixedPMCArray_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 329 "./src/pmc/fixedpmcarray.pmc"

    PMC *tempPMC = VTABLE_get_pmc_keyed(interp, pmc, key);
    return VTABLE_get_number(interp, tempPMC);
#line 285 "./src/pmc/fixedpmcarray.c"
}
FLOATVAL
Parrot_FixedPMCArray_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 314 "./src/pmc/fixedpmcarray.pmc"

    PMC *tempPMC = VTABLE_get_pmc_keyed_int(interp, pmc, key);
    return VTABLE_get_number(interp, tempPMC);
#line 294 "./src/pmc/fixedpmcarray.c"
}
PMC  *
Parrot_FixedPMCArray_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 395 "./src/pmc/fixedpmcarray.pmc"

    INTVAL k       = key_integer(interp, key);
    PMC   *nextkey = key_next(interp, key);
    PMC   *box;

    if (!nextkey)
        return VTABLE_get_pmc_keyed_int(interp, pmc, k);

    box = Parrot_FixedPMCArray_get_pmc_keyed_int(interp, pmc, k);

    if (box == NULL)
        box = pmc_new(interp, enum_class_Undef);

    return VTABLE_get_pmc_keyed(interp, box, nextkey);
#line 314 "./src/pmc/fixedpmcarray.c"
}
PMC  *
Parrot_FixedPMCArray_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 374 "./src/pmc/fixedpmcarray.pmc"

    PMC **data;

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedPMCArray: index out of bounds!");

    data = (PMC **)PMC_data(pmc);
    return data[key];
#line 329 "./src/pmc/fixedpmcarray.c"
}
STRING  *
Parrot_FixedPMCArray_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 253 "./src/pmc/fixedpmcarray.pmc"

    STRING *res = string_from_literal(interp, "(");
    INTVAL  n   = VTABLE_elements(interp, pmc);
    INTVAL  i;
    PMC    *val;

    for (i = 0; i < n; ++i) {
        PMC *val = Parrot_FixedPMCArray_get_pmc_keyed_int(interp, pmc, i);
        res      = string_append(interp, res, VTABLE_get_repr(interp, val));

        if (n == 1)
            res = string_append(interp, res, const_string(interp, ","));
        else if (i < n - 1)
            res = string_append(interp, res, const_string(interp, ", "));
    }

    res = string_append(interp, res, const_string(interp, ")"));

    return res;
#line 354 "./src/pmc/fixedpmcarray.c"
}
STRING  *
Parrot_FixedPMCArray_get_string(PARROT_INTERP, PMC *pmc)
{
#line 249 "./src/pmc/fixedpmcarray.pmc"

    return string_from_int(interp, VTABLE_elements(interp, pmc));
#line 362 "./src/pmc/fixedpmcarray.c"
}
STRING  *
Parrot_FixedPMCArray_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 359 "./src/pmc/fixedpmcarray.pmc"

    PMC *tempPMC = VTABLE_get_pmc_keyed(interp, pmc, key);
    return VTABLE_get_string(interp, tempPMC);
#line 371 "./src/pmc/fixedpmcarray.c"
}
STRING  *
Parrot_FixedPMCArray_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 344 "./src/pmc/fixedpmcarray.pmc"

    PMC *tempPMC = VTABLE_get_pmc_keyed_int(interp, pmc, key);
    return VTABLE_get_string(interp, tempPMC);
#line 380 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_init(PARROT_INTERP, PMC *pmc)
{
#line 130 "./src/pmc/fixedpmcarray.pmc"

    PMC_int_val(pmc) = 0;
    PMC_data(pmc)    = NULL;
    PObj_active_destroy_SET(pmc);
    PObj_data_is_PMC_array_SET(pmc);
#line 391 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
#line 147 "./src/pmc/fixedpmcarray.pmc"

    Parrot_default_morph(interp, pmc, type);
#line 399 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 489 "./src/pmc/fixedpmcarray.pmc"

    PMC *val = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Integer));

    VTABLE_set_integer_native(interp, val, value);

    /* Let set_pmc_keyed worry about multi keys */
    VTABLE_set_pmc_keyed(interp, pmc, key, val);
#line 413 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 471 "./src/pmc/fixedpmcarray.pmc"

    PMC *val = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Integer));

    VTABLE_set_integer_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, key, val);
#line 425 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 422 "./src/pmc/fixedpmcarray.pmc"

    int i;
    PMC **data;

    if (PMC_int_val(pmc) && size)
        real_exception(interp, NULL, E_IndexError,
                "FixedPMCArray: Can't resize!");
    if (!size)
        return;

    PMC_int_val(pmc) = size;
    data              = (PMC **)mem_sys_allocate(size * sizeof (PMC *));

    for (i = 0; i < size; i++)
        data[i] = PMCNULL;

    PMC_data(pmc) = data;
#line 448 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 529 "./src/pmc/fixedpmcarray.pmc"

    INTVAL k       = key_integer(interp, key);
    PMC   *nextkey = key_next(interp, key);

    if (nextkey == NULL) {
        VTABLE_set_number_keyed_int(interp, pmc, k, value);
    }
    else {
        PMC *box = Parrot_FixedPMCArray_get_pmc_keyed_int(interp, pmc, k);

        /* TODO: autovivify an Array and insert it in pmc */
        if (!box)
            box = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_number_keyed(interp, box, nextkey, value);
    }
#line 470 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 510 "./src/pmc/fixedpmcarray.pmc"

    PMC *val = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Float));

    VTABLE_set_number_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, key, val);
#line 482 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 441 "./src/pmc/fixedpmcarray.pmc"

    INTVAL size;

    if (pmc == value)
        return;

    if (!VTABLE_does(interp, value, CONST_STRING(interp, "array")))
        real_exception(interp, NULL, E_TypeError,
                "Can't set self from this type");

    if (PMC_data(pmc))
        mem_sys_free(PMC_data(pmc));

    size           = PMC_int_val(pmc) = PMC_int_val(value);
    PMC_data(pmc) = mem_sys_allocate(size * sizeof (PMC *));

    mem_sys_memcopy(PMC_data(pmc), PMC_data(value), size * sizeof (PMC *));
    PMC_int_val2(pmc) = size;
    PObj_data_is_PMC_array_SET(pmc);
#line 507 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 618 "./src/pmc/fixedpmcarray.pmc"

    INTVAL k       = key_integer(interp, key);
    PMC   *nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_pmc_keyed_int(interp, pmc, k, value);
    }
    else {
        PMC *box = Parrot_FixedPMCArray_get_pmc_keyed_int(interp, pmc, k);

        /* TODO: autovivify an Array and insert it in pmc */
        if (!box)
            box = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_pmc_keyed(interp, box, nextkey, value);
    }
#line 529 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *src)
{
#line 596 "./src/pmc/fixedpmcarray.pmc"

    PMC **data;

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
            "FixedPMCArray: index out of bounds!");

    data      = (PMC**)PMC_data(pmc);
    DOD_WRITE_BARRIER(interp, pmc, data[key], src);
    data[key] = src;
#line 545 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 576 "./src/pmc/fixedpmcarray.pmc"

    PMC *val = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_String));

    VTABLE_set_string_native(interp, val, value);

    /* Let set_pmc_keyed worry about multi keys */
    VTABLE_set_pmc_keyed(interp, pmc, key, val);
#line 559 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 557 "./src/pmc/fixedpmcarray.pmc"

    PMC *val = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_String));

    VTABLE_set_string_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, key, val);
#line 571 "./src/pmc/fixedpmcarray.c"
}
PMC  *
Parrot_FixedPMCArray_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL f)
{
#line 687 "./src/pmc/fixedpmcarray.pmc"

    if (f == 0) {
        PMC *iter = pmc_new_init(interp, enum_class_Iterator, pmc);
        PMC_struct_val(iter) = key;
        return iter;
    }

    real_exception(interp, NULL, E_IndexError, "Array: Unknown slice type");
    return NULL;
#line 586 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 776 "./src/pmc/fixedpmcarray.pmc"

    IMAGE_IO *io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
        VTABLE_set_integer_native(interp, pmc, VTABLE_shift_integer(interp, io));
#line 597 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 757 "./src/pmc/fixedpmcarray.pmc"

    INTVAL  i;
    INTVAL  n   = VTABLE_elements(interp, pmc);
    PMC   **pos = (PMC **)PMC_data(pmc);

    for (i = 0; i < n; ++i, ++pos) {
        info->thaw_ptr = pos;
        (info->visit_pmc_now)(interp, *pos, info);
    }

    Parrot_default_visit(interp, pmc, info);
#line 614 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_nci_sort(PARROT_INTERP, PMC *pmc, PMC *cmp_func)
{
#line 105 "./src/pmc/fixedpmcarray.pmc"

UINTVAL n = (UINTVAL) PMC_int_val(pmc);

if (n <= 1)
    return;

quicksort(interp, PMC_data_typed(pmc, void **), n, cmp_func);
#line 627 "./src/pmc/fixedpmcarray.c"
}
void
Parrot_FixedPMCArray_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of FixedPMCArray");
}
PMC *
Parrot_FixedPMCArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_FixedPMCArray_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of FixedPMCArray");
}
FLOATVAL
Parrot_FixedPMCArray_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of FixedPMCArray");
}
INTVAL
Parrot_FixedPMCArray_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of FixedPMCArray");
}
PMC *
Parrot_FixedPMCArray_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of FixedPMCArray");
}
STRING *
Parrot_FixedPMCArray_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of FixedPMCArray");
}
FLOATVAL
Parrot_FixedPMCArray_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of FixedPMCArray");
}
INTVAL
Parrot_FixedPMCArray_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of FixedPMCArray");
}
PMC *
Parrot_FixedPMCArray_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of FixedPMCArray");
}
STRING *
Parrot_FixedPMCArray_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of FixedPMCArray");
}
void
Parrot_FixedPMCArray_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_FixedPMCArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedPMCArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_FixedPMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_does,
        Parrot_FixedPMCArray_elements,
        Parrot_FixedPMCArray_exists_keyed,
        Parrot_FixedPMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_FixedPMCArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedPMCArray_get_integer,
        Parrot_FixedPMCArray_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedPMCArray_get_pmc_keyed,
        Parrot_FixedPMCArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedPMCArray_get_repr,
        Parrot_FixedPMCArray_get_string,
        Parrot_FixedPMCArray_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedPMCArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedPMCArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedPMCArray_set_integer_keyed,
        Parrot_FixedPMCArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_FixedPMCArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedPMCArray_set_number_keyed,
        Parrot_FixedPMCArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedPMCArray_set_pmc,
        Parrot_FixedPMCArray_set_pmc_keyed,
        Parrot_FixedPMCArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedPMCArray_set_string_keyed,
        Parrot_FixedPMCArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_FixedPMCArray_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedPMCArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_FixedPMCArray_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_FixedPMCArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_FixedPMCArray_ro_add_attribute,
        Parrot_FixedPMCArray_ro_add_method,
        Parrot_FixedPMCArray_ro_add_parent,
        Parrot_FixedPMCArray_ro_add_role,
        Parrot_FixedPMCArray_ro_add_vtable_override,
        Parrot_FixedPMCArray_ro_assign_pmc,
        Parrot_FixedPMCArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_FixedPMCArray_clone,
        Parrot_default_clone_pmc,
        Parrot_FixedPMCArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_FixedPMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_FixedPMCArray_ro_delete_keyed,
        Parrot_FixedPMCArray_ro_delete_keyed_int,
        Parrot_FixedPMCArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_does,
        Parrot_FixedPMCArray_elements,
        Parrot_FixedPMCArray_exists_keyed,
        Parrot_FixedPMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_FixedPMCArray_ro_find_method,
        Parrot_FixedPMCArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedPMCArray_get_integer,
        Parrot_FixedPMCArray_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedPMCArray_get_pmc_keyed,
        Parrot_FixedPMCArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedPMCArray_get_repr,
        Parrot_FixedPMCArray_get_string,
        Parrot_FixedPMCArray_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_FixedPMCArray_ro_i_absolute,
        Parrot_FixedPMCArray_ro_i_bitwise_not,
        Parrot_FixedPMCArray_ro_i_bitwise_nots,
        Parrot_FixedPMCArray_ro_i_logical_not,
        Parrot_FixedPMCArray_ro_i_neg,
        Parrot_FixedPMCArray_ro_increment,
        Parrot_FixedPMCArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedPMCArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_FixedPMCArray_ro_pop_float,
        Parrot_FixedPMCArray_ro_pop_integer,
        Parrot_FixedPMCArray_ro_pop_pmc,
        Parrot_FixedPMCArray_ro_pop_string,
        Parrot_FixedPMCArray_ro_push_float,
        Parrot_FixedPMCArray_ro_push_integer,
        Parrot_FixedPMCArray_ro_push_pmc,
        Parrot_FixedPMCArray_ro_push_string,
        Parrot_FixedPMCArray_ro_remove_attribute,
        Parrot_FixedPMCArray_ro_remove_method,
        Parrot_FixedPMCArray_ro_remove_parent,
        Parrot_FixedPMCArray_ro_remove_role,
        Parrot_FixedPMCArray_ro_remove_vtable_override,
        Parrot_FixedPMCArray_ro_set_attr,
        Parrot_FixedPMCArray_ro_set_attr_str,
        Parrot_FixedPMCArray_ro_set_bignum_int,
        Parrot_FixedPMCArray_ro_set_bignum_num,
        Parrot_FixedPMCArray_ro_set_bignum_str,
        Parrot_FixedPMCArray_ro_set_bool,
        Parrot_FixedPMCArray_ro_set_integer_keyed,
        Parrot_FixedPMCArray_ro_set_integer_keyed_int,
        Parrot_FixedPMCArray_ro_set_integer_keyed_str,
        Parrot_FixedPMCArray_ro_set_integer_native,
        Parrot_FixedPMCArray_ro_set_integer_same,
        Parrot_FixedPMCArray_ro_set_number_keyed,
        Parrot_FixedPMCArray_ro_set_number_keyed_int,
        Parrot_FixedPMCArray_ro_set_number_keyed_str,
        Parrot_FixedPMCArray_ro_set_number_native,
        Parrot_FixedPMCArray_ro_set_number_same,
        Parrot_FixedPMCArray_ro_set_pmc,
        Parrot_FixedPMCArray_ro_set_pmc_keyed,
        Parrot_FixedPMCArray_ro_set_pmc_keyed_int,
        Parrot_FixedPMCArray_ro_set_pmc_keyed_str,
        Parrot_FixedPMCArray_ro_set_pointer,
        Parrot_FixedPMCArray_ro_set_pointer_keyed,
        Parrot_FixedPMCArray_ro_set_pointer_keyed_int,
        Parrot_FixedPMCArray_ro_set_pointer_keyed_str,
        Parrot_FixedPMCArray_ro_set_string_keyed,
        Parrot_FixedPMCArray_ro_set_string_keyed_int,
        Parrot_FixedPMCArray_ro_set_string_keyed_str,
        Parrot_FixedPMCArray_ro_set_string_native,
        Parrot_FixedPMCArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_FixedPMCArray_ro_shift_float,
        Parrot_FixedPMCArray_ro_shift_integer,
        Parrot_FixedPMCArray_ro_shift_pmc,
        Parrot_FixedPMCArray_ro_shift_string,
        Parrot_FixedPMCArray_slice,
        Parrot_FixedPMCArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedPMCArray_ro_thaw,
        Parrot_FixedPMCArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_FixedPMCArray_ro_unshift_float,
        Parrot_FixedPMCArray_ro_unshift_integer,
        Parrot_FixedPMCArray_ro_unshift_pmc,
        Parrot_FixedPMCArray_ro_unshift_string,
        Parrot_FixedPMCArray_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_FixedPMCArray_is_equal }
    };
    /* Dynamic PMCs need the runtime type which is passed in entry to class_init. */
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "FixedPMCArray");
        vt_clone->isa_str = CONST_STRING(interp, "FixedPMCArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_FixedPMCArray_nci_sort), "sort", "vJOP");
        /* class_init */
        {
        
        }
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_FixedPMCArray_class_init */
#line 800 "./src/pmc/fixedpmcarray.pmc"


/*

=back

=head1 TODO

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version 2004.06.11 by Matt Fowles

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
