/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/hash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/hash.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: hash.pmc 22143 2007-10-16 20:59:30Z chromatic $

=head1 NAME

src/pmc/hash.pmc - Hash PMC

=head1 DESCRIPTION

These are the vtable functions for the Hash PMC.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

/*

=item C<static PMC *get_integer_pmc(PARROT_INTERP, INTVAL base_type )>

Lookup the PMC type which is used for storing native integers.

TODO: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC *get_integer_pmc(PARROT_INTERP, INTVAL base_type) {
    return pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Integer));
}


/*

=item C<static PMC *get_number_pmc(PARROT_INTERP, INTVAL base_type )>

Lookup the PMC type which is used for floating point numbers.

TODO: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC *get_number_pmc(PARROT_INTERP, INTVAL base_type) {
    return pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Float));
}

/*

=item C<static PMC *get_string_pmc(PARROT_INTERP, INTVAL base_type )>

Lookup the PMC type which is used for storing strings.

TODO: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC *get_string_pmc(PARROT_INTERP, INTVAL base_type) {
    return pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_String));
}


/*

=item C<static STRING *make_hash_key(PARROT_INTERP, PMC *key)>

Returns a Parrot string for C<*key>.

=cut

*/

static STRING *make_hash_key(PARROT_INTERP, NOTNULL(PMC *key))
{
    if (!key)
        real_exception(interp, NULL, E_KeyError, "Hash: Cannot use NULL key");

    return key_string(interp, key);
}

/* Albeit the Hash PMC doesn't use PMC_data, it needs the next_for_GC pointer
 * We would get recursive marking of a deeply nested HoHoH...
 */
#line 108 "./src/pmc/hash.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "hash.str"
INTVAL
Parrot_Hash_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 846 "./src/pmc/hash.pmc"

    PMC * const iter = VTABLE_get_iter(interp, pmc);
    INTVAL      j, n;

    /* TODO: comparing Hash and PerlHash should probably be possible */
    if (value->vtable->base_type != pmc->vtable->base_type)
        return 0;

    n = Parrot_Hash_elements(interp, pmc);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        STRING * const key = VTABLE_shift_string(interp, iter);
        PMC           *item1, *item2;

        if (!VTABLE_exists_keyed_str(interp, value, key))
            return 0;

        item1 = Parrot_Hash_get_pmc_keyed_str(interp, pmc, key);
        item2 = VTABLE_get_pmc_keyed_str(interp, value, key);

        if (item1 == item2)
            continue;

        if (!mmd_dispatch_i_pp(interp, item1, item2, MMD_EQ))
            return 0;
    }

    return 1;
#line 150 "./src/pmc/hash.c"
}
PMC  *
Parrot_Hash_clone(PARROT_INTERP, PMC *pmc)
{
#line 196 "./src/pmc/hash.pmc"

    PMC * const dest = pmc_new_noinit(interp, pmc->vtable->base_type);
    PObj_custom_mark_destroy_SETALL(dest);

    parrot_hash_clone(interp, (Hash *)PMC_struct_val(pmc),
               (Hash **)&PMC_struct_val(dest));

    ((Hash *)PMC_struct_val(dest))->container = dest;
    return dest;
#line 165 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 951 "./src/pmc/hash.pmc"

    Hash   * const h  = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interp, key);
    HashBucket    *b;

    key = key_next(interp, key);
    b   = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return 0;

    if (!key)
        return VTABLE_defined(interp, (PMC*)b->value);
    else
        return VTABLE_defined_keyed(interp, (PMC*)b->value, key);
#line 187 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 930 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);

    /* no such key */
    if (!b)
        return 0;

    return VTABLE_defined(interp, (PMC*)b->value);
#line 202 "./src/pmc/hash.c"
}
void
Parrot_Hash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 991 "./src/pmc/hash.pmc"

    Hash   * const h  = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interp, key);
    HashBucket    *b;

    key = key_next(interp, key);
    b   = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return;

    if (!key)
        parrot_hash_delete(interp, h, sx);
    else
        VTABLE_delete_keyed(interp, (PMC*)b->value, key);
#line 224 "./src/pmc/hash.c"
}
void
Parrot_Hash_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 977 "./src/pmc/hash.pmc"

    parrot_hash_delete(interp, (Hash *)PMC_struct_val(pmc), key);
#line 232 "./src/pmc/hash.c"
}
void
Parrot_Hash_destroy(PARROT_INTERP, PMC *pmc)
{
#line 116 "./src/pmc/hash.pmc"

    if (PMC_struct_val(pmc)) {
        parrot_hash_destroy(interp, (Hash *)PMC_struct_val(pmc));
        PMC_struct_val(pmc) = NULL;
    }
#line 243 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_elements(PARROT_INTERP, PMC *pmc)
{
#line 518 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc));
#line 251 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 903 "./src/pmc/hash.pmc"

    Hash   * const h  = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interp, key);
    HashBucket    *b;

    key = key_next(interp, key);
    b   = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return 0;

    /* lookup stops here */
    if (!key)
        return 1;

    return VTABLE_exists_keyed(interp, (PMC *)b->value, key);
#line 274 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 887 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash *)PMC_struct_val(pmc), key);
    return b != NULL;
#line 284 "./src/pmc/hash.c"
}
void
Parrot_Hash_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1056 "./src/pmc/hash.pmc"

    IMAGE_IO * const io   = info->image_io;
    Hash * const     hash = (Hash *)PMC_struct_val(pmc);;

    Parrot_default_freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, VTABLE_elements(interp, pmc));
    VTABLE_push_integer(interp, io, hash->key_type);
    VTABLE_push_integer(interp, io, hash->entry_type);
#line 298 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 504 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc)) != 0;
#line 306 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 217 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc));
#line 314 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 265 "./src/pmc/hash.pmc"

    PMC        *valpmc;
    STRING     *keystr;
    HashBucket *b;
    PMC        *nextkey;
    const Hash * const hash = (Hash *)PMC_struct_val(pmc);

    /* called from iterator with an integer idx in key */
    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_hash_iterator_FLAGS) {

        /* check if we really have Hash_key_type_int */
        if (hash->key_type == Hash_key_type_int) {
            void *idx = parrot_hash_get_idx(interp, hash, key);
            return (INTVAL)idx;
        }
        else {
            const STRING * const s =
                (STRING *)parrot_hash_get_idx(interp, hash, key);
            return string_to_int(interp, s);
        }
    }

    keystr  = make_hash_key(interp, key);
    b       = parrot_hash_get_bucket(interp, hash, keystr);

    if (!b)
        return 0;

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_get_integer(interp, valpmc);

    return VTABLE_get_integer_keyed(interp, valpmc, nextkey);
#line 355 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 241 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)PMC_struct_val(pmc);
    HashBucket *b;

    if (hash->key_type == Hash_key_type_STRING)
        return Parrot_Hash_get_integer_keyed_str(interp, pmc, string_from_int(interp, key));

    b = parrot_hash_get_bucket(interp, hash, (void *)key);

    if (!b)
        return 0;

    return (INTVAL)b->value;
#line 374 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 231 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash *)PMC_struct_val(pmc), key);

    if (!b)
        return 0;

    return VTABLE_get_integer(interp, (PMC*) b->value);
#line 388 "./src/pmc/hash.c"
}
PMC  *
Parrot_Hash_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 561 "./src/pmc/hash.pmc"

    PMC * const iter     = pmc_new_init(interp, enum_class_Iterator, pmc);
    PMC * const key      =  pmc_new(interp, enum_class_Key);

    PMC_struct_val(iter) = key;
    PObj_get_FLAGS(key) |= KEY_hash_iterator_FLAGS;
    PMC_data(key)        = (void *)INITBucketIndex;

    /* -1 for an empty hash, 0 for a non-empty hash.  */
    PMC_int_val(key)     =
        parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc)) ? 0 : -1;

    return iter;
#line 407 "./src/pmc/hash.c"
}
FLOATVAL
Parrot_Hash_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 336 "./src/pmc/hash.pmc"

    PMC               *nextkey;
    PMC               *valpmc;
    STRING     * const keystr = make_hash_key(interp, key);
    HashBucket * const b      = parrot_hash_get_bucket(interp,
                                       (Hash*)PMC_struct_val(pmc), keystr);

    if (!b)
        return 0.0;

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_get_number(interp, valpmc);

    return VTABLE_get_number_keyed(interp, valpmc, nextkey);
#line 430 "./src/pmc/hash.c"
}
FLOATVAL
Parrot_Hash_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 322 "./src/pmc/hash.pmc"

    STRING * const s = string_from_int(interp, key);
    return Parrot_Hash_get_number_keyed_str(interp, pmc, s);
#line 439 "./src/pmc/hash.c"
}
FLOATVAL
Parrot_Hash_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 312 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);

    if (!b)
        return 0.0;

    return VTABLE_get_number(interp, (PMC *)b->value);
#line 453 "./src/pmc/hash.c"
}
PMC  *
Parrot_Hash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 580 "./src/pmc/hash.pmc"

    Hash   * const hash = (Hash *)PMC_struct_val(pmc);
    STRING        *keystr;
    HashBucket    *b;
    PMC           *nextkey;
    PMC           *result;

    /* called from iterator with an integer idx in key */
    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_hash_iterator_FLAGS) {
        /* check if we really have Hash_key_type_int */
        if (hash->key_type == Hash_key_type_int) {
            void *idx           = parrot_hash_get_idx(interp, hash,key);
            const INTVAL i      = (INTVAL)idx;
            result              = pmc_new(interp, enum_class_Integer);
            PMC_int_val(result) = i;
        }
        else {
            STRING *s = (STRING *)parrot_hash_get_idx(interp, hash, key);
            result    = pmc_new(interp, enum_class_String);
            VTABLE_set_string_native(interp, result, s);
        }

        return result;
    }

    keystr = make_hash_key(interp, key);
    b      = parrot_hash_get_bucket(interp, hash, keystr);

    if (!b)
        return PMCNULL;

    nextkey = key_next(interp, key);

    if (!nextkey)
        return (PMC *)b->value;

    return VTABLE_get_pmc_keyed(interp, (PMC*)b->value, nextkey);
#line 496 "./src/pmc/hash.c"
}
PMC  *
Parrot_Hash_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 542 "./src/pmc/hash.pmc"

    STRING * const s = string_from_int(interp, key);
    return Parrot_Hash_get_pmc_keyed_str(interp, pmc, s);
#line 505 "./src/pmc/hash.c"
}
PMC  *
Parrot_Hash_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 532 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);

    if (!b)
        return PMCNULL;

    return (PMC *)b->value;
#line 519 "./src/pmc/hash.c"
}
STRING  *
Parrot_Hash_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 375 "./src/pmc/hash.pmc"

    /* TODO use freeze */
    PMC * const  iter = VTABLE_get_iter(interp, pmc);
    STRING      *res  = string_from_literal(interp, "{");
    const INTVAL n    = VTABLE_elements(interp, pmc);
    INTVAL       j;

    for (j = 0; j < n; ++j) {
        STRING * const key       = VTABLE_shift_string(interp, iter);
        int            all_digit = 1;
        int            i;
        PMC           *val;

        for (i = 0; i < (int)key->strlen; ++i) {
            if (!isdigit((unsigned char)((char *)key->strstart)[i])) {
                all_digit = 0;
                break;
            }
        }

        if (all_digit) {
            res = string_append(interp, res, key);
        }
        else {
            res = string_append(interp, res, const_string(interp, "'"));
            res = string_append(interp, res, key);
            res = string_append(interp, res, const_string(interp, "'"));
        }

        res = string_append(interp, res, const_string(interp, ": "));
        val = Parrot_Hash_get_pmc_keyed_str(interp, pmc, key);
        res = string_append(interp, res, VTABLE_get_string(interp, val));

        if (j < n - 1)
            res = string_append(interp, res, const_string(interp, ", "));
    }

    res = string_append(interp, res, const_string(interp, "}"));

    return res;
#line 565 "./src/pmc/hash.c"
}
STRING  *
Parrot_Hash_get_string(PARROT_INTERP, PMC *pmc)
{
#line 371 "./src/pmc/hash.pmc"

    return Parrot_sprintf_c(interp, "Hash[0x%x]", pmc);
#line 573 "./src/pmc/hash.c"
}
STRING  *
Parrot_Hash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 457 "./src/pmc/hash.pmc"

    PMC         *valpmc;
    STRING      *keystr;
    HashBucket  *b;
    PMC         *nextkey;
    Hash * const hash = (Hash *)PMC_struct_val(pmc);

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_hash_iterator_FLAGS) {
        /* called from iterator with an integer idx in key */
        if (hash->key_type == Hash_key_type_int) {
            void  *idx = parrot_hash_get_idx(interp, hash, key);
            return string_from_int(interp, (INTVAL)idx);
        }

        return (STRING *)parrot_hash_get_idx(interp, hash, key);
    }

    keystr = make_hash_key(interp, key);
    b      = parrot_hash_get_bucket(interp, hash, keystr);

    /*
     * TODO current behaviour of $S0 = hsh['no_such_key'] in
     *      PGE and possibly more code needs an empty STRING
     *      (--leo)
     */
    if (!b)
        return string_make_empty(interp, enum_stringrep_one, 0);

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_get_string(interp, valpmc);

    return VTABLE_get_string_keyed(interp, valpmc, nextkey);
#line 614 "./src/pmc/hash.c"
}
STRING  *
Parrot_Hash_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 442 "./src/pmc/hash.pmc"

    STRING * const s = string_from_int(interp, key);
    return Parrot_Hash_get_string_keyed_str(interp, pmc, s);
#line 623 "./src/pmc/hash.c"
}
STRING  *
Parrot_Hash_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 427 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash *)PMC_struct_val(pmc), key);

    /*
     * TODO current behaviour of $S0 = hsh['no_such_key'] in
     *      PGE and possibly more code needs an empty STRING
     *      (--leo)
     */
    if (!b)
        return string_make_empty(interp, enum_stringrep_one, 0);

    return VTABLE_get_string(interp, (PMC*) b->value);
#line 642 "./src/pmc/hash.c"
}
void
Parrot_Hash_init(PARROT_INTERP, PMC *pmc)
{
#line 110 "./src/pmc/hash.pmc"

    PMC_struct_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
    parrot_new_pmc_hash(interp, pmc);
#line 652 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_is_same(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 629 "./src/pmc/hash.pmc"

    return (INTVAL)(other->vtable == pmc->vtable &&
        PMC_struct_val(other) == PMC_struct_val(pmc));
#line 661 "./src/pmc/hash.c"
}
void
Parrot_Hash_mark(PARROT_INTERP, PMC *pmc)
{
#line 132 "./src/pmc/hash.pmc"

    if (PMC_struct_val(pmc))
        parrot_mark_hash(interp, (Hash *)PMC_struct_val(pmc));
#line 670 "./src/pmc/hash.c"
}
void
Parrot_Hash_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 642 "./src/pmc/hash.pmc"

    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        PMC *val = get_integer_pmc(interp, pmc->vtable->base_type);

        VTABLE_set_integer_native(interp, val, value);
        parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), keystr, val);
        return;
    }

    box = Parrot_Hash_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_keyed(interp, box, nextkey, value);
#line 702 "./src/pmc/hash.c"
}
void
Parrot_Hash_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
#line 678 "./src/pmc/hash.pmc"

    PMC * const val  = get_integer_pmc(interp, pmc->vtable->base_type);
    PMC_int_val(val) = value;

    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, val);
#line 713 "./src/pmc/hash.c"
}
void
Parrot_Hash_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 693 "./src/pmc/hash.pmc"

    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        PMC *val         = get_number_pmc(interp, pmc->vtable->base_type);
        PMC_num_val(val) = value;
        parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), keystr, val);
        return;
    }

    box = Parrot_Hash_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_keyed(interp, box, nextkey, value);
#line 744 "./src/pmc/hash.c"
}
void
Parrot_Hash_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
#line 730 "./src/pmc/hash.pmc"

    PMC * const val  = get_number_pmc(interp, pmc->vtable->base_type);
    PMC_num_val(val) = value;

    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, val);
#line 755 "./src/pmc/hash.c"
}
void
Parrot_Hash_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 795 "./src/pmc/hash.pmc"

    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        parrot_hash_put(interp, (Hash*)PMC_struct_val(pmc), keystr, value);
        return;
    }

    box = Parrot_Hash_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_pmc_keyed(interp, box, nextkey, value);
#line 784 "./src/pmc/hash.c"
}
void
Parrot_Hash_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 830 "./src/pmc/hash.pmc"

    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, value);
#line 792 "./src/pmc/hash.c"
}
void
Parrot_Hash_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 745 "./src/pmc/hash.pmc"

    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        PMC * const val = get_string_pmc(interp, pmc->vtable->base_type);
        VTABLE_set_string_native(interp, val, value);
        parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), keystr, val);
        return;
    }

    box = Parrot_Hash_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_keyed(interp, box, nextkey, value);
#line 823 "./src/pmc/hash.c"
}
void
Parrot_Hash_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
#line 780 "./src/pmc/hash.pmc"

    PMC * const val = get_string_pmc(interp, pmc->vtable->base_type);

    VTABLE_set_string_native(interp, val, value);
    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, val);
#line 834 "./src/pmc/hash.c"
}
PMC  *
Parrot_Hash_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL f)
{
#line 1019 "./src/pmc/hash.pmc"

    if (f == 0) {
        PMC * const iter = pmc_new_init(interp, enum_class_Iterator, pmc);
        PMC_struct_val(iter) = key;
        return iter;
    }

    real_exception(interp, NULL, E_IndexError, "Hash: Unknown slice type");
#line 848 "./src/pmc/hash.c"
}
void
Parrot_Hash_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1076 "./src/pmc/hash.pmc"

    IMAGE_IO * const io = info->image_io;

    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL) {
        const INTVAL elems  = VTABLE_shift_integer(interp, io);
        const INTVAL k_type = VTABLE_shift_integer(interp, io);
        const INTVAL v_type = VTABLE_shift_integer(interp, io);
        Hash        *hash;

        /* TODO make a better interface for hash creation
         * TODO create hash with needed size in the first place
         */
        if (k_type == Hash_key_type_int && v_type == enum_hash_int) {
            PMC * const dummy     = Parrot_new_INTVAL_hash(interp, 0);
            PMC_struct_val(pmc)  = PMC_struct_val(dummy);
            PMC_struct_val(dummy) = NULL;
        }

        hash            = (Hash *)PMC_struct_val(pmc);

        PARROT_ASSERT((INTVAL)hash->key_type == k_type);
        PARROT_ASSERT(hash->entry_type       == v_type);

        hash->container = pmc;
        hash->entries   = elems;
    }
#line 881 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_type_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 167 "./src/pmc/hash.pmc"

    PMC               *valpmc;
    PMC               *nextkey;
    STRING     * const keystr = make_hash_key(interp, key);
    HashBucket * const b      = parrot_hash_get_bucket(interp,
        (Hash *)PMC_struct_val(pmc), keystr);

    if (!b)
        return 0;

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_type(interp, valpmc);

    return VTABLE_type_keyed(interp, valpmc, nextkey);
#line 904 "./src/pmc/hash.c"
}
INTVAL
Parrot_Hash_type_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 147 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash *)PMC_struct_val(pmc), key);

    if (!b)
        return 0;

    return VTABLE_type(interp, (PMC *)b->value);
#line 918 "./src/pmc/hash.c"
}
void
Parrot_Hash_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1040 "./src/pmc/hash.pmc"

    info->container = pmc;
    parrot_hash_visit(interp, (Hash *)PMC_struct_val(pmc), info);
    Parrot_default_visit(interp, pmc, info);
#line 928 "./src/pmc/hash.c"
}
void
Parrot_Hash_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Hash");
}
void
Parrot_Hash_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Hash");
}
void
Parrot_Hash_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Hash");
}
void
Parrot_Hash_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Hash");
}
void
Parrot_Hash_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Hash");
}
void
Parrot_Hash_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Hash");
}
void
Parrot_Hash_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Hash");
}
void
Parrot_Hash_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Hash");
}
void
Parrot_Hash_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Hash");
}
PMC *
Parrot_Hash_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Hash_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Hash");
}
void
Parrot_Hash_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Hash");
}
void
Parrot_Hash_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Hash");
}
void
Parrot_Hash_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Hash");
}
void
Parrot_Hash_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Hash");
}
void
Parrot_Hash_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Hash");
}
void
Parrot_Hash_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Hash");
}
FLOATVAL
Parrot_Hash_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Hash");
}
INTVAL
Parrot_Hash_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Hash");
}
PMC *
Parrot_Hash_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Hash");
}
STRING *
Parrot_Hash_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Hash");
}
void
Parrot_Hash_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Hash");
}
void
Parrot_Hash_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Hash");
}
void
Parrot_Hash_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Hash");
}
void
Parrot_Hash_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Hash");
}
void
Parrot_Hash_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Hash");
}
void
Parrot_Hash_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Hash");
}
void
Parrot_Hash_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Hash");
}
void
Parrot_Hash_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Hash");
}
void
Parrot_Hash_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Hash");
}
void
Parrot_Hash_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Hash");
}
FLOATVAL
Parrot_Hash_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Hash");
}
INTVAL
Parrot_Hash_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Hash");
}
PMC *
Parrot_Hash_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Hash");
}
STRING *
Parrot_Hash_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Hash");
}
void
Parrot_Hash_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Hash");
}
void
Parrot_Hash_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Hash");
}
void
Parrot_Hash_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Hash");
}
void
Parrot_Hash_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Hash");
}
void
Parrot_Hash_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Hash");
}
void
Parrot_Hash_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Hash");
}
void
Parrot_Hash_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Hash");
}
void
Parrot_Hash_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_Hash, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Hash_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_Hash_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_Hash_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_Hash_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Hash_destroy,
        Parrot_default_does,
        Parrot_Hash_elements,
        Parrot_Hash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_Hash_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Hash_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_Hash_get_integer_keyed,
        Parrot_Hash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_number,
        Parrot_Hash_get_number_keyed,
        Parrot_Hash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Hash_get_pmc_keyed,
        Parrot_Hash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string,
        Parrot_Hash_get_string_keyed,
        Parrot_Hash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Hash_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_Hash_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_Hash_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_Hash_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_Hash_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_Hash_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_Hash_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Hash_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_Hash_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_Hash_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Hash_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Hash_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_Hash, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Hash_ro_add_attribute,
        Parrot_Hash_ro_add_method,
        Parrot_Hash_ro_add_parent,
        Parrot_Hash_ro_add_role,
        Parrot_Hash_ro_add_vtable_override,
        Parrot_Hash_ro_assign_pmc,
        Parrot_Hash_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Hash_clone,
        Parrot_default_clone_pmc,
        Parrot_Hash_ro_decrement,
        Parrot_default_defined,
        Parrot_Hash_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_Hash_ro_delete_keyed,
        Parrot_Hash_ro_delete_keyed_int,
        Parrot_Hash_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Hash_destroy,
        Parrot_default_does,
        Parrot_Hash_elements,
        Parrot_Hash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_Hash_exists_keyed_str,
        Parrot_Hash_ro_find_method,
        Parrot_Hash_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_Hash_get_integer_keyed,
        Parrot_Hash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_number,
        Parrot_Hash_get_number_keyed,
        Parrot_Hash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Hash_get_pmc_keyed,
        Parrot_Hash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string,
        Parrot_Hash_get_string_keyed,
        Parrot_Hash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Hash_ro_i_absolute,
        Parrot_Hash_ro_i_bitwise_not,
        Parrot_Hash_ro_i_bitwise_nots,
        Parrot_Hash_ro_i_logical_not,
        Parrot_Hash_ro_i_neg,
        Parrot_Hash_ro_increment,
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Hash_mark,
        Parrot_Hash_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Hash_ro_pop_float,
        Parrot_Hash_ro_pop_integer,
        Parrot_Hash_ro_pop_pmc,
        Parrot_Hash_ro_pop_string,
        Parrot_Hash_ro_push_float,
        Parrot_Hash_ro_push_integer,
        Parrot_Hash_ro_push_pmc,
        Parrot_Hash_ro_push_string,
        Parrot_Hash_ro_remove_attribute,
        Parrot_Hash_ro_remove_method,
        Parrot_Hash_ro_remove_parent,
        Parrot_Hash_ro_remove_role,
        Parrot_Hash_ro_remove_vtable_override,
        Parrot_Hash_ro_set_attr,
        Parrot_Hash_ro_set_attr_str,
        Parrot_Hash_ro_set_bignum_int,
        Parrot_Hash_ro_set_bignum_num,
        Parrot_Hash_ro_set_bignum_str,
        Parrot_Hash_ro_set_bool,
        Parrot_Hash_ro_set_integer_keyed,
        Parrot_Hash_ro_set_integer_keyed_int,
        Parrot_Hash_ro_set_integer_keyed_str,
        Parrot_Hash_ro_set_integer_native,
        Parrot_Hash_ro_set_integer_same,
        Parrot_Hash_ro_set_number_keyed,
        Parrot_Hash_ro_set_number_keyed_int,
        Parrot_Hash_ro_set_number_keyed_str,
        Parrot_Hash_ro_set_number_native,
        Parrot_Hash_ro_set_number_same,
        Parrot_Hash_ro_set_pmc,
        Parrot_Hash_ro_set_pmc_keyed,
        Parrot_Hash_ro_set_pmc_keyed_int,
        Parrot_Hash_ro_set_pmc_keyed_str,
        Parrot_Hash_ro_set_pointer,
        Parrot_Hash_ro_set_pointer_keyed,
        Parrot_Hash_ro_set_pointer_keyed_int,
        Parrot_Hash_ro_set_pointer_keyed_str,
        Parrot_Hash_ro_set_string_keyed,
        Parrot_Hash_ro_set_string_keyed_int,
        Parrot_Hash_ro_set_string_keyed_str,
        Parrot_Hash_ro_set_string_native,
        Parrot_Hash_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Hash_ro_shift_float,
        Parrot_Hash_ro_shift_integer,
        Parrot_Hash_ro_shift_pmc,
        Parrot_Hash_ro_shift_string,
        Parrot_Hash_slice,
        Parrot_Hash_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Hash_ro_thaw,
        Parrot_Hash_ro_thawfinish,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_Hash_ro_unshift_float,
        Parrot_Hash_ro_unshift_integer,
        Parrot_Hash_ro_unshift_pmc,
        Parrot_Hash_ro_unshift_string,
        Parrot_Hash_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_Hash_is_equal }
    };
    /* Dynamic PMCs need the runtime type which is passed in entry to class_init. */
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Hash");
        vt_clone->isa_str = CONST_STRING(interp, "Hash");
        vt_clone->does_str = CONST_STRING(interp, "hash");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
        }
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_Hash_class_init */
#line 1103 "./src/pmc/hash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
