/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/integer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/integer.pmc"
/*
Copyright (C) 2003-2007, The Perl Foundation.
$Id: integer.pmc 21147 2007-09-08 21:36:34Z paultcochrane $

=head1 NAME

src/pmc/integer.pmc - Integer PMC class

=head1 DESCRIPTION

C<Integer> provides an integer for languages that want a value-restricted
integer type without going to an I register.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

/* XXX create MMD headers to in Pmc2c.pm */
extern INTVAL Parrot_BigInt_is_equal_BigInt(PARROT_INTERP, PMC*, PMC*);
extern PMC *Parrot_BigInt_multiply_int(PARROT_INTERP,
        PMC *pmc, INTVAL value, PMC *dest) ;

static PMC*
overflow(PARROT_INTERP, PMC *self, INTVAL b, PMC *dest, int mmd) {
    const INTVAL a = VTABLE_get_integer(interp, self);

    if (PARROT_ERRORS_test(interp,PARROT_ERRORS_OVERFLOW_FLAG))
        real_exception(interp, NULL, ERR_OVERFLOW, "Integer overflow");

    if (self == dest) {
        /* TODO preserve type system */
        VTABLE_morph(interp, self, enum_class_BigInt);
        VTABLE_set_integer_native(interp, self, a);
        return mmd_dispatch_p_pip(interp, self, b, dest, mmd);
    }
    else {
        PMC * const temp = VTABLE_get_bignum(interp, self);
        return mmd_dispatch_p_pip(interp, temp, b, dest, mmd);
    }
}

static PMC*
overflow_p(PARROT_INTERP, PMC *self, PMC *val, PMC *dest, int mmd) {
    const INTVAL a = VTABLE_get_integer(interp, self);

    if (PARROT_ERRORS_test(interp,PARROT_ERRORS_OVERFLOW_FLAG))
        real_exception(interp, NULL, ERR_OVERFLOW, "Integer overflow");

    if (self == dest) {
        VTABLE_morph(interp, self, enum_class_BigInt);
        VTABLE_set_integer_native(interp, self, a);
        return mmd_dispatch_p_ppp(interp, self, val, dest, mmd);
    }
    else {
        PMC * const temp = VTABLE_get_bignum(interp, self);
        return mmd_dispatch_p_ppp(interp, temp, val, dest, mmd);
    }
}
#line 79 "./src/pmc/integer.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_integer.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "integer.str"
PMC  *
Parrot_Integer_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 359 "./src/pmc/integer.pmc"

        if (!dest)
            dest = pmc_new(interp, value->vtable->base_type);

        VTABLE_set_number_native(interp, dest,
            VTABLE_get_integer(interp, pmc) + VTABLE_get_number(interp, value));
        return dest;
#line 98 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 317 "./src/pmc/integer.pmc"

        /*
         * pmc and value can both be PMCs that inherit
         * from Integer:
         *   cl = subclass "Integer", "MyInt"
         * so we can't used PMC_int_val(pmc) in any of these
         * Integer methods
         *
         * TODO
         *   check for exact Integer type
         *   e.g. MMD_Integer_EXACT
         */

        const INTVAL a = VTABLE_get_integer(interp, pmc);
        const INTVAL b = VTABLE_get_integer(interp, value);
        const INTVAL c = a + b;

        if ((c^a) >= 0 || (c^b) >= 0) {
            if (!dest)
                dest = pmc_new(interp, pmc->vtable->base_type);

            /* need this for e.g. Undef PMC */
            VTABLE_set_integer_native(interp, dest, c);
            return dest;
        }
        else
            return overflow(interp, pmc, b, dest, MMD_ADD);
#line 131 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 344 "./src/pmc/integer.pmc"

        const INTVAL a = VTABLE_get_integer(interp, pmc);
        if (dest)
            VTABLE_morph(interp, dest, value->vtable->base_type);
        else
            dest = pmc_new(interp, value->vtable->base_type);

        VTABLE_set_number_native(interp, dest,
                a + VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, dest, 1,
                VTABLE_get_number_keyed_int(interp, value, 1));

        return dest;
#line 150 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_add_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 357 "./src/pmc/integer.pmc"

        return overflow_p(interp, pmc, value, dest, MMD_ADD);
#line 158 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_add_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 373 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0) {
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else
        return overflow(interp, pmc, b, dest, MMD_ADD);
#line 177 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 413 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
        PMC_int_val(pmc) + VTABLE_get_number(interp, value));
#line 186 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 402 "./src/pmc/integer.pmc"

        Parrot_Integer_i_add_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 194 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 404 "./src/pmc/integer.pmc"

        const INTVAL a = VTABLE_get_integer(interp, pmc);

        VTABLE_morph(interp, pmc, value->vtable->base_type);
        VTABLE_set_number_native(interp, pmc,
                (FLOATVAL)a +
                VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, pmc, 1,
                VTABLE_get_number_keyed_int(interp, value, 1));
#line 209 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 422 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else
        overflow(interp, pmc, b, pmc, MMD_SUBTRACT);
#line 223 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 432 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a + value);
#line 232 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 478 "./src/pmc/integer.pmc"

        if (!dest)
            dest = pmc_new(interp, value->vtable->base_type);

        VTABLE_set_number_native(interp, dest,
            VTABLE_get_integer(interp, pmc) - VTABLE_get_number(interp, value));
        return dest;
#line 245 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 449 "./src/pmc/integer.pmc"

        const INTVAL a = VTABLE_get_integer(interp, pmc);
        const INTVAL b = VTABLE_get_integer(interp, value);
        const INTVAL c = a - b;

        if ((c^a) >= 0 || (c^~b) >= 0) {
            if (!dest)
                dest = pmc_new(interp, pmc->vtable->base_type);

            VTABLE_set_integer_native(interp, dest, c);
            return dest;
        }
        else
            return overflow(interp, pmc, b, dest, MMD_SUBTRACT);
#line 265 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 463 "./src/pmc/integer.pmc"

        const INTVAL a = VTABLE_get_integer(interp, pmc);
        if (dest)
            VTABLE_morph(interp, dest, value->vtable->base_type);
        else
            dest = pmc_new(interp, value->vtable->base_type);

        VTABLE_set_number_native(interp, dest,
                a - VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, dest, 1,
                -VTABLE_get_number_keyed_int(interp, value, 1));

        return dest;
#line 284 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_subtract_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 476 "./src/pmc/integer.pmc"

        return overflow_p(interp, pmc, value, dest, MMD_SUBTRACT);
#line 292 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 501 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0) {
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else
        return overflow(interp, pmc, b, dest, MMD_SUBTRACT);
#line 311 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 548 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_integer(interp, pmc) - VTABLE_get_number(interp, value));
#line 320 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 530 "./src/pmc/integer.pmc"

        const INTVAL a = VTABLE_get_integer(interp, pmc);
        const INTVAL b = VTABLE_get_integer(interp, value);
        const INTVAL c = a - b;

        if ((c^a) >= 0 || (c^~b) >= 0)
            VTABLE_set_integer_native(interp, pmc, c);
        else
            overflow(interp, pmc, b, pmc, MMD_SUBTRACT);
#line 335 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 539 "./src/pmc/integer.pmc"

        const INTVAL a = VTABLE_get_integer(interp, pmc);

        VTABLE_morph(interp, pmc, value->vtable->base_type);
        VTABLE_set_number_native(interp, pmc,
                (FLOATVAL)a -
                VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, pmc, 1,
                -VTABLE_get_number_keyed_int(interp, value, 1));
#line 350 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 557 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else
        overflow(interp, pmc, b, pmc, MMD_SUBTRACT);
#line 364 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 567 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a - value);
#line 373 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 606 "./src/pmc/integer.pmc"

        const FLOATVAL valf = VTABLE_get_number(interp, value);
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);

        VTABLE_set_number_native(interp, dest, valf * PMC_int_val(pmc));
        return dest;
#line 386 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 583 "./src/pmc/integer.pmc"

        const INTVAL a  = VTABLE_get_integer(interp, pmc);
        const INTVAL b  = VTABLE_get_integer(interp, value);
        const double cf = (double)a * (double)b;
        const INTVAL c  = a * b;

        if ((double) c == cf) {
            if (!dest)
                dest = pmc_new(interp, pmc->vtable->base_type);

            VTABLE_set_integer_native(interp, dest, c);
            return dest;
        }
        else
            return overflow(interp, pmc, b, dest, MMD_MULTIPLY);
#line 407 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 598 "./src/pmc/integer.pmc"

            real_exception(interp, NULL, E_NotImplementedError,
                    "TODO mul<Integer, Complex>");
#line 416 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 601 "./src/pmc/integer.pmc"

        return Parrot_BigInt_multiply_int(interp, value,
                VTABLE_get_integer(interp, pmc), dest);
#line 425 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_multiply_String(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 604 "./src/pmc/integer.pmc"

        return Parrot_Integer_multiply_Integer(interp, pmc, value, dest);
#line 433 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 621 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const double cf = (double)a * (double)b;
    const INTVAL c  = a * b;

    if ((double) c == cf) {
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else
        return overflow(interp, pmc, b, dest, MMD_MULTIPLY);
#line 453 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 659 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
        PMC_int_val(pmc) * VTABLE_get_number(interp, value));
#line 462 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 651 "./src/pmc/integer.pmc"

        Parrot_Integer_i_multiply_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 470 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 653 "./src/pmc/integer.pmc"

        Parrot_BigInt_multiply_int(interp, value,
                VTABLE_get_integer(interp, pmc), pmc);
#line 479 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 656 "./src/pmc/integer.pmc"

            real_exception(interp, NULL, E_NotImplementedError,
                    "TODO i_mul<Integer, Complex>");
#line 488 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 669 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const double cf = (double)a * (double)b;
    const INTVAL c  = a * b;

    if ((double) c == cf)
        VTABLE_set_integer_native(interp, pmc, c);
    else
        overflow(interp, pmc, b, pmc, MMD_MULTIPLY);
#line 503 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 680 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a * value);
#line 512 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 709 "./src/pmc/integer.pmc"

        FLOATVAL d = VTABLE_get_number(interp, value);

        if (FLOAT_IS_ZERO(d))
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "float division by zero");
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_number_native(interp, dest, VTABLE_get_number(interp, pmc) / d);
        return dest;
#line 528 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 707 "./src/pmc/integer.pmc"

        return overflow_p(interp, pmc, value, dest, MMD_DIVIDE);
#line 536 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 726 "./src/pmc/integer.pmc"

        FLOATVAL d = VTABLE_get_number(interp, value);

        if (FLOAT_IS_ZERO(d))
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "float division by zero");
        VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) / d);
#line 549 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 724 "./src/pmc/integer.pmc"

         overflow_p(interp, pmc, value, pmc, MMD_DIVIDE);
#line 557 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 762 "./src/pmc/integer.pmc"

        FLOATVAL d = VTABLE_get_number(interp, value);
        FLOATVAL f;

        if (FLOAT_IS_ZERO(d))
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "float division by zero");
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);

        f = floor(VTABLE_get_number(interp, pmc) / d);
        VTABLE_set_integer_native(interp, dest, (INTVAL)f);
        return dest;
#line 576 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 760 "./src/pmc/integer.pmc"

        return overflow_p(interp, pmc, value, dest, MMD_FLOOR_DIVIDE);
#line 584 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 780 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 604 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 796 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 624 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 814 "./src/pmc/integer.pmc"

        FLOATVAL d = VTABLE_get_number(interp, value);
        FLOATVAL f;

        if (FLOAT_IS_ZERO(d))
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "float division by zero");

        f = floor(VTABLE_get_number(interp, pmc) / d);
        VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 640 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 812 "./src/pmc/integer.pmc"

        overflow_p(interp, pmc, value, pmc, MMD_FLOOR_DIVIDE);
#line 648 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 829 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 663 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 840 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 678 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 980 "./src/pmc/integer.pmc"

        const INTVAL d = VTABLE_get_integer(interp, value);

        if (d == 0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "int modulus by zero");

        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);

        VTABLE_set_integer_native(interp, dest,
                intval_mod(VTABLE_get_integer(interp, pmc), d));
        return dest;
#line 697 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 978 "./src/pmc/integer.pmc"

        return overflow_p(interp, pmc, value, dest, MMD_MOD);
#line 705 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 998 "./src/pmc/integer.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int modulus by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest,
            intval_mod(VTABLE_get_integer(interp, pmc), value));
    return dest;
#line 722 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1011 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int modulus by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest,
            intval_mod(VTABLE_get_integer(interp, pmc), (INTVAL)value));
    return dest;
#line 739 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1025 "./src/pmc/integer.pmc"

        const INTVAL d = VTABLE_get_integer(interp, value);

        if (d == 0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "int modulus by zero");

        VTABLE_set_integer_native(interp, pmc,
                intval_mod(VTABLE_get_integer(interp, pmc), d));
#line 754 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1023 "./src/pmc/integer.pmc"

         overflow_p(interp, pmc, value, pmc, MMD_MOD);
#line 762 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1039 "./src/pmc/integer.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(VTABLE_get_integer(interp, pmc) , value));
#line 775 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1048 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(VTABLE_get_integer(interp, pmc) , (INTVAL)value));
#line 788 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_cmodulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 877 "./src/pmc/integer.pmc"

        INTVAL d = VTABLE_get_integer(interp, value);

        if (d == 0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "int cmodulus by zero");
        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);

        VTABLE_set_integer_native(interp, dest,
                VTABLE_get_integer(interp, pmc) % d);
        return dest;
#line 806 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_cmodulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 875 "./src/pmc/integer.pmc"

        return overflow_p(interp, pmc, value, dest, MMD_CMOD);
#line 814 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_cmodulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 910 "./src/pmc/integer.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, dest,
            VTABLE_get_integer(interp, pmc) % value);
    return dest;
#line 829 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_cmodulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 894 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    f = fmod(VTABLE_get_integer(interp, pmc), value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 849 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_cmodulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 923 "./src/pmc/integer.pmc"

        const INTVAL d = VTABLE_get_integer(interp, value);

        if (d == 0)
            real_exception(interp, NULL, E_ZeroDivisionError,
                    "int cmodulus by zero");
        VTABLE_set_integer_native(interp, pmc,
                VTABLE_get_integer(interp, pmc) % d);
#line 863 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_cmodulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 921 "./src/pmc/integer.pmc"

         overflow_p(interp, pmc, value, pmc, MMD_CMOD);
#line 871 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_cmodulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 936 "./src/pmc/integer.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");
    VTABLE_set_integer_native(interp, pmc,
            VTABLE_get_integer(interp, pmc) % value);
#line 883 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_cmodulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 944 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "int cmodulus by zero");

    f = fmod(VTABLE_get_integer(interp, pmc), value);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 898 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1076 "./src/pmc/integer.pmc"

    const INTVAL v = VTABLE_get_integer(interp, value);
    return Parrot_Integer_pow_int(interp, pmc, v, dest);
#line 907 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_pow_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 1081 "./src/pmc/integer.pmc"

    const INTVAL a      = VTABLE_get_integer(interp, pmc);
    const INTVAL orig_b = b;
    INTVAL       r;

    if (b < 0)
        return Parrot_scalar_pow_int(interp, pmc, b, dest);

    r = 1;

    if (a) {
        INTVAL temp = a;
        while (b > 0) {
            INTVAL prev = r;
            if (b & 1) {
                r *= temp;
                if (r / temp != prev)
                    return overflow(interp, pmc, orig_b, dest, MMD_POW);
            }

            b >>= 1;
            if (!b)
                break;

            prev  = temp;
            temp *= temp;

            if (prev != 0 && temp / prev != prev)
                return overflow(interp, pmc, orig_b, dest, MMD_POW);
        }
    }

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, r);
    return dest;
#line 950 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1120 "./src/pmc/integer.pmc"

    Parrot_Integer_pow(interp, pmc, value, pmc);
#line 958 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1124 "./src/pmc/integer.pmc"

    Parrot_Integer_pow_int(interp, pmc, value, pmc);
#line 966 "./src/pmc/integer.c"
}
INTVAL
Parrot_Integer_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1141 "./src/pmc/integer.pmc"

    return (INTVAL)(PMC_int_val(pmc) ==
        VTABLE_get_integer(interp, value));
#line 975 "./src/pmc/integer.c"
}
INTVAL
Parrot_Integer_is_equal_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1137 "./src/pmc/integer.pmc"

    PMC * const temp = pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, PMC_int_val(pmc));
    return Parrot_BigInt_is_equal_BigInt(interp, temp, value);
#line 985 "./src/pmc/integer.c"
}
INTVAL
Parrot_Integer_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1173 "./src/pmc/integer.pmc"

        /* int or undef */
        const INTVAL diff = PMC_int_val(pmc)
            - VTABLE_get_integer(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 996 "./src/pmc/integer.c"
}
INTVAL
Parrot_Integer_cmp_String(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1158 "./src/pmc/integer.pmc"

        FLOATVAL fdiff =
            PMC_int_val(pmc) - VTABLE_get_number(interp, value);
        if (FLOAT_IS_ZERO(fdiff)) {
            const INTVAL idiff =
                PMC_int_val(pmc) - VTABLE_get_integer(interp, value);
            return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
        }
        else {
            return fdiff > 0 ? 1 : -1;
        }
#line 1013 "./src/pmc/integer.c"
}
INTVAL
Parrot_Integer_cmp_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1169 "./src/pmc/integer.pmc"

        const FLOATVAL diff =
            (FLOATVAL)PMC_int_val(pmc) - VTABLE_get_number(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1023 "./src/pmc/integer.c"
}
INTVAL
Parrot_Integer_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1209 "./src/pmc/integer.pmc"

        /* int or undef */
        const INTVAL diff =
            PMC_int_val(pmc) - VTABLE_get_integer(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1034 "./src/pmc/integer.c"
}
INTVAL
Parrot_Integer_cmp_num_String(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1193 "./src/pmc/integer.pmc"

        FLOATVAL fdiff =
            PMC_int_val(pmc) - VTABLE_get_number(interp, value);

        if (FLOAT_IS_ZERO(fdiff)) {
            const INTVAL idiff =
                PMC_int_val(pmc) - VTABLE_get_integer(interp, value);
            return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
        }
        else {
            return fdiff > 0 ? 1 : -1;
        }
#line 1052 "./src/pmc/integer.c"
}
INTVAL
Parrot_Integer_cmp_num_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1205 "./src/pmc/integer.pmc"

        const FLOATVAL diff =
            (FLOATVAL)PMC_int_val(pmc) - VTABLE_get_number(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1062 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1259 "./src/pmc/integer.pmc"

    const INTVAL a = abs(VTABLE_get_integer(interp, pmc));

    /* XXX overlflow for -maxint */
    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, a);
    return dest;
#line 1077 "./src/pmc/integer.c"
}
void
Parrot_Integer_decrement(PARROT_INTERP, PMC *pmc)
{
#line 1243 "./src/pmc/integer.pmc"

    /* XXX overflow */
    PMC_int_val(pmc) --;
#line 1086 "./src/pmc/integer.c"
}
void
Parrot_Integer_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1306 "./src/pmc/integer.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, PMC_int_val(pmc));
#line 1096 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_get_bignum(PARROT_INTERP, PMC *pmc)
{
#line 217 "./src/pmc/integer.pmc"

    const INTVAL val = VTABLE_get_integer(interp, pmc);
    PMC * const  ret = pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, ret, val);
    return ret;
#line 1107 "./src/pmc/integer.c"
}
INTVAL
Parrot_Integer_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 191 "./src/pmc/integer.pmc"

    return PMC_int_val(pmc) ? 1 : 0;
#line 1115 "./src/pmc/integer.c"
}
INTVAL
Parrot_Integer_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 178 "./src/pmc/integer.pmc"

    return PMC_int_val(pmc);
#line 1123 "./src/pmc/integer.c"
}
FLOATVAL
Parrot_Integer_get_number(PARROT_INTERP, PMC *pmc)
{
#line 204 "./src/pmc/integer.pmc"

    return (FLOATVAL)PMC_int_val(pmc);
#line 1131 "./src/pmc/integer.c"
}
STRING  *
Parrot_Integer_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 237 "./src/pmc/integer.pmc"

    return string_from_int(interp, PMC_int_val(pmc));
#line 1139 "./src/pmc/integer.c"
}
STRING  *
Parrot_Integer_get_string(PARROT_INTERP, PMC *pmc)
{
#line 233 "./src/pmc/integer.pmc"

    return string_from_int(interp, PMC_int_val(pmc));
#line 1147 "./src/pmc/integer.c"
}
void
Parrot_Integer_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 1270 "./src/pmc/integer.pmc"

    const INTVAL a = abs(VTABLE_get_integer(interp, pmc));
    VTABLE_set_integer_native(interp, pmc, a);
#line 1156 "./src/pmc/integer.c"
}
void
Parrot_Integer_increment(PARROT_INTERP, PMC *pmc)
{
#line 1229 "./src/pmc/integer.pmc"

    /* XXX overflow */
    PMC_int_val(pmc) ++;
#line 1165 "./src/pmc/integer.c"
}
void
Parrot_Integer_init(PARROT_INTERP, PMC *pmc)
{
#line 106 "./src/pmc/integer.pmc"

    PMC_int_val(pmc) = 0;
#line 1173 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_instantiate(PARROT_INTERP, PMC *pmc, PMC *sig)
{
#line 80 "./src/pmc/integer.pmc"

    PMC * const ret    = new_pmc_header(interp, 0);
    opcode_t   *arg_op = interp->current_args;
    INTVAL      init   = 0;

    ret->vtable        = interp->vtables[pmc->vtable->base_type];

    if (SIG_ELEMS(sig) == 2) {
        switch (SIG_ITEM(sig, 1)) {
            case PARROT_ARG_I:
                init = REG_INT(interp, arg_op[3]);
                break;
            case PARROT_ARG_IC:
                init = arg_op[3];
                break;
            default:
                real_exception(interp, NULL, 1,
                        "Integer.instantiate: unhandled initializer");
                break;
        }
    }

    PMC_int_val(ret) = init;
    return ret;
#line 1203 "./src/pmc/integer.c"
}
PMC  *
Parrot_Integer_new_from_string(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags)
{
#line 119 "./src/pmc/integer.pmc"

    PMC *res;
    const INTVAL type = pmc->vtable->base_type;

    if (flags & PObj_constant_FLAG)
        res = constant_pmc_new(interp, type);
    else
        res = pmc_new(interp, type);

    /* TODO bigint overflow */
    PMC_int_val(res) = string_to_int(interp, rep);
    return res;
#line 1221 "./src/pmc/integer.c"
}
void
Parrot_Integer_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 291 "./src/pmc/integer.pmc"

    VTABLE_morph(interp, pmc, enum_class_BigInt);
    VTABLE_set_integer_native(interp, pmc, value);
#line 1230 "./src/pmc/integer.c"
}
void
Parrot_Integer_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 286 "./src/pmc/integer.pmc"

    VTABLE_morph(interp, pmc, enum_class_Boolean);
    VTABLE_set_bool(interp, pmc, value);
#line 1239 "./src/pmc/integer.c"
}
void
Parrot_Integer_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 256 "./src/pmc/integer.pmc"

    PMC_int_val(pmc) = value;
#line 1247 "./src/pmc/integer.c"
}
void
Parrot_Integer_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 252 "./src/pmc/integer.pmc"

    PMC_int_val(pmc) = PMC_int_val(value);
#line 1255 "./src/pmc/integer.c"
}
void
Parrot_Integer_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 281 "./src/pmc/integer.pmc"

    VTABLE_morph(interp, pmc, enum_class_Float);
    VTABLE_set_number_native(interp, pmc, value);
#line 1264 "./src/pmc/integer.c"
}
void
Parrot_Integer_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 143 "./src/pmc/integer.pmc"

    PMC_int_val(pmc) = VTABLE_get_integer(interp, value);
#line 1272 "./src/pmc/integer.c"
}
void
Parrot_Integer_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 296 "./src/pmc/integer.pmc"

    VTABLE_morph(interp, pmc, enum_class_String);
    VTABLE_set_string_native(interp, pmc, value);
#line 1281 "./src/pmc/integer.c"
}
void
Parrot_Integer_share(PARROT_INTERP, PMC *pmc)
{
#line 156 "./src/pmc/integer.pmc"

    /*
     * assume that the access to a long is atomic.
     * integers are most often (1) equal to C longs,
     * not C ints, and this makes a difference in 64-bit
     * platforms where longs are 64-bit but ints are 32-bit.
     * (1) Not equal when integers have been configured
     *     to be software-emulated long longs.
     */
    if (sizeof (INTVAL) != sizeof (long))
        Parrot_default_share(interp, pmc);
#line 1298 "./src/pmc/integer.c"
}
void
Parrot_Integer_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1321 "./src/pmc/integer.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
        PMC_int_val(pmc) = VTABLE_shift_integer(interp, io);
#line 1309 "./src/pmc/integer.c"
}
STRING  *
Parrot_Integer_nci_get_as_base(PARROT_INTERP, PMC *pmc, INTVAL base)
{
#line 1286 "./src/pmc/integer.pmc"

    char buf[128];

    if ((base < 2) || (base > 36))
        real_exception(interp, NULL, E_RuntimeError,
                "get_as_base: base out of bounds");

    return int_to_str(interp, buf,
            (HUGEINTVAL)VTABLE_get_integer(interp, pmc), (char)base);
#line 1324 "./src/pmc/integer.c"
}
void
Parrot_Integer_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Integer");
}
void
Parrot_Integer_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Integer");
}
void
Parrot_Integer_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Integer");
}
void
Parrot_Integer_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Integer");
}
void
Parrot_Integer_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Integer");
}
void
Parrot_Integer_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Integer");
}
void
Parrot_Integer_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Integer");
}
void
Parrot_Integer_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Integer");
}
void
Parrot_Integer_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Integer");
}
PMC *
Parrot_Integer_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Integer_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Integer");
}
void
Parrot_Integer_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Integer");
}
void
Parrot_Integer_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Integer");
}
void
Parrot_Integer_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Integer");
}
void
Parrot_Integer_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Integer");
}
void
Parrot_Integer_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Integer");
}
void
Parrot_Integer_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Integer");
}
FLOATVAL
Parrot_Integer_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Integer");
}
INTVAL
Parrot_Integer_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Integer");
}
PMC *
Parrot_Integer_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Integer");
}
STRING *
Parrot_Integer_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Integer");
}
void
Parrot_Integer_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Integer");
}
void
Parrot_Integer_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Integer");
}
void
Parrot_Integer_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Integer");
}
void
Parrot_Integer_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Integer");
}
void
Parrot_Integer_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Integer");
}
void
Parrot_Integer_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Integer");
}
void
Parrot_Integer_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Integer");
}
void
Parrot_Integer_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Integer");
}
void
Parrot_Integer_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Integer");
}
void
Parrot_Integer_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Integer");
}
FLOATVAL
Parrot_Integer_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Integer");
}
INTVAL
Parrot_Integer_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Integer");
}
PMC *
Parrot_Integer_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Integer");
}
STRING *
Parrot_Integer_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Integer");
}
void
Parrot_Integer_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Integer");
}
void
Parrot_Integer_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Integer");
}
void
Parrot_Integer_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Integer");
}
void
Parrot_Integer_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Integer");
}
void
Parrot_Integer_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Integer");
}
void
Parrot_Integer_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Integer");
}
void
Parrot_Integer_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Integer");
}
void
Parrot_Integer_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_Integer, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_Integer_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_scalar_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_scalar_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_scalar_clone,
        Parrot_default_clone_pmc,
        Parrot_Integer_decrement,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Integer_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_Integer_get_bignum,
        Parrot_Integer_get_bool,
        Parrot_default_get_class,
        Parrot_Integer_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_Integer_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Integer_get_repr,
        Parrot_Integer_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Integer_i_absolute,
        Parrot_scalar_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_scalar_i_logical_not,
        Parrot_scalar_i_neg,
        Parrot_Integer_increment,
        Parrot_Integer_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_Integer_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_scalar_logical_not,
        Parrot_default_mark,
        Parrot_scalar_morph,
        Parrot_default_name,
        Parrot_scalar_neg,
        Parrot_Integer_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_Integer_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Integer_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Integer_set_integer_native,
        Parrot_Integer_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Integer_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Integer_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Integer_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_Integer_share,
        Parrot_scalar_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_subtype,
        Parrot_Integer_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_Integer, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_Integer_absolute,
        Parrot_Integer_ro_add_attribute,
        Parrot_Integer_ro_add_method,
        Parrot_Integer_ro_add_parent,
        Parrot_Integer_ro_add_role,
        Parrot_Integer_ro_add_vtable_override,
        Parrot_Integer_ro_assign_pmc,
        Parrot_Integer_ro_assign_string_native,
        Parrot_scalar_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_scalar_clone,
        Parrot_default_clone_pmc,
        Parrot_Integer_ro_decrement,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Integer_ro_delete_keyed,
        Parrot_Integer_ro_delete_keyed_int,
        Parrot_Integer_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Integer_ro_find_method,
        Parrot_Integer_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_Integer_get_bignum,
        Parrot_Integer_get_bool,
        Parrot_default_get_class,
        Parrot_Integer_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_Integer_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Integer_get_repr,
        Parrot_Integer_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Integer_ro_i_absolute,
        Parrot_Integer_ro_i_bitwise_not,
        Parrot_Integer_ro_i_bitwise_nots,
        Parrot_Integer_ro_i_logical_not,
        Parrot_Integer_ro_i_neg,
        Parrot_Integer_ro_increment,
        Parrot_Integer_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_Integer_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_scalar_logical_not,
        Parrot_default_mark,
        Parrot_Integer_ro_morph,
        Parrot_default_name,
        Parrot_scalar_neg,
        Parrot_Integer_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Integer_ro_pop_float,
        Parrot_Integer_ro_pop_integer,
        Parrot_Integer_ro_pop_pmc,
        Parrot_Integer_ro_pop_string,
        Parrot_Integer_ro_push_float,
        Parrot_Integer_ro_push_integer,
        Parrot_Integer_ro_push_pmc,
        Parrot_Integer_ro_push_string,
        Parrot_Integer_ro_remove_attribute,
        Parrot_Integer_ro_remove_method,
        Parrot_Integer_ro_remove_parent,
        Parrot_Integer_ro_remove_role,
        Parrot_Integer_ro_remove_vtable_override,
        Parrot_Integer_ro_set_attr,
        Parrot_Integer_ro_set_attr_str,
        Parrot_Integer_ro_set_bignum_int,
        Parrot_Integer_ro_set_bignum_num,
        Parrot_Integer_ro_set_bignum_str,
        Parrot_Integer_ro_set_bool,
        Parrot_Integer_ro_set_integer_keyed,
        Parrot_Integer_ro_set_integer_keyed_int,
        Parrot_Integer_ro_set_integer_keyed_str,
        Parrot_Integer_ro_set_integer_native,
        Parrot_Integer_ro_set_integer_same,
        Parrot_Integer_ro_set_number_keyed,
        Parrot_Integer_ro_set_number_keyed_int,
        Parrot_Integer_ro_set_number_keyed_str,
        Parrot_Integer_ro_set_number_native,
        Parrot_Integer_ro_set_number_same,
        Parrot_Integer_ro_set_pmc,
        Parrot_Integer_ro_set_pmc_keyed,
        Parrot_Integer_ro_set_pmc_keyed_int,
        Parrot_Integer_ro_set_pmc_keyed_str,
        Parrot_Integer_ro_set_pointer,
        Parrot_Integer_ro_set_pointer_keyed,
        Parrot_Integer_ro_set_pointer_keyed_int,
        Parrot_Integer_ro_set_pointer_keyed_str,
        Parrot_Integer_ro_set_string_keyed,
        Parrot_Integer_ro_set_string_keyed_int,
        Parrot_Integer_ro_set_string_keyed_str,
        Parrot_Integer_ro_set_string_native,
        Parrot_Integer_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_Integer_share,
        Parrot_scalar_share_ro,
        Parrot_Integer_ro_shift_float,
        Parrot_Integer_ro_shift_integer,
        Parrot_Integer_ro_shift_pmc,
        Parrot_Integer_ro_shift_string,
        Parrot_default_slice,
        Parrot_Integer_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_subtype,
        Parrot_Integer_ro_thaw,
        Parrot_Integer_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Integer_ro_unshift_float,
        Parrot_Integer_ro_unshift_integer,
        Parrot_Integer_ro_unshift_pmc,
        Parrot_Integer_ro_unshift_string,
        Parrot_default_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_ADD, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_add_Complex },
        { MMD_ADD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_add },
        { MMD_ADD, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_add_Integer },
        { MMD_ADD, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_add_Complex },
        { MMD_ADD, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_add_BigInt },
        { MMD_ADD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_add_int },
        { MMD_ADD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_add_float },
        { MMD_I_ADD, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_i_add_Complex },
        { MMD_I_ADD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_add },
        { MMD_I_ADD, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_i_add_Integer },
        { MMD_I_ADD, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_i_add_Complex },
        { MMD_I_ADD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_add_int },
        { MMD_I_ADD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_add_float },
        { MMD_SUBTRACT, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_subtract_Complex },
        { MMD_SUBTRACT, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_subtract },
        { MMD_SUBTRACT, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_subtract_Integer },
        { MMD_SUBTRACT, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_subtract_Complex },
        { MMD_SUBTRACT, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_subtract_BigInt },
        { MMD_SUBTRACT, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_subtract_int },
        { MMD_SUBTRACT, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_subtract_float },
        { MMD_I_SUBTRACT, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_i_subtract_Complex },
        { MMD_I_SUBTRACT, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_subtract },
        { MMD_I_SUBTRACT, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_i_subtract_Integer },
        { MMD_I_SUBTRACT, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_i_subtract_Complex },
        { MMD_I_SUBTRACT, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_subtract_int },
        { MMD_I_SUBTRACT, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_subtract_float },
        { MMD_MULTIPLY, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_multiply_Complex },
        { MMD_MULTIPLY, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_multiply },
        { MMD_MULTIPLY, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_multiply_Integer },
        { MMD_MULTIPLY, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_multiply_Complex },
        { MMD_MULTIPLY, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_multiply_BigInt },
        { MMD_MULTIPLY, 0, enum_class_String, (funcptr_t) Parrot_Integer_multiply_String },
        { MMD_MULTIPLY, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_multiply_int },
        { MMD_MULTIPLY, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_multiply_float },
        { MMD_I_MULTIPLY, 0, enum_class_Complex, (funcptr_t) Parrot_scalar_i_multiply_Complex },
        { MMD_I_MULTIPLY, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_multiply },
        { MMD_I_MULTIPLY, 0, enum_class_Integer, (funcptr_t) Parrot_Integer_i_multiply_Integer },
        { MMD_I_MULTIPLY, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_i_multiply_BigInt },
        { MMD_I_MULTIPLY, 0, enum_class_Complex, (funcptr_t) Parrot_Integer_i_multiply_Complex },
        { MMD_I_MULTIPLY, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_multiply_int },
        { MMD_I_MULTIPLY, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_multiply_float },
        { MMD_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_divide },
        { MMD_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_divide_BigInt },
        { MMD_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_divide_int },
        { MMD_DIVIDE, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_divide_float },
        { MMD_I_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_divide },
        { MMD_I_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_i_divide_BigInt },
        { MMD_I_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_divide_int },
        { MMD_I_DIVIDE, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_i_divide_float },
        { MMD_FLOOR_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_floor_divide },
        { MMD_FLOOR_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_floor_divide_BigInt },
        { MMD_FLOOR_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_floor_divide_int },
        { MMD_FLOOR_DIVIDE, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_floor_divide_float },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_floor_divide },
        { MMD_I_FLOOR_DIVIDE, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_i_floor_divide_BigInt },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_floor_divide_int },
        { MMD_I_FLOOR_DIVIDE, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_floor_divide_float },
        { MMD_MOD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_modulus },
        { MMD_MOD, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_modulus_BigInt },
        { MMD_MOD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_modulus_int },
        { MMD_MOD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_modulus_float },
        { MMD_I_MOD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_modulus },
        { MMD_I_MOD, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_i_modulus_BigInt },
        { MMD_I_MOD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_modulus_int },
        { MMD_I_MOD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_modulus_float },
        { MMD_CMOD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_cmodulus },
        { MMD_CMOD, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_cmodulus_BigInt },
        { MMD_CMOD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_cmodulus_int },
        { MMD_CMOD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_cmodulus_float },
        { MMD_I_CMOD, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_cmodulus },
        { MMD_I_CMOD, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_i_cmodulus_BigInt },
        { MMD_I_CMOD, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_cmodulus_int },
        { MMD_I_CMOD, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_Integer_i_cmodulus_float },
        { MMD_POW, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_pow },
        { MMD_POW, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_pow_int },
        { MMD_POW, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_pow_float },
        { MMD_I_POW, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_i_pow },
        { MMD_I_POW, 0, enum_type_INTVAL, (funcptr_t) Parrot_Integer_i_pow_int },
        { MMD_I_POW, 0, enum_type_FLOATVAL, (funcptr_t) Parrot_scalar_i_pow_float },
        { MMD_BOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_or },
        { MMD_BOR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_or_int },
        { MMD_I_BOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_or },
        { MMD_I_BOR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_or_int },
        { MMD_BAND, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_and },
        { MMD_BAND, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_and_int },
        { MMD_I_BAND, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_and },
        { MMD_I_BAND, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_and_int },
        { MMD_BXOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_xor },
        { MMD_BXOR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_xor_int },
        { MMD_I_BXOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_xor },
        { MMD_I_BXOR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_xor_int },
        { MMD_BSL, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_shl },
        { MMD_BSL, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_shl_int },
        { MMD_I_BSL, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_shl },
        { MMD_I_BSL, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_shl_int },
        { MMD_BSR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_shr },
        { MMD_BSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_shr_int },
        { MMD_I_BSR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_shr },
        { MMD_I_BSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_shr_int },
        { MMD_LSR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_bitwise_lsr },
        { MMD_LSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_bitwise_lsr_int },
        { MMD_I_LSR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_bitwise_lsr },
        { MMD_I_LSR, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_bitwise_lsr_int },
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_is_equal },
        { MMD_EQ, 0, enum_class_BigInt, (funcptr_t) Parrot_Integer_is_equal_BigInt },
        { MMD_CMP, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_cmp },
        { MMD_CMP, 0, enum_class_String, (funcptr_t) Parrot_Integer_cmp_String },
        { MMD_CMP, 0, enum_class_Float, (funcptr_t) Parrot_Integer_cmp_Float },
        { MMD_NUMCMP, 0, enum_type_PMC, (funcptr_t) Parrot_Integer_cmp_num },
        { MMD_NUMCMP, 0, enum_class_String, (funcptr_t) Parrot_Integer_cmp_num_String },
        { MMD_NUMCMP, 0, enum_class_Float, (funcptr_t) Parrot_Integer_cmp_num_Float },
        { MMD_STRCMP, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_cmp_string },
        { MMD_LOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_logical_or },
        { MMD_LAND, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_logical_and },
        { MMD_LXOR, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_logical_xor },
        { MMD_CONCAT, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_concatenate },
        { MMD_CONCAT, 0, enum_type_STRING, (funcptr_t) Parrot_scalar_concatenate_str },
        { MMD_I_CONCAT, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_concatenate },
        { MMD_I_CONCAT, 0, enum_type_STRING, (funcptr_t) Parrot_scalar_i_concatenate_str },
        { MMD_REPEAT, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_repeat },
        { MMD_REPEAT, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_repeat_int },
        { MMD_I_REPEAT, 0, enum_type_PMC, (funcptr_t) Parrot_scalar_i_repeat },
        { MMD_I_REPEAT, 0, enum_type_INTVAL, (funcptr_t) Parrot_scalar_i_repeat_int }
    };
    /* Dynamic PMCs need the runtime type which is passed in entry to class_init. */
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Integer");
        vt_clone->isa_str = CONST_STRING(interp, "Integer scalar");
        vt_clone->does_str = CONST_STRING(interp, "scalar integer");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_Integer_nci_get_as_base), "get_as_base", "SJOI");
        /* class_init */
        {
        
        }
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_Integer_class_init */
#line 1326 "./src/pmc/integer.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
