/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/iterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/iterator.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: iterator.pmc 21070 2007-09-04 07:08:50Z chromatic $

=head1 NAME

src/pmc/iterator.pmc - Iterator PMC

=head1 DESCRIPTION

These are the vtable functions for the Iterator base class. Iterators are
used in combination with other classes(mainly aggregates) to visit all entries
in that aggregate.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, array, entry
    iterator = new 'Iterator', array
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = shift iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

The C<new> can alteratively be written as:

  iterator = iter array

=head2 iterate from the end, for arrays

    .local pmc iterator, array, entry
    iterator = new 'Iterator', array
    iterator = .ITERATE_FROM_END
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = pop iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 iterate over a hash

    .local pmc iterator, hash, key, entry
    iterator = new 'Iterator', hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    key   = shift iterator     # get the key..
    entry = hash[key]
    ...
    goto iter_loop
  iter_end:

=head1 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 79 "./src/pmc/iterator.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "iterator.str"
PMC  *
Parrot_Iterator_clone(PARROT_INTERP, PMC *pmc)
{
#line 142 "./src/pmc/iterator.pmc"

    PMC * const key     = (PMC *)PMC_struct_val(pmc);
    PMC * const res     = pmc_new_init(interp, pmc->vtable->base_type,
                                       PMC_pmc_val(pmc));
    PMC_struct_val(res) = VTABLE_clone(interp, key);
    return res;
#line 96 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_defined(PARROT_INTERP, PMC *pmc)
{
#line 617 "./src/pmc/iterator.pmc"

    return (INTVAL)(PMC_pmc_val(pmc) != 0);
#line 104 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 629 "./src/pmc/iterator.pmc"

    return VTABLE_defined_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
#line 112 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 643 "./src/pmc/iterator.pmc"

    PMC * const key = (PMC *)PMC_struct_val(pmc);
    PMC * const agg = (PMC *)PMC_pmc_val(pmc);
    return VTABLE_defined_keyed_int(interp, agg, PMC_int_val(key) + idx);
#line 122 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_elements(PARROT_INTERP, PMC *pmc)
{
#line 291 "./src/pmc/iterator.pmc"

    return VTABLE_elements(interp, (PMC *)PMC_pmc_val(pmc));
#line 130 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 587 "./src/pmc/iterator.pmc"

    return VTABLE_exists_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
#line 138 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 601 "./src/pmc/iterator.pmc"

    PMC * const key = (PMC *)PMC_struct_val(pmc);
    PMC * const agg = (PMC *)PMC_pmc_val(pmc);
    return VTABLE_exists_keyed_int(interp, agg, PMC_int_val(key) + idx);
#line 148 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 276 "./src/pmc/iterator.pmc"

    PMC * const key = (PMC *)PMC_struct_val(pmc);
    return key && PMC_int_val(key) != -1;
#line 157 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 161 "./src/pmc/iterator.pmc"

    return Parrot_Iterator_elements(interp, pmc);
#line 165 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 188 "./src/pmc/iterator.pmc"

    return VTABLE_get_integer_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
#line 173 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 202 "./src/pmc/iterator.pmc"

    PMC * const key = (PMC *)PMC_struct_val(pmc);
    PMC * const agg = (PMC *)PMC_pmc_val(pmc);
    return VTABLE_get_integer_keyed_int(interp, agg, PMC_int_val(key) +idx);
#line 183 "./src/pmc/iterator.c"
}
PMC  *
Parrot_Iterator_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 679 "./src/pmc/iterator.pmc"

    return pmc;
#line 191 "./src/pmc/iterator.c"
}
FLOATVAL
Parrot_Iterator_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 216 "./src/pmc/iterator.pmc"

    return VTABLE_get_number_keyed(interp,(PMC *)PMC_pmc_val(pmc), key);
#line 199 "./src/pmc/iterator.c"
}
FLOATVAL
Parrot_Iterator_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 230 "./src/pmc/iterator.pmc"

    PMC * const key = (PMC *)PMC_struct_val(pmc);
    PMC * const agg = (PMC *)PMC_pmc_val(pmc);
    return VTABLE_get_number_keyed_int(interp, agg, PMC_int_val(key) + idx);
#line 209 "./src/pmc/iterator.c"
}
PMC  *
Parrot_Iterator_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 305 "./src/pmc/iterator.pmc"

    return VTABLE_get_pmc_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
#line 217 "./src/pmc/iterator.c"
}
PMC  *
Parrot_Iterator_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 319 "./src/pmc/iterator.pmc"

    PMC * const key = (PMC *)PMC_struct_val(pmc);
    PMC * const agg = (PMC *)PMC_pmc_val(pmc);
    return VTABLE_get_pmc_keyed_int(interp, agg, PMC_int_val(key) + idx);
#line 227 "./src/pmc/iterator.c"
}
STRING  *
Parrot_Iterator_get_string(PARROT_INTERP, PMC *pmc)
{
#line 175 "./src/pmc/iterator.pmc"

    PMC * const key = (PMC *)PMC_struct_val(pmc);
    return string_from_int(interp, key_integer(interp, key));
#line 236 "./src/pmc/iterator.c"
}
STRING  *
Parrot_Iterator_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 246 "./src/pmc/iterator.pmc"

    return VTABLE_get_string_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
#line 244 "./src/pmc/iterator.c"
}
STRING  *
Parrot_Iterator_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 260 "./src/pmc/iterator.pmc"

    PMC * const key = (PMC *)PMC_struct_val(pmc);
    PMC * const agg = (PMC *)PMC_pmc_val(pmc);
    return VTABLE_get_string_keyed_int(interp, agg, PMC_int_val(key) + idx);
#line 254 "./src/pmc/iterator.c"
}
void
Parrot_Iterator_init(PARROT_INTERP, PMC *pmc)
{
#line 87 "./src/pmc/iterator.pmc"

    real_exception(interp, NULL, E_Exception,
            "Iterator init without aggregate");
#line 263 "./src/pmc/iterator.c"
}
void
Parrot_Iterator_init_pmc(PARROT_INTERP, PMC *pmc, PMC *aggregate)
{
#line 103 "./src/pmc/iterator.pmc"

    PMC_pmc_val(pmc)    = aggregate;
    PMC_struct_val(pmc) = NULL;
    PObj_custom_mark_SET(pmc);

    /* by default, iterate from start */
    VTABLE_set_integer_native(interp, pmc, ITERATE_FROM_START);
#line 276 "./src/pmc/iterator.c"
}
opcode_t  *
Parrot_Iterator_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 471 "./src/pmc/iterator.pmc"

    PMC *agg;

    /* iterator constructor */
    if (REG_INT(interp, 3) == 1) {
        PMC *arg = REG_PMC(interp, 5);
        PMC *iter;

        if (PObj_is_object_TEST(arg)) {
            REG_PMC(interp, 5) = VTABLE_get_iter(interp, arg);
            return (opcode_t *)next;
        }

        REG_PMC(interp, 5) = iter = pmc_new_init(interp,
                enum_class_Iterator, arg);
        VTABLE_set_integer_native(interp, iter, 0);
        return (opcode_t *)next;
    }
    /* TODO function + sentinel */
    else if (REG_INT(interp, 3) == 2)
        real_exception(interp, NULL, E_AssertionError,
                "Iterator: invoke 2 args");

    REG_INT(interp, 1) =
        REG_INT(interp, 2) =
        REG_INT(interp, 3) =
        REG_INT(interp, 4) = 0;

    agg        = (PMC *)PMC_pmc_val(pmc);

    if (agg->vtable->base_type == enum_class_IntList) {
        const INTVAL ires  = VTABLE_shift_integer(interp, pmc);
        REG_INT(interp, 1) = 1;
        REG_INT(interp, 5) = ires;
        return (opcode_t *)next;
    }
    else {
        PMC * const res    = VTABLE_shift_pmc(interp, pmc);
        REG_INT(interp, 3) = 1;
        REG_PMC(interp, 5) = res;
        return (opcode_t *)next;
    }
#line 324 "./src/pmc/iterator.c"
}
void
Parrot_Iterator_mark(PARROT_INTERP, PMC *pmc)
{
#line 122 "./src/pmc/iterator.pmc"

    /* the KEY */
    if (PMC_struct_val(pmc))
         pobject_lives(interp, (PObj *)PMC_struct_val(pmc));

    /* the aggregate */
    if (PMC_pmc_val(pmc))
         pobject_lives(interp, (PObj *)PMC_pmc_val(pmc));
#line 338 "./src/pmc/iterator.c"
}
FLOATVAL
Parrot_Iterator_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 390 "./src/pmc/iterator.pmc"

    PMC * const key      = (PMC *)PMC_struct_val(pmc);
    PMC * const agg      = (PMC *)PMC_pmc_val(pmc);
    const FLOATVAL ret   = VTABLE_get_number_keyed(interp, agg, key);
    PMC_struct_val(pmc) =
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_PREV);

    return ret;
#line 352 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 372 "./src/pmc/iterator.pmc"

    PMC * const key      = (PMC *)PMC_struct_val(pmc);
    PMC * const agg      = (PMC *)PMC_pmc_val(pmc);
    const INTVAL ret     = VTABLE_get_integer_keyed(interp, agg, key);
    PMC_struct_val(pmc) =
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_PREV);

    return ret;
#line 366 "./src/pmc/iterator.c"
}
PMC  *
Parrot_Iterator_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 428 "./src/pmc/iterator.pmc"

    PMC * const key      = (PMC *)PMC_struct_val(pmc);
    PMC * const agg      = (PMC *)PMC_pmc_val(pmc);
    PMC * const ret      = VTABLE_get_pmc_keyed(interp, agg, key);
    PMC_struct_val(pmc) =
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_PREV);

    return ret;
#line 380 "./src/pmc/iterator.c"
}
STRING  *
Parrot_Iterator_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 408 "./src/pmc/iterator.pmc"

    PMC * const key      = (PMC *)PMC_struct_val(pmc);
    PMC * const agg      = (PMC *)PMC_pmc_val(pmc);
    STRING * const ret   = VTABLE_get_string_keyed(interp, agg, key);
    PMC_struct_val(pmc) =
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_PREV);
    return ret;
#line 393 "./src/pmc/iterator.c"
}
void
Parrot_Iterator_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 339 "./src/pmc/iterator.pmc"

    PMC *key, *agg;
    if (value < ITERATE_FROM_START || value > ITERATE_FROM_END)
        real_exception(interp, NULL, E_TypeError,
                "Illegal set_integer on iterator");

    /* reset iterator on aggregate */
    agg = (PMC *)PMC_pmc_val(pmc);

    if (agg->vtable->base_type == enum_class_Slice) {
        /* it's an xrange serving as its own aggregate */
        PMC_struct_val(pmc) =
            VTABLE_nextkey_keyed(interp, agg, NULL, value);
    }
    else {
        if (!PMC_struct_val(pmc))
            key = key_new(interp);
        else
            key = (PMC *)PMC_struct_val(pmc);

        PMC_struct_val(pmc) =
            VTABLE_nextkey_keyed(interp, key, agg, value);
    }
#line 422 "./src/pmc/iterator.c"
}
FLOATVAL
Parrot_Iterator_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 523 "./src/pmc/iterator.pmc"

    PMC * const key      = (PMC *)PMC_struct_val(pmc);
    PMC * const agg      = (PMC *)PMC_pmc_val(pmc);
    const FLOATVAL ret   = VTABLE_get_number_keyed(interp, agg, key);
    PMC_struct_val(pmc) =
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_NEXT);
    return ret;
#line 435 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 449 "./src/pmc/iterator.pmc"

    PMC * const key      = (PMC *)PMC_struct_val(pmc);
    PMC * const agg      = (PMC *)PMC_pmc_val(pmc);
    const INTVAL ret     = VTABLE_get_integer_keyed(interp, agg, key);
    PMC_struct_val(pmc) =
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_NEXT);
    return ret;
#line 448 "./src/pmc/iterator.c"
}
PMC  *
Parrot_Iterator_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 561 "./src/pmc/iterator.pmc"

    PMC * const key = (PMC *)PMC_struct_val(pmc);
    PMC * const agg = (PMC *)PMC_pmc_val(pmc);
    PMC        *ret;

    if (PMC_int_val(key) == -1)
        real_exception(interp, NULL, E_StopIteration, "StopIteration");

    ret = VTABLE_get_pmc_keyed(interp, agg, key);

    PMC_struct_val(pmc) =
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_NEXT);

    return ret;
#line 468 "./src/pmc/iterator.c"
}
STRING  *
Parrot_Iterator_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 541 "./src/pmc/iterator.pmc"

    PMC * const key      = (PMC *)PMC_struct_val(pmc);
    PMC * const agg      = (PMC *)PMC_pmc_val(pmc);
    STRING * const ret   = VTABLE_get_string_keyed(interp, agg, key);
    PMC_struct_val(pmc) =
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_NEXT);
    return ret;
#line 481 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_type_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 659 "./src/pmc/iterator.pmc"

    return VTABLE_type_keyed(interp, (PMC *)PMC_pmc_val(pmc), key);
#line 489 "./src/pmc/iterator.c"
}
INTVAL
Parrot_Iterator_type_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 673 "./src/pmc/iterator.pmc"

    PMC * const key = (PMC *)PMC_struct_val(pmc);
    PMC * const agg = (PMC *)PMC_pmc_val(pmc);
    return VTABLE_type_keyed_int(interp, agg, PMC_int_val(key) + idx);
#line 499 "./src/pmc/iterator.c"
}
void
Parrot_Iterator_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Iterator");
}
PMC *
Parrot_Iterator_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_Iterator_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Iterator");
}
FLOATVAL
Parrot_Iterator_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Iterator");
}
INTVAL
Parrot_Iterator_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Iterator");
}
PMC *
Parrot_Iterator_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Iterator");
}
STRING *
Parrot_Iterator_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Iterator");
}
FLOATVAL
Parrot_Iterator_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Iterator");
}
INTVAL
Parrot_Iterator_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Iterator");
}
PMC *
Parrot_Iterator_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Iterator");
}
STRING *
Parrot_Iterator_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Iterator");
}
void
Parrot_Iterator_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Iterator");
}
void
Parrot_Iterator_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_Iterator, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Iterator_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_Iterator_defined,
        Parrot_Iterator_defined_keyed,
        Parrot_Iterator_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_Iterator_elements,
        Parrot_Iterator_exists_keyed,
        Parrot_Iterator_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Iterator_get_bool,
        Parrot_default_get_class,
        Parrot_Iterator_get_integer,
        Parrot_Iterator_get_integer_keyed,
        Parrot_Iterator_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Iterator_get_iter,
        Parrot_default_get_number,
        Parrot_Iterator_get_number_keyed,
        Parrot_Iterator_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Iterator_get_pmc_keyed,
        Parrot_Iterator_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Iterator_get_string,
        Parrot_Iterator_get_string_keyed,
        Parrot_Iterator_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Iterator_init,
        Parrot_Iterator_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Iterator_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Iterator_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Iterator_pop_float,
        Parrot_Iterator_pop_integer,
        Parrot_Iterator_pop_pmc,
        Parrot_Iterator_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Iterator_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Iterator_shift_float,
        Parrot_Iterator_shift_integer,
        Parrot_Iterator_shift_pmc,
        Parrot_Iterator_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_Iterator_type_keyed,
        Parrot_Iterator_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_Iterator, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_Iterator_ro_add_attribute,
        Parrot_Iterator_ro_add_method,
        Parrot_Iterator_ro_add_parent,
        Parrot_Iterator_ro_add_role,
        Parrot_Iterator_ro_add_vtable_override,
        Parrot_Iterator_ro_assign_pmc,
        Parrot_Iterator_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Iterator_clone,
        Parrot_default_clone_pmc,
        Parrot_Iterator_ro_decrement,
        Parrot_Iterator_defined,
        Parrot_Iterator_defined_keyed,
        Parrot_Iterator_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Iterator_ro_delete_keyed,
        Parrot_Iterator_ro_delete_keyed_int,
        Parrot_Iterator_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_Iterator_elements,
        Parrot_Iterator_exists_keyed,
        Parrot_Iterator_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Iterator_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Iterator_get_bool,
        Parrot_default_get_class,
        Parrot_Iterator_get_integer,
        Parrot_Iterator_get_integer_keyed,
        Parrot_Iterator_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Iterator_get_iter,
        Parrot_default_get_number,
        Parrot_Iterator_get_number_keyed,
        Parrot_Iterator_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Iterator_get_pmc_keyed,
        Parrot_Iterator_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Iterator_get_string,
        Parrot_Iterator_get_string_keyed,
        Parrot_Iterator_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_Iterator_ro_i_absolute,
        Parrot_Iterator_ro_i_bitwise_not,
        Parrot_Iterator_ro_i_bitwise_nots,
        Parrot_Iterator_ro_i_logical_not,
        Parrot_Iterator_ro_i_neg,
        Parrot_Iterator_ro_increment,
        Parrot_Iterator_init,
        Parrot_Iterator_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Iterator_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Iterator_mark,
        Parrot_Iterator_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Iterator_ro_pop_float,
        Parrot_Iterator_ro_pop_integer,
        Parrot_Iterator_ro_pop_pmc,
        Parrot_Iterator_ro_pop_string,
        Parrot_Iterator_ro_push_float,
        Parrot_Iterator_ro_push_integer,
        Parrot_Iterator_ro_push_pmc,
        Parrot_Iterator_ro_push_string,
        Parrot_Iterator_ro_remove_attribute,
        Parrot_Iterator_ro_remove_method,
        Parrot_Iterator_ro_remove_parent,
        Parrot_Iterator_ro_remove_role,
        Parrot_Iterator_ro_remove_vtable_override,
        Parrot_Iterator_ro_set_attr,
        Parrot_Iterator_ro_set_attr_str,
        Parrot_Iterator_ro_set_bignum_int,
        Parrot_Iterator_ro_set_bignum_num,
        Parrot_Iterator_ro_set_bignum_str,
        Parrot_Iterator_ro_set_bool,
        Parrot_Iterator_ro_set_integer_keyed,
        Parrot_Iterator_ro_set_integer_keyed_int,
        Parrot_Iterator_ro_set_integer_keyed_str,
        Parrot_Iterator_ro_set_integer_native,
        Parrot_Iterator_ro_set_integer_same,
        Parrot_Iterator_ro_set_number_keyed,
        Parrot_Iterator_ro_set_number_keyed_int,
        Parrot_Iterator_ro_set_number_keyed_str,
        Parrot_Iterator_ro_set_number_native,
        Parrot_Iterator_ro_set_number_same,
        Parrot_Iterator_ro_set_pmc,
        Parrot_Iterator_ro_set_pmc_keyed,
        Parrot_Iterator_ro_set_pmc_keyed_int,
        Parrot_Iterator_ro_set_pmc_keyed_str,
        Parrot_Iterator_ro_set_pointer,
        Parrot_Iterator_ro_set_pointer_keyed,
        Parrot_Iterator_ro_set_pointer_keyed_int,
        Parrot_Iterator_ro_set_pointer_keyed_str,
        Parrot_Iterator_ro_set_string_keyed,
        Parrot_Iterator_ro_set_string_keyed_int,
        Parrot_Iterator_ro_set_string_keyed_str,
        Parrot_Iterator_ro_set_string_native,
        Parrot_Iterator_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Iterator_ro_shift_float,
        Parrot_Iterator_ro_shift_integer,
        Parrot_Iterator_ro_shift_pmc,
        Parrot_Iterator_ro_shift_string,
        Parrot_default_slice,
        Parrot_Iterator_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Iterator_ro_thaw,
        Parrot_Iterator_ro_thawfinish,
        Parrot_default_type,
        Parrot_Iterator_type_keyed,
        Parrot_Iterator_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Iterator_ro_unshift_float,
        Parrot_Iterator_ro_unshift_integer,
        Parrot_Iterator_ro_unshift_pmc,
        Parrot_Iterator_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "Iterator");
        vt_clone->isa_str = CONST_STRING(interp, "Iterator");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
            if (pass) {
                /* Make the shift_pmc vtable function available as
                 * a method named "next" */
                register_nci_method(interp, enum_class_Iterator,
                        F2DPTR(Parrot_Iterator_shift_pmc), "next", "PJO");
            }

        }
        {
        }
    } /* pass */
} /* Parrot_Iterator_class_init */
#line 681 "./src/pmc/iterator.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
