/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/multiarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/multiarray.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: multiarray.pmc 20925 2007-08-30 19:42:02Z chromatic $

=head1 NAME

src/pmc/multiarray.pmc - Multi-dimensional Array

=head1 DESCRIPTION

C<MultiArray> extends C<Array> to provide a multi-dimensional array.

This is one way for calculating offsets in 2 dimensional space.

MULTIDIM CALC OFFSET

Algorithm:

    i + j*Ni + k*Ni*Nj + l*Ni*Nj*Nk ...

where i, j, k, l... are coordinates in a multidimensional space and
Ni, Nj, Nk... are the lengths of the dimensions.

Limitations: the array can only expand in the last dimension The first
(n-1) dimensions of a n-dimensional array are fixed and layed out at
array creation.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

/*

=item C<static INTVAL calc_offset(PARROT_INTERP, List *list, PMC *key)>

Calculates the offset for C<*key>.

=cut

*/

static INTVAL calc_offset(PARROT_INTERP, List*list, PMC *key)
{
    PMC   *dim  = VTABLE_get_pmc_keyed_int(interp, list->user_data, 1);
    INTVAL l    = key_integer(interp, key);
    INTVAL ninj = 1;

    for (; dim ; dim = key_next(interp, dim)) {
        key = key_next(interp, key);

        if (!key)
            break;

        ninj *= key_integer(interp, dim);
        l    += key_integer(interp, key) * ninj;
    }

    return l;
}
#line 80 "./src/pmc/multiarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_multiarray.h"
#include "pmc_array.h"
#include "pmc_default.h"
#include "multiarray.str"
INTVAL
Parrot_MultiArray_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 93 "./src/pmc/multiarray.pmc"

    INTVAL ix = calc_offset(interp, (List *)PMC_data(pmc), key);
    return VTABLE_get_integer_keyed_int(interp, pmc, ix);
#line 95 "./src/pmc/multiarray.c"
}
FLOATVAL
Parrot_MultiArray_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 108 "./src/pmc/multiarray.pmc"

    INTVAL ix = calc_offset(interp, (List *)PMC_data(pmc), key);
    return VTABLE_get_number_keyed_int(interp, pmc, ix);
#line 104 "./src/pmc/multiarray.c"
}
PMC  *
Parrot_MultiArray_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 138 "./src/pmc/multiarray.pmc"

    INTVAL ix = calc_offset(interp, (List *)PMC_data(pmc), key);
    return VTABLE_get_pmc_keyed_int(interp, pmc, ix);
#line 113 "./src/pmc/multiarray.c"
}
STRING  *
Parrot_MultiArray_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 123 "./src/pmc/multiarray.pmc"

    INTVAL ix = calc_offset(interp, (List *)PMC_data(pmc), key);
    return VTABLE_get_string_keyed_int(interp, pmc, ix);
#line 122 "./src/pmc/multiarray.c"
}
void
Parrot_MultiArray_init(PARROT_INTERP, PMC *pmc)
{
#line 79 "./src/pmc/multiarray.pmc"

    /* override default in Array - no init */
#line 130 "./src/pmc/multiarray.c"
}
void
Parrot_MultiArray_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 153 "./src/pmc/multiarray.pmc"

    INTVAL ix = calc_offset(interp, (List *)PMC_data(pmc), key);
    VTABLE_set_integer_keyed_int(interp, pmc, ix, value);
#line 139 "./src/pmc/multiarray.c"
}
void
Parrot_MultiArray_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 168 "./src/pmc/multiarray.pmc"

    INTVAL ix = calc_offset(interp, (List *)PMC_data(pmc), key);
    VTABLE_set_number_keyed_int(interp, pmc, ix, value);
#line 148 "./src/pmc/multiarray.c"
}
void
Parrot_MultiArray_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *dest_key, PMC *src)
{
#line 198 "./src/pmc/multiarray.pmc"

    /* XXX array ??? */
#line 156 "./src/pmc/multiarray.c"
}
void
Parrot_MultiArray_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 183 "./src/pmc/multiarray.pmc"

    INTVAL ix = calc_offset(interp, (List *)PMC_data(pmc), key);
    VTABLE_set_string_keyed_int(interp, pmc, ix, value);
#line 165 "./src/pmc/multiarray.c"
}
void
Parrot_MultiArray_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of MultiArray");
}
PMC *
Parrot_MultiArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_MultiArray_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of MultiArray");
}
FLOATVAL
Parrot_MultiArray_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of MultiArray");
}
INTVAL
Parrot_MultiArray_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of MultiArray");
}
PMC *
Parrot_MultiArray_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of MultiArray");
}
STRING *
Parrot_MultiArray_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of MultiArray");
}
FLOATVAL
Parrot_MultiArray_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of MultiArray");
}
INTVAL
Parrot_MultiArray_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of MultiArray");
}
PMC *
Parrot_MultiArray_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of MultiArray");
}
STRING *
Parrot_MultiArray_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of MultiArray");
}
void
Parrot_MultiArray_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_MultiArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_Array_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Array_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_Array_defined_keyed,
        Parrot_Array_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Array_delete_keyed,
        Parrot_Array_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_Array_elements,
        Parrot_Array_exists_keyed,
        Parrot_Array_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Array_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Array_get_bool,
        Parrot_default_get_class,
        Parrot_Array_get_integer,
        Parrot_MultiArray_get_integer_keyed,
        Parrot_Array_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Array_get_iter,
        Parrot_Array_get_number,
        Parrot_MultiArray_get_number_keyed,
        Parrot_Array_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_MultiArray_get_pmc_keyed,
        Parrot_Array_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Array_get_string,
        Parrot_MultiArray_get_string_keyed,
        Parrot_Array_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_MultiArray_init,
        Parrot_Array_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Array_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_Array_pop_float,
        Parrot_Array_pop_integer,
        Parrot_Array_pop_pmc,
        Parrot_Array_pop_string,
        Parrot_Array_push_float,
        Parrot_Array_push_integer,
        Parrot_Array_push_pmc,
        Parrot_Array_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_MultiArray_set_integer_keyed,
        Parrot_Array_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Array_set_integer_native,
        Parrot_Array_set_integer_same,
        Parrot_MultiArray_set_number_keyed,
        Parrot_Array_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Array_set_pmc,
        Parrot_MultiArray_set_pmc_keyed,
        Parrot_Array_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_MultiArray_set_string_keyed,
        Parrot_Array_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_Array_share_ro,
        Parrot_Array_shift_float,
        Parrot_Array_shift_integer,
        Parrot_Array_shift_pmc,
        Parrot_Array_shift_string,
        Parrot_Array_slice,
        Parrot_Array_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Array_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Array_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_Array_unshift_float,
        Parrot_Array_unshift_integer,
        Parrot_Array_unshift_pmc,
        Parrot_Array_unshift_string,
        Parrot_Array_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_MultiArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_MultiArray_ro_add_attribute,
        Parrot_MultiArray_ro_add_method,
        Parrot_MultiArray_ro_add_parent,
        Parrot_MultiArray_ro_add_role,
        Parrot_MultiArray_ro_add_vtable_override,
        Parrot_MultiArray_ro_assign_pmc,
        Parrot_MultiArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_Array_clone,
        Parrot_default_clone_pmc,
        Parrot_MultiArray_ro_decrement,
        Parrot_default_defined,
        Parrot_Array_defined_keyed,
        Parrot_Array_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_MultiArray_ro_delete_keyed,
        Parrot_MultiArray_ro_delete_keyed_int,
        Parrot_MultiArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_Array_elements,
        Parrot_Array_exists_keyed,
        Parrot_Array_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_MultiArray_ro_find_method,
        Parrot_Array_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Array_get_bool,
        Parrot_default_get_class,
        Parrot_Array_get_integer,
        Parrot_MultiArray_get_integer_keyed,
        Parrot_Array_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Array_get_iter,
        Parrot_Array_get_number,
        Parrot_MultiArray_get_number_keyed,
        Parrot_Array_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_MultiArray_get_pmc_keyed,
        Parrot_Array_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Array_get_string,
        Parrot_MultiArray_get_string_keyed,
        Parrot_Array_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_MultiArray_ro_i_absolute,
        Parrot_MultiArray_ro_i_bitwise_not,
        Parrot_MultiArray_ro_i_bitwise_nots,
        Parrot_MultiArray_ro_i_logical_not,
        Parrot_MultiArray_ro_i_neg,
        Parrot_MultiArray_ro_increment,
        Parrot_MultiArray_init,
        Parrot_Array_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Array_mark,
        Parrot_MultiArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_MultiArray_ro_pop_float,
        Parrot_MultiArray_ro_pop_integer,
        Parrot_MultiArray_ro_pop_pmc,
        Parrot_MultiArray_ro_pop_string,
        Parrot_MultiArray_ro_push_float,
        Parrot_MultiArray_ro_push_integer,
        Parrot_MultiArray_ro_push_pmc,
        Parrot_MultiArray_ro_push_string,
        Parrot_MultiArray_ro_remove_attribute,
        Parrot_MultiArray_ro_remove_method,
        Parrot_MultiArray_ro_remove_parent,
        Parrot_MultiArray_ro_remove_role,
        Parrot_MultiArray_ro_remove_vtable_override,
        Parrot_MultiArray_ro_set_attr,
        Parrot_MultiArray_ro_set_attr_str,
        Parrot_MultiArray_ro_set_bignum_int,
        Parrot_MultiArray_ro_set_bignum_num,
        Parrot_MultiArray_ro_set_bignum_str,
        Parrot_MultiArray_ro_set_bool,
        Parrot_MultiArray_ro_set_integer_keyed,
        Parrot_MultiArray_ro_set_integer_keyed_int,
        Parrot_MultiArray_ro_set_integer_keyed_str,
        Parrot_MultiArray_ro_set_integer_native,
        Parrot_MultiArray_ro_set_integer_same,
        Parrot_MultiArray_ro_set_number_keyed,
        Parrot_MultiArray_ro_set_number_keyed_int,
        Parrot_MultiArray_ro_set_number_keyed_str,
        Parrot_MultiArray_ro_set_number_native,
        Parrot_MultiArray_ro_set_number_same,
        Parrot_MultiArray_ro_set_pmc,
        Parrot_MultiArray_ro_set_pmc_keyed,
        Parrot_MultiArray_ro_set_pmc_keyed_int,
        Parrot_MultiArray_ro_set_pmc_keyed_str,
        Parrot_MultiArray_ro_set_pointer,
        Parrot_MultiArray_ro_set_pointer_keyed,
        Parrot_MultiArray_ro_set_pointer_keyed_int,
        Parrot_MultiArray_ro_set_pointer_keyed_str,
        Parrot_MultiArray_ro_set_string_keyed,
        Parrot_MultiArray_ro_set_string_keyed_int,
        Parrot_MultiArray_ro_set_string_keyed_str,
        Parrot_MultiArray_ro_set_string_native,
        Parrot_MultiArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_Array_share_ro,
        Parrot_MultiArray_ro_shift_float,
        Parrot_MultiArray_ro_shift_integer,
        Parrot_MultiArray_ro_shift_pmc,
        Parrot_MultiArray_ro_shift_string,
        Parrot_Array_slice,
        Parrot_MultiArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_MultiArray_ro_thaw,
        Parrot_MultiArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Array_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_MultiArray_ro_unshift_float,
        Parrot_MultiArray_ro_unshift_integer,
        Parrot_MultiArray_ro_unshift_pmc,
        Parrot_MultiArray_ro_unshift_string,
        Parrot_Array_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "MultiArray");
        vt_clone->isa_str = CONST_STRING(interp, "MultiArray Array");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_MultiArray_class_init */
#line 200 "./src/pmc/multiarray.pmc"


/*

=back

=head1 HISTORY

Initial revision by Josef Hook <joh@stacken.kth.se>

1.6 Based on list.c by Leopold Toetsch <lt@toetsch.at>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
