/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/orderedhash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/orderedhash.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: orderedhash.pmc 22152 2007-10-17 00:37:43Z chromatic $

=head1 NAME

src/pmc/orderedhash.pmc - Ordered Hash

=head1 DESCRIPTION

C<OrderedHash> extends C<Hash> to provide the interfaces of C<array> and
C<hash>. To achieve ordering, hash there are a few restrictions:
C<delete_keyed> never removes items; they are just nulled.

Please note that if values are set via integer idx, these indices have to be in
strict order. Using C<push_xx> simplifies this task.  This creates a key
"\1idx" for C<idx> and is therefore not fully transparent.

There are two iterator interfaces:

=over 4

=item * retrieve values (in creation order)

Please note that after a C<delete_keyed> operation, iterating over
values doesn't work any more.  You'll get an error 'No such key'.

=item * retrieve keys (in creation order)

=back

See F<t/pmc/orderedhash.t>.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "pmc_hash.h"
#line 58 "./src/pmc/orderedhash.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_orderedhash.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "orderedhash.str"
PMC  *
Parrot_OrderedHash_clone(PARROT_INTERP, PMC *pmc)
{
#line 544 "./src/pmc/orderedhash.pmc"

    PMC        *dest   = pmc_new(interp, pmc->vtable->base_type);
    Hash       *hash   = (Hash *)PMC_struct_val(pmc);
    Hash       *h_dest = (Hash *)PMC_struct_val(dest);
    UINTVAL     i;

    for (i = 0; i <= hash->mask; i++) {
        HashBucket *b      = hash->bs + i;
        void       *key    = b->key;

        if (!key)
            continue;

        parrot_hash_put(interp, h_dest, key,
            (void *)VTABLE_clone(interp, (PMC *)b->value));
    }

    return dest;
#line 88 "./src/pmc/orderedhash.c"
}
INTVAL
Parrot_OrderedHash_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 421 "./src/pmc/orderedhash.pmc"

    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        PMC        *item, *next;
        HashBucket *b;
        Hash       *h   = (Hash *)PMC_struct_val(pmc);
        INTVAL      idx = key_integer(interp, key);
        INTVAL      n   = h->entries;

        if (idx < 0)
            idx += n;

        /* XXX non-existant is undefined - is this correct */
        if (idx < 0 || idx >= n)
            return 0;

        b = h->bs + idx;

        if (!b->key)
            return 0;

        item = (PMC *)b->value;
        next = key_next(interp, key);

        if (!next)
            return VTABLE_defined(interp, item);

        return VTABLE_defined_keyed(interp, item, next);
    }

    return Parrot_Hash_defined_keyed(interp, pmc, key);
#line 124 "./src/pmc/orderedhash.c"
}
INTVAL
Parrot_OrderedHash_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 453 "./src/pmc/orderedhash.pmc"

    Hash       *h = (Hash *)PMC_struct_val(pmc);
    INTVAL      n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        return 0;

    b = h->bs + idx;

    if (b->key)
        return VTABLE_defined(interp, (PMC *)b->value);

    return 0;
#line 147 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 486 "./src/pmc/orderedhash.pmc"

    PMC *next = key_next(interp, key);

    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        if (next) {
            PMC *item = Parrot_OrderedHash_get_pmc_keyed_int(interp, pmc, key_integer(interp, key));
            VTABLE_delete_keyed(interp, item, next);
            return;
        }

        Parrot_OrderedHash_delete_keyed_int(interp, pmc, key_integer(interp, key));
    }
    else {
        if (next) {
            PMC *item = VTABLE_get_pmc_keyed_str(interp, pmc, key_string(interp, key));
            VTABLE_delete_keyed(interp, item, next);
            return;
        }
        Parrot_OrderedHash_delete_keyed_str(interp, pmc, key_string(interp, key));
    }
#line 173 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 508 "./src/pmc/orderedhash.pmc"

    Hash       *h = (Hash *)PMC_struct_val(pmc);
    INTVAL      n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        return;

    b = h->bs + idx;

    if (b)
        b->key = NULL;
#line 194 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 525 "./src/pmc/orderedhash.pmc"

    Hash       *h = (Hash *)PMC_struct_val(pmc);
    HashBucket *b = parrot_hash_get_bucket(interp, h, key);

    if (b)
        b->key = NULL;
#line 206 "./src/pmc/orderedhash.c"
}
INTVAL
Parrot_OrderedHash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 368 "./src/pmc/orderedhash.pmc"

    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        PMC        *item, *next;
        HashBucket *b;
        Hash       *h   = (Hash *)PMC_struct_val(pmc);
        INTVAL      idx = key_integer(interp, key);
        INTVAL      n   = h->entries;

        if (idx < 0)
            idx += n;

        if (idx < 0 || idx >= n)
            return 0;

        b = h->bs + idx;

        if (!b->key)
            return 0;

        item = (PMC *)b->value;
        next = key_next(interp, key);

        if (!next)
            return 1;

        return VTABLE_exists_keyed(interp, item, next);
    }

    return Parrot_Hash_exists_keyed(interp, pmc, key);
#line 241 "./src/pmc/orderedhash.c"
}
INTVAL
Parrot_OrderedHash_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 349 "./src/pmc/orderedhash.pmc"

    Hash       *h = (Hash *)PMC_struct_val(pmc);
    HashBucket *b;
    INTVAL      n = h->entries;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        return 0;

    b = h->bs + idx;

    if (b->key)
        return 1;

    return 0;
#line 264 "./src/pmc/orderedhash.c"
}
INTVAL
Parrot_OrderedHash_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 399 "./src/pmc/orderedhash.pmc"

    Hash       *h = (Hash *)PMC_struct_val(pmc);
    HashBucket *b = parrot_hash_get_bucket(interp, h, key);

    if (b && b->key)
        return 1;

    return 0;
#line 278 "./src/pmc/orderedhash.c"
}
INTVAL
Parrot_OrderedHash_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 175 "./src/pmc/orderedhash.pmc"


    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC *item = Parrot_OrderedHash_get_pmc_keyed_int(interp, pmc, key_integer(interp, key));
        PMC *next = key_next(interp, key);

        if (!next)
            return VTABLE_get_integer(interp, item);

        return VTABLE_get_integer_keyed(interp, item, next);
    }

    return Parrot_Hash_get_integer_keyed(interp, pmc, key);
#line 297 "./src/pmc/orderedhash.c"
}
INTVAL
Parrot_OrderedHash_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 154 "./src/pmc/orderedhash.pmc"

    Hash       *h = (Hash *)PMC_struct_val(pmc);
    INTVAL      n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        real_exception(interp, NULL, OUT_OF_BOUNDS,
                "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return VTABLE_get_integer(interp, (PMC *)b->value);

    real_exception(interp, NULL, KEY_NOT_FOUND,
            "OrderedHash: No such key");
#line 322 "./src/pmc/orderedhash.c"
}
FLOATVAL
Parrot_OrderedHash_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 225 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC *item = Parrot_OrderedHash_get_pmc_keyed_int(interp, pmc, key_integer(interp, key));
        PMC *next = key_next(interp, key);

        if (!next)
            return VTABLE_get_number(interp, item);

        return VTABLE_get_number_keyed(interp, item, next);
    }

    return Parrot_Hash_get_number_keyed(interp, pmc, key);
#line 340 "./src/pmc/orderedhash.c"
}
FLOATVAL
Parrot_OrderedHash_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 204 "./src/pmc/orderedhash.pmc"

    Hash       *h = (Hash *)PMC_struct_val(pmc);
    INTVAL      n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        real_exception(interp, NULL, OUT_OF_BOUNDS,
                "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return VTABLE_get_number(interp, (PMC *)b->value);

    real_exception(interp, NULL, KEY_NOT_FOUND,
            "OrderedHash: No such key");
#line 365 "./src/pmc/orderedhash.c"
}
PMC  *
Parrot_OrderedHash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 80 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC *item = Parrot_OrderedHash_get_pmc_keyed_int(interp, pmc, key_integer(interp, key));
        PMC *next = key_next(interp, key);

        if (!next)
            return item;

        return VTABLE_get_pmc_keyed(interp, item, next);
    }

    return Parrot_Hash_get_pmc_keyed(interp, pmc, key);
#line 383 "./src/pmc/orderedhash.c"
}
PMC  *
Parrot_OrderedHash_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 59 "./src/pmc/orderedhash.pmc"

    Hash       *h = (Hash *)PMC_struct_val(pmc);
    INTVAL      n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        real_exception(interp, NULL, KEY_NOT_FOUND,
                "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return (PMC *)b->value;

    real_exception(interp, NULL, KEY_NOT_FOUND,
            "OrderedHash: No such key");
#line 408 "./src/pmc/orderedhash.c"
}
STRING  *
Parrot_OrderedHash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 127 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC *item = Parrot_OrderedHash_get_pmc_keyed_int(interp, pmc, key_integer(interp, key));
        PMC *next = key_next(interp, key);

        if (!next)
            return VTABLE_get_string(interp, item);

        return VTABLE_get_string_keyed(interp, item, next);
    }

    return Parrot_Hash_get_string_keyed(interp, pmc, key);
#line 426 "./src/pmc/orderedhash.c"
}
STRING  *
Parrot_OrderedHash_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 106 "./src/pmc/orderedhash.pmc"

    Hash       *h = (Hash *)PMC_struct_val(pmc);
    INTVAL      n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        real_exception(interp, NULL, KEY_NOT_FOUND,
                "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return VTABLE_get_string(interp, (PMC *)b->value);

    real_exception(interp, NULL, KEY_NOT_FOUND,
            "OrderedHash: No such key");
#line 451 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 322 "./src/pmc/orderedhash.pmc"

    INTVAL n = VTABLE_elements(interp, pmc);
    Parrot_OrderedHash_set_number_keyed_int(interp, pmc, n, value);
#line 460 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 327 "./src/pmc/orderedhash.pmc"

    INTVAL n = VTABLE_elements(interp, pmc);
    Parrot_OrderedHash_set_integer_keyed_int(interp, pmc, n, value);
#line 469 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 317 "./src/pmc/orderedhash.pmc"

    INTVAL n = VTABLE_elements(interp, pmc);
    Parrot_OrderedHash_set_pmc_keyed_int(interp, pmc, n, value);
#line 478 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 332 "./src/pmc/orderedhash.pmc"

    INTVAL n = VTABLE_elements(interp, pmc);
    Parrot_OrderedHash_set_string_keyed_int(interp, pmc, n, value);
#line 487 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, INTVAL value)
{
#line 283 "./src/pmc/orderedhash.pmc"

    PMC *v = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Integer));
    VTABLE_set_integer_native(interp, v, value);
    Parrot_OrderedHash_set_pmc_keyed_int(interp, pmc, idx, v);
#line 498 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, FLOATVAL value)
{
#line 290 "./src/pmc/orderedhash.pmc"

    PMC *v = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Float));
    VTABLE_set_number_native(interp, v, value);
    Parrot_OrderedHash_set_pmc_keyed_int(interp, pmc, idx, v);
#line 509 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *val)
{
#line 256 "./src/pmc/orderedhash.pmc"

    STRING     *key;
    Hash       *h   = (Hash *)PMC_struct_val(pmc);
    INTVAL      n   = h->entries;
    HashBucket *b;
    STRING     *fmt = CONST_STRING(interp, "\1%d");

    if (idx < -n)
        idx = -idx - n - 1;
    else if (idx < 0)
        idx += n;

    if (idx >= n) {
        /* TODO warn or fill if there are holes */
        key = Parrot_sprintf_s(interp, fmt, idx);
        VTABLE_set_pmc_keyed_str(interp, pmc, key, val);
    }
    else {
        b = h->bs + idx;

        if (!b->key)
            b->key = Parrot_sprintf_s(interp, fmt, idx);

        b->value = val;
    }
#line 540 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, STRING *value)
{
#line 297 "./src/pmc/orderedhash.pmc"

    PMC *v = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_String));
    VTABLE_set_string_native(interp, v, value);
    Parrot_OrderedHash_set_pmc_keyed_int(interp, pmc, idx, v);
#line 551 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 584 "./src/pmc/orderedhash.pmc"

    UINTVAL     i;
    IMAGE_IO   *io   = info->image_io;
    Hash       *hash = (Hash *)PMC_struct_val(pmc);

    info->container  = pmc;

    switch (info->what) {
        case VISIT_THAW_NORMAL:
        case VISIT_THAW_CONSTANTS:
            Parrot_Hash_visit(interp, pmc, info);
            break;

        case VISIT_FREEZE_NORMAL:
        case VISIT_FREEZE_AT_DESTRUCT:
            for (i = 0; i <= hash->entries; i++) {
                HashBucket *b   = hash->bs + i;
                STRING     *key = NULL;

                if (b)
                    key = (STRING *)b->key;

                if (!key)
                    continue;

                VTABLE_push_string(interp, io, key);
                (info->visit_pmc_now)(interp, (PMC *)b->value, info);
            }
            break;
        default:
            real_exception(interp, NULL, E_Exception,
                    "unhandled visit action (%d)", info->what);
    }
#line 590 "./src/pmc/orderedhash.c"
}
void
Parrot_OrderedHash_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of OrderedHash");
}
PMC *
Parrot_OrderedHash_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_OrderedHash_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of OrderedHash");
}
FLOATVAL
Parrot_OrderedHash_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of OrderedHash");
}
INTVAL
Parrot_OrderedHash_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of OrderedHash");
}
PMC *
Parrot_OrderedHash_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of OrderedHash");
}
STRING *
Parrot_OrderedHash_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of OrderedHash");
}
FLOATVAL
Parrot_OrderedHash_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of OrderedHash");
}
INTVAL
Parrot_OrderedHash_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of OrderedHash");
}
PMC *
Parrot_OrderedHash_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of OrderedHash");
}
STRING *
Parrot_OrderedHash_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of OrderedHash");
}
void
Parrot_OrderedHash_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_OrderedHash, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_OrderedHash_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_OrderedHash_defined_keyed,
        Parrot_OrderedHash_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_OrderedHash_delete_keyed,
        Parrot_OrderedHash_delete_keyed_int,
        Parrot_OrderedHash_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Hash_destroy,
        Parrot_default_does,
        Parrot_Hash_elements,
        Parrot_OrderedHash_exists_keyed,
        Parrot_OrderedHash_exists_keyed_int,
        Parrot_OrderedHash_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_Hash_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_OrderedHash_get_integer_keyed,
        Parrot_OrderedHash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_number,
        Parrot_OrderedHash_get_number_keyed,
        Parrot_OrderedHash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_OrderedHash_get_pmc_keyed,
        Parrot_OrderedHash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string,
        Parrot_OrderedHash_get_string_keyed,
        Parrot_OrderedHash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Hash_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_OrderedHash_push_float,
        Parrot_OrderedHash_push_integer,
        Parrot_OrderedHash_push_pmc,
        Parrot_OrderedHash_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_Hash_set_integer_keyed,
        Parrot_OrderedHash_set_integer_keyed_int,
        Parrot_Hash_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_Hash_set_number_keyed,
        Parrot_OrderedHash_set_number_keyed_int,
        Parrot_Hash_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_Hash_set_pmc_keyed,
        Parrot_OrderedHash_set_pmc_keyed_int,
        Parrot_Hash_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Hash_set_string_keyed,
        Parrot_OrderedHash_set_string_keyed_int,
        Parrot_Hash_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_Hash_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_Hash_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_OrderedHash_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_OrderedHash, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_OrderedHash_ro_add_attribute,
        Parrot_OrderedHash_ro_add_method,
        Parrot_OrderedHash_ro_add_parent,
        Parrot_OrderedHash_ro_add_role,
        Parrot_OrderedHash_ro_add_vtable_override,
        Parrot_OrderedHash_ro_assign_pmc,
        Parrot_OrderedHash_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_OrderedHash_clone,
        Parrot_default_clone_pmc,
        Parrot_OrderedHash_ro_decrement,
        Parrot_default_defined,
        Parrot_OrderedHash_defined_keyed,
        Parrot_OrderedHash_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_OrderedHash_ro_delete_keyed,
        Parrot_OrderedHash_ro_delete_keyed_int,
        Parrot_OrderedHash_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Hash_destroy,
        Parrot_default_does,
        Parrot_Hash_elements,
        Parrot_OrderedHash_exists_keyed,
        Parrot_OrderedHash_exists_keyed_int,
        Parrot_OrderedHash_exists_keyed_str,
        Parrot_OrderedHash_ro_find_method,
        Parrot_Hash_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_OrderedHash_get_integer_keyed,
        Parrot_OrderedHash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_number,
        Parrot_OrderedHash_get_number_keyed,
        Parrot_OrderedHash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_OrderedHash_get_pmc_keyed,
        Parrot_OrderedHash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string,
        Parrot_OrderedHash_get_string_keyed,
        Parrot_OrderedHash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_OrderedHash_ro_i_absolute,
        Parrot_OrderedHash_ro_i_bitwise_not,
        Parrot_OrderedHash_ro_i_bitwise_nots,
        Parrot_OrderedHash_ro_i_logical_not,
        Parrot_OrderedHash_ro_i_neg,
        Parrot_OrderedHash_ro_increment,
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_Hash_mark,
        Parrot_OrderedHash_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_OrderedHash_ro_pop_float,
        Parrot_OrderedHash_ro_pop_integer,
        Parrot_OrderedHash_ro_pop_pmc,
        Parrot_OrderedHash_ro_pop_string,
        Parrot_OrderedHash_ro_push_float,
        Parrot_OrderedHash_ro_push_integer,
        Parrot_OrderedHash_ro_push_pmc,
        Parrot_OrderedHash_ro_push_string,
        Parrot_OrderedHash_ro_remove_attribute,
        Parrot_OrderedHash_ro_remove_method,
        Parrot_OrderedHash_ro_remove_parent,
        Parrot_OrderedHash_ro_remove_role,
        Parrot_OrderedHash_ro_remove_vtable_override,
        Parrot_OrderedHash_ro_set_attr,
        Parrot_OrderedHash_ro_set_attr_str,
        Parrot_OrderedHash_ro_set_bignum_int,
        Parrot_OrderedHash_ro_set_bignum_num,
        Parrot_OrderedHash_ro_set_bignum_str,
        Parrot_OrderedHash_ro_set_bool,
        Parrot_OrderedHash_ro_set_integer_keyed,
        Parrot_OrderedHash_ro_set_integer_keyed_int,
        Parrot_OrderedHash_ro_set_integer_keyed_str,
        Parrot_OrderedHash_ro_set_integer_native,
        Parrot_OrderedHash_ro_set_integer_same,
        Parrot_OrderedHash_ro_set_number_keyed,
        Parrot_OrderedHash_ro_set_number_keyed_int,
        Parrot_OrderedHash_ro_set_number_keyed_str,
        Parrot_OrderedHash_ro_set_number_native,
        Parrot_OrderedHash_ro_set_number_same,
        Parrot_OrderedHash_ro_set_pmc,
        Parrot_OrderedHash_ro_set_pmc_keyed,
        Parrot_OrderedHash_ro_set_pmc_keyed_int,
        Parrot_OrderedHash_ro_set_pmc_keyed_str,
        Parrot_OrderedHash_ro_set_pointer,
        Parrot_OrderedHash_ro_set_pointer_keyed,
        Parrot_OrderedHash_ro_set_pointer_keyed_int,
        Parrot_OrderedHash_ro_set_pointer_keyed_str,
        Parrot_OrderedHash_ro_set_string_keyed,
        Parrot_OrderedHash_ro_set_string_keyed_int,
        Parrot_OrderedHash_ro_set_string_keyed_str,
        Parrot_OrderedHash_ro_set_string_native,
        Parrot_OrderedHash_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_OrderedHash_ro_shift_float,
        Parrot_OrderedHash_ro_shift_integer,
        Parrot_OrderedHash_ro_shift_pmc,
        Parrot_OrderedHash_ro_shift_string,
        Parrot_Hash_slice,
        Parrot_OrderedHash_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_OrderedHash_ro_thaw,
        Parrot_OrderedHash_ro_thawfinish,
        Parrot_default_type,
        Parrot_Hash_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_Hash_type_keyed_str,
        Parrot_OrderedHash_ro_unshift_float,
        Parrot_OrderedHash_ro_unshift_integer,
        Parrot_OrderedHash_ro_unshift_pmc,
        Parrot_OrderedHash_ro_unshift_string,
        Parrot_OrderedHash_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "OrderedHash");
        vt_clone->isa_str = CONST_STRING(interp, "OrderedHash Hash");
        vt_clone->does_str = CONST_STRING(interp, "array hash");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_OrderedHash_class_init */
#line 617 "./src/pmc/orderedhash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=head1 HISTORY

Initial rev by leo 2003-08-21.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
