/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/parrotclass.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/parrotclass.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: parrotclass.pmc 21147 2007-09-08 21:36:34Z paultcochrane $

=head1 NAME

src/pmc/parrotclass.pmc - Parrot Class

=head1 DESCRIPTION

The structure of a Parrot class is reasonably straightforward. The PMC's
cached integer value is the number of attribute slots that an object of
this type requires. The data pointer holds a pointer to an array of
PMCs. That array has:

=over 4

=item PCD_PARENTS

An array of immediate parents.

=item PCD_CLASS_NAME

The class name PMC.

=item PCD_ATTRIBUTES

A hash, the keys are the classname/attrib name pair (separated by a
C<NULL>), while the value is the offset to the attribute.

=item PCD_CLASS_ATTRIBUTES

Array of attribute of this class.

=item PCD_OBJECT_VTABLE

Vtable PMC that holds the vtable for objects of this class.

=back

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

PARROT_WARN_UNUSED_RESULT
static PMC*
get_init_meth(PARROT_INTERP, PMC *_class, STRING *prop_str, NOTNULL(STRING **meth_str))
{
    STRING     *meth;
    HashBucket *b;
    PMC        *ns, *method;

    PMC *props = PMC_metadata(_class);
    *meth_str  = NULL;

    if (!props)
        return PMCNULL;

    b = parrot_hash_get_bucket(interp, (Hash *)PMC_struct_val(props), prop_str);

    if (!b)
        return PMCNULL;

    meth      = PMC_str_val((PMC *)b->value);
    *meth_str = meth;
    ns        = VTABLE_pmc_namespace(interp, _class);
    method    = VTABLE_get_pmc_keyed_str(interp, ns, meth);

    return method;
}

static void
do_initcall(PARROT_INTERP, PMC *_class, PMC *object, PMC *init)
{
    PMC * const classsearch_array = _class->vtable->mro;
    INTVAL      i, nparents;

    /*
     * 1) if class has a CONSTRUCT property run it on the object
     *    no redispatch
     *
     * XXX isn't CONSTRUCT for creating new objects?
     */
    STRING *meth_str;
    PMC    *meth = get_init_meth(interp, _class,
            string_from_cstring(interp, "CONSTRUCT", 9), &meth_str);
    int     default_meth;

    if (!PMC_IS_NULL(meth)) {
        if (!PMC_IS_NULL(init))
            Parrot_run_meth_fromc_args(interp, meth,
                    object, meth_str, "vP", init);
        else
            Parrot_run_meth_fromc_args(interp, meth,
                    object, meth_str, "v");
    }

    /*
     * 2. if class has a BUILD property call it for all classes
     *    in reverse search order - this class last.
     *
     *    Note: mro contains this class as first element
     */
    nparents = VTABLE_elements(interp, classsearch_array);

    for (i = nparents - 1; i >= 0; --i) {
        PMC * const parent_class =
            VTABLE_get_pmc_keyed_int(interp, classsearch_array, i);
        /* if it's a PMC, we put one PMC of that type into
         * the attribute slot #0 and call init() on that PMC
         */
        if (!PObj_is_class_TEST(parent_class)) {
            PMC *attr, *next_parent;
            SLOTTYPE *obj_data;

            /*
             * but only if init isn't inherited
             * or rather just on the last non-class parent
             */
            PARROT_ASSERT(i >= 1);
            next_parent = VTABLE_get_pmc_keyed_int(interp,
                    classsearch_array, i - 1);
            if (!PObj_is_class_TEST(next_parent))
                continue;

            attr     = pmc_new_noinit(interp, parent_class->vtable->base_type);
            obj_data = PMC_data_typed(object, SLOTTYPE *);
            set_attrib_num(object, obj_data, 0, attr);
            VTABLE_init(interp, attr);
            continue;
        }

        meth = get_init_meth(interp, parent_class,
                string_from_literal(interp, "BUILD"), &meth_str);

        /* no method found and no BUILD property set? */
        if (PMC_IS_NULL(meth) && meth_str == NULL) {
            PMC   *ns;
            INTVAL vtable_index;

            /* use __init or __init_pmc (depending on if an argument was passed)
             * as fallback constructor method, if it exists */
            if (init)
                meth_str = string_from_literal(interp, "init_pmc");
            else
                meth_str = string_from_literal(interp, "init");

            ns   = VTABLE_pmc_namespace(interp, parent_class);

            /* can't use find_method, it walks mro */
            vtable_index = Parrot_get_vtable_index(interp, meth_str);
            meth         = VTABLE_get_pmc_keyed_int(interp, ns, vtable_index);
            default_meth = 1;
        }
        else
            default_meth = 0;

        if (!PMC_IS_NULL(meth)) {
            if (init)
                Parrot_run_meth_fromc_args(interp, meth,
                        object, meth_str, "vP", init);
            else
                Parrot_run_meth_fromc_args(interp, meth,
                        object, meth_str, "v");
        }
        else if (meth_str != NULL &&
                string_length(interp, meth_str) != 0 && !default_meth) {
            real_exception(interp, NULL, METH_NOT_FOUND,
                    "Class BUILD method ('%Ss') not found", meth_str);
        }
    }
}
#line 193 "./src/pmc/parrotclass.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_parrotclass.h"
#include "pmc_default.h"
#include "pmc_delegate.h"
#include "parrotclass.str"
void
Parrot_ParrotClass_destroy(PARROT_INTERP, PMC *pmc)
{
#line 226 "./src/pmc/parrotclass.pmc"

    if (PMC_int_val(pmc))
        mem_sys_free(PMC_data(pmc));
#line 208 "./src/pmc/parrotclass.c"
}
void
Parrot_ParrotClass_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 382 "./src/pmc/parrotclass.pmc"

    IMAGE_IO *io = info->image_io;
    PMC      **class_data, **pos;

    Parrot_default_freeze(interp, pmc, info);
    class_data = (PMC **)PMC_data(pmc);

    /* 1) freeze class name */
    pos = class_data + PCD_CLASS_NAME;
    VTABLE_push_string(interp, io,
            VTABLE_get_string(interp, *pos));
#line 225 "./src/pmc/parrotclass.c"
}
PMC  *
Parrot_ParrotClass_get_class(PARROT_INTERP, PMC *pmc)
{
#line 314 "./src/pmc/parrotclass.pmc"

    return pmc;
#line 233 "./src/pmc/parrotclass.c"
}
void
Parrot_ParrotClass_init(PARROT_INTERP, PMC *pmc)
{
#line 197 "./src/pmc/parrotclass.pmc"

    /* No attributes to start with */
    PMC_int_val(pmc) = CLASS_ATTRIB_COUNT(pmc) = 0;

    /* But we are a class, really */
    PObj_is_class_SET(pmc);

    /* turn on marking of the class_data array */
    PObj_data_is_PMC_array_SET(pmc);

    /* turn on custom destruction since our PMC *array is
       dynamically allocated */
    PObj_active_destroy_SET(pmc);
#line 252 "./src/pmc/parrotclass.c"
}
void
Parrot_ParrotClass_init_pmc(PARROT_INTERP, PMC *pmc, PMC *name)
{
#line 212 "./src/pmc/parrotclass.pmc"

    Parrot_ParrotClass_init(interp, pmc);
    Parrot_new_class(interp, pmc, name);
#line 261 "./src/pmc/parrotclass.c"
}
PMC  *
Parrot_ParrotClass_instantiate(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 241 "./src/pmc/parrotclass.pmc"

    SLOTTYPE    *new_object_array;
    INTVAL       attrib_count, i;
    const INTVAL type   = pmc->vtable->base_type;
    PMC         *object = pmc_new_noinit(interp, type);
    PMC * const _class  = object->vtable->pmc_class;

    /* put in the real vtable */
    PMC * const vtable_pmc = get_attrib_num((SLOTTYPE *)PMC_data(_class),
                                            PCD_OBJECT_VTABLE);
    object->vtable         = (VTABLE *)PMC_struct_val(vtable_pmc);

    /* Grab the attribute count from the class */
    attrib_count = CLASS_ATTRIB_COUNT(_class);

    /* Build the array that hangs off the new object */
    /* First presize it */
    set_attrib_array_size(object, attrib_count);
    new_object_array = PMC_data_typed(object, SLOTTYPE *);

    /* fill with PMCNULL, so that access doesn't segfault */
    for (i = 0; i < attrib_count; ++i)
        set_attrib_num(object, new_object_array, i, PMCNULL);

    /* turn marking on */
    set_attrib_flags(object);

    /* We are an object now */
    PObj_is_object_SET(object);

    /* We really ought to call the class init routines here...
     * this assumes that an object isa delegate
     */
    do_initcall(interp, _class, object, init);

    return object;
#line 303 "./src/pmc/parrotclass.c"
}
INTVAL
Parrot_ParrotClass_isa(PARROT_INTERP, PMC *pmc, STRING *classname)
{
#line 289 "./src/pmc/parrotclass.pmc"

    PMC *_class;

    if (Parrot_default_isa(interp, pmc, classname))
        return 1;

    _class = Parrot_class_lookup(interp, classname);
    return Parrot_object_isa(interp, pmc, _class);
#line 317 "./src/pmc/parrotclass.c"
}
STRING  *
Parrot_ParrotClass_name(PARROT_INTERP, PMC *pmc)
{
#line 318 "./src/pmc/parrotclass.pmc"

    PMC **class_data = (PMC **)PMC_data(pmc);

    if (class_data) {
        PMC *name = class_data[PCD_CLASS_NAME];
        return readable_name(interp, name);
    }

    return pmc->vtable->whoami;
#line 332 "./src/pmc/parrotclass.c"
}
void
Parrot_ParrotClass_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 395 "./src/pmc/parrotclass.pmc"

    IMAGE_IO *io = info->image_io;

    /*
     * Thawing a class is tricky - it might or might not exist
     * in the interpreter, where it get thawed.
     * Additionally, it could happen that a class exists
     * but the thawed one differs.
     *
     * So here's the plan:
     * During thaw, we first extend the class_data by two,
     * thaw parents and attribs into that new area, and
     * then we see what to do.
     */
    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        Parrot_default_thaw(interp, pmc, info);
    }
    else if (info->extra_flags == EXTRA_IS_NULL) {
        INTVAL  new_type;
        PMC    *real_class;

        /* thaw class name */
        STRING *class_name = VTABLE_shift_string(interp, io);

        /* if class exists in this interpreter, check if the
         * thawed class is the same, if not bail out, if yes
         * ignore the class, consume the byte string
         */
        new_type = pmc_type(interp, class_name);
        if (new_type > enum_type_undef) {
            real_class        = Parrot_class_lookup(interp, class_name);
            info->extra       = real_class;
            info->extra_flags = EXTRA_CLASS_EXISTS;
        }
        else {
            PMC *name  = pmc_new(interp, enum_class_String);
            real_class = pmc;
            VTABLE_set_string_native(interp, name, class_name);
            Parrot_ParrotClass_init_pmc(interp, pmc, name);
        }

        /* make room for thawed arrays */
        if (PMC_int_val(real_class) == PCD_MAX) {
            PMC **class_data;
            resize_attrib_array(real_class, PCD_MAX + 2);
            class_data              = (PMC **)PMC_data(real_class);
            class_data[PCD_MAX]     = NULL;
            class_data[PCD_MAX + 1] = NULL;
        }
    }
#line 388 "./src/pmc/parrotclass.c"
}
void
Parrot_ParrotClass_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 447 "./src/pmc/parrotclass.pmc"

    PMC    *_class           = pmc;
    PMC   **class_data       = (PMC **)(PMC_data(_class));
    PMC    *old              = class_data[PCD_PARENTS];
    INTVAL  nold             = VTABLE_elements(interp, old);
    PMC    *parents          = class_data[PCD_MAX];
    int     parent_not_class = 0;
    PMC    *attribs;
    INTVAL i, n;

    if (!parents)
        n = 0;
    else
        n = VTABLE_elements(interp, parents);

    if (nold && n != nold)
        real_exception(interp, NULL, E_AssertionError,
                "thawed class differs");

    /* TODO compare elements */
    if (!nold) {
        for (i = 0; i < n; ++i) {
            PMC *parent_class = VTABLE_get_pmc_keyed_int(interp, parents,i);
            if (!PObj_is_class_TEST(parent_class)) {
                PARROT_ASSERT(!parent_not_class);
                parent_not_class++;
                parent_class = parent_class->vtable->pmc_class;
            }

            Parrot_add_parent(interp, _class, parent_class);
        }
    }

    /* preserve the thawed attrib array */
    old     = class_data[PCD_CLASS_ATTRIBUTES];
    nold    = VTABLE_elements(interp, old);
    attribs = class_data[PCD_MAX + 1];

    if (!attribs)
        n = 0;
    else
        n = VTABLE_elements(interp, attribs);

    if (nold != parent_not_class && n != nold)
        real_exception(interp, NULL, E_AssertionError,
                "thawed class differs");
    /* TODO compare attribs */

    if (nold == parent_not_class) {
        /* non-class parents already have an extra attribute for
         * delegating, which will have already been created by
         * Parrot_add_parent() and must be first
         */
        for (i = parent_not_class ? 1 : 0; i < n; ++i) {
            Parrot_add_attribute(interp, _class,
                    VTABLE_get_string_keyed_int(interp, attribs, i));
        }
    }

    class_data[PCD_MAX]     = NULL;
    class_data[PCD_MAX + 1] = NULL;
#line 455 "./src/pmc/parrotclass.c"
}
void
Parrot_ParrotClass_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 355 "./src/pmc/parrotclass.pmc"

    PMC **class_data = (PMC **)PMC_data(pmc);
    PMC **pos;

    /* 2) direct parents array */
    if (info->what == VISIT_THAW_NORMAL ||
            info->what == VISIT_THAW_CONSTANTS)
        pos = class_data + PCD_MAX;
    else
        pos = class_data + PCD_PARENTS;

    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);

    /* 3) attributes array */
    if (info->what == VISIT_THAW_NORMAL ||
            info->what == VISIT_THAW_CONSTANTS)
        pos = class_data + PCD_MAX + 1;
    else
        pos = class_data + PCD_CLASS_ATTRIBUTES;

    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);

    Parrot_default_visit(interp, pmc, info);
#line 486 "./src/pmc/parrotclass.c"
}
PMC  *
Parrot_ParrotClass_nci_get_parents(PARROT_INTERP, PMC *pmc)
{
#line 520 "./src/pmc/parrotclass.pmc"

    PMC  *_class     = pmc;
    PMC **class_data = (PMC**)(PMC_data(_class));
    return class_data[PCD_PARENTS];
#line 496 "./src/pmc/parrotclass.c"
}
void
Parrot_ParrotClass_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ParrotClass");
}
PMC *
Parrot_ParrotClass_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_ParrotClass_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ParrotClass");
}
FLOATVAL
Parrot_ParrotClass_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ParrotClass");
}
INTVAL
Parrot_ParrotClass_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ParrotClass");
}
PMC *
Parrot_ParrotClass_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ParrotClass");
}
STRING *
Parrot_ParrotClass_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ParrotClass");
}
FLOATVAL
Parrot_ParrotClass_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ParrotClass");
}
INTVAL
Parrot_ParrotClass_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ParrotClass");
}
PMC *
Parrot_ParrotClass_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ParrotClass");
}
STRING *
Parrot_ParrotClass_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ParrotClass");
}
void
Parrot_ParrotClass_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_ParrotClass, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_delegate_absolute,
        Parrot_delegate_add_attribute,
        Parrot_delegate_add_method,
        Parrot_default_add_parent,
        Parrot_delegate_add_role,
        Parrot_delegate_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_delegate_bitwise_not,
        Parrot_delegate_bitwise_nots,
        Parrot_default_can,
        Parrot_delegate_class_type,
        Parrot_delegate_clone,
        Parrot_delegate_clone_pmc,
        Parrot_delegate_decrement,
        Parrot_default_defined,
        Parrot_delegate_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_delegate_defined_keyed_str,
        Parrot_delegate_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_delegate_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_ParrotClass_destroy,
        Parrot_default_does,
        Parrot_delegate_elements,
        Parrot_delegate_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_delegate_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_ParrotClass_freeze,
        Parrot_delegate_get_attr,
        Parrot_default_get_attr_str,
        Parrot_delegate_get_bignum,
        Parrot_delegate_get_bool,
        Parrot_ParrotClass_get_class,
        Parrot_delegate_get_integer,
        Parrot_delegate_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_delegate_get_integer_keyed_str,
        Parrot_delegate_get_iter,
        Parrot_delegate_get_number,
        Parrot_delegate_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_delegate_get_number_keyed_str,
        Parrot_delegate_get_pmc,
        Parrot_delegate_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_delegate_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_delegate_get_pointer_keyed,
        Parrot_delegate_get_pointer_keyed_int,
        Parrot_delegate_get_pointer_keyed_str,
        Parrot_delegate_get_repr,
        Parrot_delegate_get_string,
        Parrot_delegate_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_delegate_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_delegate_hash,
        Parrot_delegate_i_absolute,
        Parrot_delegate_i_bitwise_not,
        Parrot_delegate_i_bitwise_nots,
        Parrot_delegate_i_logical_not,
        Parrot_delegate_i_neg,
        Parrot_delegate_increment,
        Parrot_ParrotClass_init,
        Parrot_ParrotClass_init_pmc,
        Parrot_delegate_inspect,
        Parrot_delegate_inspect_str,
        Parrot_ParrotClass_instantiate,
        Parrot_delegate_invoke,
        Parrot_default_is_same,
        Parrot_ParrotClass_isa,
        Parrot_delegate_logical_not,
        Parrot_delegate_mark,
        Parrot_default_morph,
        Parrot_ParrotClass_name,
        Parrot_delegate_neg,
        Parrot_delegate_new_from_string,
        Parrot_delegate_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_delegate_nextkey_keyed_str,
        Parrot_delegate_pmc_namespace,
        Parrot_delegate_pop_float,
        Parrot_delegate_pop_integer,
        Parrot_delegate_pop_pmc,
        Parrot_delegate_pop_string,
        Parrot_delegate_push_float,
        Parrot_delegate_push_integer,
        Parrot_delegate_push_pmc,
        Parrot_delegate_push_string,
        Parrot_delegate_remove_attribute,
        Parrot_delegate_remove_method,
        Parrot_delegate_remove_parent,
        Parrot_delegate_remove_role,
        Parrot_delegate_remove_vtable_override,
        Parrot_delegate_set_attr,
        Parrot_delegate_set_attr_str,
        Parrot_delegate_set_bignum_int,
        Parrot_delegate_set_bignum_num,
        Parrot_delegate_set_bignum_str,
        Parrot_delegate_set_bool,
        Parrot_delegate_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_delegate_set_integer_keyed_str,
        Parrot_delegate_set_integer_native,
        Parrot_delegate_set_integer_same,
        Parrot_delegate_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_delegate_set_number_keyed_str,
        Parrot_delegate_set_number_native,
        Parrot_delegate_set_number_same,
        Parrot_delegate_set_pmc,
        Parrot_delegate_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_delegate_set_pmc_keyed_str,
        Parrot_delegate_set_pointer,
        Parrot_delegate_set_pointer_keyed,
        Parrot_delegate_set_pointer_keyed_int,
        Parrot_delegate_set_pointer_keyed_str,
        Parrot_delegate_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_delegate_set_string_keyed_str,
        Parrot_delegate_set_string_native,
        Parrot_delegate_set_string_same,
        Parrot_default_setprop,
        Parrot_delegate_share,
        Parrot_delegate_share_ro,
        Parrot_delegate_shift_float,
        Parrot_delegate_shift_integer,
        Parrot_delegate_shift_pmc,
        Parrot_delegate_shift_string,
        Parrot_delegate_slice,
        Parrot_delegate_splice,
        Parrot_default_subclass,
        Parrot_delegate_substr,
        Parrot_delegate_substr_str,
        Parrot_delegate_subtype,
        Parrot_ParrotClass_thaw,
        Parrot_ParrotClass_thawfinish,
        Parrot_delegate_type,
        Parrot_delegate_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_delegate_type_keyed_str,
        Parrot_delegate_unshift_float,
        Parrot_delegate_unshift_integer,
        Parrot_delegate_unshift_pmc,
        Parrot_delegate_unshift_string,
        Parrot_ParrotClass_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_ParrotClass, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_delegate_absolute,
        Parrot_ParrotClass_ro_add_attribute,
        Parrot_ParrotClass_ro_add_method,
        Parrot_ParrotClass_ro_add_parent,
        Parrot_ParrotClass_ro_add_role,
        Parrot_ParrotClass_ro_add_vtable_override,
        Parrot_ParrotClass_ro_assign_pmc,
        Parrot_ParrotClass_ro_assign_string_native,
        Parrot_delegate_bitwise_not,
        Parrot_delegate_bitwise_nots,
        Parrot_default_can,
        Parrot_delegate_class_type,
        Parrot_delegate_clone,
        Parrot_delegate_clone_pmc,
        Parrot_ParrotClass_ro_decrement,
        Parrot_default_defined,
        Parrot_delegate_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_delegate_defined_keyed_str,
        Parrot_ParrotClass_ro_delete_keyed,
        Parrot_ParrotClass_ro_delete_keyed_int,
        Parrot_ParrotClass_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_ParrotClass_destroy,
        Parrot_default_does,
        Parrot_delegate_elements,
        Parrot_delegate_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_delegate_exists_keyed_str,
        Parrot_ParrotClass_ro_find_method,
        Parrot_ParrotClass_freeze,
        Parrot_delegate_get_attr,
        Parrot_default_get_attr_str,
        Parrot_delegate_get_bignum,
        Parrot_delegate_get_bool,
        Parrot_ParrotClass_get_class,
        Parrot_delegate_get_integer,
        Parrot_delegate_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_delegate_get_integer_keyed_str,
        Parrot_delegate_get_iter,
        Parrot_delegate_get_number,
        Parrot_delegate_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_delegate_get_number_keyed_str,
        Parrot_delegate_get_pmc,
        Parrot_delegate_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_delegate_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_delegate_get_pointer_keyed,
        Parrot_delegate_get_pointer_keyed_int,
        Parrot_delegate_get_pointer_keyed_str,
        Parrot_delegate_get_repr,
        Parrot_delegate_get_string,
        Parrot_delegate_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_delegate_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_delegate_hash,
        Parrot_ParrotClass_ro_i_absolute,
        Parrot_ParrotClass_ro_i_bitwise_not,
        Parrot_ParrotClass_ro_i_bitwise_nots,
        Parrot_ParrotClass_ro_i_logical_not,
        Parrot_ParrotClass_ro_i_neg,
        Parrot_ParrotClass_ro_increment,
        Parrot_ParrotClass_init,
        Parrot_ParrotClass_init_pmc,
        Parrot_delegate_inspect,
        Parrot_delegate_inspect_str,
        Parrot_ParrotClass_instantiate,
        Parrot_delegate_invoke,
        Parrot_default_is_same,
        Parrot_ParrotClass_isa,
        Parrot_delegate_logical_not,
        Parrot_delegate_mark,
        Parrot_ParrotClass_ro_morph,
        Parrot_ParrotClass_name,
        Parrot_delegate_neg,
        Parrot_delegate_new_from_string,
        Parrot_delegate_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_delegate_nextkey_keyed_str,
        Parrot_delegate_pmc_namespace,
        Parrot_ParrotClass_ro_pop_float,
        Parrot_ParrotClass_ro_pop_integer,
        Parrot_ParrotClass_ro_pop_pmc,
        Parrot_ParrotClass_ro_pop_string,
        Parrot_ParrotClass_ro_push_float,
        Parrot_ParrotClass_ro_push_integer,
        Parrot_ParrotClass_ro_push_pmc,
        Parrot_ParrotClass_ro_push_string,
        Parrot_ParrotClass_ro_remove_attribute,
        Parrot_ParrotClass_ro_remove_method,
        Parrot_ParrotClass_ro_remove_parent,
        Parrot_ParrotClass_ro_remove_role,
        Parrot_ParrotClass_ro_remove_vtable_override,
        Parrot_ParrotClass_ro_set_attr,
        Parrot_ParrotClass_ro_set_attr_str,
        Parrot_ParrotClass_ro_set_bignum_int,
        Parrot_ParrotClass_ro_set_bignum_num,
        Parrot_ParrotClass_ro_set_bignum_str,
        Parrot_ParrotClass_ro_set_bool,
        Parrot_ParrotClass_ro_set_integer_keyed,
        Parrot_ParrotClass_ro_set_integer_keyed_int,
        Parrot_ParrotClass_ro_set_integer_keyed_str,
        Parrot_ParrotClass_ro_set_integer_native,
        Parrot_ParrotClass_ro_set_integer_same,
        Parrot_ParrotClass_ro_set_number_keyed,
        Parrot_ParrotClass_ro_set_number_keyed_int,
        Parrot_ParrotClass_ro_set_number_keyed_str,
        Parrot_ParrotClass_ro_set_number_native,
        Parrot_ParrotClass_ro_set_number_same,
        Parrot_ParrotClass_ro_set_pmc,
        Parrot_ParrotClass_ro_set_pmc_keyed,
        Parrot_ParrotClass_ro_set_pmc_keyed_int,
        Parrot_ParrotClass_ro_set_pmc_keyed_str,
        Parrot_ParrotClass_ro_set_pointer,
        Parrot_ParrotClass_ro_set_pointer_keyed,
        Parrot_ParrotClass_ro_set_pointer_keyed_int,
        Parrot_ParrotClass_ro_set_pointer_keyed_str,
        Parrot_ParrotClass_ro_set_string_keyed,
        Parrot_ParrotClass_ro_set_string_keyed_int,
        Parrot_ParrotClass_ro_set_string_keyed_str,
        Parrot_ParrotClass_ro_set_string_native,
        Parrot_ParrotClass_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_delegate_share,
        Parrot_delegate_share_ro,
        Parrot_ParrotClass_ro_shift_float,
        Parrot_ParrotClass_ro_shift_integer,
        Parrot_ParrotClass_ro_shift_pmc,
        Parrot_ParrotClass_ro_shift_string,
        Parrot_delegate_slice,
        Parrot_ParrotClass_ro_splice,
        Parrot_default_subclass,
        Parrot_delegate_substr,
        Parrot_delegate_substr_str,
        Parrot_delegate_subtype,
        Parrot_ParrotClass_ro_thaw,
        Parrot_ParrotClass_ro_thawfinish,
        Parrot_delegate_type,
        Parrot_delegate_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_delegate_type_keyed_str,
        Parrot_ParrotClass_ro_unshift_float,
        Parrot_ParrotClass_ro_unshift_integer,
        Parrot_ParrotClass_ro_unshift_pmc,
        Parrot_ParrotClass_ro_unshift_string,
        Parrot_ParrotClass_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "ParrotClass");
        vt_clone->isa_str = CONST_STRING(interp, "ParrotClass");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotClass_nci_get_parents), "get_parents", "PJO");
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_ParrotClass_class_init */
#line 524 "./src/pmc/parrotclass.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
