/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/parrotinterpreter.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/parrotinterpreter.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: parrotinterpreter.pmc 22144 2007-10-16 21:01:17Z chromatic $

=head1 NAME

src/pmc/parrotinterpreter.pmc - Parrot Interpreter

=head1 DESCRIPTION

These are the vtable functions for the ParrotInterpreter base class

   getinterp P0
   set P1, P0[.IGLOBALS_*]  # access interpreter globals
   set I0, P0[x]            # interpinfo I0, x
   set I0, P0[-1]           # get interpreter flags
   set P0[-1], x            # set flags on interpreter
                            # NOTE: this doesn't restart

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/embed.h"
#include "parrot/dynext.h"

/*

=item C<void
clone_interpreter(Parrot_Interp dest, const Parrot_Interp source, INTVAL flags)>

Clones the interpreter as specified by the flags.

=cut

*/

void
clone_interpreter(Parrot_Interp d, Parrot_Interp s, INTVAL flags)
{
    /* we block DOD runs while cloning since C<d> is not yet running */
    Parrot_block_DOD(d);
    if (flags & PARROT_CLONE_RUNOPS)
        d->run_core = s->run_core;

    if (flags & PARROT_CLONE_INTERP_FLAGS) {
        /* XXX setting of IS_THREAD? */
        d->flags       = s->flags;
        d->debug_flags = s->debug_flags;
    }

    if (flags & PARROT_CLONE_HLL) {
        /* we'd like to share the HLL data. Give it a PMC_sync structure
           if it doesn't have one already */
        add_pmc_sync(s, s->HLL_info);
        d->HLL_info = s->HLL_info;
        Parrot_regenerate_HLL_namespaces(d);
    }

    if (flags & (PARROT_CLONE_LIBRARIES | PARROT_CLONE_CLASSES)) {
        INTVAL i, last_remove;
        INTVAL start = d->n_vtable_max;

        /* copy type registrations to keep type numbers the same */
        d->class_hash   = Parrot_clone(d, s->class_hash);
        d->n_vtable_max = s->n_vtable_max;

        if (d->n_vtable_max > d->n_vtable_alloced)
            parrot_realloc_vtables(d);

        last_remove = s->n_vtable_max;

        for (i = s->n_vtable_max - 1; i >= start; --i) {
            if (s->vtables[i] && s->vtables[i]->pmc_class &&
                PObj_is_class_TEST(s->vtables[i]->pmc_class)) {
                STRING * const class_name =
                    VTABLE_name(s, s->vtables[i]->pmc_class);
                PARROT_ASSERT(VTABLE_exists_keyed_str(d,
                    d->class_hash, class_name));

                VTABLE_delete_keyed_str(d, d->class_hash, class_name);

                if (last_remove == i + 1) {
                    --d->n_vtable_max;
                    last_remove = i;
                }
            }
        }
    }

    if (flags & PARROT_CLONE_LIBRARIES) {
        PMC   *libs     = VTABLE_get_pmc_keyed_int(s, s->iglobals,
            IGLOBALS_DYN_LIBS);
        PMC   *lib_iter = VTABLE_get_iter(s, libs);
        INTVAL n        = VTABLE_elements(s, libs);
        INTVAL i;

        for (i = 0; i < n; ++i) {
            STRING * const key     = VTABLE_shift_string(s, lib_iter);
            PMC    * const lib_pmc = VTABLE_get_pmc_keyed_str(s, libs, key);
            PMC    * const ignored = Parrot_clone_lib_into(d, s, lib_pmc);
            UNUSED(ignored);
        }
    }

    if (flags & PARROT_CLONE_CLASSES) {
        INTVAL i;
        for (i = 0; i < s->n_vtable_max; ++i) {
            if (s->vtables[i] && s->vtables[i]->pmc_class &&
                    PObj_is_class_TEST(s->vtables[i]->pmc_class)) {
                /* Cloning the class into the new interpreter ought
                 * to be sufficient to instantiate the class.  */
                 PMC *ignored = Parrot_clone(d, s->vtables[i]->pmc_class);
                UNUSED(ignored);
            }
        }
    }

    if (flags & PARROT_CLONE_CODE)
        pt_clone_code(d, s);

    if (flags & PARROT_CLONE_GLOBALS)
        pt_clone_globals(d, s);

    Parrot_unblock_DOD(d);
}


/*

=item C<static void
create_interp(PMC *self, Parrot_Interp parent)>

Creates a new child interpreter of C<parent>.

=cut

*/

static void
create_interp(PMC *self, Parrot_Interp parent)
{
    Interp_flags flag  = PARROT_NO_FLAGS;
    Parrot_Interp new_interp;

    if (self->vtable->base_type == enum_class_ParrotThread)
        flag = PARROT_IS_THREAD;

    new_interp     = make_interpreter(parent, flag);
    PMC_data(self) = new_interp;

    VTABLE_set_pmc_keyed_int(new_interp, new_interp->iglobals,
        (INTVAL) IGLOBALS_INTERPRETER, self);

    new_interp->current_cont = NEED_CONTINUATION;
}

static int
recursion_limit(Parrot_Interp interp, PMC *self, int l)
{
    int ret                 = interp->recursion_limit;
    interp->recursion_limit = l;
    return ret;
}
#line 184 "./src/pmc/parrotinterpreter.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_parrotinterpreter.h"
#include "pmc_default.h"
#include "parrotinterpreter.str"
INTVAL
Parrot_ParrotInterpreter_is_equal(PARROT_INTERP, PMC *pmc, PMC *val)
{
#line 525 "./src/pmc/parrotinterpreter.pmc"

    Parrot_Interp self  = PMC_data_typed(pmc, Parrot_Interp);
    Parrot_Interp other = PMC_data_typed(val, Parrot_Interp);

    if (!self->thread_data && !other->thread_data)
        return 1;

    if (self->thread_data && other->thread_data &&
        self->thread_data->tid == other->thread_data->tid)
        return 1;

    return 0;
#line 207 "./src/pmc/parrotinterpreter.c"
}
PMC  *
Parrot_ParrotInterpreter_clone(PARROT_INTERP, PMC *pmc)
{
#line 503 "./src/pmc/parrotinterpreter.pmc"

    PMC *dest = pmc_new(interp, pmc->vtable->base_type);

    clone_interpreter((Parrot_Interp)PMC_data(dest),
                      (Parrot_Interp)PMC_data(pmc), PARROT_CLONE_DEFAULT);

    return dest;
#line 220 "./src/pmc/parrotinterpreter.c"
}
INTVAL
Parrot_ParrotInterpreter_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 287 "./src/pmc/parrotinterpreter.pmc"

    Parrot_Interp i = PMC_data_typed(pmc, Parrot_Interp);
    return (INTVAL)i->thread_data->tid;
#line 229 "./src/pmc/parrotinterpreter.c"
}
INTVAL
Parrot_ParrotInterpreter_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 459 "./src/pmc/parrotinterpreter.pmc"

    Interp *new_interp = PMC_data_typed(pmc, Interp *);

    if (key == -1)
        return (INTVAL)new_interp->flags;

    return interpinfo(new_interp, key);
#line 242 "./src/pmc/parrotinterpreter.c"
}
PMC  *
Parrot_ParrotInterpreter_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 362 "./src/pmc/parrotinterpreter.pmc"

    PMC    *nextkey, *cont;
    STRING *outer = NULL;
    STRING *item  = key_string(interp, key);
    STRING *s     = CONST_STRING(interp, "globals");
    int     level = 0;

    parrot_context_t *ctx;

    if (string_equal(interp, item, s) == 0)
        return interp->root_namespace;

    s     = CONST_STRING(interp, "outer");

    if (string_equal(interp, item, s) == 0) {
        outer   = item;
        nextkey = key_next(interp, key);

        if (nextkey && (PObj_get_FLAGS(nextkey) & KEY_string_FLAG)) {
            key  = nextkey;
            item = key_string(interp, key);
        }
    }

    nextkey = key_next(interp, key);

    if (nextkey)
        level = key_integer(interp, nextkey);
    else if (outer)
        level = 1;

    if (level < 0)
        real_exception(interp, NULL, E_ValueError, "No such caller depth");

    ctx = CONTEXT(interp->ctx);

    if (outer) {
        for (; level; --level) {
            ctx = ctx->outer_ctx;
            if (!ctx)
                real_exception(interp, NULL, E_ValueError,
                        "No such outer depth");
        }
    }
    else {
        for (; level; --level) {
            cont = ctx->current_cont;

            if (PMC_IS_NULL(cont) || !PMC_cont(cont)->seg)
                real_exception(interp, NULL, E_ValueError,
                        "No such caller depth");

            ctx = PMC_cont(cont)->to_ctx;

            if (!ctx->current_sub)
                real_exception(interp, NULL, E_ValueError,
                        "No such caller depth");
        }
    }

    if (item == outer)
        return ctx->current_sub;

    s = CONST_STRING(interp, "sub");

    if (string_equal(interp, item, s) == 0)
        return ctx->current_sub;

    s = CONST_STRING(interp, "lexpad");

    if (string_equal(interp, item, s) == 0)
        return ctx->lex_pad;

    s = CONST_STRING(interp, "namespace");

    if (string_equal(interp, item, s) == 0)
        return ctx->current_namespace;

    s = CONST_STRING(interp, "continuation");

    if (string_equal(interp, item, s) == 0)
        return VTABLE_clone(interp, ctx->current_cont);

    real_exception(interp, NULL, E_ValueError,
            "No such item %Ss", item);
#line 333 "./src/pmc/parrotinterpreter.c"
}
PMC  *
Parrot_ParrotInterpreter_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 328 "./src/pmc/parrotinterpreter.pmc"

    Interp *new_interp = PMC_data_typed(pmc, Interp *);

    if (key >= 0 && key < IGLOBALS_SIZE)
        return VTABLE_get_pmc_keyed_int(new_interp,
            new_interp->iglobals, key);

    /* quick hack to get the global stash */
    if (key == -1)
        return new_interp->root_namespace;

    return PMCNULL;
#line 351 "./src/pmc/parrotinterpreter.c"
}
void  *
Parrot_ParrotInterpreter_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 273 "./src/pmc/parrotinterpreter.pmc"

    return PMC_struct_val(pmc);
#line 359 "./src/pmc/parrotinterpreter.c"
}
void
Parrot_ParrotInterpreter_init(PARROT_INTERP, PMC *pmc)
{
#line 213 "./src/pmc/parrotinterpreter.pmc"

    /*
     * init/init_pmc may be called internally (from thread creation in
     * ParrotThread::init_pmc() or stand-alone
     * so we check, if the interpreter is already setup
     */
    if (!PMC_data(pmc)) {
        create_interp(pmc, interp);
        PARROT_ASSERT(PMC_data(pmc));
    }

    PMC_struct_val(pmc) = NULL;
    PMC_pmc_val(pmc)    = NULL;
#line 378 "./src/pmc/parrotinterpreter.c"
}
void
Parrot_ParrotInterpreter_init_pmc(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 240 "./src/pmc/parrotinterpreter.pmc"

    Parrot_Interp p = PMC_data_typed(parent, Parrot_Interp);

    if (!PMC_data(pmc))
        create_interp(pmc, p);

    PMC_struct_val(pmc) = NULL;
#line 391 "./src/pmc/parrotinterpreter.c"
}
opcode_t  *
Parrot_ParrotInterpreter_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 302 "./src/pmc/parrotinterpreter.pmc"

    Interp *new_interp = PMC_data_typed(pmc, Interp *);

    /* setup code */
    pt_thread_prepare_for_run(new_interp, interp);

    /* TODO pass arguments from parent (interp) to child (new_interp) by
     * possibly clone of share the arguments r/o args can be passed as is */

    /* calculate offset and run */
    runops(new_interp, (opcode_t *)PMC_struct_val(pmc) -
        (opcode_t *)interp->code->base.data);

    return (opcode_t *)next;
#line 411 "./src/pmc/parrotinterpreter.c"
}
void
Parrot_ParrotInterpreter_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL val)
{
#line 478 "./src/pmc/parrotinterpreter.pmc"

    Interp *new_interp = PMC_data_typed(pmc, Interp *);

    /* set interpreter flags */
    if (key == -1) {
        INTVAL allowed = PARROT_BOUNDS_FLAG | PARROT_PROFILE_FLAG |
                         PARROT_GC_DEBUG_FLAG;
        Parrot_clear_flag(new_interp, allowed);
        Parrot_set_flag(new_interp, val & allowed);
    }
#line 427 "./src/pmc/parrotinterpreter.c"
}
void
Parrot_ParrotInterpreter_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 259 "./src/pmc/parrotinterpreter.pmc"

    PMC_struct_val(pmc) = value;
#line 435 "./src/pmc/parrotinterpreter.c"
}
void
Parrot_ParrotInterpreter_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 602 "./src/pmc/parrotinterpreter.pmc"

    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        Parrot_default_thaw(interp, pmc, info);
    }
    else if (info->extra_flags == EXTRA_IS_NULL) {
        PMC_data(pmc) = interp;
        info->what     = VISIT_THAW_CONSTANTS;
    }
#line 449 "./src/pmc/parrotinterpreter.c"
}
void
Parrot_ParrotInterpreter_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 612 "./src/pmc/parrotinterpreter.pmc"

    PMC    *new_info = PMC_pmc_val(pmc);
    INTVAL  m        = VTABLE_elements(interp, new_info);
    INTVAL  i;

    PMC_pmc_val(pmc) = NULL;

    /* merge new_info */
    /* TODO compare old entries */

    for (i = 0; i < m; ++i) {
        PMC *entry    = VTABLE_get_pmc_keyed_int(interp, new_info, i);
        PMC *lib_pmc  = VTABLE_get_pmc_keyed_int(interp, entry, e_HLL_lib);
        PMC *name_pmc = VTABLE_get_pmc_keyed_int(interp, entry, e_HLL_name);
        PMC *typemap  =
            VTABLE_get_pmc_keyed_int(interp, entry, e_HLL_typemap);
        INTVAL hll_id;

        if (!PMC_IS_NULL(name_pmc)) {
            STRING *hll_name = VTABLE_get_string(interp, name_pmc);

            PObj_constant_SET(hll_name);
            hll_id           = Parrot_register_HLL(interp, hll_name);
        }

        if (!PMC_IS_NULL(lib_pmc)) {
            STRING *lib_name = VTABLE_get_string(interp, lib_pmc);
            PMC    *ignored;

            if (!STRING_IS_EMPTY(lib_name)) {
                INTVAL id;
                PObj_constant_SET(lib_name);
                ignored      = Parrot_load_lib(interp, lib_name, NULL);
                id           = Parrot_register_HLL_lib(interp, lib_name);
                UNUSED(id);
            }

            UNUSED(ignored);
        }

        if (hll_id && !PMC_IS_NULL(typemap)) {
            PMC   *iter = VTABLE_get_iter(interp, typemap);
            INTVAL e    = VTABLE_get_integer(interp, typemap);
            INTVAL i;

            for ( i = 0; i < e; ++i ) {
                PMC   *key       = VTABLE_shift_pmc(interp, iter);
                INTVAL core_type = VTABLE_get_integer(interp, key);
                INTVAL hll_type  =
                    VTABLE_get_integer_keyed_int(interp, typemap,core_type);

                Parrot_register_HLL_type(interp, hll_id,
                    core_type, hll_type);
            }
        }
    }
#line 511 "./src/pmc/parrotinterpreter.c"
}
void
Parrot_ParrotInterpreter_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 566 "./src/pmc/parrotinterpreter.pmc"

    PMC **pos;
    /*
     * the information frozen here is part of all PBCs
     * we probably need to freeze all dynamic extensible
     * mappings (or at least the dynamic part)
     * e.g.
     *    charsets   idx - name
     *    encodings  idx - name
     *    pmc types  idx - name
     *    dynamic oplibs    opcode nr - opname
     *
     * The machine thawing this info still needs to load
     * these extensions, but the order of loading could be
     * relaxed.
     *
     * creating all these info as standard PMCs would vastly
     * simplify this process
     *
     * thaw would then need a merge operation:
     *  - compare existing for sanity
     *  - extend new
     */

    /*  HLL_info */
    if (info->what == VISIT_THAW_NORMAL ||
            info->what == VISIT_THAW_CONSTANTS) {
        pos = &PMC_pmc_val(pmc);
    }
    else
        pos = &interp->HLL_info;

    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);
#line 551 "./src/pmc/parrotinterpreter.c"
}
void
Parrot_ParrotInterpreter_nci_run_gc(PARROT_INTERP, PMC *pmc)
{
#line 670 "./src/pmc/parrotinterpreter.pmc"

    Parrot_do_dod_run(PMC_data_typed(pmc, Parrot_Interp), 0);
#line 559 "./src/pmc/parrotinterpreter.c"
}
void
Parrot_ParrotInterpreter_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ParrotInterpreter");
}
PMC *
Parrot_ParrotInterpreter_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_ParrotInterpreter_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ParrotInterpreter");
}
FLOATVAL
Parrot_ParrotInterpreter_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ParrotInterpreter");
}
INTVAL
Parrot_ParrotInterpreter_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ParrotInterpreter");
}
PMC *
Parrot_ParrotInterpreter_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ParrotInterpreter");
}
STRING *
Parrot_ParrotInterpreter_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ParrotInterpreter");
}
FLOATVAL
Parrot_ParrotInterpreter_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ParrotInterpreter");
}
INTVAL
Parrot_ParrotInterpreter_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ParrotInterpreter");
}
PMC *
Parrot_ParrotInterpreter_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ParrotInterpreter");
}
STRING *
Parrot_ParrotInterpreter_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ParrotInterpreter");
}
void
Parrot_ParrotInterpreter_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_ParrotInterpreter, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ParrotInterpreter_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_ParrotInterpreter_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_ParrotInterpreter_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_ParrotInterpreter_get_pmc_keyed,
        Parrot_ParrotInterpreter_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_ParrotInterpreter_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_ParrotInterpreter_init,
        Parrot_ParrotInterpreter_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_ParrotInterpreter_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_ParrotInterpreter_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_ParrotInterpreter_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_ParrotInterpreter_thaw,
        Parrot_ParrotInterpreter_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_ParrotInterpreter_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_ParrotInterpreter, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_ParrotInterpreter_ro_add_attribute,
        Parrot_ParrotInterpreter_ro_add_method,
        Parrot_ParrotInterpreter_ro_add_parent,
        Parrot_ParrotInterpreter_ro_add_role,
        Parrot_ParrotInterpreter_ro_add_vtable_override,
        Parrot_ParrotInterpreter_ro_assign_pmc,
        Parrot_ParrotInterpreter_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ParrotInterpreter_clone,
        Parrot_default_clone_pmc,
        Parrot_ParrotInterpreter_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ParrotInterpreter_ro_delete_keyed,
        Parrot_ParrotInterpreter_ro_delete_keyed_int,
        Parrot_ParrotInterpreter_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ParrotInterpreter_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_ParrotInterpreter_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_ParrotInterpreter_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_ParrotInterpreter_get_pmc_keyed,
        Parrot_ParrotInterpreter_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_ParrotInterpreter_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_ParrotInterpreter_ro_i_absolute,
        Parrot_ParrotInterpreter_ro_i_bitwise_not,
        Parrot_ParrotInterpreter_ro_i_bitwise_nots,
        Parrot_ParrotInterpreter_ro_i_logical_not,
        Parrot_ParrotInterpreter_ro_i_neg,
        Parrot_ParrotInterpreter_ro_increment,
        Parrot_ParrotInterpreter_init,
        Parrot_ParrotInterpreter_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_ParrotInterpreter_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_ParrotInterpreter_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ParrotInterpreter_ro_pop_float,
        Parrot_ParrotInterpreter_ro_pop_integer,
        Parrot_ParrotInterpreter_ro_pop_pmc,
        Parrot_ParrotInterpreter_ro_pop_string,
        Parrot_ParrotInterpreter_ro_push_float,
        Parrot_ParrotInterpreter_ro_push_integer,
        Parrot_ParrotInterpreter_ro_push_pmc,
        Parrot_ParrotInterpreter_ro_push_string,
        Parrot_ParrotInterpreter_ro_remove_attribute,
        Parrot_ParrotInterpreter_ro_remove_method,
        Parrot_ParrotInterpreter_ro_remove_parent,
        Parrot_ParrotInterpreter_ro_remove_role,
        Parrot_ParrotInterpreter_ro_remove_vtable_override,
        Parrot_ParrotInterpreter_ro_set_attr,
        Parrot_ParrotInterpreter_ro_set_attr_str,
        Parrot_ParrotInterpreter_ro_set_bignum_int,
        Parrot_ParrotInterpreter_ro_set_bignum_num,
        Parrot_ParrotInterpreter_ro_set_bignum_str,
        Parrot_ParrotInterpreter_ro_set_bool,
        Parrot_ParrotInterpreter_ro_set_integer_keyed,
        Parrot_ParrotInterpreter_ro_set_integer_keyed_int,
        Parrot_ParrotInterpreter_ro_set_integer_keyed_str,
        Parrot_ParrotInterpreter_ro_set_integer_native,
        Parrot_ParrotInterpreter_ro_set_integer_same,
        Parrot_ParrotInterpreter_ro_set_number_keyed,
        Parrot_ParrotInterpreter_ro_set_number_keyed_int,
        Parrot_ParrotInterpreter_ro_set_number_keyed_str,
        Parrot_ParrotInterpreter_ro_set_number_native,
        Parrot_ParrotInterpreter_ro_set_number_same,
        Parrot_ParrotInterpreter_ro_set_pmc,
        Parrot_ParrotInterpreter_ro_set_pmc_keyed,
        Parrot_ParrotInterpreter_ro_set_pmc_keyed_int,
        Parrot_ParrotInterpreter_ro_set_pmc_keyed_str,
        Parrot_ParrotInterpreter_ro_set_pointer,
        Parrot_ParrotInterpreter_ro_set_pointer_keyed,
        Parrot_ParrotInterpreter_ro_set_pointer_keyed_int,
        Parrot_ParrotInterpreter_ro_set_pointer_keyed_str,
        Parrot_ParrotInterpreter_ro_set_string_keyed,
        Parrot_ParrotInterpreter_ro_set_string_keyed_int,
        Parrot_ParrotInterpreter_ro_set_string_keyed_str,
        Parrot_ParrotInterpreter_ro_set_string_native,
        Parrot_ParrotInterpreter_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ParrotInterpreter_ro_shift_float,
        Parrot_ParrotInterpreter_ro_shift_integer,
        Parrot_ParrotInterpreter_ro_shift_pmc,
        Parrot_ParrotInterpreter_ro_shift_string,
        Parrot_default_slice,
        Parrot_ParrotInterpreter_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_ParrotInterpreter_ro_thaw,
        Parrot_ParrotInterpreter_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ParrotInterpreter_ro_unshift_float,
        Parrot_ParrotInterpreter_ro_unshift_integer,
        Parrot_ParrotInterpreter_ro_unshift_pmc,
        Parrot_ParrotInterpreter_ro_unshift_string,
        Parrot_ParrotInterpreter_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_ParrotInterpreter_is_equal }
    };
    /* Dynamic PMCs need the runtime type which is passed in entry to class_init. */
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "ParrotInterpreter");
        vt_clone->isa_str = CONST_STRING(interp, "ParrotInterpreter");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_ParrotInterpreter_nci_run_gc), "run_gc", "vJO");
        /* class_init */
        {
        
            int typ = enum_class_ParrotInterpreter;
        
            if (pass) {
                /* TODO unify and fix signatures */
                register_nci_method(interp, typ,
                        F2DPTR(pt_thread_yield), "yield", "v");
        
                /* misc functions */
                register_nci_method(interp, typ,
                        F2DPTR(recursion_limit), "recursion_limit", "iJOi");
            }

        }
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_ParrotInterpreter_class_init */
#line 672 "./src/pmc/parrotinterpreter.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
