/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/pmcproxy.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/pmcproxy.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: pmcproxy.pmc 21061 2007-09-03 21:58:10Z chromatic $

=head1 NAME

src/pmc/pmcproxy.pmc - proxy class object for a PMC enabling introspection

=head1 DESCRIPTION

This class is used to describe a PMC. It can sit in an inheritance hierarchy
of a PDD15 class as well as allowing introspection of the PMC.

PMCProxy is not derived from any other PMC.

=head2 Structure

This class stores its state in the Parrot_PMCProxy structure, which has the
following fields.

=over 4

=item C<id>

The type number of the PMC that is being described.

=item C<name>

The name of the PMC -- a STRING.

=item C<namespace>

The namespace the PMC is associated with, if any.

=item C<parents>

An array of immediate parent classes.
An empty ResizablePMCArray PMC is allocated during initialization.

=item C<all_parents>

A cached array of ourself and all parent classes, in MRO order.
A ResizablePMCArray PMC is allocated during initialization,
and is populated with the current class.

=back

NOTE: No doubt we will need other things later; this is a start.

*/

#include "parrot/parrot.h"

/*

=head2 Functions

=over 4

=cut

*/
#line 77 "./src/pmc/pmcproxy.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_pmcproxy.h"
#include "pmc_default.h"
#include "pmcproxy.str"
void
Parrot_PMCProxy_destroy(PARROT_INTERP, PMC *pmc)
{
#line 128 "./src/pmc/pmcproxy.pmc"

    mem_sys_free(PMC_data(pmc));
#line 91 "./src/pmc/pmcproxy.c"
}
void
Parrot_PMCProxy_init(PARROT_INTERP, PMC *pmc)
{
#line 77 "./src/pmc/pmcproxy.pmc"

    Parrot_PMCProxy *_pmc = mem_allocate_zeroed_typed(Parrot_PMCProxy);
    PMC_data(pmc)        = _pmc;

    /* Set flags for custom DOD mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);

    /* Set up the object. */
    _pmc->id              = 0;
    _pmc->name            = CONST_STRING(interp, "");
    _pmc->_namespace      = PMCNULL;
    _pmc->parents         = pmc_new(interp, enum_class_ResizablePMCArray);
    _pmc->all_parents     = pmc_new(interp, enum_class_ResizablePMCArray);
    _pmc->methods         = pmc_new(interp, enum_class_Hash);

    /* We put ourself on the all parents list. */
    VTABLE_push_pmc(interp, _pmc->all_parents, pmc);

    /* We are a class. */
    PObj_is_class_SET(pmc);
#line 118 "./src/pmc/pmcproxy.c"
}
PMC  *
Parrot_PMCProxy_inspect(PARROT_INTERP, PMC *pmc)
{
#line 228 "./src/pmc/pmcproxy.pmc"

    /* Create a hash, then use inspect_str to get all of the data to
     * fill it up with. */
    PMC *metadata = pmc_new(interp, enum_class_Hash);
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "name"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "name")));
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "namespace"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "namespace")));
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "methods"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "methods")));
    VTABLE_set_pmc_keyed_str(interp, metadata, CONST_STRING(interp, "parents"),
        VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "parents")));
    return metadata;
#line 137 "./src/pmc/pmcproxy.c"
}
PMC  *
Parrot_PMCProxy_inspect_str(PARROT_INTERP, PMC *pmc, STRING *what)
{
#line 188 "./src/pmc/pmcproxy.pmc"

    Parrot_PMCProxy *_pmc = PARROT_PMCPROXY(pmc);

    /* What should we return? */
    PMC          *found   = PMCNULL;

    if (string_equal(interp, what, CONST_STRING(interp, "name")) == 0) {
        found = pmc_new(interp, enum_class_String);
        VTABLE_set_string_native(interp, found, _pmc->name);
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "namespace")) == 0) {
        /* Should not clone this. */
        return _pmc->_namespace;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "methods")) == 0) {
        found = _pmc->methods;
    }
    else if (string_equal(interp, what, CONST_STRING(interp, "parents")) == 0) {
        found = _pmc->parents;
    }
    else {
        real_exception(interp, NULL, INVALID_OPERATION,
            "Unknown introspection value '%S'", what);
    }

    /* Clone and return. */
    return PMC_IS_NULL(found) ? PMCNULL : VTABLE_clone(interp, found);
#line 170 "./src/pmc/pmcproxy.c"
}
PMC  *
Parrot_PMCProxy_instantiate(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 109 "./src/pmc/pmcproxy.pmc"

    Parrot_PMCProxy *_pmc = PARROT_PMCPROXY(pmc);

    if (!PMC_IS_NULL(init))
        return pmc_new_init(interp, _pmc->id, init);

    return pmc_new(interp, _pmc->id);
#line 183 "./src/pmc/pmcproxy.c"
}
void
Parrot_PMCProxy_mark(PARROT_INTERP, PMC *pmc)
{
#line 142 "./src/pmc/pmcproxy.pmc"

    Parrot_PMCProxy * const _pmc = PARROT_PMCPROXY(pmc);

    if (_pmc->name)
        pobject_lives(interp, (PObj*)_pmc->name);
    if (_pmc->_namespace)
        pobject_lives(interp, (PObj*)_pmc->_namespace);
    if (_pmc->parents)
        pobject_lives(interp, (PObj*)_pmc->parents);
    if (_pmc->all_parents)
        pobject_lives(interp, (PObj*)_pmc->all_parents);
    if (_pmc->methods)
        pobject_lives(interp, (PObj*)_pmc->methods);
#line 202 "./src/pmc/pmcproxy.c"
}
void
Parrot_PMCProxy_nci_name(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 238 "./src/pmc/pmcproxy.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 255 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 252 "./src/pmc/pmcproxy.pmc"

    Parrot_PMCProxy *_pmc     = PARROT_PMCPROXY(pmc);
    STRING          *ret_name = _pmc->name;
    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN STRING *ret_name */
    /*BEGIN GENERATED ACCESSORS */
#line 270 "./src/pmc/pmcproxy.pmc"
    CTX_REG_STR(ctx, 0) = ret_name;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(1)"), 0);
    goto name_returns;
    /*END PCCRETURN STRING *ret_name */
    }
#line 255 "./src/pmc/pmcproxy.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
name_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 313 "./src/pmc/pmcproxy.c"
}
void
Parrot_PMCProxy_nci_pmc_namespace(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 349 "./src/pmc/pmcproxy.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 366 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 267 "./src/pmc/pmcproxy.pmc"

    Parrot_PMCProxy *_pmc          = PARROT_PMCPROXY(pmc);
    PMC             *ret_namespace = _pmc->_namespace;
    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret_namespace */
    /*BEGIN GENERATED ACCESSORS */
#line 381 "./src/pmc/pmcproxy.pmc"
    CTX_REG_PMC(ctx, 0) = ret_namespace;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto pmc_namespace_returns;
    /*END PCCRETURN PMC *ret_namespace */
    }
#line 270 "./src/pmc/pmcproxy.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
pmc_namespace_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 424 "./src/pmc/pmcproxy.c"
}
void
Parrot_PMCProxy_nci_new(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 0, 2 };
    opcode_t param_indexes[] = { 0, 1, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 130, 256)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 460 "./src/pmc/pmcproxy.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 477 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    PMC* args = CTX_REG_PMC(ctx, 1);
    INTVAL got_args = CTX_REG_INT(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 282 "./src/pmc/pmcproxy.pmc"

    PMC *obj = VTABLE_instantiate(interp, pmc, args);
    UNUSED(got_args);
    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *obj */
    /*BEGIN GENERATED ACCESSORS */
#line 494 "./src/pmc/pmcproxy.pmc"
    CTX_REG_PMC(ctx, 0) = obj;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto new_returns;
    /*END PCCRETURN PMC *obj */
    }
#line 285 "./src/pmc/pmcproxy.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
new_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 537 "./src/pmc/pmcproxy.c"
}
void
Parrot_PMCProxy_nci_methods(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 573 "./src/pmc/pmcproxy.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 590 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 297 "./src/pmc/pmcproxy.pmc"

    PMC *ret_methods = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "methods"));
    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret_methods */
    /*BEGIN GENERATED ACCESSORS */
#line 604 "./src/pmc/pmcproxy.pmc"
    CTX_REG_PMC(ctx, 0) = ret_methods;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto methods_returns;
    /*END PCCRETURN PMC *ret_methods */
    }
#line 299 "./src/pmc/pmcproxy.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
methods_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 647 "./src/pmc/pmcproxy.c"
}
void
Parrot_PMCProxy_nci_parents(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t param_indexes[] = { 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 683 "./src/pmc/pmcproxy.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 700 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 311 "./src/pmc/pmcproxy.pmc"

    PMC *ret_parents = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "parents"));
    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *ret_parents */
    /*BEGIN GENERATED ACCESSORS */
#line 714 "./src/pmc/pmcproxy.pmc"
    CTX_REG_PMC(ctx, 0) = ret_parents;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto parents_returns;
    /*END PCCRETURN PMC *ret_parents */
    }
#line 313 "./src/pmc/pmcproxy.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
parents_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 757 "./src/pmc/pmcproxy.c"
}
void
Parrot_PMCProxy_nci_inspect(PARROT_INTERP, PMC *pmc)
{
#line 399 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    INTVAL   n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t param_indexes[] = { 0, 0, 0 };
    opcode_t *return_indexes;
    opcode_t *current_args;
    PMC* _type      = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC* param_sig  = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2, 129, 256)"), 0);

    PMC* return_sig              = PMCNULL;

    parrot_context_t *caller_ctx = CONTEXT(interp->ctx);
    PMC* ret_cont                = new_ret_continuation_pmc(interp, NULL);
    parrot_context_t *ctx        = Parrot_push_context(interp, n_regs_used);
    PMC* ccont                   = PMCNULL;

    if (caller_ctx) {
        ccont = caller_ctx->current_cont;
    }
    else {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    ctx->current_cont            = ret_cont;
    PMC_cont(ret_cont)->from_ctx = ctx;

    current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 793 "./src/pmc/pmcproxy.pmc"

#line 418 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = param_sig;
    parrot_pass_args(interp, caller_ctx, ctx, current_args, param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
        --ctx->recursion_depth;
        ctx->caller_ctx      = caller_ctx->caller_ctx;
        Parrot_free_context(interp, caller_ctx, 0);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 810 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(ctx, 0);
    STRING* what = CTX_REG_STR(ctx, 0);
    INTVAL got_what = CTX_REG_INT(ctx, 0);

#line 426 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 326 "./src/pmc/pmcproxy.pmc"

    PMC *found;

    /* Just delegate to the appropriate vtable method. */
    if (got_what)
        found = VTABLE_inspect_str(interp, pmc, what);
    else
        found = VTABLE_inspect(interp, pmc);

    #line 239 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN PCCRETURN PMC *found */
    /*BEGIN GENERATED ACCESSORS */
#line 833 "./src/pmc/pmcproxy.pmc"
    CTX_REG_PMC(ctx, 0) = found;

#line 254 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t temp_return_indexes[] = { 0 };
        return_indexes = temp_return_indexes;
    }
    return_sig = Parrot_FixedIntegerArray_new_from_string(interp, _type,
        string_from_literal(interp, "(2)"), 0);
    goto inspect_returns;
    /*END PCCRETURN PMC *found */
    }
#line 335 "./src/pmc/pmcproxy.pmc"

#line 435 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 449 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
inspect_returns:

    if (! caller_ctx) {
        /* there is no point calling real_exception here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        internal_exception(1, "No caller_ctx for continuation %p.", ccont);
    }

    interp->returns_signature = return_sig;
    parrot_pass_args(interp, ctx, caller_ctx, return_indexes,
        caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 460 "/home/mandrake/rpm/BUILD/parrot-0.4.17/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_type);
    PObj_live_CLEAR(param_sig);
    PObj_live_CLEAR(return_sig);
    Parrot_pop_context(interp);
#line 876 "./src/pmc/pmcproxy.c"
}
void
Parrot_PMCProxy_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of PMCProxy");
}
PMC *
Parrot_PMCProxy_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_PMCProxy_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of PMCProxy");
}
FLOATVAL
Parrot_PMCProxy_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of PMCProxy");
}
INTVAL
Parrot_PMCProxy_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of PMCProxy");
}
PMC *
Parrot_PMCProxy_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of PMCProxy");
}
STRING *
Parrot_PMCProxy_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of PMCProxy");
}
FLOATVAL
Parrot_PMCProxy_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of PMCProxy");
}
INTVAL
Parrot_PMCProxy_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of PMCProxy");
}
PMC *
Parrot_PMCProxy_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of PMCProxy");
}
STRING *
Parrot_PMCProxy_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of PMCProxy");
}
void
Parrot_PMCProxy_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_PMCProxy, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_PMCProxy_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_PMCProxy_init,
        Parrot_default_init_pmc,
        Parrot_PMCProxy_inspect,
        Parrot_PMCProxy_inspect_str,
        Parrot_PMCProxy_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_PMCProxy_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_PMCProxy, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_PMCProxy_ro_add_attribute,
        Parrot_PMCProxy_ro_add_method,
        Parrot_PMCProxy_ro_add_parent,
        Parrot_PMCProxy_ro_add_role,
        Parrot_PMCProxy_ro_add_vtable_override,
        Parrot_PMCProxy_ro_assign_pmc,
        Parrot_PMCProxy_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_PMCProxy_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_PMCProxy_ro_delete_keyed,
        Parrot_PMCProxy_ro_delete_keyed_int,
        Parrot_PMCProxy_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_PMCProxy_destroy,
        Parrot_default_does,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_PMCProxy_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_PMCProxy_ro_i_absolute,
        Parrot_PMCProxy_ro_i_bitwise_not,
        Parrot_PMCProxy_ro_i_bitwise_nots,
        Parrot_PMCProxy_ro_i_logical_not,
        Parrot_PMCProxy_ro_i_neg,
        Parrot_PMCProxy_ro_increment,
        Parrot_PMCProxy_init,
        Parrot_default_init_pmc,
        Parrot_PMCProxy_inspect,
        Parrot_PMCProxy_inspect_str,
        Parrot_PMCProxy_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_PMCProxy_mark,
        Parrot_PMCProxy_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_PMCProxy_ro_pop_float,
        Parrot_PMCProxy_ro_pop_integer,
        Parrot_PMCProxy_ro_pop_pmc,
        Parrot_PMCProxy_ro_pop_string,
        Parrot_PMCProxy_ro_push_float,
        Parrot_PMCProxy_ro_push_integer,
        Parrot_PMCProxy_ro_push_pmc,
        Parrot_PMCProxy_ro_push_string,
        Parrot_PMCProxy_ro_remove_attribute,
        Parrot_PMCProxy_ro_remove_method,
        Parrot_PMCProxy_ro_remove_parent,
        Parrot_PMCProxy_ro_remove_role,
        Parrot_PMCProxy_ro_remove_vtable_override,
        Parrot_PMCProxy_ro_set_attr,
        Parrot_PMCProxy_ro_set_attr_str,
        Parrot_PMCProxy_ro_set_bignum_int,
        Parrot_PMCProxy_ro_set_bignum_num,
        Parrot_PMCProxy_ro_set_bignum_str,
        Parrot_PMCProxy_ro_set_bool,
        Parrot_PMCProxy_ro_set_integer_keyed,
        Parrot_PMCProxy_ro_set_integer_keyed_int,
        Parrot_PMCProxy_ro_set_integer_keyed_str,
        Parrot_PMCProxy_ro_set_integer_native,
        Parrot_PMCProxy_ro_set_integer_same,
        Parrot_PMCProxy_ro_set_number_keyed,
        Parrot_PMCProxy_ro_set_number_keyed_int,
        Parrot_PMCProxy_ro_set_number_keyed_str,
        Parrot_PMCProxy_ro_set_number_native,
        Parrot_PMCProxy_ro_set_number_same,
        Parrot_PMCProxy_ro_set_pmc,
        Parrot_PMCProxy_ro_set_pmc_keyed,
        Parrot_PMCProxy_ro_set_pmc_keyed_int,
        Parrot_PMCProxy_ro_set_pmc_keyed_str,
        Parrot_PMCProxy_ro_set_pointer,
        Parrot_PMCProxy_ro_set_pointer_keyed,
        Parrot_PMCProxy_ro_set_pointer_keyed_int,
        Parrot_PMCProxy_ro_set_pointer_keyed_str,
        Parrot_PMCProxy_ro_set_string_keyed,
        Parrot_PMCProxy_ro_set_string_keyed_int,
        Parrot_PMCProxy_ro_set_string_keyed_str,
        Parrot_PMCProxy_ro_set_string_native,
        Parrot_PMCProxy_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_PMCProxy_ro_shift_float,
        Parrot_PMCProxy_ro_shift_integer,
        Parrot_PMCProxy_ro_shift_pmc,
        Parrot_PMCProxy_ro_shift_string,
        Parrot_default_slice,
        Parrot_PMCProxy_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_PMCProxy_ro_thaw,
        Parrot_PMCProxy_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_PMCProxy_ro_unshift_float,
        Parrot_PMCProxy_ro_unshift_integer,
        Parrot_PMCProxy_ro_unshift_pmc,
        Parrot_PMCProxy_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "PMCProxy");
        vt_clone->isa_str = CONST_STRING(interp, "PMCProxy");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_name), "name");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_pmc_namespace), "pmc_namespace");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_new), "new");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_methods), "methods");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_parents), "parents");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_inspect), "inspect");
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_PMCProxy_class_init */
#line 336 "./src/pmc/pmcproxy.pmc"
 /* END pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_pmc.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
