/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablefloatarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/resizablefloatarray.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: resizablefloatarray.pmc 20995 2007-09-02 05:17:03Z chromatic $

=head1 NAME

src/pmc/resizablefloatarray.pmc - resizable array for floating point
numbers only

=head1 DESCRIPTION

This class, C<ResizableFloatArray>, implements an array of resizable size,
which stores FLOATVALs. It uses Float PMCs to do all necessary conversions.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 38 "./src/pmc/resizablefloatarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablefloatarray.h"
#include "pmc_fixedfloatarray.h"
#include "pmc_default.h"
#include "resizablefloatarray.str"
PMC  *
Parrot_ResizableFloatArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 142 "./src/pmc/resizablefloatarray.pmc"

    PMC *copy          = Parrot_FixedFloatArray_clone(interp, pmc);

    /* copy trimmed extra space */
    PMC_int_val2(copy) = PMC_int_val(pmc);

    return copy;
#line 57 "./src/pmc/resizablefloatarray.c"
}
FLOATVAL
Parrot_ResizableFloatArray_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 38 "./src/pmc/resizablefloatarray.pmc"

    FLOATVAL *data;

    if (key < 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableFloatArray: index out of bounds!");

    if (key >= PMC_int_val(pmc))
        VTABLE_set_integer_native(interp, pmc, key+1);

    data = (FLOATVAL *)PMC_data(pmc);
    return data[key];
#line 75 "./src/pmc/resizablefloatarray.c"
}
FLOATVAL
Parrot_ResizableFloatArray_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 176 "./src/pmc/resizablefloatarray.pmc"

    FLOATVAL value;
    INTVAL size = PMC_int_val(pmc);

    if (size == 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableFloatArray: Can't pop from an empty array!");

    value = VTABLE_get_number_keyed_int(interp, pmc, size-1);
    VTABLE_set_integer_native(interp, pmc, size - 1);
    return value;
#line 92 "./src/pmc/resizablefloatarray.c"
}
void
Parrot_ResizableFloatArray_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 161 "./src/pmc/resizablefloatarray.pmc"

    INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_number_keyed_int(interp, pmc, nextix, value);
#line 101 "./src/pmc/resizablefloatarray.c"
}
void
Parrot_ResizableFloatArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 94 "./src/pmc/resizablefloatarray.pmc"

    if (size < 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableFloatArray: Can't resize to negative value!");

    if (!PMC_data(pmc)) {
        /* empty - used fixed routine */
        if (size < 8) {
            Parrot_FixedFloatArray_set_integer_native(interp, pmc, 8);
            PMC_int_val(pmc)  = size;
            PMC_int_val2(pmc) = 8;
        }
        else {
            Parrot_FixedFloatArray_set_integer_native(interp, pmc, size);
            PMC_int_val2(pmc) = size;
        }
    }
    else if (size <= PMC_int_val2(pmc)) {
        /* we could shrink here if necessary */
        PMC_int_val(pmc) = size;
        return;
    }
    else {
        INTVAL cur = PMC_int_val2(pmc);
        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            INTVAL needed = size - cur;
            cur          += needed + 4096;
            cur          &= ~0xfff;
        }
        PMC_data(pmc) = mem_sys_realloc(PMC_data(pmc),
                cur * sizeof (FLOATVAL));
        PMC_int_val2(pmc) = cur;
        PMC_int_val(pmc)  = size;
    }
#line 143 "./src/pmc/resizablefloatarray.c"
}
void
Parrot_ResizableFloatArray_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 63 "./src/pmc/resizablefloatarray.pmc"

    FLOATVAL *data;

    if (key < 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableFloatArray: index out of bounds!");

    if (key >= PMC_int_val(pmc))
        VTABLE_set_integer_native(interp, pmc, key+1);

    data      = (FLOATVAL *)PMC_data(pmc);
    data[key] = value;
#line 161 "./src/pmc/resizablefloatarray.c"
}
FLOATVAL
Parrot_ResizableFloatArray_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 198 "./src/pmc/resizablefloatarray.pmc"

    FLOATVAL value, *data;
    INTVAL size = PMC_int_val(pmc);

    if (size == 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableFloatArray: Can't shift from an empty array!");

    data              = (FLOATVAL *)PMC_data(pmc);
    value             = data[0];
    PMC_int_val(pmc) = --size;

    mem_sys_memmove(data, data + 1, size * sizeof (FLOATVAL));
    return value;
#line 181 "./src/pmc/resizablefloatarray.c"
}
void
Parrot_ResizableFloatArray_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 224 "./src/pmc/resizablefloatarray.pmc"

    INTVAL    size = PMC_int_val(pmc);
    FLOATVAL *data;

    VTABLE_set_integer_native(interp, pmc, size + 1);
    data    = (FLOATVAL *)PMC_data(pmc);
    mem_sys_memmove(data + 1, data, size * sizeof (FLOATVAL));
    data[0] = value;
#line 195 "./src/pmc/resizablefloatarray.c"
}
void
Parrot_ResizableFloatArray_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ResizableFloatArray");
}
PMC *
Parrot_ResizableFloatArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_ResizableFloatArray_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ResizableFloatArray");
}
FLOATVAL
Parrot_ResizableFloatArray_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ResizableFloatArray");
}
INTVAL
Parrot_ResizableFloatArray_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ResizableFloatArray");
}
PMC *
Parrot_ResizableFloatArray_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ResizableFloatArray");
}
STRING *
Parrot_ResizableFloatArray_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ResizableFloatArray");
}
FLOATVAL
Parrot_ResizableFloatArray_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ResizableFloatArray");
}
INTVAL
Parrot_ResizableFloatArray_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ResizableFloatArray");
}
PMC *
Parrot_ResizableFloatArray_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ResizableFloatArray");
}
STRING *
Parrot_ResizableFloatArray_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ResizableFloatArray");
}
void
Parrot_ResizableFloatArray_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_ResizableFloatArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizableFloatArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedFloatArray_destroy,
        Parrot_default_does,
        Parrot_FixedFloatArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedFloatArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedFloatArray_get_integer,
        Parrot_FixedFloatArray_get_integer_keyed,
        Parrot_FixedFloatArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedFloatArray_get_number_keyed,
        Parrot_ResizableFloatArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedFloatArray_get_pmc_keyed,
        Parrot_FixedFloatArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedFloatArray_get_string_keyed,
        Parrot_FixedFloatArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedFloatArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedFloatArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ResizableFloatArray_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_ResizableFloatArray_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedFloatArray_set_integer_keyed,
        Parrot_FixedFloatArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_ResizableFloatArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedFloatArray_set_number_keyed,
        Parrot_ResizableFloatArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedFloatArray_set_pmc_keyed,
        Parrot_FixedFloatArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedFloatArray_set_string_keyed,
        Parrot_FixedFloatArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableFloatArray_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ResizableFloatArray_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_ResizableFloatArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_ResizableFloatArray_ro_add_attribute,
        Parrot_ResizableFloatArray_ro_add_method,
        Parrot_ResizableFloatArray_ro_add_parent,
        Parrot_ResizableFloatArray_ro_add_role,
        Parrot_ResizableFloatArray_ro_add_vtable_override,
        Parrot_ResizableFloatArray_ro_assign_pmc,
        Parrot_ResizableFloatArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizableFloatArray_clone,
        Parrot_default_clone_pmc,
        Parrot_ResizableFloatArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableFloatArray_ro_delete_keyed,
        Parrot_ResizableFloatArray_ro_delete_keyed_int,
        Parrot_ResizableFloatArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedFloatArray_destroy,
        Parrot_default_does,
        Parrot_FixedFloatArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ResizableFloatArray_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedFloatArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedFloatArray_get_integer,
        Parrot_FixedFloatArray_get_integer_keyed,
        Parrot_FixedFloatArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedFloatArray_get_number_keyed,
        Parrot_ResizableFloatArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedFloatArray_get_pmc_keyed,
        Parrot_FixedFloatArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedFloatArray_get_string_keyed,
        Parrot_FixedFloatArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_ResizableFloatArray_ro_i_absolute,
        Parrot_ResizableFloatArray_ro_i_bitwise_not,
        Parrot_ResizableFloatArray_ro_i_bitwise_nots,
        Parrot_ResizableFloatArray_ro_i_logical_not,
        Parrot_ResizableFloatArray_ro_i_neg,
        Parrot_ResizableFloatArray_ro_increment,
        Parrot_FixedFloatArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_ResizableFloatArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ResizableFloatArray_ro_pop_float,
        Parrot_ResizableFloatArray_ro_pop_integer,
        Parrot_ResizableFloatArray_ro_pop_pmc,
        Parrot_ResizableFloatArray_ro_pop_string,
        Parrot_ResizableFloatArray_ro_push_float,
        Parrot_ResizableFloatArray_ro_push_integer,
        Parrot_ResizableFloatArray_ro_push_pmc,
        Parrot_ResizableFloatArray_ro_push_string,
        Parrot_ResizableFloatArray_ro_remove_attribute,
        Parrot_ResizableFloatArray_ro_remove_method,
        Parrot_ResizableFloatArray_ro_remove_parent,
        Parrot_ResizableFloatArray_ro_remove_role,
        Parrot_ResizableFloatArray_ro_remove_vtable_override,
        Parrot_ResizableFloatArray_ro_set_attr,
        Parrot_ResizableFloatArray_ro_set_attr_str,
        Parrot_ResizableFloatArray_ro_set_bignum_int,
        Parrot_ResizableFloatArray_ro_set_bignum_num,
        Parrot_ResizableFloatArray_ro_set_bignum_str,
        Parrot_ResizableFloatArray_ro_set_bool,
        Parrot_ResizableFloatArray_ro_set_integer_keyed,
        Parrot_ResizableFloatArray_ro_set_integer_keyed_int,
        Parrot_ResizableFloatArray_ro_set_integer_keyed_str,
        Parrot_ResizableFloatArray_ro_set_integer_native,
        Parrot_ResizableFloatArray_ro_set_integer_same,
        Parrot_ResizableFloatArray_ro_set_number_keyed,
        Parrot_ResizableFloatArray_ro_set_number_keyed_int,
        Parrot_ResizableFloatArray_ro_set_number_keyed_str,
        Parrot_ResizableFloatArray_ro_set_number_native,
        Parrot_ResizableFloatArray_ro_set_number_same,
        Parrot_ResizableFloatArray_ro_set_pmc,
        Parrot_ResizableFloatArray_ro_set_pmc_keyed,
        Parrot_ResizableFloatArray_ro_set_pmc_keyed_int,
        Parrot_ResizableFloatArray_ro_set_pmc_keyed_str,
        Parrot_ResizableFloatArray_ro_set_pointer,
        Parrot_ResizableFloatArray_ro_set_pointer_keyed,
        Parrot_ResizableFloatArray_ro_set_pointer_keyed_int,
        Parrot_ResizableFloatArray_ro_set_pointer_keyed_str,
        Parrot_ResizableFloatArray_ro_set_string_keyed,
        Parrot_ResizableFloatArray_ro_set_string_keyed_int,
        Parrot_ResizableFloatArray_ro_set_string_keyed_str,
        Parrot_ResizableFloatArray_ro_set_string_native,
        Parrot_ResizableFloatArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableFloatArray_ro_shift_float,
        Parrot_ResizableFloatArray_ro_shift_integer,
        Parrot_ResizableFloatArray_ro_shift_pmc,
        Parrot_ResizableFloatArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_ResizableFloatArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_ResizableFloatArray_ro_thaw,
        Parrot_ResizableFloatArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ResizableFloatArray_ro_unshift_float,
        Parrot_ResizableFloatArray_ro_unshift_integer,
        Parrot_ResizableFloatArray_ro_unshift_pmc,
        Parrot_ResizableFloatArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "ResizableFloatArray");
        vt_clone->isa_str = CONST_STRING(interp, "ResizableFloatArray FixedFloatArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_ResizableFloatArray_class_init */
#line 232 "./src/pmc/resizablefloatarray.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11
Changed allocator to double size - Matt Fowles 2004-06-15
moved available size to int_val2 - Matt Fowles 2005-07-22

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
