/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablepmcarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/resizablepmcarray.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: resizablepmcarray.pmc 21606 2007-09-26 16:15:10Z paultcochrane $

=head1 NAME

src/pmc/resizablepmcarray.pmc - resizable array for PMCs only

=head1 DESCRIPTION

This class, ResizablePMCArray, implements an resizable array which stores PMCs.
It puts things into Integer, Float, or String PMCs as appropriate.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 37 "./src/pmc/resizablepmcarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablepmcarray.h"
#include "pmc_fixedpmcarray.h"
#include "pmc_default.h"
#include "resizablepmcarray.str"
INTVAL
Parrot_ResizablePMCArray_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 588 "./src/pmc/resizablepmcarray.pmc"

    INTVAL j, n;

    if (value->vtable->base_type != enum_class_ResizablePMCArray)
        return 0;

    n = VTABLE_elements(interp, pmc);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        PMC *item1 = VTABLE_get_pmc_keyed_int(interp, pmc, j);
        PMC *item2 = VTABLE_get_pmc_keyed_int(interp, value, j);

        if (item1 == item2)
            continue;

        if (!mmd_dispatch_i_pp(interp, item1, item2, MMD_EQ))
            return 0;
    }

    return 1;
#line 72 "./src/pmc/resizablepmcarray.c"
}
PMC  *
Parrot_ResizablePMCArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 569 "./src/pmc/resizablepmcarray.pmc"

    PMC *copy = Parrot_FixedPMCArray_clone(interp, pmc);

    /* copy trimmed extra space */
    PMC_int_val2(copy) = PMC_int_val(pmc);

    return copy;
#line 85 "./src/pmc/resizablepmcarray.c"
}
INTVAL
Parrot_ResizablePMCArray_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 303 "./src/pmc/resizablepmcarray.pmc"

    PMC *val;

    if (key < 0)
        key += PMC_int_val(pmc);

    if (key < 0 || key >= PMC_int_val(pmc))
        return 0;

    val = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    if (PMC_IS_NULL(val))
        return 0;

    return VTABLE_defined(interp, val);
#line 106 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 252 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  i;
    INTVAL  idx  = key_integer(interp, key);
    INTVAL  n    = PMC_int_val(pmc);
    PMC   **data = PMC_data_typed(pmc, PMC **);

    for (i = idx; i < n - 1; ++i)
        data[i] = data[i + 1];

    PMC_int_val(pmc)--;
#line 122 "./src/pmc/resizablepmcarray.c"
}
INTVAL
Parrot_ResizablePMCArray_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 288 "./src/pmc/resizablepmcarray.pmc"

    INTVAL ix = key_integer(interp, key);
    return Parrot_ResizablePMCArray_exists_keyed_int(interp, pmc, ix);
#line 131 "./src/pmc/resizablepmcarray.c"
}
INTVAL
Parrot_ResizablePMCArray_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 275 "./src/pmc/resizablepmcarray.pmc"

    PMC **data;

    if (key < 0)
        key += PMC_int_val(pmc);

    if (key < 0 || key >= PMC_int_val(pmc))
        return 0;

    data = (PMC **)PMC_data(pmc);
    return !PMC_IS_NULL(data[key]);
#line 148 "./src/pmc/resizablepmcarray.c"
}
PMC  *
Parrot_ResizablePMCArray_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 195 "./src/pmc/resizablepmcarray.pmc"

    PMC **data;

    if (key < 0)
        key += PMC_int_val(pmc);

    if (key < 0)
        real_exception(interp, NULL, E_IndexError,
            "ResizablePMCArray: index out of bounds!");

    if (key >= PMC_int_val(pmc))
        VTABLE_set_integer_native(interp, pmc, key+1);

    data = PMC_data_typed(pmc, PMC **);

    if (PMC_IS_NULL(data[key]))
        data[key] = pmc_new(interp, enum_class_Undef);

    return data[key];
#line 173 "./src/pmc/resizablepmcarray.c"
}
STRING  *
Parrot_ResizablePMCArray_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 658 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  j;
    INTVAL  n = VTABLE_elements(interp, pmc);
    STRING *res = string_from_literal(interp, "[ ");

    for (j = 0; j < n; ++j) {
        PMC *val = Parrot_ResizablePMCArray_get_pmc_keyed_int(interp, pmc, j);
        res      = string_append(interp, res, VTABLE_get_repr(interp, val));

        if (j < n - 1)
            res = string_append(interp, res, const_string(interp, ", "));
    }

    return string_append(interp, res, const_string(interp, " ]"));
#line 193 "./src/pmc/resizablepmcarray.c"
}
FLOATVAL
Parrot_ResizablePMCArray_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 399 "./src/pmc/resizablepmcarray.pmc"

    INTVAL   size = PMC_int_val(pmc);
    PMC     *data;
    FLOATVAL value;

    if (0 == size)
        real_exception(interp, NULL, E_IndexError,
                "ResizablePMCArray: Can't pop from an empty array!");

    data              = ((PMC **)PMC_data(pmc))[--size];
    PMC_int_val(pmc) = size;

    return VTABLE_get_number(interp, data);
#line 212 "./src/pmc/resizablepmcarray.c"
}
INTVAL
Parrot_ResizablePMCArray_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 414 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  size = PMC_int_val(pmc);
    PMC    *data;

    if (0 == size)
        real_exception(interp, NULL, E_IndexError,
                "ResizablePMCArray: Can't pop from an empty array!");

    data              = ((PMC **)PMC_data(pmc))[--size];
    PMC_int_val(pmc) = size;

    return VTABLE_get_integer(interp, data);
#line 230 "./src/pmc/resizablepmcarray.c"
}
PMC  *
Parrot_ResizablePMCArray_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 428 "./src/pmc/resizablepmcarray.pmc"

    INTVAL size = PMC_int_val(pmc);
    PMC   *data;

    if (0 == size)
        real_exception(interp, NULL, E_IndexError,
                "ResizablePMCArray: Can't pop from an empty array!");

    data              = ((PMC **)PMC_data(pmc))[--size];
    PMC_int_val(pmc) = size;

    return data;
#line 248 "./src/pmc/resizablepmcarray.c"
}
STRING  *
Parrot_ResizablePMCArray_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 442 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  size = PMC_int_val(pmc);
    PMC    *data;
    STRING *value;

    if (0 == size)
        real_exception(interp, NULL, E_IndexError,
                "ResizablePMCArray: Can't pop from an empty array!");

    data              = ((PMC **)PMC_data(pmc))[--size];
    PMC_int_val(pmc) = size;

    return VTABLE_get_string(interp, data);
#line 267 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 337 "./src/pmc/resizablepmcarray.pmc"

    INTVAL size = PMC_int_val(pmc);
    PMC   *val  = pmc_new(interp, enum_class_Float);

    VTABLE_set_number_native(interp, val, value);

    /* let set_pmc_keyed_int() worry about memory allocation */
    VTABLE_set_pmc_keyed_int(interp, pmc, size, val);

    return;
#line 283 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 349 "./src/pmc/resizablepmcarray.pmc"

    INTVAL size = PMC_int_val(pmc);
    PMC   *val  = pmc_new(interp, enum_class_Integer);

    VTABLE_set_integer_native(interp, val, value);

    /* let set_pmc_keyed_int() worry about memory allocation */
    VTABLE_set_pmc_keyed_int(interp, pmc, size, val);

    return;
#line 299 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 361 "./src/pmc/resizablepmcarray.pmc"

    INTVAL size = PMC_int_val(pmc);

    /* let set_integer_native() worry about memory allocation */
    VTABLE_set_integer_native(interp, pmc, size + 1);
    ((PMC **)PMC_data(pmc))[size] = value;

    return;
#line 313 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 371 "./src/pmc/resizablepmcarray.pmc"

    INTVAL size = PMC_int_val(pmc);
    PMC   *val  = pmc_new(interp, enum_class_String);

    VTABLE_assign_string_native(interp, val, value);

    /* let set_pmc_keyed_int() worry about memory allocation */
    VTABLE_set_pmc_keyed_int(interp, pmc, size, val);

    return;
#line 329 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 37 "./src/pmc/resizablepmcarray.pmc"

    if (size < 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizablePMCArray: Can't resize!");

    if (!PMC_data(pmc)) {
        /* empty - used fixed routine */
        if (size < 8) {
            Parrot_FixedPMCArray_set_integer_native(interp, pmc, 8);
            PMC_int_val(pmc)  = size;
            PMC_int_val2(pmc) = 8;
        }
        else {
            Parrot_FixedPMCArray_set_integer_native(interp, pmc, size);
            PMC_int_val2(pmc) = size;
        }
    }
    else if (size <= PMC_int_val2(pmc)) {
        PMC_int_val(pmc) = size;
        /* we could shrink here if necessary */
        return;
    }
    else {
        INTVAL i, cur, needed;
        i = cur = PMC_int_val2(pmc);
        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            needed = size - cur;
            cur   += needed + 4096;
            cur   &= ~0xfff;
        }

        PMC_data(pmc) = mem_sys_realloc(PMC_data(pmc),
                cur * sizeof (PMC *));

        for (; i < cur; i++)
            ((PMC **)PMC_data(pmc))[i] = PMCNULL;

        PMC_int_val2(pmc) = cur;
        PMC_int_val(pmc)  = size;
    }
#line 377 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *src)
{
#line 248 "./src/pmc/resizablepmcarray.pmc"

    Parrot_FixedPMCArray_set_pmc_keyed(interp, pmc, key, src);
#line 385 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *src)
{
#line 230 "./src/pmc/resizablepmcarray.pmc"

    PMC **data;

    if (key < 0)
        key += PMC_int_val(pmc);

    if (key < 0)
        real_exception(interp, NULL, E_IndexError,
            "ResizablePMCArray: index out of bounds!");

    if (key >= PMC_int_val(pmc))
        VTABLE_set_integer_native(interp, pmc, key+1);

    data      = (PMC **)PMC_data(pmc);
    DOD_WRITE_BARRIER(interp, pmc, data[key], src);
    data[key] = src;
#line 407 "./src/pmc/resizablepmcarray.c"
}
FLOATVAL
Parrot_ResizablePMCArray_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 100 "./src/pmc/resizablepmcarray.pmc"

    INTVAL    size = PMC_int_val(pmc);
    PMC      *data;
    PMC     **item;
    FLOATVAL  value;

    if (0 == size)
        real_exception(interp, NULL, E_IndexError,
                "ResizablePMCArray: Can't shift from an empty array!");

    item              = (PMC  **)PMC_data(pmc);
    data              = item[0];
    value             = VTABLE_get_number(interp, data);
    PMC_int_val(pmc) = --size;

    mem_sys_memmove(item, item + 1, size * sizeof (PMC *));

    item[size]        = PMCNULL;

    return value;
#line 433 "./src/pmc/resizablepmcarray.c"
}
INTVAL
Parrot_ResizablePMCArray_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 122 "./src/pmc/resizablepmcarray.pmc"

    INTVAL    size = PMC_int_val(pmc);
    PMC      *data;
    PMC     **item;
    INTVAL    value;

    if (0 == size)
        real_exception(interp, NULL, E_IndexError,
                "ResizablePMCArray: Can't shift from an empty array!");

    item              = (PMC **)PMC_data(pmc);
    data              = item[0];
    value             = VTABLE_get_integer(interp, data);
    PMC_int_val(pmc) = --size;

    mem_sys_memmove(item, item + 1, size * sizeof (PMC*));
    item[size]        = PMCNULL;

    return value;
#line 458 "./src/pmc/resizablepmcarray.c"
}
PMC  *
Parrot_ResizablePMCArray_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 143 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  size = PMC_int_val(pmc);
    PMC    *data;
    PMC   **item;

    if (0 == size)
        real_exception(interp, NULL, E_IndexError,
                "ResizablePMCArray: Can't shift from an empty array!");

    item              = (PMC **)PMC_data(pmc);
    data              = item[0];
    PMC_int_val(pmc) = --size;

    mem_sys_memmove(item, item + 1, size * sizeof (PMC *));
    item[size]        = PMCNULL;

    return data;
#line 481 "./src/pmc/resizablepmcarray.c"
}
STRING  *
Parrot_ResizablePMCArray_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 162 "./src/pmc/resizablepmcarray.pmc"

    INTVAL   size = PMC_int_val(pmc);
    PMC     *data;
    PMC    **item;
    STRING  *value;

    if (0 == size)
        real_exception(interp, NULL, E_IndexError,
                "ResizablePMCArray: Can't shift from an empty array!");

    item              = (PMC **)PMC_data(pmc);
    data              = item[0];
    value             = VTABLE_get_string(interp, data);
    PMC_int_val(pmc) = --size;

    mem_sys_memmove(item, item + 1, size * sizeof (PMC *));

    item[size]        = PMCNULL;

    return value;
#line 507 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
#line 690 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL length = VTABLE_elements(interp, pmc);
    const INTVAL elems  = VTABLE_elements(interp, value);
    INTVAL       shift  = elems - count;
    INTVAL       i;

    /* start from end? */
    if (offset < 0)
        offset += length;

    if (offset < 0)
        real_exception(interp, NULL, OUT_OF_BOUNDS,
            "illegal splice offset\n");

    /* shrink the array */
    if (shift < 0) {
        /* start at offset so we don't overwrite values we'll need */
        for (i = offset + count; i < length; i++)
            VTABLE_set_pmc_keyed_int(interp, pmc, i + shift,
                VTABLE_get_pmc_keyed_int(interp, pmc, i));

        VTABLE_set_integer_native(interp, pmc, length + shift);
    }
    /* grow the array */
    else if (shift > 0) {
        VTABLE_set_integer_native(interp, pmc, length + shift);

        /* move the existing values */
        /* start at length-1 so we don't overwrite values we'll need */
        for (i = length - 1; i >= offset; i--)
            VTABLE_set_pmc_keyed_int(interp, pmc, i + shift,
                VTABLE_get_pmc_keyed_int(interp, pmc, i));
    }

    /* copy the new values */
    for (i = 0; i < elems; i++)
        VTABLE_set_pmc_keyed_int(interp, pmc, i + offset,
            VTABLE_get_pmc_keyed_int(interp, value, i));
#line 551 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 474 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  size = PMC_int_val(pmc);
    PMC    *val  = pmc_new(interp, enum_class_Float);
    PMC   **data;
    INTVAL  i;

    VTABLE_set_number_native(interp, val, value);

    /* let set_integer_native() worry about memory allocation */
    VTABLE_set_integer_native(interp, pmc, size + 1);

    /* make room */
    data = (PMC **)PMC_data(pmc);

    for (i = size; i; --i)
        data[i] = data[i - 1];

    data[0] = val;

    return;
#line 577 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 496 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  size = PMC_int_val(pmc);
    PMC    *val  = pmc_new(interp, enum_class_Integer);
    PMC    **data;
    INTVAL   i;

    VTABLE_set_integer_native(interp, val, value);

    /* let set_integer_native() worry about memory allocation */
    VTABLE_set_integer_native(interp, pmc, size + 1);

    /* make room */
    data = (PMC **)PMC_data(pmc);

    for (i = size; i; --i)
        data[i] = data[i - 1];

    data[0] = val;

    return;
#line 603 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 518 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  size = PMC_int_val(pmc);
    PMC   **data;
    INTVAL  i;

    /* let set_integer_native() worry about memory allocation */
    VTABLE_set_integer_native(interp, pmc, size + 1);

    /* make room */
    data = (PMC **)PMC_data(pmc);

    for (i = size; i; --i)
        data[i] = data[i - 1];

    data[0] = value;

    return;
#line 626 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 537 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  size = PMC_int_val(pmc);
    PMC    *val  = pmc_new(interp, enum_class_String);
    PMC   **data;
    INTVAL  i;

    VTABLE_set_string_native(interp, val, value);

    /* let set_integer_native() worry about memory allocation */
    VTABLE_set_integer_native(interp, pmc, size + 1);

    /* make room */
    data = (PMC **)PMC_data(pmc);

    for (i = size; i; --i)
        data[i] = data[i - 1];

    data[0] = val;

    return;
#line 652 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_nci_append(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 623 "./src/pmc/resizablepmcarray.pmc"

    INTVAL i;
    INTVAL n = VTABLE_elements(interp, pmc);
    INTVAL m = VTABLE_elements(interp, other);

    if (!m)
        return;

    /* pre-size it */
    VTABLE_set_integer_native(interp, pmc, n + m);
    if (other->vtable->base_type == pmc->vtable->base_type ||
            other->vtable->base_type == enum_class_FixedPMCArray) {
        PMC **other_data = PMC_data_typed(other, PMC **);
        PMC **this_data  = PMC_data_typed(pmc, PMC **);

        for (i = 0; i < m; ++i)
            this_data[n + i] = other_data[i];
    }
    else {
        PMC **this_data = PMC_data_typed(pmc, PMC **);

        for (i = 0; i < m; ++i)
            this_data[n + i] = VTABLE_get_pmc_keyed_int(interp, other, i);
    }
#line 682 "./src/pmc/resizablepmcarray.c"
}
void
Parrot_ResizablePMCArray_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ResizablePMCArray");
}
PMC *
Parrot_ResizablePMCArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_ResizablePMCArray_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ResizablePMCArray");
}
FLOATVAL
Parrot_ResizablePMCArray_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ResizablePMCArray");
}
INTVAL
Parrot_ResizablePMCArray_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ResizablePMCArray");
}
PMC *
Parrot_ResizablePMCArray_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ResizablePMCArray");
}
STRING *
Parrot_ResizablePMCArray_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ResizablePMCArray");
}
FLOATVAL
Parrot_ResizablePMCArray_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ResizablePMCArray");
}
INTVAL
Parrot_ResizablePMCArray_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ResizablePMCArray");
}
PMC *
Parrot_ResizablePMCArray_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ResizablePMCArray");
}
STRING *
Parrot_ResizablePMCArray_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ResizablePMCArray");
}
void
Parrot_ResizablePMCArray_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_ResizablePMCArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizablePMCArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_ResizablePMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizablePMCArray_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_does,
        Parrot_FixedPMCArray_elements,
        Parrot_ResizablePMCArray_exists_keyed,
        Parrot_ResizablePMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_FixedPMCArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedPMCArray_get_integer,
        Parrot_FixedPMCArray_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedPMCArray_get_pmc_keyed,
        Parrot_ResizablePMCArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ResizablePMCArray_get_repr,
        Parrot_FixedPMCArray_get_string,
        Parrot_FixedPMCArray_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedPMCArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_FixedPMCArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ResizablePMCArray_pop_float,
        Parrot_ResizablePMCArray_pop_integer,
        Parrot_ResizablePMCArray_pop_pmc,
        Parrot_ResizablePMCArray_pop_string,
        Parrot_ResizablePMCArray_push_float,
        Parrot_ResizablePMCArray_push_integer,
        Parrot_ResizablePMCArray_push_pmc,
        Parrot_ResizablePMCArray_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedPMCArray_set_integer_keyed,
        Parrot_FixedPMCArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_ResizablePMCArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedPMCArray_set_number_keyed,
        Parrot_FixedPMCArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedPMCArray_set_pmc,
        Parrot_ResizablePMCArray_set_pmc_keyed,
        Parrot_ResizablePMCArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedPMCArray_set_string_keyed,
        Parrot_FixedPMCArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizablePMCArray_shift_float,
        Parrot_ResizablePMCArray_shift_integer,
        Parrot_ResizablePMCArray_shift_pmc,
        Parrot_ResizablePMCArray_shift_string,
        Parrot_FixedPMCArray_slice,
        Parrot_ResizablePMCArray_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedPMCArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ResizablePMCArray_unshift_float,
        Parrot_ResizablePMCArray_unshift_integer,
        Parrot_ResizablePMCArray_unshift_pmc,
        Parrot_ResizablePMCArray_unshift_string,
        Parrot_FixedPMCArray_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_ResizablePMCArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_ResizablePMCArray_ro_add_attribute,
        Parrot_ResizablePMCArray_ro_add_method,
        Parrot_ResizablePMCArray_ro_add_parent,
        Parrot_ResizablePMCArray_ro_add_role,
        Parrot_ResizablePMCArray_ro_add_vtable_override,
        Parrot_ResizablePMCArray_ro_assign_pmc,
        Parrot_ResizablePMCArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizablePMCArray_clone,
        Parrot_default_clone_pmc,
        Parrot_ResizablePMCArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_ResizablePMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizablePMCArray_ro_delete_keyed,
        Parrot_ResizablePMCArray_ro_delete_keyed_int,
        Parrot_ResizablePMCArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_does,
        Parrot_FixedPMCArray_elements,
        Parrot_ResizablePMCArray_exists_keyed,
        Parrot_ResizablePMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ResizablePMCArray_ro_find_method,
        Parrot_FixedPMCArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedPMCArray_get_integer,
        Parrot_FixedPMCArray_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedPMCArray_get_pmc_keyed,
        Parrot_ResizablePMCArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ResizablePMCArray_get_repr,
        Parrot_FixedPMCArray_get_string,
        Parrot_FixedPMCArray_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_ResizablePMCArray_ro_i_absolute,
        Parrot_ResizablePMCArray_ro_i_bitwise_not,
        Parrot_ResizablePMCArray_ro_i_bitwise_nots,
        Parrot_ResizablePMCArray_ro_i_logical_not,
        Parrot_ResizablePMCArray_ro_i_neg,
        Parrot_ResizablePMCArray_ro_increment,
        Parrot_FixedPMCArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_default_mark,
        Parrot_ResizablePMCArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ResizablePMCArray_ro_pop_float,
        Parrot_ResizablePMCArray_ro_pop_integer,
        Parrot_ResizablePMCArray_ro_pop_pmc,
        Parrot_ResizablePMCArray_ro_pop_string,
        Parrot_ResizablePMCArray_ro_push_float,
        Parrot_ResizablePMCArray_ro_push_integer,
        Parrot_ResizablePMCArray_ro_push_pmc,
        Parrot_ResizablePMCArray_ro_push_string,
        Parrot_ResizablePMCArray_ro_remove_attribute,
        Parrot_ResizablePMCArray_ro_remove_method,
        Parrot_ResizablePMCArray_ro_remove_parent,
        Parrot_ResizablePMCArray_ro_remove_role,
        Parrot_ResizablePMCArray_ro_remove_vtable_override,
        Parrot_ResizablePMCArray_ro_set_attr,
        Parrot_ResizablePMCArray_ro_set_attr_str,
        Parrot_ResizablePMCArray_ro_set_bignum_int,
        Parrot_ResizablePMCArray_ro_set_bignum_num,
        Parrot_ResizablePMCArray_ro_set_bignum_str,
        Parrot_ResizablePMCArray_ro_set_bool,
        Parrot_ResizablePMCArray_ro_set_integer_keyed,
        Parrot_ResizablePMCArray_ro_set_integer_keyed_int,
        Parrot_ResizablePMCArray_ro_set_integer_keyed_str,
        Parrot_ResizablePMCArray_ro_set_integer_native,
        Parrot_ResizablePMCArray_ro_set_integer_same,
        Parrot_ResizablePMCArray_ro_set_number_keyed,
        Parrot_ResizablePMCArray_ro_set_number_keyed_int,
        Parrot_ResizablePMCArray_ro_set_number_keyed_str,
        Parrot_ResizablePMCArray_ro_set_number_native,
        Parrot_ResizablePMCArray_ro_set_number_same,
        Parrot_ResizablePMCArray_ro_set_pmc,
        Parrot_ResizablePMCArray_ro_set_pmc_keyed,
        Parrot_ResizablePMCArray_ro_set_pmc_keyed_int,
        Parrot_ResizablePMCArray_ro_set_pmc_keyed_str,
        Parrot_ResizablePMCArray_ro_set_pointer,
        Parrot_ResizablePMCArray_ro_set_pointer_keyed,
        Parrot_ResizablePMCArray_ro_set_pointer_keyed_int,
        Parrot_ResizablePMCArray_ro_set_pointer_keyed_str,
        Parrot_ResizablePMCArray_ro_set_string_keyed,
        Parrot_ResizablePMCArray_ro_set_string_keyed_int,
        Parrot_ResizablePMCArray_ro_set_string_keyed_str,
        Parrot_ResizablePMCArray_ro_set_string_native,
        Parrot_ResizablePMCArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizablePMCArray_ro_shift_float,
        Parrot_ResizablePMCArray_ro_shift_integer,
        Parrot_ResizablePMCArray_ro_shift_pmc,
        Parrot_ResizablePMCArray_ro_shift_string,
        Parrot_FixedPMCArray_slice,
        Parrot_ResizablePMCArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_ResizablePMCArray_ro_thaw,
        Parrot_ResizablePMCArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ResizablePMCArray_ro_unshift_float,
        Parrot_ResizablePMCArray_ro_unshift_integer,
        Parrot_ResizablePMCArray_ro_unshift_pmc,
        Parrot_ResizablePMCArray_ro_unshift_string,
        Parrot_FixedPMCArray_visit
    };

    const  MMD_init _temp_mmd_init[] = {
        { MMD_EQ, 0, enum_type_PMC, (funcptr_t) Parrot_ResizablePMCArray_is_equal }
    };
    /* Dynamic PMCs need the runtime type which is passed in entry to class_init. */
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "ResizablePMCArray");
        vt_clone->isa_str = CONST_STRING(interp, "ResizablePMCArray FixedPMCArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        register_nci_method(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_append), "append", "vJOP");
        /* class_init */
        {
        
        }
        {
#define N_MMD_INIT (sizeof(_temp_mmd_init)/sizeof(_temp_mmd_init[0]))
            Parrot_mmd_register_table(interp, entry,
                _temp_mmd_init, N_MMD_INIT);
        }
    } /* pass */
} /* Parrot_ResizablePMCArray_class_init */
#line 728 "./src/pmc/resizablepmcarray.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11
Changed allocator to double size - Matt Fowles 2004-06-15

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
