/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablestringarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/resizablestringarray.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: resizablestringarray.pmc 21070 2007-09-04 07:08:50Z chromatic $

=head1 NAME

src/pmc/resizablestringarray.pmc - resizable array for strings only

=head1 DESCRIPTION

ResizableStringArray implements a resizeable array which stores Parrot strings
only. Any ints or floats assigned to elements of the array will first be
converted to String PMCs and then to native Parrot strings.  PMCs assigned to
to elements of the array will be stringified by having their C<get_string>
method called.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 40 "./src/pmc/resizablestringarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablestringarray.h"
#include "pmc_fixedstringarray.h"
#include "pmc_default.h"
#include "resizablestringarray.str"
PMC  *
Parrot_ResizableStringArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 255 "./src/pmc/resizablestringarray.pmc"

    PMC *copy = Parrot_FixedStringArray_clone(interp, pmc);
    /* copy trimmed extra space */
    PMC_int_val2(copy) = PMC_int_val(pmc);
    return copy;
#line 57 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 534 "./src/pmc/resizablestringarray.pmc"

    INTVAL   idx  = key_integer(interp, key);
    STRING **data = PMC_data_typed(pmc, STRING **);
    INTVAL   size = PMC_int_val(pmc);
    INTVAL   i;

    for (i = idx; i < size - 1; ++i)
        data[i] = data[i + 1];

    VTABLE_set_integer_native(interp, pmc, size - 1);
#line 73 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 513 "./src/pmc/resizablestringarray.pmc"

    STRING **data = PMC_data_typed(pmc, STRING **);
    INTVAL   size = PMC_int_val(pmc);
    INTVAL   i;

    for (i = key; i < size - 1; ++i)
        data[i] = data[i + 1];

    VTABLE_set_integer_native(interp, pmc, size - 1);
#line 88 "./src/pmc/resizablestringarray.c"
}
STRING  *
Parrot_ResizableStringArray_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 39 "./src/pmc/resizablestringarray.pmc"

    STRING **data;

    if (key < 0) {
        INTVAL size = VTABLE_elements(interp, pmc);
        if (key < -size)
            real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: index out of bounds!");
        else
            key += size;
    }

    if (key >= PMC_int_val(pmc))
        VTABLE_set_integer_native(interp, pmc, key+1);

    data = (STRING**)PMC_data(pmc);

    if (!data[key])
        data[key] = string_from_cstring(interp, NULL, 0);

    return data[key];
#line 115 "./src/pmc/resizablestringarray.c"
}
FLOATVAL
Parrot_ResizableStringArray_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 176 "./src/pmc/resizablestringarray.pmc"

    PMC *pmcval = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_number(interp, pmcval);
#line 124 "./src/pmc/resizablestringarray.c"
}
INTVAL
Parrot_ResizableStringArray_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 161 "./src/pmc/resizablestringarray.pmc"

    PMC *pmcval = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_integer(interp, pmcval);
#line 133 "./src/pmc/resizablestringarray.c"
}
PMC  *
Parrot_ResizableStringArray_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 142 "./src/pmc/resizablestringarray.pmc"

    STRING *strval = VTABLE_pop_string(interp, pmc);
    PMC    *value  = pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, value, strval);

    return value;
#line 146 "./src/pmc/resizablestringarray.c"
}
STRING  *
Parrot_ResizableStringArray_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 118 "./src/pmc/resizablestringarray.pmc"

    INTVAL  size = PMC_int_val(pmc);
    STRING *value;

    if (size == 0) {
        real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: Can't pop from an empty array!");
    }

    value = VTABLE_get_string_keyed_int(interp, pmc, size - 1);
    VTABLE_set_integer_native(interp, pmc, size - 1);
    return value;
#line 164 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 382 "./src/pmc/resizablestringarray.pmc"

    PMC    *ret = pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_number_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_push_string(interp, pmc, val);
#line 177 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 362 "./src/pmc/resizablestringarray.pmc"

    PMC    *ret = pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_integer_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_push_string(interp, pmc, val);
#line 190 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 346 "./src/pmc/resizablestringarray.pmc"

    STRING *strvalue = VTABLE_get_string(interp, value);
    VTABLE_push_string(interp, pmc, strvalue);
#line 199 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 103 "./src/pmc/resizablestringarray.pmc"

    INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_string_keyed_int(interp, pmc, nextix, value);
#line 208 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 191 "./src/pmc/resizablestringarray.pmc"

    if (size < 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: Can't resize!");

    if (!PMC_data(pmc)) {
        /* empty - used fixed routine */
        if (size < 8) {
            Parrot_FixedStringArray_set_integer_native(interp, pmc, 8);
            PMC_int_val(pmc)  = size;
            PMC_int_val2(pmc) = 8;
        }
        else {
            Parrot_FixedStringArray_set_integer_native(interp, pmc, size);
            PMC_int_val2(pmc) = size;
        }
    }
    else if (size <= PMC_int_val2(pmc)) {
        /* zero out anything that was previously allocated
         * if we're growing the array */
        INTVAL oldsize = PMC_int_val(pmc);
        if (size > oldsize) {
            STRING **data   = (STRING**)PMC_data(pmc);
            INTVAL i;
            for (i=oldsize; i<size; i++)
                data[i] = NULL;
        }

        PMC_int_val(pmc) = size;
        /* we could shrink here if necessary */
        return;
    }
    else {
        INTVAL i   = PMC_int_val2(pmc);
        INTVAL cur = i;

        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            cur = size + 4096;
            cur &= ~0xfff;
        }

        PMC_data(pmc) = mem_sys_realloc(PMC_data(pmc),
                cur * sizeof (STRING*));

        for (; i < cur; i++)
            ((STRING **)PMC_data(pmc))[i] = NULL;

        PMC_int_val2(pmc) = cur;
        PMC_int_val(pmc)  = size;
    }
#line 266 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 72 "./src/pmc/resizablestringarray.pmc"

    STRING **data;

    if (key < 0) {
        INTVAL size = VTABLE_elements(interp, pmc);
        if (key < -size)
            real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: index out of bounds!");
        else
            key += size;
    }

    if (key >= PMC_int_val(pmc))
        VTABLE_set_integer_native(interp, pmc, key+1);

    data      = (STRING **)PMC_data(pmc);
    DOD_WRITE_BARRIER(interp, pmc, data[key], value);
    data[key] = value;
#line 290 "./src/pmc/resizablestringarray.c"
}
FLOATVAL
Parrot_ResizableStringArray_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 329 "./src/pmc/resizablestringarray.pmc"

    PMC *pmcval = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_number(interp, pmcval);
#line 299 "./src/pmc/resizablestringarray.c"
}
INTVAL
Parrot_ResizableStringArray_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 314 "./src/pmc/resizablestringarray.pmc"

    PMC *pmcval = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_integer(interp, pmcval);
#line 308 "./src/pmc/resizablestringarray.c"
}
PMC  *
Parrot_ResizableStringArray_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 401 "./src/pmc/resizablestringarray.pmc"

    INTVAL  size = PMC_int_val(pmc);
    PMC    *ret;
    STRING *value;

    if (size == 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: Can't shift from an empty array!");

    value = VTABLE_get_string_keyed_int(interp, pmc, 0);
    ret   = pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, ret, value);
    VTABLE_delete_keyed_int(interp, pmc, 0);

    return ret;
#line 330 "./src/pmc/resizablestringarray.c"
}
STRING  *
Parrot_ResizableStringArray_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 272 "./src/pmc/resizablestringarray.pmc"

    INTVAL  size = PMC_int_val(pmc);
    STRING *value;

    if (size == 0)
        real_exception(interp, NULL, E_IndexError,
                "ResizableStringArray: Can't shift from an empty array!");

    value = VTABLE_get_string_keyed_int(interp, pmc, 0);
    VTABLE_delete_keyed_int(interp, pmc, 0);
    return value;
#line 347 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
#line 562 "./src/pmc/resizablestringarray.pmc"

    INTVAL length, elems, shift, i;

    if (value->vtable->base_type != pmc->vtable->base_type &&
            value->vtable->base_type != enum_class_FixedStringArray)
        real_exception(interp, NULL, E_TypeError,
                "ResizableStringArray: illegal type for splice!");

    length = VTABLE_elements(interp, pmc);
    elems  = VTABLE_elements(interp, value);
    shift  = elems - count;

    /* start from end? */
    if (offset < 0)
        offset += length;

    if (offset < 0)
        real_exception(interp, NULL, OUT_OF_BOUNDS,
            "illegal splice offset\n");

    /* shrink the array */
    if (shift < 0) {
        /* start at offset so we don't overwrite values we'll need */
        for (i = offset+count; i < length; i++)
            VTABLE_set_pmc_keyed_int(interp, pmc, i + shift,
                VTABLE_get_pmc_keyed_int(interp, pmc, i));

        VTABLE_set_integer_native(interp, pmc, length + shift);
    }

    /* grow the array */
    else if (shift > 0) {
        VTABLE_set_integer_native(interp, pmc, length + shift);

        /* move the existing values */
        /* start at length-1 so we don't overwrite values we'll need */
        for (i = length - 1; i >= offset; i--)
            VTABLE_set_pmc_keyed_int(interp, pmc, i + shift,
                VTABLE_get_pmc_keyed_int(interp, pmc, i));
    }

    /* copy the new values */
    for (i = 0; i < elems; i++)
        VTABLE_set_pmc_keyed_int(interp, pmc, i + offset,
            VTABLE_get_pmc_keyed_int(interp, value, i));
#line 398 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 494 "./src/pmc/resizablestringarray.pmc"

    PMC    *ret = pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_number_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_unshift_string(interp, pmc, val);
#line 411 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 474 "./src/pmc/resizablestringarray.pmc"

    PMC    *ret = pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_integer_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_unshift_string(interp, pmc, val);
#line 424 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 458 "./src/pmc/resizablestringarray.pmc"

    STRING *strvalue = VTABLE_get_string(interp, value);
    VTABLE_unshift_string(interp, pmc, strvalue);
#line 433 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 430 "./src/pmc/resizablestringarray.pmc"

    STRING **data = PMC_data_typed(pmc, STRING **);
    INTVAL   size = PMC_int_val(pmc);
    INTVAL   i;


    VTABLE_set_integer_native(interp, pmc, size + 1);

    data = PMC_data_typed(pmc, STRING **);

    for (i = size; i; --i)
        data[i] = data[i - 1];

    VTABLE_set_string_keyed_int(interp, pmc, 0, value);
#line 453 "./src/pmc/resizablestringarray.c"
}
void
Parrot_ResizableStringArray_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ResizableStringArray");
}
PMC *
Parrot_ResizableStringArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_ResizableStringArray_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ResizableStringArray");
}
FLOATVAL
Parrot_ResizableStringArray_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ResizableStringArray");
}
INTVAL
Parrot_ResizableStringArray_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ResizableStringArray");
}
PMC *
Parrot_ResizableStringArray_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ResizableStringArray");
}
STRING *
Parrot_ResizableStringArray_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ResizableStringArray");
}
FLOATVAL
Parrot_ResizableStringArray_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ResizableStringArray");
}
INTVAL
Parrot_ResizableStringArray_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ResizableStringArray");
}
PMC *
Parrot_ResizableStringArray_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ResizableStringArray");
}
STRING *
Parrot_ResizableStringArray_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ResizableStringArray");
}
void
Parrot_ResizableStringArray_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_ResizableStringArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizableStringArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableStringArray_delete_keyed,
        Parrot_ResizableStringArray_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedStringArray_destroy,
        Parrot_default_does,
        Parrot_FixedStringArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_FixedStringArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedStringArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedStringArray_get_integer,
        Parrot_FixedStringArray_get_integer_keyed,
        Parrot_FixedStringArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedStringArray_get_number_keyed,
        Parrot_FixedStringArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedStringArray_get_pmc_keyed,
        Parrot_FixedStringArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedStringArray_get_string_keyed,
        Parrot_ResizableStringArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_FixedStringArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_FixedStringArray_mark,
        Parrot_FixedStringArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ResizableStringArray_pop_float,
        Parrot_ResizableStringArray_pop_integer,
        Parrot_ResizableStringArray_pop_pmc,
        Parrot_ResizableStringArray_pop_string,
        Parrot_ResizableStringArray_push_float,
        Parrot_ResizableStringArray_push_integer,
        Parrot_ResizableStringArray_push_pmc,
        Parrot_ResizableStringArray_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedStringArray_set_integer_keyed,
        Parrot_FixedStringArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_ResizableStringArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedStringArray_set_number_keyed,
        Parrot_FixedStringArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedStringArray_set_pmc_keyed,
        Parrot_FixedStringArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedStringArray_set_string_keyed,
        Parrot_ResizableStringArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableStringArray_shift_float,
        Parrot_ResizableStringArray_shift_integer,
        Parrot_ResizableStringArray_shift_pmc,
        Parrot_ResizableStringArray_shift_string,
        Parrot_default_slice,
        Parrot_ResizableStringArray_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_FixedStringArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ResizableStringArray_unshift_float,
        Parrot_ResizableStringArray_unshift_integer,
        Parrot_ResizableStringArray_unshift_pmc,
        Parrot_ResizableStringArray_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_ResizableStringArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_ResizableStringArray_ro_add_attribute,
        Parrot_ResizableStringArray_ro_add_method,
        Parrot_ResizableStringArray_ro_add_parent,
        Parrot_ResizableStringArray_ro_add_role,
        Parrot_ResizableStringArray_ro_add_vtable_override,
        Parrot_ResizableStringArray_ro_assign_pmc,
        Parrot_ResizableStringArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_ResizableStringArray_clone,
        Parrot_default_clone_pmc,
        Parrot_ResizableStringArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableStringArray_ro_delete_keyed,
        Parrot_ResizableStringArray_ro_delete_keyed_int,
        Parrot_ResizableStringArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedStringArray_destroy,
        Parrot_default_does,
        Parrot_FixedStringArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ResizableStringArray_ro_find_method,
        Parrot_FixedStringArray_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedStringArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedStringArray_get_integer,
        Parrot_FixedStringArray_get_integer_keyed,
        Parrot_FixedStringArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_FixedStringArray_get_number_keyed,
        Parrot_FixedStringArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedStringArray_get_pmc_keyed,
        Parrot_FixedStringArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_FixedStringArray_get_string_keyed,
        Parrot_ResizableStringArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_ResizableStringArray_ro_i_absolute,
        Parrot_ResizableStringArray_ro_i_bitwise_not,
        Parrot_ResizableStringArray_ro_i_bitwise_nots,
        Parrot_ResizableStringArray_ro_i_logical_not,
        Parrot_ResizableStringArray_ro_i_neg,
        Parrot_ResizableStringArray_ro_increment,
        Parrot_FixedStringArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_FixedStringArray_mark,
        Parrot_ResizableStringArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_ResizableStringArray_ro_pop_float,
        Parrot_ResizableStringArray_ro_pop_integer,
        Parrot_ResizableStringArray_ro_pop_pmc,
        Parrot_ResizableStringArray_ro_pop_string,
        Parrot_ResizableStringArray_ro_push_float,
        Parrot_ResizableStringArray_ro_push_integer,
        Parrot_ResizableStringArray_ro_push_pmc,
        Parrot_ResizableStringArray_ro_push_string,
        Parrot_ResizableStringArray_ro_remove_attribute,
        Parrot_ResizableStringArray_ro_remove_method,
        Parrot_ResizableStringArray_ro_remove_parent,
        Parrot_ResizableStringArray_ro_remove_role,
        Parrot_ResizableStringArray_ro_remove_vtable_override,
        Parrot_ResizableStringArray_ro_set_attr,
        Parrot_ResizableStringArray_ro_set_attr_str,
        Parrot_ResizableStringArray_ro_set_bignum_int,
        Parrot_ResizableStringArray_ro_set_bignum_num,
        Parrot_ResizableStringArray_ro_set_bignum_str,
        Parrot_ResizableStringArray_ro_set_bool,
        Parrot_ResizableStringArray_ro_set_integer_keyed,
        Parrot_ResizableStringArray_ro_set_integer_keyed_int,
        Parrot_ResizableStringArray_ro_set_integer_keyed_str,
        Parrot_ResizableStringArray_ro_set_integer_native,
        Parrot_ResizableStringArray_ro_set_integer_same,
        Parrot_ResizableStringArray_ro_set_number_keyed,
        Parrot_ResizableStringArray_ro_set_number_keyed_int,
        Parrot_ResizableStringArray_ro_set_number_keyed_str,
        Parrot_ResizableStringArray_ro_set_number_native,
        Parrot_ResizableStringArray_ro_set_number_same,
        Parrot_ResizableStringArray_ro_set_pmc,
        Parrot_ResizableStringArray_ro_set_pmc_keyed,
        Parrot_ResizableStringArray_ro_set_pmc_keyed_int,
        Parrot_ResizableStringArray_ro_set_pmc_keyed_str,
        Parrot_ResizableStringArray_ro_set_pointer,
        Parrot_ResizableStringArray_ro_set_pointer_keyed,
        Parrot_ResizableStringArray_ro_set_pointer_keyed_int,
        Parrot_ResizableStringArray_ro_set_pointer_keyed_str,
        Parrot_ResizableStringArray_ro_set_string_keyed,
        Parrot_ResizableStringArray_ro_set_string_keyed_int,
        Parrot_ResizableStringArray_ro_set_string_keyed_str,
        Parrot_ResizableStringArray_ro_set_string_native,
        Parrot_ResizableStringArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableStringArray_ro_shift_float,
        Parrot_ResizableStringArray_ro_shift_integer,
        Parrot_ResizableStringArray_ro_shift_pmc,
        Parrot_ResizableStringArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_ResizableStringArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_ResizableStringArray_ro_thaw,
        Parrot_ResizableStringArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_ResizableStringArray_ro_unshift_float,
        Parrot_ResizableStringArray_ro_unshift_integer,
        Parrot_ResizableStringArray_ro_unshift_pmc,
        Parrot_ResizableStringArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "ResizableStringArray");
        vt_clone->isa_str = CONST_STRING(interp, "ResizableStringArray FixedStringArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_ResizableStringArray_class_init */
#line 607 "./src/pmc/resizablestringarray.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11
Changed allocator to double size - Matt Fowles 2004-06-15
Added push_string                - Bernhard Schmalhofer 2004-10-17
moved available size to int_val2 - Matt Fowles 2005-07-22

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
