/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/sarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/sarray.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: sarray.pmc 21080 2007-09-05 00:00:42Z chromatic $

=head1 NAME

src/pmc/sarray.pmc - Simple Array or Subroutine Parameter Array

=head1 DESCRIPTION

Simple Array or Subroutine Parameter Array PMC.
SArray data are kept in an malloced array of C<HashEntry>s:

=over 4

=item 0 C<start_idx>

First index, for C<shift>.

=item 1 C<end_idx>

Last index, for C<push>.

=item 2...

Data.

=back

SArrays are fixed size, implying that the first operation on it must be
setting its size, and that only the most important vtable methods are
implemented.

Currently SArrays are used for:

=over 4

=item Global data per interpreter

=item Implementing lists, see F<src/list.c>.

=item Base class of the Exception PMC, see F<src/exception.pmc>

=back

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

/*

=item C<static PARROT_INLINE INTVAL
ret_int(PARROT_INTERP, const HashEntry *e)>

Processes C<*e>, returning the appropriate integer, or raising an
exception if necessary.

=cut

*/

static PARROT_INLINE INTVAL
ret_int(PARROT_INTERP, const HashEntry *e)
{
    switch (e->type) {
        case enum_hash_int:
            return UVal_int(e->val);
        case enum_hash_pmc:
            return VTABLE_get_integer(interp, UVal_pmc(e->val));
        default:
            break;
    }

    real_exception(interp, NULL, E_IndexError, "SArray: Entry not an integer!");
}

/*

=item C<static PARROT_INLINE FLOATVAL
ret_num(PARROT_INTERP, const HashEntry *e)>

Processes C<*e>, returning the appropriate floating-point number, or
raising an exception if necessary.

=cut

*/

static PARROT_INLINE FLOATVAL
ret_num(PARROT_INTERP, const HashEntry *e)
{
    switch (e->type) {
        case enum_hash_num:
            return UVal_num(e->val);
        case enum_hash_pmc:
            return VTABLE_get_number(interp, UVal_pmc(e->val));
        default:
            break;
    }

    real_exception(interp, NULL, E_IndexError, "SArray: Entry not a number!");
}

/*

=item C<static PARROT_INLINE STRING *
ret_string(PARROT_INTERP, HashEntry *e)>

Processes C<*e>, returning the appropriate Parrot string, or raising an
exception if necessary.

=cut

*/

static PARROT_INLINE STRING*
ret_string(PARROT_INTERP, const HashEntry *e)
{
    switch (e->type) {
        case enum_hash_string:
            return UVal_str(e->val);
        case enum_hash_pmc:
            return VTABLE_get_string(interp, UVal_pmc(e->val));
        default:
            break;
    }

    real_exception(interp, NULL, E_IndexError, "SArray: Entry not a string!");
}

/*

=item C<static PARROT_INLINE PMC *
ret_pmc(PARROT_INTERP, const HashEntry *e)>

Processes C<*e>, returning the appropriate PMC, or raising an exception
if necessary.

=cut

*/

static PARROT_INLINE PMC*
ret_pmc(PARROT_INTERP, const HashEntry *e)
{
    PMC *ret;
    switch (e->type) {
        case enum_hash_int:
            ret = pmc_new(interp, enum_class_Undef);
            VTABLE_set_integer_native(interp, ret, UVal_int(e->val));
            return ret;
        case enum_hash_num:
            ret = pmc_new(interp, enum_class_Undef);
            VTABLE_set_number_native(interp, ret, UVal_num(e->val));
            return ret;
        case enum_hash_string:
            ret = pmc_new(interp, enum_class_Undef);
            VTABLE_set_string_native(interp, ret, UVal_str(e->val));
            return ret;
        case enum_hash_pmc:
            return UVal_pmc(e->val);
        default:
            real_exception(interp, NULL, E_IndexError, "SArray: Unknown entry!");
    }
}

/*

=item C<static PARROT_INLINE HashEntry *
shift_entry(PARROT_INTERP, PMC *self)>

Removes and returns the first element from the array.

=cut

*/

static PARROT_INLINE HashEntry *
shift_entry(PARROT_INTERP, PMC *self)
{
    HashEntry   * const e    = (HashEntry *) PMC_data(self);
    INTVAL       start_index = UVal_int(e[0].val);
    const INTVAL end_index   = UVal_int(e[1].val);
    HashEntry   *ret;

    if (start_index >= end_index)
        real_exception(interp, NULL, OUT_OF_BOUNDS,
            "SArray index out of bounds!");

    ret = (HashEntry *) PMC_data(self) + (2 + start_index++);

    /* Update the starting index */
    UVal_int(e[0].val) = start_index;
    return ret;
}

/*

=item C<static PARROT_INLINE HashEntry *
get_entry(PARROT_INTERP, PMC *self, INTVAL key)>

Returns the element for index C<key>.

=cut

*/

static PARROT_INLINE HashEntry*
get_entry(PARROT_INTERP, PMC *self, INTVAL key)
{
    HashEntry   *e           = (HashEntry *)PMC_data(self);
    const INTVAL start_index = UVal_int(e[0].val);
    const INTVAL end_index   = UVal_int(e[1].val);

    if (key < 0)
        key += end_index;

    key += start_index;   /* lower bound if already shifted */

    if (key < start_index || key >= end_index)
        real_exception(interp, NULL, OUT_OF_BOUNDS,
            "SArray index out of bounds!");

    return (HashEntry *)PMC_data(self) + (2 + key);
}
#line 246 "./src/pmc/sarray.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_sarray.h"
#include "pmc_default.h"
#include "sarray.str"
PMC  *
Parrot_SArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 334 "./src/pmc/sarray.pmc"

    HashEntry *e, *d;
    int i, start, end;
    INTVAL size;
    PMC *dest = pmc_new(interp, pmc->vtable->base_type);

    if (!PMC_data(pmc))
        return dest;

    size              = PMC_int_val(pmc);
    PMC_int_val(dest) = size;
    PMC_data(dest)    = mem_sys_allocate_zeroed((2 + size) *
        sizeof (HashEntry));

    e     = (HashEntry *)PMC_data(pmc);
    d     = (HashEntry *)PMC_data(dest);
    start = UVal_int(e[0].val);
    end   = UVal_int(e[1].val);

    UVal_int(d[0].val) = start;
    UVal_int(d[1].val) = end;

    e = (HashEntry *)PMC_data(pmc) + (2 + start);
    d = (HashEntry *)PMC_data(dest) + (2 + start);

    for (i = start; i < end; i++, e++, d++) {
        d->type = e->type;
        switch (e->type) {
            case enum_hash_int:
                UVal_int(d->val) = UVal_int(e->val);
                break;
            case enum_hash_num:
                UVal_num(d->val) = UVal_num(e->val);
                break;
            case enum_hash_string:
                UVal_str(d->val) =
                    string_copy(interp, UVal_str(e->val));
                break;
            case enum_hash_pmc:
                UVal_pmc(d->val) =
                    VTABLE_clone(interp, UVal_pmc(e->val));
                break;
            default:
                break;
        }
    }

    PObj_custom_mark_destroy_SETALL(dest);
    return dest;
#line 306 "./src/pmc/sarray.c"
}
void
Parrot_SArray_destroy(PARROT_INTERP, PMC *pmc)
{
#line 318 "./src/pmc/sarray.pmc"

    if (PMC_data(pmc))
        mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
#line 316 "./src/pmc/sarray.c"
}
INTVAL
Parrot_SArray_elements(PARROT_INTERP, PMC *pmc)
{
#line 408 "./src/pmc/sarray.pmc"

    HashEntry *e;

    if (!PMC_data(pmc))
        return 0;

    e = (HashEntry *)PMC_data(pmc);
    return UVal_int(e[1].val) - UVal_int(e[0].val);
#line 330 "./src/pmc/sarray.c"
}
INTVAL
Parrot_SArray_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 395 "./src/pmc/sarray.pmc"

    INTVAL size = VTABLE_elements(interp, pmc);
    return (INTVAL)(size != 0);
#line 339 "./src/pmc/sarray.c"
}
INTVAL
Parrot_SArray_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 428 "./src/pmc/sarray.pmc"

    return VTABLE_elements(interp, pmc);
#line 347 "./src/pmc/sarray.c"
}
INTVAL
Parrot_SArray_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 472 "./src/pmc/sarray.pmc"

    /* simple int keys only */
    INTVAL k = key_integer(interp, key);
    return Parrot_SArray_get_integer_keyed_int(interp, pmc, k);
#line 357 "./src/pmc/sarray.c"
}
INTVAL
Parrot_SArray_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 457 "./src/pmc/sarray.pmc"

    HashEntry *e = get_entry(interp, pmc, key);
    return ret_int(interp, e);
#line 366 "./src/pmc/sarray.c"
}
FLOATVAL
Parrot_SArray_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 518 "./src/pmc/sarray.pmc"

    INTVAL k = key_integer(interp, key);
    return Parrot_SArray_get_number_keyed_int(interp, pmc, k);
#line 375 "./src/pmc/sarray.c"
}
FLOATVAL
Parrot_SArray_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 503 "./src/pmc/sarray.pmc"

    HashEntry *e = get_entry(interp, pmc, key);
    return ret_num(interp, e);
#line 384 "./src/pmc/sarray.c"
}
PMC  *
Parrot_SArray_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 610 "./src/pmc/sarray.pmc"

    INTVAL k = key_integer(interp, key);
    return Parrot_SArray_get_pmc_keyed_int(interp, pmc, k);
#line 393 "./src/pmc/sarray.c"
}
PMC  *
Parrot_SArray_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 595 "./src/pmc/sarray.pmc"

    HashEntry *e = get_entry(interp, pmc, key);
    return ret_pmc(interp, e);
#line 402 "./src/pmc/sarray.c"
}
STRING  *
Parrot_SArray_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 564 "./src/pmc/sarray.pmc"

    INTVAL k = key_integer(interp, key);
    return Parrot_SArray_get_string_keyed_int(interp, pmc, k);
#line 411 "./src/pmc/sarray.c"
}
STRING  *
Parrot_SArray_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 549 "./src/pmc/sarray.pmc"

    HashEntry *e = get_entry(interp, pmc, key);
    return ret_string(interp, e);
#line 420 "./src/pmc/sarray.c"
}
void
Parrot_SArray_init(PARROT_INTERP, PMC *pmc)
{
#line 251 "./src/pmc/sarray.pmc"

    PMC_int_val(pmc) = 0;
    PMC_data(pmc)    = NULL;
#line 429 "./src/pmc/sarray.c"
}
void
Parrot_SArray_mark(PARROT_INTERP, PMC *pmc)
{
#line 280 "./src/pmc/sarray.pmc"

    HashEntry *e;
    int        i, start, end;

    if (!PMC_data(pmc))
        return;

    e     = (HashEntry *)PMC_data(pmc);
    start = UVal_int(e[0].val);
    end   = UVal_int(e[1].val);
    e     = (HashEntry *)PMC_data(pmc) + (2 + start);

    for (i = start; i < end; i++, e++) {
        switch (e->type) {
            case enum_hash_string:
                if (UVal_str(e->val))
                    pobject_lives(interp, (PObj *)UVal_str(e->val));
                break;
            case enum_hash_pmc:
                if (UVal_pmc(e->val))
                    pobject_lives(interp, (PObj *)UVal_pmc(e->val));
                break;
            default:
                break;
        }
    }
#line 461 "./src/pmc/sarray.c"
}
void
Parrot_SArray_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
#line 266 "./src/pmc/sarray.pmc"

    Parrot_default_morph(interp, pmc, type);
#line 469 "./src/pmc/sarray.c"
}
void
Parrot_SArray_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 743 "./src/pmc/sarray.pmc"

    HashEntry *e;
    INTVAL     nextix;

    if (!PMC_data(pmc))
        real_exception(interp, NULL, E_IndexError,
                "SArray index out of bounds!");

    e      = (HashEntry *) PMC_data(pmc) + 1;
    nextix = UVal_int(e->val);

    VTABLE_set_number_keyed_int(interp, pmc, nextix, value);
#line 487 "./src/pmc/sarray.c"
}
void
Parrot_SArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 692 "./src/pmc/sarray.pmc"

    HashEntry *e;
    INTVAL     nextix;

    if (!PMC_data(pmc))
        real_exception(interp, NULL, E_IndexError,
                "SArray index out of bounds!");

    e      = (HashEntry *)PMC_data(pmc) + 1;
    nextix = UVal_int(e->val);

    VTABLE_set_integer_keyed_int(interp, pmc, nextix, value);
#line 505 "./src/pmc/sarray.c"
}
void
Parrot_SArray_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 846 "./src/pmc/sarray.pmc"

    HashEntry *e;
    INTVAL     nextix;

    if (!PMC_data(pmc))
        real_exception(interp, NULL, E_IndexError,
                "SArray index out of bounds!");

    e      = (HashEntry *)PMC_data(pmc) + 1;
    nextix = UVal_int(e->val);

    VTABLE_set_pmc_keyed_int(interp, pmc, nextix, value);
#line 523 "./src/pmc/sarray.c"
}
void
Parrot_SArray_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 794 "./src/pmc/sarray.pmc"

    HashEntry *e;
    INTVAL     nextix;

    if (!PMC_data(pmc))
        real_exception(interp, NULL, E_IndexError,
                "SArray index out of bounds!");

    e      = (HashEntry *)PMC_data(pmc) + 1;
    nextix = UVal_int(e->val);

    VTABLE_set_string_keyed_int(interp, pmc, nextix, value);
#line 541 "./src/pmc/sarray.c"
}
void
Parrot_SArray_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 666 "./src/pmc/sarray.pmc"

    HashEntry *e;

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
                "SArray index out of bounds!");

    e                = (HashEntry *)PMC_data(pmc) + (2 + key);
    e->type          = enum_hash_int;
    UVal_int(e->val) = value;
    e                = (HashEntry *)PMC_data(pmc) + 1;

    if (key >= UVal_int(e->val))
        UVal_int(e->val) = key + 1;
#line 561 "./src/pmc/sarray.c"
}
void
Parrot_SArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 640 "./src/pmc/sarray.pmc"

    if (PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError, "SArray: Can't resize!");

    PMC_int_val(pmc) = size;

    /* Probably ought to actually copy this... */

    if (PMC_data(pmc))
      mem_sys_free(PMC_data(pmc));

    PMC_data(pmc) = mem_sys_allocate_zeroed((2 + size) *
        sizeof (HashEntry));
    PObj_custom_mark_destroy_SETALL(pmc);
#line 581 "./src/pmc/sarray.c"
}
void
Parrot_SArray_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 717 "./src/pmc/sarray.pmc"

    HashEntry *e;

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
                "SArray index out of bounds!");

    e                = (HashEntry *)PMC_data(pmc) + (2 + key);
    e->type          = enum_hash_num;
    UVal_num(e->val) = value;
    e                = (HashEntry *)PMC_data(pmc) + 1;

    if (key >= UVal_int(e->val))
        UVal_int(e->val) = key + 1;
#line 601 "./src/pmc/sarray.c"
}
void
Parrot_SArray_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *src)
{
#line 818 "./src/pmc/sarray.pmc"

    HashEntry *e;

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
                "SArray index out of bounds!");

    e       = (HashEntry *) PMC_data(pmc) + (2 + key);
    e->type = enum_hash_pmc;

    DOD_WRITE_BARRIER(interp, pmc, UVal_pmc(e->val), src);
    UVal_pmc(e->val) = src;
    e                = (HashEntry *) PMC_data(pmc) + 1;

    if (key >= UVal_int(e->val))
        UVal_int(e->val) = key + 1;
#line 623 "./src/pmc/sarray.c"
}
void
Parrot_SArray_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 767 "./src/pmc/sarray.pmc"

    HashEntry *e;

    if (key < 0 || key >= PMC_int_val(pmc))
        real_exception(interp, NULL, E_IndexError,
                "SArray index out of bounds!");

    e                = (HashEntry *)PMC_data(pmc) + (2 + key);
    e->type          = enum_hash_string;
    UVal_str(e->val) = value;
    e                = (HashEntry *)PMC_data(pmc) + 1;

    if (key >= UVal_int(e->val))
        UVal_int(e->val) = key + 1;
#line 643 "./src/pmc/sarray.c"
}
FLOATVAL
Parrot_SArray_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 534 "./src/pmc/sarray.pmc"

    HashEntry *ret = shift_entry(interp, pmc);
    return ret_num(interp, ret);
#line 652 "./src/pmc/sarray.c"
}
INTVAL
Parrot_SArray_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 488 "./src/pmc/sarray.pmc"

    HashEntry *ret = shift_entry(interp, pmc);
    return ret_int(interp, ret);
#line 661 "./src/pmc/sarray.c"
}
PMC  *
Parrot_SArray_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 625 "./src/pmc/sarray.pmc"

    HashEntry *ret = shift_entry(interp, pmc);
    return ret_pmc(interp, ret);
#line 670 "./src/pmc/sarray.c"
}
STRING  *
Parrot_SArray_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 580 "./src/pmc/sarray.pmc"

    HashEntry *ret = shift_entry(interp, pmc);
    return ret_string(interp, ret);
#line 679 "./src/pmc/sarray.c"
}
INTVAL
Parrot_SArray_type_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 442 "./src/pmc/sarray.pmc"

    HashEntry *e = get_entry(interp, pmc, key);
    return e->type;
#line 688 "./src/pmc/sarray.c"
}
void
Parrot_SArray_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of SArray");
}
void
Parrot_SArray_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of SArray");
}
void
Parrot_SArray_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of SArray");
}
void
Parrot_SArray_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of SArray");
}
void
Parrot_SArray_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of SArray");
}
void
Parrot_SArray_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of SArray");
}
void
Parrot_SArray_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of SArray");
}
void
Parrot_SArray_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of SArray");
}
void
Parrot_SArray_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of SArray");
}
void
Parrot_SArray_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of SArray");
}
void
Parrot_SArray_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of SArray");
}
PMC *
Parrot_SArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_SArray_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of SArray");
}
void
Parrot_SArray_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of SArray");
}
void
Parrot_SArray_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of SArray");
}
void
Parrot_SArray_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of SArray");
}
void
Parrot_SArray_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of SArray");
}
void
Parrot_SArray_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of SArray");
}
void
Parrot_SArray_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of SArray");
}
FLOATVAL
Parrot_SArray_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of SArray");
}
INTVAL
Parrot_SArray_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of SArray");
}
PMC *
Parrot_SArray_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of SArray");
}
STRING *
Parrot_SArray_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of SArray");
}
void
Parrot_SArray_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of SArray");
}
void
Parrot_SArray_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of SArray");
}
void
Parrot_SArray_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of SArray");
}
void
Parrot_SArray_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of SArray");
}
void
Parrot_SArray_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of SArray");
}
void
Parrot_SArray_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of SArray");
}
void
Parrot_SArray_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of SArray");
}
void
Parrot_SArray_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of SArray");
}
void
Parrot_SArray_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of SArray");
}
void
Parrot_SArray_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of SArray");
}
FLOATVAL
Parrot_SArray_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of SArray");
}
INTVAL
Parrot_SArray_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of SArray");
}
PMC *
Parrot_SArray_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of SArray");
}
STRING *
Parrot_SArray_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of SArray");
}
void
Parrot_SArray_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of SArray");
}
void
Parrot_SArray_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of SArray");
}
void
Parrot_SArray_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of SArray");
}
void
Parrot_SArray_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of SArray");
}
void
Parrot_SArray_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of SArray");
}
void
Parrot_SArray_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of SArray");
}
void
Parrot_SArray_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of SArray");
}
void
Parrot_SArray_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_SArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_SArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_SArray_destroy,
        Parrot_default_does,
        Parrot_SArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_SArray_get_bool,
        Parrot_default_get_class,
        Parrot_SArray_get_integer,
        Parrot_SArray_get_integer_keyed,
        Parrot_SArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_SArray_get_number_keyed,
        Parrot_SArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_SArray_get_pmc_keyed,
        Parrot_SArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_SArray_get_string_keyed,
        Parrot_SArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_SArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_SArray_mark,
        Parrot_SArray_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_SArray_push_float,
        Parrot_SArray_push_integer,
        Parrot_SArray_push_pmc,
        Parrot_SArray_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_SArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_SArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_SArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_SArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_SArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_SArray_shift_float,
        Parrot_SArray_shift_integer,
        Parrot_SArray_shift_pmc,
        Parrot_SArray_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_SArray_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_SArray, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_SArray_ro_add_attribute,
        Parrot_SArray_ro_add_method,
        Parrot_SArray_ro_add_parent,
        Parrot_SArray_ro_add_role,
        Parrot_SArray_ro_add_vtable_override,
        Parrot_SArray_ro_assign_pmc,
        Parrot_SArray_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_SArray_clone,
        Parrot_default_clone_pmc,
        Parrot_SArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_SArray_ro_delete_keyed,
        Parrot_SArray_ro_delete_keyed_int,
        Parrot_SArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_SArray_destroy,
        Parrot_default_does,
        Parrot_SArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_SArray_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_SArray_get_bool,
        Parrot_default_get_class,
        Parrot_SArray_get_integer,
        Parrot_SArray_get_integer_keyed,
        Parrot_SArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_SArray_get_number_keyed,
        Parrot_SArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_SArray_get_pmc_keyed,
        Parrot_SArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_SArray_get_string_keyed,
        Parrot_SArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_SArray_ro_i_absolute,
        Parrot_SArray_ro_i_bitwise_not,
        Parrot_SArray_ro_i_bitwise_nots,
        Parrot_SArray_ro_i_logical_not,
        Parrot_SArray_ro_i_neg,
        Parrot_SArray_ro_increment,
        Parrot_SArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_SArray_mark,
        Parrot_SArray_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_SArray_ro_pop_float,
        Parrot_SArray_ro_pop_integer,
        Parrot_SArray_ro_pop_pmc,
        Parrot_SArray_ro_pop_string,
        Parrot_SArray_ro_push_float,
        Parrot_SArray_ro_push_integer,
        Parrot_SArray_ro_push_pmc,
        Parrot_SArray_ro_push_string,
        Parrot_SArray_ro_remove_attribute,
        Parrot_SArray_ro_remove_method,
        Parrot_SArray_ro_remove_parent,
        Parrot_SArray_ro_remove_role,
        Parrot_SArray_ro_remove_vtable_override,
        Parrot_SArray_ro_set_attr,
        Parrot_SArray_ro_set_attr_str,
        Parrot_SArray_ro_set_bignum_int,
        Parrot_SArray_ro_set_bignum_num,
        Parrot_SArray_ro_set_bignum_str,
        Parrot_SArray_ro_set_bool,
        Parrot_SArray_ro_set_integer_keyed,
        Parrot_SArray_ro_set_integer_keyed_int,
        Parrot_SArray_ro_set_integer_keyed_str,
        Parrot_SArray_ro_set_integer_native,
        Parrot_SArray_ro_set_integer_same,
        Parrot_SArray_ro_set_number_keyed,
        Parrot_SArray_ro_set_number_keyed_int,
        Parrot_SArray_ro_set_number_keyed_str,
        Parrot_SArray_ro_set_number_native,
        Parrot_SArray_ro_set_number_same,
        Parrot_SArray_ro_set_pmc,
        Parrot_SArray_ro_set_pmc_keyed,
        Parrot_SArray_ro_set_pmc_keyed_int,
        Parrot_SArray_ro_set_pmc_keyed_str,
        Parrot_SArray_ro_set_pointer,
        Parrot_SArray_ro_set_pointer_keyed,
        Parrot_SArray_ro_set_pointer_keyed_int,
        Parrot_SArray_ro_set_pointer_keyed_str,
        Parrot_SArray_ro_set_string_keyed,
        Parrot_SArray_ro_set_string_keyed_int,
        Parrot_SArray_ro_set_string_keyed_str,
        Parrot_SArray_ro_set_string_native,
        Parrot_SArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_SArray_ro_shift_float,
        Parrot_SArray_ro_shift_integer,
        Parrot_SArray_ro_shift_pmc,
        Parrot_SArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_SArray_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_SArray_ro_thaw,
        Parrot_SArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_SArray_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_SArray_ro_unshift_float,
        Parrot_SArray_ro_unshift_integer,
        Parrot_SArray_ro_unshift_pmc,
        Parrot_SArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "SArray");
        vt_clone->isa_str = CONST_STRING(interp, "SArray");
        vt_clone->does_str = CONST_STRING(interp, "array");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_SArray_class_init */
#line 858 "./src/pmc/sarray.pmc"

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd03_calling_conventions.pod>.

=head1 HISTORY

Initial version 2003.07.04 by leo

2003.11.06 boemmels renamed HASH_ENTRY to HashEntry

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
