/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/scalar.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/scalar.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: scalar.pmc 21373 2007-09-19 07:25:51Z particle $

=head1 NAME

src/pmc/scalar.pmc - Scalar Abstract Superclass

=head1 DESCRIPTION

These are the vtable functions for the scalar base PMC class

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

/* XXX This should be declared in a .h file somewhere */
extern PMC *
Parrot_BigInt_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);

static PMC *
bitwise_left_shift_internal(PARROT_INTERP, PMC *self,
                            PMC *dest, INTVAL shift_amount)
{
    /* This handles both left and right shifts; the sign of shift_amount
       controls the direction, shifting left if positive and right if negative.
       If we get an error (which can only happen for left shifts) and
       PARROT_ERRORS_OVERFLOW_FLAG is set, then we throw an error, else the
       destination is promoted to a BigInt before shifting.  If dest == self,
       then the shift is done in place.  */
    const INTVAL base = VTABLE_get_integer(interp, self);
    INTVAL result     = 0;
    int overflow_p    = 0;

    /* Compute the shift. */
    if (shift_amount >= 8*INTVAL_SIZE) {
        /* Extreme left shift; no need to do an integer shift first. */
        overflow_p = 1;
    }
    else if (shift_amount >= 0) {
        /* Left shift. */
        result = base << shift_amount;
        overflow_p = (result >> shift_amount) != base;
    }
    else if (shift_amount > -8*INTVAL_SIZE) {
        /* Right shift.  By definition, this can never overflow. */
        result = base >> -shift_amount;
    }
    else {
        /* Extreme right shift. */
        result = 0;
    }

    /* Store the result. */
    if (! overflow_p) {
        if (!dest)
            dest = pmc_new(interp, self->vtable->base_type);
        VTABLE_set_integer_native(interp, dest, result);
    }
    else if (PARROT_ERRORS_test(interp, PARROT_ERRORS_OVERFLOW_FLAG)) {
        real_exception(interp, NULL, ERR_OVERFLOW, "Integer overflow");
    }
    else {
        /* Overflow; must promote dest to BigInt, and do a BigInt shift. */
        if (dest)
            VTABLE_morph(interp, dest, enum_class_BigInt);
        else {
            /* Arguably, we should throw an error here if dest == self and self
             * is not a numeric type.  However, that would require a firmer
             * definition of "numeric type."
             */
            dest = pmc_new(interp, enum_class_BigInt);
        }

        VTABLE_set_integer_native(interp, dest, base);
        Parrot_BigInt_bitwise_shl_int(interp, dest, shift_amount, dest);
    }

    return dest;
}
#line 101 "./src/pmc/scalar.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "scalar.str"
PMC  *
Parrot_scalar_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 223 "./src/pmc/scalar.pmc"

        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);

        VTABLE_set_number_native(interp, dest,
                VTABLE_get_number(interp, pmc) + VTABLE_get_number(interp, value));
        return dest;
#line 119 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 210 "./src/pmc/scalar.pmc"

        const FLOATVAL a = VTABLE_get_number(interp, pmc);

        if (dest)
            VTABLE_morph(interp, dest, value->vtable->base_type);
        else
            dest = pmc_new(interp, value->vtable->base_type);

        VTABLE_set_number_native(interp, dest,
                a + VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, dest, 1,
                VTABLE_get_number_keyed_int(interp, value, 1));
        return dest;
#line 138 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 235 "./src/pmc/scalar.pmc"

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) + (FLOATVAL)value);
    return dest;
#line 151 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 244 "./src/pmc/scalar.pmc"

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) + value);
    return dest;
#line 164 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 261 "./src/pmc/scalar.pmc"

        VTABLE_set_number_native(interp, pmc,
            VTABLE_get_number(interp, pmc) + VTABLE_get_number(interp, value));
#line 173 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 253 "./src/pmc/scalar.pmc"

        const FLOATVAL a = VTABLE_get_number(interp, pmc);

        VTABLE_morph(interp, pmc, value->vtable->base_type);
        VTABLE_set_number_native(interp, pmc,
                a + VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, pmc, 1,
                VTABLE_get_number_keyed_int(interp, value, 1));
#line 187 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 269 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) + (FLOATVAL)value);
#line 196 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 274 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) + value);
#line 205 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 314 "./src/pmc/scalar.pmc"

        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);
        VTABLE_set_number_native(interp, dest,
                VTABLE_get_number(interp, pmc) - VTABLE_get_number(interp, value));
        return dest;
#line 217 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 302 "./src/pmc/scalar.pmc"

        const FLOATVAL a = VTABLE_get_number(interp, pmc);
        if (dest)
            VTABLE_morph(interp, dest, value->vtable->base_type);
        else
            dest = pmc_new(interp, value->vtable->base_type);

        VTABLE_set_number_native(interp, dest,
                a - VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, dest, 1,
                -VTABLE_get_number_keyed_int(interp, value, 1));
        return dest;
#line 235 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 325 "./src/pmc/scalar.pmc"

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) - (FLOATVAL)value);
    return dest;
#line 248 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 334 "./src/pmc/scalar.pmc"

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) - value);
    return dest;
#line 261 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 351 "./src/pmc/scalar.pmc"

        VTABLE_set_number_native(interp, pmc,
            VTABLE_get_number(interp, pmc) - VTABLE_get_number(interp, value));
#line 270 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 343 "./src/pmc/scalar.pmc"

        const FLOATVAL a = VTABLE_get_number(interp, pmc);

        VTABLE_morph(interp, pmc, value->vtable->base_type);
        VTABLE_set_number_native(interp, pmc,
                a - VTABLE_get_number_keyed_int(interp, value, 0));
        VTABLE_set_number_keyed_int(interp, pmc, 1,
                -VTABLE_get_number_keyed_int(interp, value, 1));
#line 284 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 359 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) - (FLOATVAL)value);
#line 293 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 364 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) - value);
#line 302 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 386 "./src/pmc/scalar.pmc"

        if (!dest)
            dest = pmc_new(interp, pmc->vtable->base_type);

        VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) * VTABLE_get_number(interp, value));
        return dest;
#line 315 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 383 "./src/pmc/scalar.pmc"

        real_exception(interp, NULL, E_NotImplementedError,
                "TODO mul<Float, Complex>");
#line 324 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 398 "./src/pmc/scalar.pmc"

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
        VTABLE_get_number(interp, pmc) * value);
    return dest;
#line 337 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 407 "./src/pmc/scalar.pmc"

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
        VTABLE_get_number(interp, pmc) * value);
    return dest;
#line 350 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 419 "./src/pmc/scalar.pmc"

        VTABLE_set_number_native(interp, pmc,
            VTABLE_get_number(interp, pmc) * VTABLE_get_number(interp, value));
#line 359 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 416 "./src/pmc/scalar.pmc"

        real_exception(interp, NULL, E_NotImplementedError,
                "TODO i_mul<Float, Complex>");
#line 368 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 427 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) * (FLOATVAL)value);
#line 377 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 432 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) * value);
#line 385 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 458 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest, VTABLE_get_number(interp, pmc) / d);
    return dest;
#line 403 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 472 "./src/pmc/scalar.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest, VTABLE_get_number(interp, pmc) / value);
    return dest;
#line 419 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 484 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest, VTABLE_get_number(interp, pmc) / value);
    return dest;
#line 435 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 496 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) / d);
#line 449 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 506 "./src/pmc/scalar.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) / value);
#line 461 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 514 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) / value);
#line 473 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 544 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            floor(VTABLE_get_number(interp, pmc) / d));
    return dest;
#line 492 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 559 "./src/pmc/scalar.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            floor(VTABLE_get_number(interp, pmc) / value));
    return dest;
#line 509 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 572 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            floor(VTABLE_get_number(interp, pmc) / value));
    return dest;
#line 526 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 585 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    VTABLE_set_number_native(interp, pmc,
            floor(VTABLE_get_number(interp, pmc) / d));
#line 541 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 596 "./src/pmc/scalar.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    VTABLE_set_number_native(interp, pmc,
            floor(VTABLE_get_number(interp, pmc) / value));
#line 554 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 605 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float division by zero");

    VTABLE_set_number_native(interp, pmc,
            floor(VTABLE_get_number(interp, pmc) / value));
#line 567 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 731 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            floatval_mod(VTABLE_get_number(interp, pmc), d));
    return dest;
#line 586 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 746 "./src/pmc/scalar.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            floatval_mod(VTABLE_get_number(interp, pmc), value));
    return dest;
#line 603 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 759 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            floatval_mod(VTABLE_get_number(interp, pmc), value));
    return dest;
#line 620 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 772 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");

    VTABLE_set_number_native(interp, pmc,
            floatval_mod(VTABLE_get_number(interp, pmc) , d));
#line 635 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 783 "./src/pmc/scalar.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");

    VTABLE_set_number_native(interp, pmc,
            floatval_mod(VTABLE_get_number(interp, pmc) , value));
#line 648 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 792 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float modulus by zero");

    VTABLE_set_number_native(interp, pmc,
            floatval_mod(VTABLE_get_number(interp, pmc) , value));
#line 661 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_cmodulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 638 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float cmodulus by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            fmod(VTABLE_get_number(interp, pmc), d));
    return dest;
#line 680 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_cmodulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 666 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float cmodulus by zero");

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            fmod(VTABLE_get_number(interp, pmc), value));
    return dest;
#line 697 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_cmodulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 679 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float cmodulus by zero");

    VTABLE_set_number_native(interp, pmc,
            fmod(VTABLE_get_number(interp, pmc) , d));
#line 712 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_cmodulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 690 "./src/pmc/scalar.pmc"

    if (value == 0)
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float cmodulus by zero");

    VTABLE_set_number_native(interp, pmc,
            fmod(VTABLE_get_number(interp, pmc) , value));
#line 725 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_cmodulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 699 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        real_exception(interp, NULL, E_ZeroDivisionError,
                "float cmodulus by zero");

    VTABLE_set_number_native(interp, pmc,
            fmod(VTABLE_get_number(interp, pmc) , value));
#line 738 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 824 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest, pow(VTABLE_get_number(interp, pmc), d));
    return dest;
#line 752 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 834 "./src/pmc/scalar.pmc"

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            pow(VTABLE_get_number(interp, pmc), value));

    return dest;
#line 766 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 844 "./src/pmc/scalar.pmc"

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_number_native(interp, dest,
            pow(VTABLE_get_number(interp, pmc), value));
    return dest;
#line 779 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 853 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    VTABLE_set_number_native(interp, pmc,
            pow(VTABLE_get_number(interp, pmc), d));
#line 790 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 860 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
            pow(VTABLE_get_number(interp, pmc), value));
#line 799 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 865 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
            pow(VTABLE_get_number(interp, pmc), value));
#line 808 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 920 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) | VTABLE_get_integer(interp, value);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 822 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 931 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) | value;

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 836 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 941 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) | VTABLE_get_integer(interp, value);

    VTABLE_set_integer_native(interp, pmc, result);
#line 847 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 949 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) | value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 856 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 972 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) & VTABLE_get_integer(interp, value);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 871 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 983 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) & value;

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 885 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 993 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) & VTABLE_get_integer(interp, value);
    VTABLE_set_integer_native(interp, pmc, result);
#line 895 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1000 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) & value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 904 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1023 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) ^ VTABLE_get_integer(interp, value);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 919 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1034 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) ^ value;

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 933 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1044 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) ^ VTABLE_get_integer(interp, value);
    VTABLE_set_integer_native(interp, pmc, result);
#line 943 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1050 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) ^ value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 952 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1192 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest,
                                       VTABLE_get_integer(interp, value));
#line 961 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1197 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest, value);
#line 969 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1201 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc,
                                VTABLE_get_integer(interp, value));
#line 978 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1206 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc, value);
#line 986 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1104 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest,
                                       -VTABLE_get_integer(interp, value));
#line 995 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1109 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest, -value);
#line 1003 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1113 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc,
                                -VTABLE_get_integer(interp, value));
#line 1012 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1118 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc, -value);
#line 1020 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1140 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >>
        VTABLE_get_integer(interp, value);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 1035 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1151 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >> value;

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 1049 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1161 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >>
            VTABLE_get_integer(interp, value);
    VTABLE_set_integer_native(interp, pmc, result);
#line 1059 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1167 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >> value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 1068 "./src/pmc/scalar.c"
}
INTVAL
Parrot_scalar_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1341 "./src/pmc/scalar.pmc"

    /* XXX - Floating-point precision errors possible? */
    FLOATVAL diff = VTABLE_get_number(interp, value) -
                    VTABLE_get_number(interp, pmc);

    return FLOAT_IS_ZERO(diff) ? 0 : diff < 0.0 ? -1 : 1;
#line 1080 "./src/pmc/scalar.c"
}
INTVAL
Parrot_scalar_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1360 "./src/pmc/scalar.pmc"

    return string_compare(interp, VTABLE_get_string(interp, pmc),
        VTABLE_get_string(interp, value));
#line 1089 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_logical_or(PARROT_INTERP, PMC *pmc, PMC *value,  PMC *dest)
{
#line 1382 "./src/pmc/scalar.pmc"

    if (VTABLE_get_bool(interp, pmc))
        return pmc;

    return value;
#line 1100 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_logical_and(PARROT_INTERP, PMC *pmc, PMC *value,  PMC *dest)
{
#line 1400 "./src/pmc/scalar.pmc"

    if (VTABLE_get_bool(interp, pmc))
        return value;

    return pmc;
#line 1111 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value,  PMC *dest)
{
#line 1417 "./src/pmc/scalar.pmc"

    const INTVAL my_bool    = VTABLE_get_bool(interp, pmc);
    const INTVAL value_bool = VTABLE_get_bool(interp, value);

    if (my_bool && ! value_bool)
        return pmc;
    else if (value_bool && ! my_bool)
        return value;

    dest = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_bool(interp, dest, 0);
    return dest;
#line 1129 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_concatenate(PARROT_INTERP, PMC *pmc, PMC *value,  PMC *dest)
{
#line 1234 "./src/pmc/scalar.pmc"

    STRING * const s = string_concat(interp, VTABLE_get_string(interp, pmc),
        VTABLE_get_string(interp, value), 0);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_string_native(interp, dest, s);
    return dest;
#line 1144 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value,  PMC *dest)
{
#line 1245 "./src/pmc/scalar.pmc"

    STRING * const s = string_concat(interp,
        VTABLE_get_string(interp, pmc), value, 0);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_string_native(interp, dest, s);
    return dest;
#line 1159 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1256 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    STRING * const v = VTABLE_get_string(interp, value);
    VTABLE_set_string_native(interp, pmc, string_append(interp, s, v));
#line 1169 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 1262 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    VTABLE_set_string_native(interp, pmc, string_append(interp, s, value));
#line 1178 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_repeat(PARROT_INTERP, PMC *pmc, PMC *value,  PMC *dest)
{
#line 1285 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = (UINTVAL)VTABLE_get_integer(interp, value);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_string_native(interp, dest,
        string_repeat(interp, s, n, NULL));
    return dest;
#line 1194 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1297 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = value;

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_string_native(interp, dest,
        string_repeat(interp, s, n, NULL));
    return dest;
#line 1210 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1310 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = (UINTVAL)VTABLE_get_integer(interp, value);
    VTABLE_set_string_native(interp, pmc, string_repeat(interp, s, n, NULL));
#line 1220 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1316 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = value;
    VTABLE_set_string_native(interp, pmc, string_repeat(interp, s, n, NULL));
#line 1230 "./src/pmc/scalar.c"
}
void
Parrot_scalar_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 116 "./src/pmc/scalar.pmc"

    STRING * const s_int = CONST_STRING(interp, "Integer");
    STRING        *s_num;
    STRING        *s_str;

    if (pmc->vtable->base_type == enum_class_Boolean) {
        /* doesn't morph */
        VTABLE_morph(interp, pmc, value->vtable->base_type);
    }

    if (value->vtable->base_type == enum_class_Undef) {
        VTABLE_morph(interp, pmc, value->vtable->base_type);
        return;
    }

    if (VTABLE_isa(interp, value, s_int)) {
        const INTVAL v = VTABLE_get_integer(interp, value);
        VTABLE_set_integer_native(interp, pmc, v);
        return;
    }

    s_num = CONST_STRING(interp, "Float");

    if (VTABLE_isa(interp, value, s_num)) {
        const FLOATVAL v = VTABLE_get_number(interp, value);
        VTABLE_set_number_native(interp, pmc, v);
        return;
    }

    s_str = CONST_STRING(interp, "String");

    if (VTABLE_isa(interp, value, s_str)) {
        STRING * const v = VTABLE_get_string(interp, value);
        VTABLE_set_string_native(interp, pmc, v);
        return;
    }
    VTABLE_morph(interp, pmc, enum_class_Ref);
    VTABLE_set_pmc(interp, pmc, value);
#line 1274 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_bitwise_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1067 "./src/pmc/scalar.pmc"

    const INTVAL a = ~VTABLE_get_integer(interp, pmc);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, a);
    return dest;
#line 1288 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_clone(PARROT_INTERP, PMC *pmc)
{
#line 166 "./src/pmc/scalar.pmc"

    PMC * const dest = pmc_new(interp, pmc->vtable->base_type);
    memcpy(&PMC_union(dest), &PMC_union(pmc), sizeof (UnionVal));
    return dest;
#line 1298 "./src/pmc/scalar.c"
}
INTVAL
Parrot_scalar_defined(PARROT_INTERP, PMC *pmc)
{
#line 1468 "./src/pmc/scalar.pmc"

    return 1;
#line 1306 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
#line 1077 "./src/pmc/scalar.pmc"

    VTABLE_set_integer_native(interp, pmc, ~VTABLE_get_integer(interp, pmc));
#line 1314 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_logical_not(PARROT_INTERP, PMC *pmc)
{
#line 1454 "./src/pmc/scalar.pmc"

    VTABLE_set_bool(interp, pmc, ! VTABLE_get_bool(interp, pmc));
#line 1322 "./src/pmc/scalar.c"
}
void
Parrot_scalar_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 892 "./src/pmc/scalar.pmc"

    VTABLE_set_integer_native(interp, pmc, -VTABLE_get_integer(interp, pmc));
#line 1330 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1444 "./src/pmc/scalar.pmc"

    const INTVAL a = ! VTABLE_get_bool(interp, pmc);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_bool(interp, dest, a);
    return dest;
#line 1344 "./src/pmc/scalar.c"
}
void
Parrot_scalar_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
#line 100 "./src/pmc/scalar.pmc"

    if (pmc->vtable->base_type == type)
        return;
    pmc_reuse(interp, pmc, type, 0);
#line 1354 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 882 "./src/pmc/scalar.pmc"

    const INTVAL a = -VTABLE_get_integer(interp, pmc);

    if (!dest)
        dest = pmc_new(interp, pmc->vtable->base_type);

    VTABLE_set_integer_native(interp, dest, a);
    return dest;
#line 1368 "./src/pmc/scalar.c"
}
PMC  *
Parrot_scalar_share_ro(PARROT_INTERP, PMC *pmc)
{
#line 1497 "./src/pmc/scalar.pmc"

    PMC         *ret  = pt_shared_fixup(interp, pmc);
    PMC * const _true = pmc_new(interp, enum_class_Integer);

    VTABLE_set_integer_native(interp, _true, 1);

    /* first set readonly */
    VTABLE_setprop(interp, ret, const_string(interp, "_ro"), _true);

    /* now share; we add a PMC_EXT so we can identify the owning interp */
    add_pmc_sync(interp, ret);
    PObj_is_PMC_shared_SET(ret);

    /* XXX FIXME workaround lack of metadata sharing*/
    PMC_metadata(pmc) = NULL;

    return ret;
#line 1391 "./src/pmc/scalar.c"
}
STRING  *
Parrot_scalar_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length)
{
#line 1483 "./src/pmc/scalar.pmc"

    return string_substr(interp, VTABLE_get_string(interp, pmc),
        offset, length, NULL, 0);
#line 1400 "./src/pmc/scalar.c"
}
#line 1514 "./src/pmc/scalar.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
