/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/tqueue.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#line 1 "./src/pmc/tqueue.pmc"
/*
Copyright (C) 2001-2007, The Perl Foundation.
$Id: tqueue.pmc 20925 2007-08-30 19:42:02Z chromatic $

=head1 NAME

src/pmc/tqueue.pmc - Threadsafe Queue

=head1 DESCRIPTION

Threadsafe queue class for inter thread communication. If you have an
unthreaded program then please use an Array-like PMC.

     new P0, 'TQueue'
     push P0, some
     new P2, 'ParrotThread'
     ...

and in other thread (at least, when shared PMCs work :)

     shift P1, P0

Note: The TQueue must always be emptied before program exit.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 48 "./src/pmc/tqueue.c"
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_tqueue.h"
#include "pmc_default.h"
#include "tqueue.str"
PMC  *
Parrot_TQueue_clone(PARROT_INTERP, PMC *pmc)
{
#line 63 "./src/pmc/tqueue.pmc"

    /* XXX fake a shared PMC */
    return pmc;
#line 62 "./src/pmc/tqueue.c"
}
INTVAL
Parrot_TQueue_defined(PARROT_INTERP, PMC *pmc)
{
#line 137 "./src/pmc/tqueue.pmc"

    return Parrot_TQueue_get_integer(interp, pmc) != 0;
#line 70 "./src/pmc/tqueue.c"
}
void
Parrot_TQueue_destroy(PARROT_INTERP, PMC *pmc)
{
#line 107 "./src/pmc/tqueue.pmc"

    if (PMC_data(pmc)) {
        QUEUE *queue = PMC_data_typed(pmc, QUEUE *);
#if 0
        /*
         * wait til queue is empty
         * XXX implement a time wait and PANIC if queue
         * isn't empty after some TIMEOUT
         */
        while (Parrot_TQueue_elements(interp, pmc)) {
            queue_lock(queue);
            queue_wait(queue);
            queue_unlock(queue);
        }
#endif
        mem_sys_free(queue);
        PMC_data(pmc) = NULL;
    }
#line 94 "./src/pmc/tqueue.c"
}
INTVAL
Parrot_TQueue_elements(PARROT_INTERP, PMC *pmc)
{
#line 163 "./src/pmc/tqueue.pmc"

    return Parrot_TQueue_get_integer(interp, pmc);
#line 102 "./src/pmc/tqueue.c"
}
INTVAL
Parrot_TQueue_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 149 "./src/pmc/tqueue.pmc"

    return PMC_int_val(pmc);
#line 110 "./src/pmc/tqueue.c"
}
void
Parrot_TQueue_init(PARROT_INTERP, PMC *pmc)
{
#line 47 "./src/pmc/tqueue.pmc"

    PMC_int_val(pmc) = 0;
    PMC_data(pmc)    = queue_init(0);
    PObj_custom_mark_destroy_SETALL(pmc);
#line 120 "./src/pmc/tqueue.c"
}
void
Parrot_TQueue_mark(PARROT_INTERP, PMC *pmc)
{
#line 78 "./src/pmc/tqueue.pmc"

    QUEUE       *queue = PMC_data_typed(pmc, QUEUE *);
    QUEUE_ENTRY *entry;

    queue_lock(queue);
    entry = queue->head;

    while (entry) {
        pobject_lives(interp, (PObj *)entry->data);

        if (entry == queue->tail)
            break;

        entry = entry->next;
    }

    queue_unlock(queue);
#line 143 "./src/pmc/tqueue.c"
}
void
Parrot_TQueue_push_pmc(PARROT_INTERP, PMC *pmc, PMC *item)
{
#line 177 "./src/pmc/tqueue.pmc"

    QUEUE_ENTRY *entry = mem_allocate_typed(QUEUE_ENTRY);
    QUEUE       *queue = PMC_data_typed(pmc, QUEUE *);

    /*
     * if item isn't shared nor const, then make
     *       a shared item
     */
    if (!(item->vtable->flags &
                (VTABLE_IS_CONST_FLAG | VTABLE_IS_SHARED_FLAG)))
        VTABLE_share(interp, item);

    DOD_WRITE_BARRIER(interp, pmc, NULL, item);

    entry->data = item;
    entry->type = QUEUE_ENTRY_TYPE_NONE;

    /* s. tsq.c:queue_push */
    queue_lock(queue);
    ++PMC_int_val(pmc);

    /* Is there something in the queue? */
    if (queue->tail) {
        queue->tail->next = entry;
        queue->tail       = entry;
    }
    else {
        queue->head = entry;
        queue->tail = entry;
    }

    /* signal all waiters */
    queue_broadcast(queue);
    queue_unlock(queue);
#line 183 "./src/pmc/tqueue.c"
}
PMC  *
Parrot_TQueue_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 223 "./src/pmc/tqueue.pmc"

    QUEUE       *queue = PMC_data_typed(pmc, QUEUE *);
    QUEUE_ENTRY *entry;
    PMC         *ret;

    queue_lock(queue);

    while (queue->head == NULL) {
        queue_wait(queue);
    }

    entry = nosync_pop_entry(queue);
    --PMC_int_val(pmc);

    queue_unlock(queue);

    ret   = (PMC *)entry->data;
    mem_sys_free(entry);

    return ret;
#line 209 "./src/pmc/tqueue.c"
}
void
Parrot_TQueue_ro_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_decrement(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of TQueue");
}
PMC *
Parrot_TQueue_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, const_string(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
void
Parrot_TQueue_ro_i_absolute(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_i_neg(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_increment(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_morph(PARROT_INTERP, PMC *pmc, INTVAL type)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of TQueue");
}
FLOATVAL
Parrot_TQueue_ro_pop_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of TQueue");
}
INTVAL
Parrot_TQueue_ro_pop_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of TQueue");
}
PMC *
Parrot_TQueue_ro_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of TQueue");
}
STRING *
Parrot_TQueue_ro_pop_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_attr(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of TQueue");
}
FLOATVAL
Parrot_TQueue_ro_shift_float(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of TQueue");
}
INTVAL
Parrot_TQueue_ro_shift_integer(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of TQueue");
}
PMC *
Parrot_TQueue_ro_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of TQueue");
}
STRING *
Parrot_TQueue_ro_shift_string(PARROT_INTERP, PMC *pmc)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of TQueue");
}
void
Parrot_TQueue_ro_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    real_exception(interp, NULL, WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of TQueue");
}
void
Parrot_TQueue_class_init(PARROT_INTERP, int entry, int pass)
{
    const VTABLE temp_base_vtable = {
        NULL,   /* namespace */
        enum_class_TQueue, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_SHARED_FLAG|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add_attribute,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_TQueue_clone,
        Parrot_default_clone_pmc,
        Parrot_default_decrement,
        Parrot_TQueue_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_TQueue_destroy,
        Parrot_default_does,
        Parrot_TQueue_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_TQueue_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_default_i_absolute,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_logical_not,
        Parrot_default_i_neg,
        Parrot_default_increment,
        Parrot_TQueue_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_TQueue_mark,
        Parrot_default_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_TQueue_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_set_attr,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_TQueue_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,   /* namespace */
        enum_class_TQueue, /* base_type */
        NULL,   /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_SHARED_FLAG|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,   /* does_str */
        NULL,   /* isa_str */
        NULL,   /* class */
        NULL,   /* mro */
        NULL,   /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_TQueue_ro_add_attribute,
        Parrot_TQueue_ro_add_method,
        Parrot_TQueue_ro_add_parent,
        Parrot_TQueue_ro_add_role,
        Parrot_TQueue_ro_add_vtable_override,
        Parrot_TQueue_ro_assign_pmc,
        Parrot_TQueue_ro_assign_string_native,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_can,
        Parrot_default_class_type,
        Parrot_TQueue_clone,
        Parrot_default_clone_pmc,
        Parrot_TQueue_ro_decrement,
        Parrot_TQueue_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_TQueue_ro_delete_keyed,
        Parrot_TQueue_ro_delete_keyed_int,
        Parrot_TQueue_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_TQueue_destroy,
        Parrot_default_does,
        Parrot_TQueue_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_TQueue_ro_find_method,
        Parrot_default_freeze,
        Parrot_default_get_attr,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_TQueue_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_hash,
        Parrot_TQueue_ro_i_absolute,
        Parrot_TQueue_ro_i_bitwise_not,
        Parrot_TQueue_ro_i_bitwise_nots,
        Parrot_TQueue_ro_i_logical_not,
        Parrot_TQueue_ro_i_neg,
        Parrot_TQueue_ro_increment,
        Parrot_TQueue_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_invoke,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_logical_not,
        Parrot_TQueue_mark,
        Parrot_TQueue_ro_morph,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_new_from_string,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pmc_namespace,
        Parrot_TQueue_ro_pop_float,
        Parrot_TQueue_ro_pop_integer,
        Parrot_TQueue_ro_pop_pmc,
        Parrot_TQueue_ro_pop_string,
        Parrot_TQueue_ro_push_float,
        Parrot_TQueue_ro_push_integer,
        Parrot_TQueue_ro_push_pmc,
        Parrot_TQueue_ro_push_string,
        Parrot_TQueue_ro_remove_attribute,
        Parrot_TQueue_ro_remove_method,
        Parrot_TQueue_ro_remove_parent,
        Parrot_TQueue_ro_remove_role,
        Parrot_TQueue_ro_remove_vtable_override,
        Parrot_TQueue_ro_set_attr,
        Parrot_TQueue_ro_set_attr_str,
        Parrot_TQueue_ro_set_bignum_int,
        Parrot_TQueue_ro_set_bignum_num,
        Parrot_TQueue_ro_set_bignum_str,
        Parrot_TQueue_ro_set_bool,
        Parrot_TQueue_ro_set_integer_keyed,
        Parrot_TQueue_ro_set_integer_keyed_int,
        Parrot_TQueue_ro_set_integer_keyed_str,
        Parrot_TQueue_ro_set_integer_native,
        Parrot_TQueue_ro_set_integer_same,
        Parrot_TQueue_ro_set_number_keyed,
        Parrot_TQueue_ro_set_number_keyed_int,
        Parrot_TQueue_ro_set_number_keyed_str,
        Parrot_TQueue_ro_set_number_native,
        Parrot_TQueue_ro_set_number_same,
        Parrot_TQueue_ro_set_pmc,
        Parrot_TQueue_ro_set_pmc_keyed,
        Parrot_TQueue_ro_set_pmc_keyed_int,
        Parrot_TQueue_ro_set_pmc_keyed_str,
        Parrot_TQueue_ro_set_pointer,
        Parrot_TQueue_ro_set_pointer_keyed,
        Parrot_TQueue_ro_set_pointer_keyed_int,
        Parrot_TQueue_ro_set_pointer_keyed_str,
        Parrot_TQueue_ro_set_string_keyed,
        Parrot_TQueue_ro_set_string_keyed_int,
        Parrot_TQueue_ro_set_string_keyed_str,
        Parrot_TQueue_ro_set_string_native,
        Parrot_TQueue_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_TQueue_ro_shift_float,
        Parrot_TQueue_ro_shift_integer,
        Parrot_TQueue_ro_shift_pmc,
        Parrot_TQueue_ro_shift_string,
        Parrot_default_slice,
        Parrot_TQueue_ro_splice,
        Parrot_default_subclass,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtype,
        Parrot_TQueue_ro_thaw,
        Parrot_TQueue_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_type_keyed_int,
        Parrot_default_type_keyed_str,
        Parrot_TQueue_ro_unshift_float,
        Parrot_TQueue_ro_unshift_integer,
        Parrot_TQueue_ro_unshift_pmc,
        Parrot_TQueue_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        /* create vtable - clone it - we have to set a few items */
        VTABLE *vt_clone = Parrot_clone_vtable(interp, &temp_base_vtable);
        VTABLE *vt_ro_clone = Parrot_clone_vtable(interp, &temp_ro_vtable);
        vt_clone->whoami = CONST_STRING(interp, "TQueue");
        vt_clone->isa_str = CONST_STRING(interp, "TQueue");
        vt_clone->does_str = CONST_STRING(interp, "scalar");
        vt_ro_clone->base_type = entry;
        vt_ro_clone->whoami = vt_clone->whoami;
        vt_ro_clone->isa_str = vt_clone->isa_str;
        vt_ro_clone->does_str = vt_clone->does_str;
        vt_clone->ro_variant_vtable = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        interp->vtables[entry] = vt_clone;
    }
    else { /* pass */
        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* create PMC Proxy object */
        Parrot_create_pmc_proxy(interp, entry);
        /* class_init */
        {
        
        }
        {
        }
    } /* pass */
} /* Parrot_TQueue_class_init */
#line 243 "./src/pmc/tqueue.pmc"


/*

=back

=head1 HISTORY

2003.12.19 leo initial rev.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
