/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically by tools/build/nativecall.pl
 * from definitions in src/call_list.txt
 *
 * Any changes made here will be lost!
 *
 */

/* nci.c
 *  Copyright (C) 2001-2007, The Perl Foundation.
 *  SVN Info
 *     $Id$
 *  Overview:
 *     Native Call Interface routines. The code needed to build a
 *     parrot to C call frame is in here
 *  Data Structure and Algorithms:
 *  History:
 *  Notes:
 *  References:
 */
#include "parrot/parrot.h"
#include "parrot/hash.h"
#include "parrot/oplib/ops.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

/*
 * if the architecture can build some or all of these signatures
 * enable the define below
 * - the JITed function will be called first
 * - if it returns NULL, the hardcoded version will do the job
 */

#if defined(HAS_JIT) && defined(I386)
#  include "parrot/exec.h"
#  include "jit.h"
/*#  define CAN_BUILD_CALL_FRAMES*/
#endif

/*
 * helper funcs - get argument n
 */
static INTVAL
get_nci_I(PARROT_INTERP, NOTNULL(call_state *st), int n)
{
    if (n >= st->src.n) {
        real_exception(interp, NULL, E_ValueError,
                    "too few arguments passed to NCI function");
    }
    Parrot_fetch_arg_nci(interp, st);

    return UVal_int(st->val);
}

static FLOATVAL
get_nci_N(PARROT_INTERP, NOTNULL(call_state *st), int n)
{
    if (n >= st->src.n) {
        real_exception(interp, NULL, E_ValueError,
                    "too few arguments passed to NCI function");
    }
    Parrot_fetch_arg_nci(interp, st);

    return UVal_num(st->val);
}

static STRING*
get_nci_S(PARROT_INTERP, NOTNULL(call_state *st), int n)
{
    /* TODO or act like below? */
    if (n >= st->src.n) {
        real_exception(interp, NULL, E_ValueError,
                    "too few arguments passed to NCI function");
    }
    Parrot_fetch_arg_nci(interp, st);

    return UVal_str(st->val);
}

static PMC*
get_nci_P(PARROT_INTERP, NOTNULL(call_state *st), int n)
{
    /*
     * exessive args are passed as NULL
     * used by e.g. MMD infix like __add
     */
    if (n < st->src.n)
        Parrot_fetch_arg_nci(interp, st);
    else
        UVal_pmc(st->val) = PMCNULL;

    return UVal_pmc(st->val);
}

#define GET_NCI_I(n) get_nci_I(interp, &st, n)
#define GET_NCI_S(n) get_nci_S(interp, &st, n)
#define GET_NCI_N(n) get_nci_N(interp, &st, n)
#define GET_NCI_P(n) get_nci_P(interp, &st, n)

/*
 * set return value
 */
static void
set_nci_I(PARROT_INTERP, ARGOUT(call_state *st), INTVAL val)
{
    Parrot_init_ret_nci(interp, st, "I");
    if (st->dest.i < st->dest.n) {
        UVal_int(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_N(PARROT_INTERP, ARGOUT(call_state *st), FLOATVAL val)
{
    Parrot_init_ret_nci(interp, st, "N");
    if (st->dest.i < st->dest.n) {
        UVal_num(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_S(PARROT_INTERP, ARGOUT(call_state *st), STRING *val)
{
    Parrot_init_ret_nci(interp, st, "S");
    if (st->dest.i < st->dest.n) {
        UVal_str(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_P(PARROT_INTERP, ARGOUT(call_state *st), PMC* val)
{
    Parrot_init_ret_nci(interp, st, "P");
    if (st->dest.i < st->dest.n) {
        UVal_pmc(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

/* All our static functions that call in various ways. Yes, terribly
   hackish, but that is just fine */

static void
pcf_c_(PARROT_INTERP, PMC *self)
{
    char (*pointer)(void);
    char return_data;
    
    call_state st;
    

    pointer =  (char (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (char)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_p(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *);
    func_t pointer;
    call_state st;
    char return_data;
    
    PMC *t_0;
    Parrot_init_arg_nci(interp, &st, "P");
    t_0 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(PMC_data(t_0));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_pi(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    char return_data;
    
    PMC *t_1;
    int t_2;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_1 = GET_NCI_P(0);
    t_2 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(PMC_data(t_1),t_2);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_d_(PARROT_INTERP, PMC *self)
{
    double (*pointer)(void);
    double return_data;
    
    call_state st;
    

    pointer =  (double (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (double)(*pointer)();
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_d_d(PARROT_INTERP, PMC *self)
{
    typedef double (*func_t)(double);
    func_t pointer;
    call_state st;
    double return_data;
    
    double t_3;
    Parrot_init_arg_nci(interp, &st, "N");
    t_3 = (double)GET_NCI_N(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (double)(*pointer)(t_3);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_d_JOd(PARROT_INTERP, PMC *self)
{
    typedef double (*func_t)(PARROT_INTERP, PMC *, double);
    func_t pointer;
    call_state st;
    double return_data;
    
    PMC *t_5;
    double t_6;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_5 = GET_NCI_P(0);
    t_6 = (double)GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (double)(*pointer)(interp,PMC_IS_NULL(t_5) ? NULL : t_5,t_6);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_I_JOS(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_8;
    STRING *t_9;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_8 = GET_NCI_P(0);
    t_9 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_8) ? NULL : t_8,t_9);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_S_JOS(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    PMC *t_11;
    STRING *t_12;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_11 = GET_NCI_P(0);
    t_12 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_11) ? NULL : t_11,t_12);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_I_JI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, INTVAL);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    INTVAL t_14;
    Parrot_init_arg_nci(interp, &st, "I");
    t_14 = GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,t_14);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JOSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_16;
    STRING *t_17;
    PMC *t_18;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_16 = GET_NCI_P(0);
    t_17 = GET_NCI_S(1);
    t_18 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_16) ? NULL : t_16,t_17,PMC_IS_NULL(t_18) ? NULL : t_18);
    
    
    
}
static void
pcf_v_JOS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_20;
    STRING *t_21;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_20 = GET_NCI_P(0);
    t_21 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_20) ? NULL : t_20,t_21);
    
    
    
}
static void
pcf_P_JOS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_23;
    STRING *t_24;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_23 = GET_NCI_P(0);
    t_24 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_23) ? NULL : t_23,t_24);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JOI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_26;
    INTVAL t_27;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_26 = GET_NCI_P(0);
    t_27 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_26) ? NULL : t_26,t_27);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOPS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, STRING *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_29;
    PMC *t_30;
    STRING *t_31;
    Parrot_init_arg_nci(interp, &st, "PPS");
    t_29 = GET_NCI_P(0);
    t_30 = GET_NCI_P(1);
    t_31 = GET_NCI_S(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_29) ? NULL : t_29,PMC_IS_NULL(t_30) ? NULL : t_30,t_31);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOPSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, STRING *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_33;
    PMC *t_34;
    STRING *t_35;
    PMC *t_36;
    Parrot_init_arg_nci(interp, &st, "PPSP");
    t_33 = GET_NCI_P(0);
    t_34 = GET_NCI_P(1);
    t_35 = GET_NCI_S(2);
    t_36 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_33) ? NULL : t_33,PMC_IS_NULL(t_34) ? NULL : t_34,t_35,PMC_IS_NULL(t_36) ? NULL : t_36);
    
    
    
}
static void
pcf_v_JPPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_38;
    PMC *t_39;
    PMC *t_40;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_38 = GET_NCI_P(0);
    t_39 = GET_NCI_P(1);
    t_40 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_38) ? NULL : t_38,PMC_IS_NULL(t_39) ? NULL : t_39,PMC_IS_NULL(t_40) ? NULL : t_40);
    
    
    
}
static void
pcf_v_JPIP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_42;
    INTVAL t_43;
    PMC *t_44;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_42 = GET_NCI_P(0);
    t_43 = GET_NCI_I(1);
    t_44 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_42) ? NULL : t_42,t_43,PMC_IS_NULL(t_44) ? NULL : t_44);
    
    
    
}
static void
pcf_v_JPSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_46;
    STRING *t_47;
    PMC *t_48;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_46 = GET_NCI_P(0);
    t_47 = GET_NCI_S(1);
    t_48 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_46) ? NULL : t_46,t_47,PMC_IS_NULL(t_48) ? NULL : t_48);
    
    
    
}
static void
pcf_v_JPNP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_50;
    FLOATVAL t_51;
    PMC *t_52;
    Parrot_init_arg_nci(interp, &st, "PNP");
    t_50 = GET_NCI_P(0);
    t_51 = GET_NCI_N(1);
    t_52 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_50) ? NULL : t_50,t_51,PMC_IS_NULL(t_52) ? NULL : t_52);
    
    
    
}
static void
pcf_v_JPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_54;
    PMC *t_55;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_54 = GET_NCI_P(0);
    t_55 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_54) ? NULL : t_54,PMC_IS_NULL(t_55) ? NULL : t_55);
    
    
    
}
static void
pcf_v_JPI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    call_state st;
    
    
    PMC *t_57;
    INTVAL t_58;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_57 = GET_NCI_P(0);
    t_58 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_57) ? NULL : t_57,t_58);
    
    
    
}
static void
pcf_v_JPS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_60;
    STRING *t_61;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_60 = GET_NCI_P(0);
    t_61 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_60) ? NULL : t_60,t_61);
    
    
    
}
static void
pcf_v_JPN(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL);
    func_t pointer;
    call_state st;
    
    
    PMC *t_63;
    FLOATVAL t_64;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_63 = GET_NCI_P(0);
    t_64 = GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_63) ? NULL : t_63,t_64);
    
    
    
}
static void
pcf_P_JPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_66;
    PMC *t_67;
    PMC *t_68;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_66 = GET_NCI_P(0);
    t_67 = GET_NCI_P(1);
    t_68 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_66) ? NULL : t_66,PMC_IS_NULL(t_67) ? NULL : t_67,PMC_IS_NULL(t_68) ? NULL : t_68);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPIP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_70;
    INTVAL t_71;
    PMC *t_72;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_70 = GET_NCI_P(0);
    t_71 = GET_NCI_I(1);
    t_72 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_70) ? NULL : t_70,t_71,PMC_IS_NULL(t_72) ? NULL : t_72);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPSP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_74;
    STRING *t_75;
    PMC *t_76;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_74 = GET_NCI_P(0);
    t_75 = GET_NCI_S(1);
    t_76 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_74) ? NULL : t_74,t_75,PMC_IS_NULL(t_76) ? NULL : t_76);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPNP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, FLOATVAL, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_78;
    FLOATVAL t_79;
    PMC *t_80;
    Parrot_init_arg_nci(interp, &st, "PNP");
    t_78 = GET_NCI_P(0);
    t_79 = GET_NCI_N(1);
    t_80 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_78) ? NULL : t_78,t_79,PMC_IS_NULL(t_80) ? NULL : t_80);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JPP(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_82;
    PMC *t_83;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_82 = GET_NCI_P(0);
    t_83 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_82) ? NULL : t_82,PMC_IS_NULL(t_83) ? NULL : t_83);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_f_(PARROT_INTERP, PMC *self)
{
    float (*pointer)(void);
    float return_data;
    
    call_state st;
    

    pointer =  (float (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (float)(*pointer)();
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_ff(PARROT_INTERP, PMC *self)
{
    typedef float (*func_t)(float, float);
    func_t pointer;
    call_state st;
    float return_data;
    
    float t_84;
    float t_85;
    Parrot_init_arg_nci(interp, &st, "NN");
    t_84 = (float)GET_NCI_N(0);
    t_85 = (float)GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (float)(*pointer)(t_84,t_85);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_is(PARROT_INTERP, PMC *self)
{
    typedef float (*func_t)(int, short);
    func_t pointer;
    call_state st;
    float return_data;
    
    int t_86;
    short t_87;
    Parrot_init_arg_nci(interp, &st, "II");
    t_86 = (int)GET_NCI_I(0);
    t_87 = (short)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (float)(*pointer)(t_86,t_87);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_i_(PARROT_INTERP, PMC *self)
{
    int (*pointer)(void);
    int return_data;
    
    call_state st;
    

    pointer =  (int (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (int)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_b(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    STRING *t_88;
    Parrot_init_arg_nci(interp, &st, "S");
    t_88 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PObj_bufstart(t_88));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_d(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(double);
    func_t pointer;
    call_state st;
    int return_data;
    
    double t_89;
    Parrot_init_arg_nci(interp, &st, "N");
    t_89 = (double)GET_NCI_N(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_89);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_90;
    Parrot_init_arg_nci(interp, &st, "I");
    t_90 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_90);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_91;
    int t_92;
    Parrot_init_arg_nci(interp, &st, "II");
    t_91 = (int)GET_NCI_I(0);
    t_92 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_91,t_92);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ii4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg2;
    int t_93;
    int t_94;
    PMC *t_95;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_93 = (int)GET_NCI_I(0);
    t_94 = (int)GET_NCI_I(1);
    t_95 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_95);
    return_data =  (int)(*pointer)(t_93,t_94,&arg2);
    PMC_int_val(t_95) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ii4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long *, int);
    func_t pointer;
    call_state st;
    int return_data;
    long arg2;
    int t_96;
    int t_97;
    PMC *t_98;
    int t_99;
    Parrot_init_arg_nci(interp, &st, "IIPI");
    t_96 = (int)GET_NCI_I(0);
    t_97 = (int)GET_NCI_I(1);
    t_98 = GET_NCI_P(2);
    t_99 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_98);
    return_data =  (int)(*pointer)(t_96,t_97,&arg2,t_99);
    PMC_int_val(t_98) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_100;
    int t_101;
    int t_102;
    int t_103;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_100 = (int)GET_NCI_I(0);
    t_101 = (int)GET_NCI_I(1);
    t_102 = (int)GET_NCI_I(2);
    t_103 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_100,t_101,t_102,t_103);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_104;
    int t_105;
    int t_106;
    long t_107;
    short t_108;
    PMC *t_109;
    Parrot_init_arg_nci(interp, &st, "IIIIIP");
    t_104 = (int)GET_NCI_I(0);
    t_105 = (int)GET_NCI_I(1);
    t_106 = (int)GET_NCI_I(2);
    t_107 = (long)GET_NCI_I(3);
    t_108 = (short)GET_NCI_I(4);
    t_109 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_104,t_105,t_106,t_107,t_108,PMC_data(t_109));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iil(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_110;
    int t_111;
    long t_112;
    Parrot_init_arg_nci(interp, &st, "III");
    t_110 = (int)GET_NCI_I(0);
    t_111 = (int)GET_NCI_I(1);
    t_112 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_110,t_111,t_112);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iili(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_113;
    int t_114;
    long t_115;
    int t_116;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_113 = (int)GET_NCI_I(0);
    t_114 = (int)GET_NCI_I(1);
    t_115 = (long)GET_NCI_I(2);
    t_116 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_113,t_114,t_115,t_116);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_117;
    int t_118;
    PMC *t_119;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_117 = (int)GET_NCI_I(0);
    t_118 = (int)GET_NCI_I(1);
    t_119 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_117,t_118,PMC_data(t_119));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_120;
    int t_121;
    char *t_122;
    Parrot_init_arg_nci(interp, &st, "IIS");
    t_120 = (int)GET_NCI_I(0);
    t_121 = (int)GET_NCI_I(1);
    t_122 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_120,t_121,t_122);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_122);
}
static void
pcf_i_iiti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, char *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_123;
    int t_124;
    char *t_125;
    int t_126;
    Parrot_init_arg_nci(interp, &st, "IISI");
    t_123 = (int)GET_NCI_I(0);
    t_124 = (int)GET_NCI_I(1);
    t_125 = string_to_cstring(interp, GET_NCI_S(2));
    t_126 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_123,t_124,t_125,t_126);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_125);
}
static void
pcf_i_ilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_127;
    long t_128;
    short t_129;
    PMC *t_130;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_127 = (int)GET_NCI_I(0);
    t_128 = (long)GET_NCI_I(1);
    t_129 = (short)GET_NCI_I(2);
    t_130 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_127,t_128,t_129,PMC_data(t_130));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, char *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_131;
    char *t_132;
    int t_133;
    Parrot_init_arg_nci(interp, &st, "ISI");
    t_131 = (int)GET_NCI_I(0);
    t_132 = string_to_cstring(interp, GET_NCI_S(1));
    t_133 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_131,t_132,t_133);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_132);
}
static void
pcf_i_l(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long);
    func_t pointer;
    call_state st;
    int return_data;
    
    long t_134;
    Parrot_init_arg_nci(interp, &st, "I");
    t_134 = (long)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_134);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_li(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    long t_135;
    int t_136;
    Parrot_init_arg_nci(interp, &st, "II");
    t_135 = (long)GET_NCI_I(0);
    t_136 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_135,t_136);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_lp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    long t_137;
    PMC *t_138;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_137 = (long)GET_NCI_I(0);
    t_138 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_137,PMC_data(t_138));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_lsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    long t_139;
    short t_140;
    PMC *t_141;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_139 = (long)GET_NCI_I(0);
    t_140 = (short)GET_NCI_I(1);
    t_141 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_139,t_140,PMC_data(t_141));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_142;
    Parrot_init_arg_nci(interp, &st, "P");
    t_142 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_142));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg1;
    int arg2;
    PMC *t_143;
    PMC *t_144;
    PMC *t_145;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_143 = GET_NCI_P(0);
    t_144 = GET_NCI_P(1);
    t_145 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_144);
    arg2 = PMC_int_val(t_145);
    return_data =  (int)(*pointer)(PMC_data(t_143),&arg1,&arg2);
    PMC_int_val(t_144) = arg1;
    PMC_int_val(t_145) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p333(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg1;
    int arg2;
    int arg3;
    PMC *t_146;
    PMC *t_147;
    PMC *t_148;
    PMC *t_149;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_146 = GET_NCI_P(0);
    t_147 = GET_NCI_P(1);
    t_148 = GET_NCI_P(2);
    t_149 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_147);
    arg2 = PMC_int_val(t_148);
    arg3 = PMC_int_val(t_149);
    return_data =  (int)(*pointer)(PMC_data(t_146),&arg1,&arg2,&arg3);
    PMC_int_val(t_147) = arg1;
    PMC_int_val(t_148) = arg2;
    PMC_int_val(t_149) = arg3;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p333333(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *, int *, int *, int *, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg1;
    int arg2;
    int arg3;
    int arg4;
    int arg5;
    int arg6;
    PMC *t_150;
    PMC *t_151;
    PMC *t_152;
    PMC *t_153;
    PMC *t_154;
    PMC *t_155;
    PMC *t_156;
    Parrot_init_arg_nci(interp, &st, "PPPPPPP");
    t_150 = GET_NCI_P(0);
    t_151 = GET_NCI_P(1);
    t_152 = GET_NCI_P(2);
    t_153 = GET_NCI_P(3);
    t_154 = GET_NCI_P(4);
    t_155 = GET_NCI_P(5);
    t_156 = GET_NCI_P(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_151);
    arg2 = PMC_int_val(t_152);
    arg3 = PMC_int_val(t_153);
    arg4 = PMC_int_val(t_154);
    arg5 = PMC_int_val(t_155);
    arg6 = PMC_int_val(t_156);
    return_data =  (int)(*pointer)(PMC_data(t_150),&arg1,&arg2,&arg3,&arg4,&arg5,&arg6);
    PMC_int_val(t_151) = arg1;
    PMC_int_val(t_152) = arg2;
    PMC_int_val(t_153) = arg3;
    PMC_int_val(t_154) = arg4;
    PMC_int_val(t_155) = arg5;
    PMC_int_val(t_156) = arg6;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg1;
    PMC *t_157;
    PMC *t_158;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_157 = GET_NCI_P(0);
    t_158 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_158);
    return_data =  (int)(*pointer)(PMC_data(t_157),&arg1);
    PMC_int_val(t_158) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p42p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *, short *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg1;
    short arg2;
    PMC *t_159;
    PMC *t_160;
    PMC* t_161;
    PMC *t_162;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_159 = GET_NCI_P(0);
    t_160 = GET_NCI_P(1);
    t_161 = GET_NCI_P(2);
    t_162 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_160);
    arg2 = (short)PMC_int_val(t_161);
    return_data =  (int)(*pointer)(PMC_data(t_159),&arg1,&arg2,PMC_data(t_162));
    PMC_int_val(t_160) = arg1;
    PMC_int_val(t_161) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *, int);
    func_t pointer;
    call_state st;
    int return_data;
    long arg1;
    PMC *t_163;
    PMC *t_164;
    int t_165;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_163 = GET_NCI_P(0);
    t_164 = GET_NCI_P(1);
    t_165 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_164);
    return_data =  (int)(*pointer)(PMC_data(t_163),&arg1,t_165);
    PMC_int_val(t_164) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pb(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_166;
    STRING *t_167;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_166 = GET_NCI_P(0);
    t_167 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_166),PObj_bufstart(t_167));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_168;
    int t_169;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_168 = GET_NCI_P(0);
    t_169 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_168),t_169);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_170;
    int t_171;
    int t_172;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_170 = GET_NCI_P(0);
    t_171 = (int)GET_NCI_I(1);
    t_172 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_170),t_171,t_172);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pii4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg3;
    PMC *t_173;
    int t_174;
    int t_175;
    PMC *t_176;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_173 = GET_NCI_P(0);
    t_174 = (int)GET_NCI_I(1);
    t_175 = (int)GET_NCI_I(2);
    t_176 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_176);
    return_data =  (int)(*pointer)(PMC_data(t_173),t_174,t_175,&arg3);
    PMC_int_val(t_176) = arg3;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pii4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long *, int);
    func_t pointer;
    call_state st;
    int return_data;
    long arg3;
    PMC *t_177;
    int t_178;
    int t_179;
    PMC *t_180;
    int t_181;
    Parrot_init_arg_nci(interp, &st, "PIIPI");
    t_177 = GET_NCI_P(0);
    t_178 = (int)GET_NCI_I(1);
    t_179 = (int)GET_NCI_I(2);
    t_180 = GET_NCI_P(3);
    t_181 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_180);
    return_data =  (int)(*pointer)(PMC_data(t_177),t_178,t_179,&arg3,t_181);
    PMC_int_val(t_180) = arg3;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_182;
    int t_183;
    int t_184;
    int t_185;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_182 = GET_NCI_P(0);
    t_183 = (int)GET_NCI_I(1);
    t_184 = (int)GET_NCI_I(2);
    t_185 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_182),t_183,t_184,t_185);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piiiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_186;
    int t_187;
    int t_188;
    int t_189;
    int t_190;
    int t_191;
    int t_192;
    Parrot_init_arg_nci(interp, &st, "PIIIIII");
    t_186 = GET_NCI_P(0);
    t_187 = (int)GET_NCI_I(1);
    t_188 = (int)GET_NCI_I(2);
    t_189 = (int)GET_NCI_I(3);
    t_190 = (int)GET_NCI_I(4);
    t_191 = (int)GET_NCI_I(5);
    t_192 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_186),t_187,t_188,t_189,t_190,t_191,t_192);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piiilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_193;
    int t_194;
    int t_195;
    int t_196;
    long t_197;
    short t_198;
    PMC *t_199;
    Parrot_init_arg_nci(interp, &st, "PIIIIIP");
    t_193 = GET_NCI_P(0);
    t_194 = (int)GET_NCI_I(1);
    t_195 = (int)GET_NCI_I(2);
    t_196 = (int)GET_NCI_I(3);
    t_197 = (long)GET_NCI_I(4);
    t_198 = (short)GET_NCI_I(5);
    t_199 = GET_NCI_P(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_193),t_194,t_195,t_196,t_197,t_198,PMC_data(t_199));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piil(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_200;
    int t_201;
    int t_202;
    long t_203;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_200 = GET_NCI_P(0);
    t_201 = (int)GET_NCI_I(1);
    t_202 = (int)GET_NCI_I(2);
    t_203 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_200),t_201,t_202,t_203);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piili(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_204;
    int t_205;
    int t_206;
    long t_207;
    int t_208;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_204 = GET_NCI_P(0);
    t_205 = (int)GET_NCI_I(1);
    t_206 = (int)GET_NCI_I(2);
    t_207 = (long)GET_NCI_I(3);
    t_208 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_204),t_205,t_206,t_207,t_208);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_209;
    int t_210;
    int t_211;
    char *t_212;
    Parrot_init_arg_nci(interp, &st, "PIIS");
    t_209 = GET_NCI_P(0);
    t_210 = (int)GET_NCI_I(1);
    t_211 = (int)GET_NCI_I(2);
    t_212 = string_to_cstring(interp, GET_NCI_S(3));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_209),t_210,t_211,t_212);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_212);
}
static void
pcf_i_piiti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, char *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_213;
    int t_214;
    int t_215;
    char *t_216;
    int t_217;
    Parrot_init_arg_nci(interp, &st, "PIISI");
    t_213 = GET_NCI_P(0);
    t_214 = (int)GET_NCI_I(1);
    t_215 = (int)GET_NCI_I(2);
    t_216 = string_to_cstring(interp, GET_NCI_S(3));
    t_217 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_213),t_214,t_215,t_216,t_217);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_216);
}
static void
pcf_i_pilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_218;
    int t_219;
    long t_220;
    short t_221;
    PMC *t_222;
    Parrot_init_arg_nci(interp, &st, "PIIIP");
    t_218 = GET_NCI_P(0);
    t_219 = (int)GET_NCI_I(1);
    t_220 = (long)GET_NCI_I(2);
    t_221 = (short)GET_NCI_I(3);
    t_222 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_218),t_219,t_220,t_221,PMC_data(t_222));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_223;
    int t_224;
    char *t_225;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_223 = GET_NCI_P(0);
    t_224 = (int)GET_NCI_I(1);
    t_225 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_223),t_224,t_225);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_225);
}
static void
pcf_i_pl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_226;
    long t_227;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_226 = GET_NCI_P(0);
    t_227 = (long)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_226),t_227);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pli(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_228;
    long t_229;
    int t_230;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_228 = GET_NCI_P(0);
    t_229 = (long)GET_NCI_I(1);
    t_230 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_228),t_229,t_230);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pll(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_231;
    long t_232;
    long t_233;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_231 = GET_NCI_P(0);
    t_232 = (long)GET_NCI_I(1);
    t_233 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_231),t_232,t_233);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pllllllll(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, long, long, long, long, long, long, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_234;
    long t_235;
    long t_236;
    long t_237;
    long t_238;
    long t_239;
    long t_240;
    long t_241;
    long t_242;
    Parrot_init_arg_nci(interp, &st, "PIIIIIIII");
    t_234 = GET_NCI_P(0);
    t_235 = (long)GET_NCI_I(1);
    t_236 = (long)GET_NCI_I(2);
    t_237 = (long)GET_NCI_I(3);
    t_238 = (long)GET_NCI_I(4);
    t_239 = (long)GET_NCI_I(5);
    t_240 = (long)GET_NCI_I(6);
    t_241 = (long)GET_NCI_I(7);
    t_242 = (long)GET_NCI_I(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_234),t_235,t_236,t_237,t_238,t_239,t_240,t_241,t_242);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_243;
    long t_244;
    PMC *t_245;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_243 = GET_NCI_P(0);
    t_244 = (long)GET_NCI_I(1);
    t_245 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_243),t_244,PMC_data(t_245));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_246;
    long t_247;
    short t_248;
    PMC *t_249;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_246 = GET_NCI_P(0);
    t_247 = (long)GET_NCI_I(1);
    t_248 = (short)GET_NCI_I(2);
    t_249 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_246),t_247,t_248,PMC_data(t_249));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_250;
    PMC *t_251;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_250 = GET_NCI_P(0);
    t_251 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_250),PMC_data(t_251));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_252;
    PMC *t_253;
    int t_254;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_252 = GET_NCI_P(0);
    t_253 = GET_NCI_P(1);
    t_254 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_252),PMC_data(t_253),t_254);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppiiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, int, int, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_255;
    PMC *t_256;
    int t_257;
    int t_258;
    int t_259;
    int t_260;
    int t_261;
    int t_262;
    int t_263;
    int t_264;
    Parrot_init_arg_nci(interp, &st, "PPIIIIIIII");
    t_255 = GET_NCI_P(0);
    t_256 = GET_NCI_P(1);
    t_257 = (int)GET_NCI_I(2);
    t_258 = (int)GET_NCI_I(3);
    t_259 = (int)GET_NCI_I(4);
    t_260 = (int)GET_NCI_I(5);
    t_261 = (int)GET_NCI_I(6);
    t_262 = (int)GET_NCI_I(7);
    t_263 = (int)GET_NCI_I(8);
    t_264 = (int)GET_NCI_I(9);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_255),PMC_data(t_256),t_257,t_258,t_259,t_260,t_261,t_262,t_263,t_264);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_265;
    PMC *t_266;
    PMC *t_267;
    PMC *t_268;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_265 = GET_NCI_P(0);
    t_266 = GET_NCI_P(1);
    t_267 = GET_NCI_P(2);
    t_268 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_265),PMC_data(t_266),PMC_data(t_267),PMC_data(t_268));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_psp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_269;
    short t_270;
    PMC *t_271;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_269 = GET_NCI_P(0);
    t_270 = (short)GET_NCI_I(1);
    t_271 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_269),t_270,PMC_data(t_271));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_272;
    char *t_273;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_272 = GET_NCI_P(0);
    t_273 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_272),t_273);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_273);
}
static void
pcf_i_pti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_274;
    char *t_275;
    int t_276;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_274 = GET_NCI_P(0);
    t_275 = string_to_cstring(interp, GET_NCI_S(1));
    t_276 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_274),t_275,t_276);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_275);
}
static void
pcf_i_pitl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, char *, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_277;
    int t_278;
    char *t_279;
    long t_280;
    Parrot_init_arg_nci(interp, &st, "PISI");
    t_277 = GET_NCI_P(0);
    t_278 = (int)GET_NCI_I(1);
    t_279 = string_to_cstring(interp, GET_NCI_S(2));
    t_280 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_277),t_278,t_279,t_280);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_279);
}
static void
pcf_i_s(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short);
    func_t pointer;
    call_state st;
    int return_data;
    
    short t_281;
    Parrot_init_arg_nci(interp, &st, "I");
    t_281 = (short)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_281);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_s22(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short *, short *);
    func_t pointer;
    call_state st;
    int return_data;
    short arg1;
    short arg2;
    short t_282;
    PMC* t_283;
    PMC* t_284;
    Parrot_init_arg_nci(interp, &st, "IPP");
    t_282 = (short)GET_NCI_I(0);
    t_283 = GET_NCI_P(1);
    t_284 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = (short)PMC_int_val(t_283);
    arg2 = (short)PMC_int_val(t_284);
    return_data =  (int)(*pointer)(t_282,&arg1,&arg2);
    PMC_int_val(t_283) = arg1;
    PMC_int_val(t_284) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_s222(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short *, short *, short *);
    func_t pointer;
    call_state st;
    int return_data;
    short arg1;
    short arg2;
    short arg3;
    short t_285;
    PMC* t_286;
    PMC* t_287;
    PMC* t_288;
    Parrot_init_arg_nci(interp, &st, "IPPP");
    t_285 = (short)GET_NCI_I(0);
    t_286 = GET_NCI_P(1);
    t_287 = GET_NCI_P(2);
    t_288 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = (short)PMC_int_val(t_286);
    arg2 = (short)PMC_int_val(t_287);
    arg3 = (short)PMC_int_val(t_288);
    return_data =  (int)(*pointer)(t_285,&arg1,&arg2,&arg3);
    PMC_int_val(t_286) = arg1;
    PMC_int_val(t_287) = arg2;
    PMC_int_val(t_288) = arg3;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_sp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    short t_289;
    PMC *t_290;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_289 = (short)GET_NCI_I(0);
    t_290 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_289,PMC_data(t_290));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_sss(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short, short);
    func_t pointer;
    call_state st;
    int return_data;
    
    short t_291;
    short t_292;
    short t_293;
    Parrot_init_arg_nci(interp, &st, "III");
    t_291 = (short)GET_NCI_I(0);
    t_292 = (short)GET_NCI_I(1);
    t_293 = (short)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_291,t_292,t_293);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ssss(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short, short, short);
    func_t pointer;
    call_state st;
    int return_data;
    
    short t_294;
    short t_295;
    short t_296;
    short t_297;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_294 = (short)GET_NCI_I(0);
    t_295 = (short)GET_NCI_I(1);
    t_296 = (short)GET_NCI_I(2);
    t_297 = (short)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_294,t_295,t_296,t_297);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_t(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    char *t_298;
    Parrot_init_arg_nci(interp, &st, "S");
    t_298 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_298);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_298);
}
static void
pcf_i_ti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    char *t_299;
    int t_300;
    Parrot_init_arg_nci(interp, &st, "SI");
    t_299 = string_to_cstring(interp, GET_NCI_S(0));
    t_300 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_299,t_300);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_299);
}
static void
pcf_i_4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg0;
    PMC *t_301;
    Parrot_init_arg_nci(interp, &st, "P");
    t_301 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_301);
    return_data =  (int)(*pointer)(&arg0);
    PMC_int_val(t_301) = arg0;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *, int);
    func_t pointer;
    call_state st;
    int return_data;
    long arg0;
    PMC *t_302;
    int t_303;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_302 = GET_NCI_P(0);
    t_303 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_302);
    return_data =  (int)(*pointer)(&arg0,t_303);
    PMC_int_val(t_302) = arg0;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_42p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *, short *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    long arg0;
    short arg1;
    PMC *t_304;
    PMC* t_305;
    PMC *t_306;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_304 = GET_NCI_P(0);
    t_305 = GET_NCI_P(1);
    t_306 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_304);
    arg1 = (short)PMC_int_val(t_305);
    return_data =  (int)(*pointer)(&arg0,&arg1,PMC_data(t_306));
    PMC_int_val(t_304) = arg0;
    PMC_int_val(t_305) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_(PARROT_INTERP, PMC *self)
{
    long (*pointer)(void);
    long return_data;
    
    call_state st;
    

    pointer =  (long (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (long)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_ii(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(int, int);
    func_t pointer;
    call_state st;
    long return_data;
    
    int t_307;
    int t_308;
    Parrot_init_arg_nci(interp, &st, "II");
    t_307 = (int)GET_NCI_I(0);
    t_308 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(t_307,t_308);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_l4(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(long, long *);
    func_t pointer;
    call_state st;
    long return_data;
    long arg1;
    long t_309;
    PMC *t_310;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_309 = (long)GET_NCI_I(0);
    t_310 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_310);
    return_data =  (long)(*pointer)(t_309,&arg1);
    PMC_int_val(t_310) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_p(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_311;
    Parrot_init_arg_nci(interp, &st, "P");
    t_311 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_311));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_pi(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_312;
    int t_313;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_312 = GET_NCI_P(0);
    t_313 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_312),t_313);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_pii(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int, int);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_314;
    int t_315;
    int t_316;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_314 = GET_NCI_P(0);
    t_315 = (int)GET_NCI_I(1);
    t_316 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_314),t_315,t_316);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_p33l(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int *, int *, long);
    func_t pointer;
    call_state st;
    long return_data;
    int arg1;
    int arg2;
    PMC *t_317;
    PMC *t_318;
    PMC *t_319;
    long t_320;
    Parrot_init_arg_nci(interp, &st, "PPPI");
    t_317 = GET_NCI_P(0);
    t_318 = GET_NCI_P(1);
    t_319 = GET_NCI_P(2);
    t_320 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_318);
    arg2 = PMC_int_val(t_319);
    return_data =  (long)(*pointer)(PMC_data(t_317),&arg1,&arg2,t_320);
    PMC_int_val(t_318) = arg1;
    PMC_int_val(t_319) = arg2;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_33l(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(int *, int *, long);
    func_t pointer;
    call_state st;
    long return_data;
    int arg0;
    int arg1;
    PMC *t_321;
    PMC *t_322;
    long t_323;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_321 = GET_NCI_P(0);
    t_322 = GET_NCI_P(1);
    t_323 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_321);
    arg1 = PMC_int_val(t_322);
    return_data =  (long)(*pointer)(&arg0,&arg1,t_323);
    PMC_int_val(t_321) = arg0;
    PMC_int_val(t_322) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_Ji(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    int t_325;
    Parrot_init_arg_nci(interp, &st, "I");
    t_325 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,t_325);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOl(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, long);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_327;
    long t_328;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_327 = GET_NCI_P(0);
    t_328 = (long)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_327) ? NULL : t_327,t_328);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_330;
    PMC *t_331;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_330 = GET_NCI_P(0);
    t_331 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_330) ? NULL : t_330,PMC_IS_NULL(t_331) ? NULL : t_331);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_Jt(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    char *t_333;
    Parrot_init_arg_nci(interp, &st, "S");
    t_333 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,t_333);
    
    set_nci_P(interp, &st, return_data);
    string_cstring_free(t_333);
}
static void
pcf_p_(PARROT_INTERP, PMC *self)
{
    void * (*pointer)(void);
    void * return_data;
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);
    call_state st;
    

    pointer =  (void * (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (void *)(*pointer)();
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_B(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void **);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);STRING *t_334;
    Parrot_init_arg_nci(interp, &st, "S");
    t_334 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(&PObj_bufstart(t_334));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_b(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);STRING *t_335;
    Parrot_init_arg_nci(interp, &st, "S");
    t_335 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PObj_bufstart(t_335));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_337;
    Parrot_init_arg_nci(interp, &st, "S");
    t_337 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp,t_337);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_337);
}
static void
pcf_p_i(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_338;
    Parrot_init_arg_nci(interp, &st, "I");
    t_338 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_338);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_ii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_339;
    int t_340;
    Parrot_init_arg_nci(interp, &st, "II");
    t_339 = (int)GET_NCI_I(0);
    t_340 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_339,t_340);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_341;
    int t_342;
    int t_343;
    int t_344;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_341 = (int)GET_NCI_I(0);
    t_342 = (int)GET_NCI_I(1);
    t_343 = (int)GET_NCI_I(2);
    t_344 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_341,t_342,t_343,t_344);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiiiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_345;
    int t_346;
    int t_347;
    int t_348;
    int t_349;
    int t_350;
    Parrot_init_arg_nci(interp, &st, "IIIIII");
    t_345 = (int)GET_NCI_I(0);
    t_346 = (int)GET_NCI_I(1);
    t_347 = (int)GET_NCI_I(2);
    t_348 = (int)GET_NCI_I(3);
    t_349 = (int)GET_NCI_I(4);
    t_350 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_345,t_346,t_347,t_348,t_349,t_350);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int, int, int, int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_351;
    int t_352;
    int t_353;
    int t_354;
    int t_355;
    int t_356;
    int t_357;
    int t_358;
    Parrot_init_arg_nci(interp, &st, "IIIIIIII");
    t_351 = (int)GET_NCI_I(0);
    t_352 = (int)GET_NCI_I(1);
    t_353 = (int)GET_NCI_I(2);
    t_354 = (int)GET_NCI_I(3);
    t_355 = (int)GET_NCI_I(4);
    t_356 = (int)GET_NCI_I(5);
    t_357 = (int)GET_NCI_I(6);
    t_358 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_351,t_352,t_353,t_354,t_355,t_356,t_357,t_358);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_p(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_359;
    Parrot_init_arg_nci(interp, &st, "P");
    t_359 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_359));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_360;
    char *t_361;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_360 = GET_NCI_P(0);
    t_361 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_360),t_361);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_361);
}
static void
pcf_p_pi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_362;
    int t_363;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_362 = GET_NCI_P(0);
    t_363 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_362),t_363);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_364;
    int t_365;
    int t_366;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_364 = GET_NCI_P(0);
    t_365 = (int)GET_NCI_I(1);
    t_366 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_364),t_365,t_366);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_piiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int, int, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_367;
    int t_368;
    int t_369;
    int t_370;
    int t_371;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_367 = GET_NCI_P(0);
    t_368 = (int)GET_NCI_I(1);
    t_369 = (int)GET_NCI_I(2);
    t_370 = (int)GET_NCI_I(3);
    t_371 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_367),t_368,t_369,t_370,t_371);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_t(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_372;
    Parrot_init_arg_nci(interp, &st, "S");
    t_372 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_372);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_372);
}
static void
pcf_p_tpp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, void *, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_373;
    PMC *t_374;
    PMC *t_375;
    Parrot_init_arg_nci(interp, &st, "SPP");
    t_373 = string_to_cstring(interp, GET_NCI_S(0));
    t_374 = GET_NCI_P(1);
    t_375 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_373,PMC_data(t_374),PMC_data(t_375));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_373);
}
static void
pcf_p_ttttttt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, char *, char *, char *, char *, char *, char *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_376;
    char *t_377;
    char *t_378;
    char *t_379;
    char *t_380;
    char *t_381;
    char *t_382;
    Parrot_init_arg_nci(interp, &st, "SSSSSSS");
    t_376 = string_to_cstring(interp, GET_NCI_S(0));
    t_377 = string_to_cstring(interp, GET_NCI_S(1));
    t_378 = string_to_cstring(interp, GET_NCI_S(2));
    t_379 = string_to_cstring(interp, GET_NCI_S(3));
    t_380 = string_to_cstring(interp, GET_NCI_S(4));
    t_381 = string_to_cstring(interp, GET_NCI_S(5));
    t_382 = string_to_cstring(interp, GET_NCI_S(6));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_376,t_377,t_378,t_379,t_380,t_381,t_382);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_376);
    string_cstring_free(t_377);
    string_cstring_free(t_378);
    string_cstring_free(t_379);
    string_cstring_free(t_380);
    string_cstring_free(t_381);
    string_cstring_free(t_382);
}
static void
pcf_s_(PARROT_INTERP, PMC *self)
{
    short (*pointer)(void);
    short return_data;
    
    call_state st;
    

    pointer =  (short (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (short)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_t_(PARROT_INTERP, PMC *self)
{
    char * (*pointer)(void);
    char * return_data;
    STRING *final_destination;
    call_state st;
    

    pointer =  (char * (*)(void))D2FPTR(PMC_struct_val(self));
    return_data =  (char *)(*pointer)();
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_i(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(int);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;int t_383;
    Parrot_init_arg_nci(interp, &st, "I");
    t_383 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_383);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_ii(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(int, int);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;int t_384;
    int t_385;
    Parrot_init_arg_nci(interp, &st, "II");
    t_384 = (int)GET_NCI_I(0);
    t_385 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_384,t_385);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_p(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_386;
    Parrot_init_arg_nci(interp, &st, "P");
    t_386 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_386));
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pi(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_387;
    int t_388;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_387 = GET_NCI_P(0);
    t_388 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_387),t_388);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pii(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, int, int);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_389;
    int t_390;
    int t_391;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_389 = GET_NCI_P(0);
    t_390 = (int)GET_NCI_I(1);
    t_391 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_389),t_390,t_391);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pt(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, char *);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_392;
    char *t_393;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_392 = GET_NCI_P(0);
    t_393 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PMC_data(t_392),t_393);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_393);
}
static void
pcf_t_t(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;char *t_394;
    Parrot_init_arg_nci(interp, &st, "S");
    t_394 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_394);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_394);
}
static void
pcf_t_tl4(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, long, long *);
    func_t pointer;
    call_state st;
    char * return_data;
    long arg2;
    STRING *final_destination;char *t_395;
    long t_396;
    PMC *t_397;
    Parrot_init_arg_nci(interp, &st, "SIP");
    t_395 = string_to_cstring(interp, GET_NCI_S(0));
    t_396 = (long)GET_NCI_I(1);
    t_397 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_397);
    return_data =  (char *)(*pointer)(t_395,t_396,&arg2);
    PMC_int_val(t_397) = arg2;
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_395);
}
static void
pcf_t_t4(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, long *);
    func_t pointer;
    call_state st;
    char * return_data;
    long arg1;
    STRING *final_destination;char *t_398;
    PMC *t_399;
    Parrot_init_arg_nci(interp, &st, "SP");
    t_398 = string_to_cstring(interp, GET_NCI_S(0));
    t_399 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_399);
    return_data =  (char *)(*pointer)(t_398,&arg1);
    PMC_int_val(t_399) = arg1;
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_398);
}
static void
pcf_v_(PARROT_INTERP, PMC *self)
{
    void (*pointer)(void);
    
    
    
    

    pointer =  (void (*)(void))D2FPTR(PMC_struct_val(self));
     (void)(*pointer)();
    
    
}
static void
pcf_v_Jiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, int, int, int, void *);
    func_t pointer;
    call_state st;
    
    
    int t_401;
    int t_402;
    int t_403;
    PMC *t_404;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_401 = (int)GET_NCI_I(0);
    t_402 = (int)GET_NCI_I(1);
    t_403 = (int)GET_NCI_I(2);
    t_404 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,t_401,t_402,t_403,PMC_data(t_404));
    
    
    
}
static void
pcf_v_JOP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_406;
    PMC *t_407;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_406 = GET_NCI_P(0);
    t_407 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_406) ? NULL : t_406,PMC_IS_NULL(t_407) ? NULL : t_407);
    
    
    
}
static void
pcf_v_i(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int);
    func_t pointer;
    call_state st;
    
    
    int t_408;
    Parrot_init_arg_nci(interp, &st, "I");
    t_408 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_408);
    
    
    
}
static void
pcf_v_ii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int);
    func_t pointer;
    call_state st;
    
    
    int t_409;
    int t_410;
    Parrot_init_arg_nci(interp, &st, "II");
    t_409 = (int)GET_NCI_I(0);
    t_410 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_409,t_410);
    
    
    
}
static void
pcf_v_illllllll(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, long, long, long, long, long, long, long, long);
    func_t pointer;
    call_state st;
    
    
    int t_411;
    long t_412;
    long t_413;
    long t_414;
    long t_415;
    long t_416;
    long t_417;
    long t_418;
    long t_419;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIII");
    t_411 = (int)GET_NCI_I(0);
    t_412 = (long)GET_NCI_I(1);
    t_413 = (long)GET_NCI_I(2);
    t_414 = (long)GET_NCI_I(3);
    t_415 = (long)GET_NCI_I(4);
    t_416 = (long)GET_NCI_I(5);
    t_417 = (long)GET_NCI_I(6);
    t_418 = (long)GET_NCI_I(7);
    t_419 = (long)GET_NCI_I(8);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_411,t_412,t_413,t_414,t_415,t_416,t_417,t_418,t_419);
    
    
    
}
static void
pcf_v_l(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(long);
    func_t pointer;
    call_state st;
    
    
    long t_420;
    Parrot_init_arg_nci(interp, &st, "I");
    t_420 = (long)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_420);
    
    
    
}
static void
pcf_v_p(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_421;
    Parrot_init_arg_nci(interp, &st, "P");
    t_421 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_421));
    
    
    
}
static void
pcf_v_pbip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *, int, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_422;
    STRING *t_423;
    int t_424;
    PMC *t_425;
    Parrot_init_arg_nci(interp, &st, "PSIP");
    t_422 = GET_NCI_P(0);
    t_423 = GET_NCI_S(1);
    t_424 = (int)GET_NCI_I(2);
    t_425 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_422),PObj_bufstart(t_423),t_424,PMC_data(t_425));
    
    
    
}
static void
pcf_v_pi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_426;
    int t_427;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_426 = GET_NCI_P(0);
    t_427 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_426),t_427);
    
    
    
}
static void
pcf_v_piiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, int, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_428;
    int t_429;
    int t_430;
    int t_431;
    int t_432;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_428 = GET_NCI_P(0);
    t_429 = (int)GET_NCI_I(1);
    t_430 = (int)GET_NCI_I(2);
    t_431 = (int)GET_NCI_I(3);
    t_432 = (int)GET_NCI_I(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_428),t_429,t_430,t_431,t_432);
    
    
    
}
static void
pcf_v_pl(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, long);
    func_t pointer;
    call_state st;
    
    
    PMC *t_433;
    long t_434;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_433 = GET_NCI_P(0);
    t_434 = (long)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_433),t_434);
    
    
    
}
static void
pcf_v_pp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_435;
    PMC *t_436;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_435 = GET_NCI_P(0);
    t_436 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_435),PMC_data(t_436));
    
    
    
}
static void
pcf_i_JP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_438;
    Parrot_init_arg_nci(interp, &st, "P");
    t_438 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_438) ? NULL : t_438);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_440;
    Parrot_init_arg_nci(interp, &st, "P");
    t_440 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_440) ? NULL : t_440);
    
    
    
}
static void
pcf_i_JPi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_442;
    int t_443;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_442 = GET_NCI_P(0);
    t_443 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_442) ? NULL : t_442,t_443);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_445;
    int t_446;
    int t_447;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_445 = GET_NCI_P(0);
    t_446 = (int)GET_NCI_I(1);
    t_447 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_445) ? NULL : t_445,t_446,t_447);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_449;
    int t_450;
    int t_451;
    int t_452;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_449 = GET_NCI_P(0);
    t_450 = (int)GET_NCI_I(1);
    t_451 = (int)GET_NCI_I(2);
    t_452 = (int)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_449) ? NULL : t_449,t_450,t_451,t_452);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_454;
    char *t_455;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_454 = GET_NCI_P(0);
    t_455 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_454) ? NULL : t_454,t_455);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_455);
}
static void
pcf_P_JOSSS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, STRING *, STRING *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_457;
    STRING *t_458;
    STRING *t_459;
    STRING *t_460;
    Parrot_init_arg_nci(interp, &st, "PSSS");
    t_457 = GET_NCI_P(0);
    t_458 = GET_NCI_S(1);
    t_459 = GET_NCI_S(2);
    t_460 = GET_NCI_S(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_457) ? NULL : t_457,t_458,t_459,t_460);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOSS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, STRING *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_462;
    STRING *t_463;
    STRING *t_464;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_462 = GET_NCI_P(0);
    t_463 = GET_NCI_S(1);
    t_464 = GET_NCI_S(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_462) ? NULL : t_462,t_463,t_464);
    
    
    
}
static void
pcf_P_JP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_466;
    Parrot_init_arg_nci(interp, &st, "P");
    t_466 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_466) ? NULL : t_466);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_468;
    PMC *t_469;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_468 = GET_NCI_P(0);
    t_469 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_468) ? NULL : t_468,PMC_IS_NULL(t_469) ? NULL : t_469);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JO(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_471;
    Parrot_init_arg_nci(interp, &st, "P");
    t_471 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_471) ? NULL : t_471);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_S_JO(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    PMC *t_473;
    Parrot_init_arg_nci(interp, &st, "P");
    t_473 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_473) ? NULL : t_473);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_i_P(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_474;
    Parrot_init_arg_nci(interp, &st, "P");
    t_474 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_IS_NULL(t_474) ? NULL : t_474);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_S_JOI(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    PMC *t_476;
    INTVAL t_477;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_476 = GET_NCI_P(0);
    t_477 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_476) ? NULL : t_476,t_477);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_i_sc(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, char);
    func_t pointer;
    call_state st;
    int return_data;
    
    short t_478;
    char t_479;
    Parrot_init_arg_nci(interp, &st, "II");
    t_478 = (short)GET_NCI_I(0);
    t_479 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_478,t_479);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_s_sc(PARROT_INTERP, PMC *self)
{
    typedef short (*func_t)(short, char);
    func_t pointer;
    call_state st;
    short return_data;
    
    short t_480;
    char t_481;
    Parrot_init_arg_nci(interp, &st, "II");
    t_480 = (short)GET_NCI_I(0);
    t_481 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (short)(*pointer)(t_480,t_481);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_sc(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(short, char);
    func_t pointer;
    call_state st;
    char return_data;
    
    short t_482;
    char t_483;
    Parrot_init_arg_nci(interp, &st, "II");
    t_482 = (short)GET_NCI_I(0);
    t_483 = (char)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(t_482,t_483);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_484;
    int t_485;
    int t_486;
    Parrot_init_arg_nci(interp, &st, "III");
    t_484 = (int)GET_NCI_I(0);
    t_485 = (int)GET_NCI_I(1);
    t_486 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_484,t_485,t_486);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_i3(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg1;
    int t_487;
    PMC *t_488;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_487 = (int)GET_NCI_I(0);
    t_488 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_488);
    return_data =  (int)(*pointer)(t_487,&arg1);
    PMC_int_val(t_488) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_t_b(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;STRING *t_489;
    Parrot_init_arg_nci(interp, &st, "S");
    t_489 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(PObj_bufstart(t_489));
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_B(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void **);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;STRING *t_490;
    Parrot_init_arg_nci(interp, &st, "S");
    t_490 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(&PObj_bufstart(t_490));
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_v_P(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_491;
    Parrot_init_arg_nci(interp, &st, "P");
    t_491 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_IS_NULL(t_491) ? NULL : t_491);
    
    
    
}
static void
pcf_v_pP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_492;
    PMC *t_493;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_492 = GET_NCI_P(0);
    t_493 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_492),PMC_IS_NULL(t_493) ? NULL : t_493);
    
    
    
}
static void
pcf_p_ip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_494;
    PMC *t_495;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_494 = (int)GET_NCI_I(0);
    t_495 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_494,PMC_data(t_495));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int *, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg0;
    int arg1;
    PMC *t_496;
    PMC *t_497;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_496 = GET_NCI_P(0);
    t_497 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg0 = PMC_int_val(t_496);
    arg1 = PMC_int_val(t_497);
    return_data =  (int)(*pointer)(&arg0,&arg1);
    PMC_int_val(t_496) = arg0;
    PMC_int_val(t_497) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_pii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_498;
    int t_499;
    int t_500;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_498 = GET_NCI_P(0);
    t_499 = (int)GET_NCI_I(1);
    t_500 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_498),t_499,t_500);
    
    
    
}
static void
pcf_v_JO(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_502;
    Parrot_init_arg_nci(interp, &st, "P");
    t_502 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_502) ? NULL : t_502);
    
    
    
}
static void
pcf_i_JO(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_504;
    Parrot_init_arg_nci(interp, &st, "P");
    t_504 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_504) ? NULL : t_504);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JOi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_506;
    int t_507;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_506 = GET_NCI_P(0);
    t_507 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_506) ? NULL : t_506,t_507);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JOt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_509;
    char *t_510;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_509 = GET_NCI_P(0);
    t_510 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_509) ? NULL : t_509,t_510);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_510);
}
static void
pcf_i_Jt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    char *t_512;
    Parrot_init_arg_nci(interp, &st, "S");
    t_512 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,t_512);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_512);
}
static void
pcf_i_Ji(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_514;
    Parrot_init_arg_nci(interp, &st, "I");
    t_514 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,t_514);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_ptippppi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, void *, void *, void *, void *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_515;
    char *t_516;
    int t_517;
    PMC *t_518;
    PMC *t_519;
    PMC *t_520;
    PMC *t_521;
    int t_522;
    Parrot_init_arg_nci(interp, &st, "PSIPPPPI");
    t_515 = GET_NCI_P(0);
    t_516 = string_to_cstring(interp, GET_NCI_S(1));
    t_517 = (int)GET_NCI_I(2);
    t_518 = GET_NCI_P(3);
    t_519 = GET_NCI_P(4);
    t_520 = GET_NCI_P(5);
    t_521 = GET_NCI_P(6);
    t_522 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_515),t_516,t_517,PMC_data(t_518),PMC_data(t_519),PMC_data(t_520),PMC_data(t_521),t_522);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_516);
}
static void
pcf_p_pi33ipi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int *, int *, int, void *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    int arg2;
    int arg3;
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_523;
    int t_524;
    PMC *t_525;
    PMC *t_526;
    int t_527;
    PMC *t_528;
    int t_529;
    Parrot_init_arg_nci(interp, &st, "PIPPIPI");
    t_523 = GET_NCI_P(0);
    t_524 = (int)GET_NCI_I(1);
    t_525 = GET_NCI_P(2);
    t_526 = GET_NCI_P(3);
    t_527 = (int)GET_NCI_I(4);
    t_528 = GET_NCI_P(5);
    t_529 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_525);
    arg3 = PMC_int_val(t_526);
    return_data =  (void *)(*pointer)(PMC_data(t_523),t_524,&arg2,&arg3,t_527,PMC_data(t_528),t_529);
    PMC_int_val(t_525) = arg2;
    PMC_int_val(t_526) = arg3;
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pttip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, int, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_530;
    char *t_531;
    char *t_532;
    int t_533;
    PMC *t_534;
    Parrot_init_arg_nci(interp, &st, "PSSIP");
    t_530 = GET_NCI_P(0);
    t_531 = string_to_cstring(interp, GET_NCI_S(1));
    t_532 = string_to_cstring(interp, GET_NCI_S(2));
    t_533 = (int)GET_NCI_I(3);
    t_534 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_530),t_531,t_532,t_533,PMC_data(t_534));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_531);
    string_cstring_free(t_532);
}
static void
pcf_p_ptipppi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, void *, void *, void *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_535;
    char *t_536;
    int t_537;
    PMC *t_538;
    PMC *t_539;
    PMC *t_540;
    int t_541;
    Parrot_init_arg_nci(interp, &st, "PSIPPPI");
    t_535 = GET_NCI_P(0);
    t_536 = string_to_cstring(interp, GET_NCI_S(1));
    t_537 = (int)GET_NCI_I(2);
    t_538 = GET_NCI_P(3);
    t_539 = GET_NCI_P(4);
    t_540 = GET_NCI_P(5);
    t_541 = (int)GET_NCI_I(6);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_535),t_536,t_537,PMC_data(t_538),PMC_data(t_539),PMC_data(t_540),t_541);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_536);
}
static void
pcf_p_ppP(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *, PMC *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_542;
    PMC *t_543;
    PMC *t_544;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_542 = GET_NCI_P(0);
    t_543 = GET_NCI_P(1);
    t_544 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_542),PMC_data(t_543),PMC_IS_NULL(t_544) ? NULL : t_544);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_tiB3P(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int, void **, int *, PMC *);
    func_t pointer;
    call_state st;
    void * return_data;
    int arg3;
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_545;
    int t_546;
    STRING *t_547;
    PMC *t_548;
    PMC *t_549;
    Parrot_init_arg_nci(interp, &st, "SISPP");
    t_545 = string_to_cstring(interp, GET_NCI_S(0));
    t_546 = (int)GET_NCI_I(1);
    t_547 = GET_NCI_S(2);
    t_548 = GET_NCI_P(3);
    t_549 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_548);
    return_data =  (void *)(*pointer)(t_545,t_546,&PObj_bufstart(t_547),&arg3,PMC_IS_NULL(t_549) ? NULL : t_549);
    PMC_int_val(t_548) = arg3;
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_545);
}
static void
pcf_p_tip3P(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int, void *, int *, PMC *);
    func_t pointer;
    call_state st;
    void * return_data;
    int arg3;
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_550;
    int t_551;
    PMC *t_552;
    PMC *t_553;
    PMC *t_554;
    Parrot_init_arg_nci(interp, &st, "SIPPP");
    t_550 = string_to_cstring(interp, GET_NCI_S(0));
    t_551 = (int)GET_NCI_I(1);
    t_552 = GET_NCI_P(2);
    t_553 = GET_NCI_P(3);
    t_554 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg3 = PMC_int_val(t_553);
    return_data =  (void *)(*pointer)(t_550,t_551,PMC_data(t_552),&arg3,PMC_IS_NULL(t_554) ? NULL : t_554);
    PMC_int_val(t_553) = arg3;
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_550);
}
static void
pcf_i_pPtiiipi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, PMC *, char *, int, int, int, void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_555;
    PMC *t_556;
    char *t_557;
    int t_558;
    int t_559;
    int t_560;
    PMC *t_561;
    int t_562;
    Parrot_init_arg_nci(interp, &st, "PPSIIIPI");
    t_555 = GET_NCI_P(0);
    t_556 = GET_NCI_P(1);
    t_557 = string_to_cstring(interp, GET_NCI_S(2));
    t_558 = (int)GET_NCI_I(3);
    t_559 = (int)GET_NCI_I(4);
    t_560 = (int)GET_NCI_I(5);
    t_561 = GET_NCI_P(6);
    t_562 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_555),PMC_IS_NULL(t_556) ? NULL : t_556,t_557,t_558,t_559,t_560,PMC_data(t_561),t_562);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_557);
}
static void
pcf_i_tpiibi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, void *, int, int, void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    char *t_563;
    PMC *t_564;
    int t_565;
    int t_566;
    STRING *t_567;
    int t_568;
    Parrot_init_arg_nci(interp, &st, "SPIISI");
    t_563 = string_to_cstring(interp, GET_NCI_S(0));
    t_564 = GET_NCI_P(1);
    t_565 = (int)GET_NCI_I(2);
    t_566 = (int)GET_NCI_I(3);
    t_567 = GET_NCI_S(4);
    t_568 = (int)GET_NCI_I(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_563,PMC_data(t_564),t_565,t_566,PObj_bufstart(t_567),t_568);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_563);
}
static void
pcf_p_iiil(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, long);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_569;
    int t_570;
    int t_571;
    long t_572;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_569 = (int)GET_NCI_I(0);
    t_570 = (int)GET_NCI_I(1);
    t_571 = (int)GET_NCI_I(2);
    t_572 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_569,t_570,t_571,t_572);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_ppl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_573;
    PMC *t_574;
    long t_575;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_573 = GET_NCI_P(0);
    t_574 = GET_NCI_P(1);
    t_575 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_573),PMC_data(t_574),t_575);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_pip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_576;
    int t_577;
    PMC *t_578;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_576 = GET_NCI_P(0);
    t_577 = (int)GET_NCI_I(1);
    t_578 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_576),t_577,PMC_data(t_578));
    
    
    
}
static void
pcf_p_pti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_579;
    char *t_580;
    int t_581;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_579 = GET_NCI_P(0);
    t_580 = string_to_cstring(interp, GET_NCI_S(1));
    t_581 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_579),t_580,t_581);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_580);
}
static void
pcf_i_ppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_582;
    PMC *t_583;
    PMC *t_584;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_582 = GET_NCI_P(0);
    t_583 = GET_NCI_P(1);
    t_584 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_582),PMC_data(t_583),PMC_data(t_584));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_ti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_585;
    int t_586;
    Parrot_init_arg_nci(interp, &st, "SI");
    t_585 = string_to_cstring(interp, GET_NCI_S(0));
    t_586 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(t_585,t_586);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_585);
}
static void
pcf_p_ptp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_587;
    char *t_588;
    PMC *t_589;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_587 = GET_NCI_P(0);
    t_588 = string_to_cstring(interp, GET_NCI_S(1));
    t_589 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_587),t_588,PMC_data(t_589));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_588);
}
static void
pcf_i_pt33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, int *, int *);
    func_t pointer;
    call_state st;
    int return_data;
    int arg2;
    int arg3;
    PMC *t_590;
    char *t_591;
    PMC *t_592;
    PMC *t_593;
    Parrot_init_arg_nci(interp, &st, "PSPP");
    t_590 = GET_NCI_P(0);
    t_591 = string_to_cstring(interp, GET_NCI_S(1));
    t_592 = GET_NCI_P(2);
    t_593 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg2 = PMC_int_val(t_592);
    arg3 = PMC_int_val(t_593);
    return_data =  (int)(*pointer)(PMC_data(t_590),t_591,&arg2,&arg3);
    PMC_int_val(t_592) = arg2;
    PMC_int_val(t_593) = arg3;
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_591);
}
static void
pcf_i_JPP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_595;
    PMC *t_596;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_595 = GET_NCI_P(0);
    t_596 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_595) ? NULL : t_595,PMC_IS_NULL(t_596) ? NULL : t_596);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_597;
    PMC *t_598;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_597 = (int)GET_NCI_I(0);
    t_598 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_597,PMC_data(t_598));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_600;
    int t_601;
    PMC *t_602;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_600 = GET_NCI_P(0);
    t_601 = (int)GET_NCI_I(1);
    t_602 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_600) ? NULL : t_600,t_601,PMC_data(t_602));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JpP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, void *, PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_604;
    PMC *t_605;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_604 = GET_NCI_P(0);
    t_605 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_data(t_604),PMC_IS_NULL(t_605) ? NULL : t_605);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_Jpii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, void *, int, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_607;
    int t_608;
    int t_609;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_607 = GET_NCI_P(0);
    t_608 = (int)GET_NCI_I(1);
    t_609 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_data(t_607),t_608,t_609);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_tp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    char *t_610;
    PMC *t_611;
    Parrot_init_arg_nci(interp, &st, "SP");
    t_610 = string_to_cstring(interp, GET_NCI_S(0));
    t_611 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_610,PMC_data(t_611));
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_610);
}
static void
pcf_p_J(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);
    Parrot_init_arg_nci(interp, &st, "");
    

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_614;
    Parrot_init_arg_nci(interp, &st, "P");
    t_614 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp,PMC_data(t_614));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_t_J(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(PARROT_INTERP);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;
    Parrot_init_arg_nci(interp, &st, "");
    

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(interp);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_Jpti(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(PARROT_INTERP, void *, char *, int);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;PMC *t_617;
    char *t_618;
    int t_619;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_617 = GET_NCI_P(0);
    t_618 = string_to_cstring(interp, GET_NCI_S(1));
    t_619 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(interp,PMC_data(t_617),t_618,t_619);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_618);
}
static void
pcf_v_pit(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, char *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_620;
    int t_621;
    char *t_622;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_620 = GET_NCI_P(0);
    t_621 = (int)GET_NCI_I(1);
    t_622 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_620),t_621,t_622);
    
    
    string_cstring_free(t_622);
}
static void
pcf_v_ptt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, char *, char *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_623;
    char *t_624;
    char *t_625;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_623 = GET_NCI_P(0);
    t_624 = string_to_cstring(interp, GET_NCI_S(1));
    t_625 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(PMC_data(t_623),t_624,t_625);
    
    
    string_cstring_free(t_624);
    string_cstring_free(t_625);
}
static void
pcf_v_tiiiptt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char *, int, int, int, void *, char *, char *);
    func_t pointer;
    call_state st;
    
    
    char *t_626;
    int t_627;
    int t_628;
    int t_629;
    PMC *t_630;
    char *t_631;
    char *t_632;
    Parrot_init_arg_nci(interp, &st, "SIIIPSS");
    t_626 = string_to_cstring(interp, GET_NCI_S(0));
    t_627 = (int)GET_NCI_I(1);
    t_628 = (int)GET_NCI_I(2);
    t_629 = (int)GET_NCI_I(3);
    t_630 = GET_NCI_P(4);
    t_631 = string_to_cstring(interp, GET_NCI_S(5));
    t_632 = string_to_cstring(interp, GET_NCI_S(6));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_626,t_627,t_628,t_629,PMC_data(t_630),t_631,t_632);
    
    
    string_cstring_free(t_626);
    string_cstring_free(t_631);
    string_cstring_free(t_632);
}
static void
pcf_P_JOPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_634;
    PMC *t_635;
    PMC *t_636;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_634 = GET_NCI_P(0);
    t_635 = GET_NCI_P(1);
    t_636 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_634) ? NULL : t_634,PMC_IS_NULL(t_635) ? NULL : t_635,PMC_IS_NULL(t_636) ? NULL : t_636);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_638;
    PMC *t_639;
    PMC *t_640;
    PMC *t_641;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_638 = GET_NCI_P(0);
    t_639 = GET_NCI_P(1);
    t_640 = GET_NCI_P(2);
    t_641 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_638) ? NULL : t_638,PMC_IS_NULL(t_639) ? NULL : t_639,PMC_IS_NULL(t_640) ? NULL : t_640,PMC_IS_NULL(t_641) ? NULL : t_641);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_643;
    PMC *t_644;
    PMC *t_645;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_643 = GET_NCI_P(0);
    t_644 = GET_NCI_P(1);
    t_645 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_643) ? NULL : t_643,PMC_IS_NULL(t_644) ? NULL : t_644,PMC_IS_NULL(t_645) ? NULL : t_645);
    
    
    
}
static void
pcf_v_JOPPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_647;
    PMC *t_648;
    PMC *t_649;
    PMC *t_650;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_647 = GET_NCI_P(0);
    t_648 = GET_NCI_P(1);
    t_649 = GET_NCI_P(2);
    t_650 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_647) ? NULL : t_647,PMC_IS_NULL(t_648) ? NULL : t_648,PMC_IS_NULL(t_649) ? NULL : t_649,PMC_IS_NULL(t_650) ? NULL : t_650);
    
    
    
}
static void
pcf_P_JOPPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_652;
    PMC *t_653;
    PMC *t_654;
    PMC *t_655;
    PMC *t_656;
    Parrot_init_arg_nci(interp, &st, "PPPPP");
    t_652 = GET_NCI_P(0);
    t_653 = GET_NCI_P(1);
    t_654 = GET_NCI_P(2);
    t_655 = GET_NCI_P(3);
    t_656 = GET_NCI_P(4);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_652) ? NULL : t_652,PMC_IS_NULL(t_653) ? NULL : t_653,PMC_IS_NULL(t_654) ? NULL : t_654,PMC_IS_NULL(t_655) ? NULL : t_655,PMC_IS_NULL(t_656) ? NULL : t_656);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPPPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_658;
    PMC *t_659;
    PMC *t_660;
    PMC *t_661;
    PMC *t_662;
    PMC *t_663;
    Parrot_init_arg_nci(interp, &st, "PPPPPP");
    t_658 = GET_NCI_P(0);
    t_659 = GET_NCI_P(1);
    t_660 = GET_NCI_P(2);
    t_661 = GET_NCI_P(3);
    t_662 = GET_NCI_P(4);
    t_663 = GET_NCI_P(5);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_658) ? NULL : t_658,PMC_IS_NULL(t_659) ? NULL : t_659,PMC_IS_NULL(t_660) ? NULL : t_660,PMC_IS_NULL(t_661) ? NULL : t_661,PMC_IS_NULL(t_662) ? NULL : t_662,PMC_IS_NULL(t_663) ? NULL : t_663);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JOSI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_665;
    STRING *t_666;
    INTVAL t_667;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_665 = GET_NCI_P(0);
    t_666 = GET_NCI_S(1);
    t_667 = GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_665) ? NULL : t_665,t_666,t_667);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOSII(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL, INTVAL);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_669;
    STRING *t_670;
    INTVAL t_671;
    INTVAL t_672;
    Parrot_init_arg_nci(interp, &st, "PSII");
    t_669 = GET_NCI_P(0);
    t_670 = GET_NCI_S(1);
    t_671 = GET_NCI_I(2);
    t_672 = GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_669) ? NULL : t_669,t_670,t_671,t_672);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_p_Ji(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_674;
    Parrot_init_arg_nci(interp, &st, "I");
    t_674 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp,t_674);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jipp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, int, void *, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_676;
    PMC *t_677;
    PMC *t_678;
    Parrot_init_arg_nci(interp, &st, "IPP");
    t_676 = (int)GET_NCI_I(0);
    t_677 = GET_NCI_P(1);
    t_678 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp,t_676,PMC_data(t_677),PMC_data(t_678));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jbip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, void *, int, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);STRING *t_680;
    int t_681;
    PMC *t_682;
    Parrot_init_arg_nci(interp, &st, "SIP");
    t_680 = GET_NCI_S(0);
    t_681 = (int)GET_NCI_I(1);
    t_682 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(interp,PObj_bufstart(t_680),t_681,PMC_data(t_682));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_v_Jp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_684;
    Parrot_init_arg_nci(interp, &st, "P");
    t_684 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_data(t_684));
    
    
    
}
static void
pcf_v_JS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, STRING *);
    func_t pointer;
    call_state st;
    
    
    STRING *t_686;
    Parrot_init_arg_nci(interp, &st, "S");
    t_686 = GET_NCI_S(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,t_686);
    
    
    
}
static void
pcf_t_tt(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, char *);
    func_t pointer;
    call_state st;
    char * return_data;
    
    STRING *final_destination;char *t_687;
    char *t_688;
    Parrot_init_arg_nci(interp, &st, "SS");
    t_687 = string_to_cstring(interp, GET_NCI_S(0));
    t_688 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char *)(*pointer)(t_687,t_688);
    
    final_destination = string_from_cstring(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    string_cstring_free(t_687);
    string_cstring_free(t_688);
}
static void
pcf_I_JOt(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_690;
    char *t_691;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_690 = GET_NCI_P(0);
    t_691 = string_to_cstring(interp, GET_NCI_S(1));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_690) ? NULL : t_690,t_691);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_691);
}
static void
pcf_v_JOSI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL);
    func_t pointer;
    call_state st;
    
    
    PMC *t_693;
    STRING *t_694;
    INTVAL t_695;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_693 = GET_NCI_P(0);
    t_694 = GET_NCI_S(1);
    t_695 = GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_693) ? NULL : t_693,t_694,t_695);
    
    
    
}
static void
pcf_S_JOi(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    PMC *t_697;
    int t_698;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_697 = GET_NCI_P(0);
    t_698 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_697) ? NULL : t_697,t_698);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_v_JOi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    
    
    PMC *t_700;
    int t_701;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_700 = GET_NCI_P(0);
    t_701 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_700) ? NULL : t_700,t_701);
    
    
    
}
static void
pcf_I_JO(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_703;
    Parrot_init_arg_nci(interp, &st, "P");
    t_703 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_703) ? NULL : t_703);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_N_JO(PARROT_INTERP, PMC *self)
{
    typedef FLOATVAL (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    call_state st;
    FLOATVAL return_data;
    
    PMC *t_705;
    Parrot_init_arg_nci(interp, &st, "P");
    t_705 = GET_NCI_P(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (FLOATVAL)(*pointer)(interp,PMC_IS_NULL(t_705) ? NULL : t_705);
    
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_v_JON(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL);
    func_t pointer;
    call_state st;
    
    
    PMC *t_707;
    FLOATVAL t_708;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_707 = GET_NCI_P(0);
    t_708 = GET_NCI_N(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_707) ? NULL : t_707,t_708);
    
    
    
}
static void
pcf_P_JOi(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_710;
    int t_711;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_710 = GET_NCI_P(0);
    t_711 = (int)GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_710) ? NULL : t_710,t_711);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    call_state st;
    
    
    PMC *t_713;
    INTVAL t_714;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_713 = GET_NCI_P(0);
    t_714 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_713) ? NULL : t_713,t_714);
    
    
    
}
static void
pcf_P_JOI(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_716;
    INTVAL t_717;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_716 = GET_NCI_P(0);
    t_717 = GET_NCI_I(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_716) ? NULL : t_716,t_717);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOIS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL, STRING *);
    func_t pointer;
    call_state st;
    PMC * return_data;
    
    PMC *t_719;
    INTVAL t_720;
    STRING *t_721;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_719 = GET_NCI_P(0);
    t_720 = GET_NCI_I(1);
    t_721 = GET_NCI_S(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_719) ? NULL : t_719,t_720,t_721);
    
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_S_JOSP(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    PMC *t_723;
    STRING *t_724;
    PMC *t_725;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_723 = GET_NCI_P(0);
    t_724 = GET_NCI_S(1);
    t_725 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_723) ? NULL : t_723,t_724,PMC_IS_NULL(t_725) ? NULL : t_725);
    
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_i_JOPxAT_(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_727;
    PMC *t_728;
    PMC *t_729;
    Parrot_init_arg_nci(interp, &st, "PP@");
    t_727 = GET_NCI_P(0);
    t_728 = GET_NCI_P(1);
    t_729 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_727) ? NULL : t_727,PMC_IS_NULL(t_728) ? NULL : t_728,PMC_IS_NULL(t_729) ? NULL : t_729);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_I_JOPxAT_(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_731;
    PMC *t_732;
    PMC *t_733;
    Parrot_init_arg_nci(interp, &st, "PP@");
    t_731 = GET_NCI_P(0);
    t_732 = GET_NCI_P(1);
    t_733 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_731) ? NULL : t_731,PMC_IS_NULL(t_732) ? NULL : t_732,PMC_IS_NULL(t_733) ? NULL : t_733);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_I_JOIPxAT_(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *, PMC *);
    func_t pointer;
    call_state st;
    INTVAL return_data;
    
    PMC *t_735;
    INTVAL t_736;
    PMC *t_737;
    PMC *t_738;
    Parrot_init_arg_nci(interp, &st, "PIP@");
    t_735 = GET_NCI_P(0);
    t_736 = GET_NCI_I(1);
    t_737 = GET_NCI_P(2);
    t_738 = GET_NCI_P(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_735) ? NULL : t_735,t_736,PMC_IS_NULL(t_737) ? NULL : t_737,PMC_IS_NULL(t_738) ? NULL : t_738);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JOb(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, void *);
    func_t pointer;
    call_state st;
    
    
    PMC *t_740;
    STRING *t_741;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_740 = GET_NCI_P(0);
    t_741 = GET_NCI_S(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(interp,PMC_IS_NULL(t_740) ? NULL : t_740,PObj_bufstart(t_741));
    
    
    
}
static void
pcf_i_pttttt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, char *, char *, char *, char *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_742;
    char *t_743;
    char *t_744;
    char *t_745;
    char *t_746;
    char *t_747;
    Parrot_init_arg_nci(interp, &st, "PSSSSS");
    t_742 = GET_NCI_P(0);
    t_743 = string_to_cstring(interp, GET_NCI_S(1));
    t_744 = string_to_cstring(interp, GET_NCI_S(2));
    t_745 = string_to_cstring(interp, GET_NCI_S(3));
    t_746 = string_to_cstring(interp, GET_NCI_S(4));
    t_747 = string_to_cstring(interp, GET_NCI_S(5));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_742),t_743,t_744,t_745,t_746,t_747);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_743);
    string_cstring_free(t_744);
    string_cstring_free(t_745);
    string_cstring_free(t_746);
    string_cstring_free(t_747);
}
static void
pcf_c_pttt(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *, char *, char *, char *);
    func_t pointer;
    call_state st;
    char return_data;
    
    PMC *t_748;
    char *t_749;
    char *t_750;
    char *t_751;
    Parrot_init_arg_nci(interp, &st, "PSSS");
    t_748 = GET_NCI_P(0);
    t_749 = string_to_cstring(interp, GET_NCI_S(1));
    t_750 = string_to_cstring(interp, GET_NCI_S(2));
    t_751 = string_to_cstring(interp, GET_NCI_S(3));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (char)(*pointer)(PMC_data(t_748),t_749,t_750,t_751);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_749);
    string_cstring_free(t_750);
    string_cstring_free(t_751);
}
static void
pcf_p_pttttiti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, char *, char *, int, char *, int);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_752;
    char *t_753;
    char *t_754;
    char *t_755;
    char *t_756;
    int t_757;
    char *t_758;
    int t_759;
    Parrot_init_arg_nci(interp, &st, "PSSSSISI");
    t_752 = GET_NCI_P(0);
    t_753 = string_to_cstring(interp, GET_NCI_S(1));
    t_754 = string_to_cstring(interp, GET_NCI_S(2));
    t_755 = string_to_cstring(interp, GET_NCI_S(3));
    t_756 = string_to_cstring(interp, GET_NCI_S(4));
    t_757 = (int)GET_NCI_I(5);
    t_758 = string_to_cstring(interp, GET_NCI_S(6));
    t_759 = (int)GET_NCI_I(7);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_752),t_753,t_754,t_755,t_756,t_757,t_758,t_759);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_753);
    string_cstring_free(t_754);
    string_cstring_free(t_755);
    string_cstring_free(t_756);
    string_cstring_free(t_758);
}
static void
pcf_i_ptl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, long);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_760;
    char *t_761;
    long t_762;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_760 = GET_NCI_P(0);
    t_761 = string_to_cstring(interp, GET_NCI_S(1));
    t_762 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_760),t_761,t_762);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_761);
}
static void
pcf_p_ptt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_763;
    char *t_764;
    char *t_765;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_763 = GET_NCI_P(0);
    t_764 = string_to_cstring(interp, GET_NCI_S(1));
    t_765 = string_to_cstring(interp, GET_NCI_S(2));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_763),t_764,t_765);
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    string_cstring_free(t_764);
    string_cstring_free(t_765);
}
static void
pcf_p_pp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *);
    func_t pointer;
    call_state st;
    void * return_data;
    
    PMC *final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_766;
    PMC *t_767;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_766 = GET_NCI_P(0);
    t_767 = GET_NCI_P(1);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (void *)(*pointer)(PMC_data(t_766),PMC_data(t_767));
    
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_l_ttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(char *, char *, long);
    func_t pointer;
    call_state st;
    long return_data;
    
    char *t_768;
    char *t_769;
    long t_770;
    Parrot_init_arg_nci(interp, &st, "SSI");
    t_768 = string_to_cstring(interp, GET_NCI_S(0));
    t_769 = string_to_cstring(interp, GET_NCI_S(1));
    t_770 = (long)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(t_768,t_769,t_770);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_768);
    string_cstring_free(t_769);
}
static void
pcf_l_pttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, char *, char *, long);
    func_t pointer;
    call_state st;
    long return_data;
    
    PMC *t_771;
    char *t_772;
    char *t_773;
    long t_774;
    Parrot_init_arg_nci(interp, &st, "PSSI");
    t_771 = GET_NCI_P(0);
    t_772 = string_to_cstring(interp, GET_NCI_S(1));
    t_773 = string_to_cstring(interp, GET_NCI_S(2));
    t_774 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(PMC_data(t_771),t_772,t_773,t_774);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_772);
    string_cstring_free(t_773);
}
static void
pcf_v_t(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char *);
    func_t pointer;
    call_state st;
    
    
    char *t_775;
    Parrot_init_arg_nci(interp, &st, "S");
    t_775 = string_to_cstring(interp, GET_NCI_S(0));

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
     (void)(*pointer)(t_775);
    
    
    string_cstring_free(t_775);
}
static void
pcf_i_i3i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int *, int);
    func_t pointer;
    call_state st;
    int return_data;
    int arg1;
    int t_776;
    PMC *t_777;
    int t_778;
    Parrot_init_arg_nci(interp, &st, "IPI");
    t_776 = (int)GET_NCI_I(0);
    t_777 = GET_NCI_P(1);
    t_778 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    arg1 = PMC_int_val(t_777);
    return_data =  (int)(*pointer)(t_776,&arg1,t_778);
    PMC_int_val(t_777) = arg1;
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ibi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, void *, int);
    func_t pointer;
    call_state st;
    int return_data;
    
    int t_779;
    STRING *t_780;
    int t_781;
    Parrot_init_arg_nci(interp, &st, "ISI");
    t_779 = (int)GET_NCI_I(0);
    t_780 = GET_NCI_S(1);
    t_781 = (int)GET_NCI_I(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(t_779,PObj_bufstart(t_780),t_781);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_lttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(long, char *, char *, long);
    func_t pointer;
    call_state st;
    long return_data;
    
    long t_782;
    char *t_783;
    char *t_784;
    long t_785;
    Parrot_init_arg_nci(interp, &st, "ISSI");
    t_782 = (long)GET_NCI_I(0);
    t_783 = string_to_cstring(interp, GET_NCI_S(1));
    t_784 = string_to_cstring(interp, GET_NCI_S(2));
    t_785 = (long)GET_NCI_I(3);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (long)(*pointer)(t_782,t_783,t_784,t_785);
    
    set_nci_I(interp, &st, return_data);
    string_cstring_free(t_783);
    string_cstring_free(t_784);
}
static void
pcf_i_pip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, void *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_786;
    int t_787;
    PMC *t_788;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_786 = GET_NCI_P(0);
    t_787 = (int)GET_NCI_I(1);
    t_788 = GET_NCI_P(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_786),t_787,PMC_data(t_788));
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piS(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, STRING *);
    func_t pointer;
    call_state st;
    int return_data;
    
    PMC *t_789;
    int t_790;
    STRING *t_791;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_789 = GET_NCI_P(0);
    t_790 = (int)GET_NCI_I(1);
    t_791 = GET_NCI_S(2);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (int)(*pointer)(PMC_data(t_789),t_790,t_791);
    
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_S_i(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(int);
    func_t pointer;
    call_state st;
    STRING * return_data;
    
    int t_792;
    Parrot_init_arg_nci(interp, &st, "I");
    t_792 = (int)GET_NCI_I(0);

    pointer =  (func_t)D2FPTR(PMC_struct_val(self));
    
    return_data =  (STRING *)(*pointer)(t_792);
    
    set_nci_S(interp, &st, return_data);
    
}


/* This function serves a single purpose. It takes the function
   signature for a C function we want to call and returns a pointer
   to a function that can call it. */
void *
build_call_func(PARROT_INTERP, SHIM(PMC *pmc_nci), NOTNULL(STRING *signature))
{
    char       *c;
    STRING     *ns, *message;
    PMC        *b;
    PMC        *iglobals;
    PMC        *temp_pmc;
    UINTVAL    signature_len;

    PMC        *HashPointer   = NULL;

#if defined(CAN_BUILD_CALL_FRAMES)
    /* Try if JIT code can build that signature. If yes, we are done */
    void * const result = Parrot_jit_build_call_func(interp, pmc_nci, signature);
    if (result)
        return result;
#endif
    /* And in here is the platform-independent way. Which is to say
       "here there be hacks" */
    signature_len = string_length(interp, signature);
    if (0 == signature_len)
       return F2DPTR(pcf_v_);
    /* remove deprecated void argument 'v' character */
    if (2 == signature_len && 'v' == string_index(interp, signature, 1)) {
       Parrot_warn(interp, PARROT_WARNINGS_ALL_FLAG, "function signature argument character 'v' ignored");
       string_chopn_inplace(interp, signature, 1);
       signature_len = string_length(interp, signature);
    }

    iglobals = interp->iglobals;

    if (PMC_IS_NULL(iglobals))
        PANIC(interp, "iglobals isn't created yet");
    HashPointer = VTABLE_get_pmc_keyed_int(interp, iglobals,
            IGLOBALS_NCI_FUNCS);

    if (!HashPointer) {
        HashPointer = pmc_new(interp, enum_class_Hash);
        VTABLE_set_pmc_keyed_int(interp, iglobals, IGLOBALS_NCI_FUNCS,
                HashPointer);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "c"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "cp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "cpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_d_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "d"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_d_d;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "dd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_d_JOd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "dJOd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "SJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOPS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOPSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPIP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPIP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPNP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPNP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JPN;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJPN"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPIP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJPIP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPNP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJPNP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_f_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "f"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_f_ff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "fff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_f_is;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "fis"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_b;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ib"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_d;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "id"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ii4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iii4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ii4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iii4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iil;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iili;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iiti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "il"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_li;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_lp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ilp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_lsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p33;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p333;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip333"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p333333;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip333333"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p42p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip42p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_p4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ip4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pb;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pii4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipii4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pii4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipii4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiiilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piil;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piili;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piiti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pli;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipli"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pllllllll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipllllllll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_plp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iplp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_plsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iplsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ippi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppiiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ippiiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_psp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pitl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipitl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_s;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "is"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_s22;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "is22"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_s222;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "is222"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_sp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "isp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_sss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "isss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ssss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "issss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "it"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "i4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "i4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_42p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "i42p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_l4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ll4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_p33l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lp33l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_33l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "l33l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_Ji;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_Jt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_B;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pB"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_b;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "piiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "piiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "piiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_piiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_tpp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ptpp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ttttttt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pttttttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_s_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "s"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "t"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_pt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tpt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_tl4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ttl4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_t4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tt4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "v"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_Jiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_illllllll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "villllllll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pbip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpbip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_piiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOSSS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOSSS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOSS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOSS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "SJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "SJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_sc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "isc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_s_sc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ssc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_sc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "csc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_iii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_i3;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ii3"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_b;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_B;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tB"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_33;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "i33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JOt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJOt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Jt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Ji;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptippppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pptippppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pi33ipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppi33ipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pttip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppttip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptipppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pptipppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ppP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pppP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_tiB3P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ptiB3P"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_tip3P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ptip3P"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pPtiiipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipPtiiipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_tpiibi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "itpiibi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_iiil;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "piiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ippl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ippp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pptp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pt33;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipt33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JPip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJPip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JpP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJpP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_Jpii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_tp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "itp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_J;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJ"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_J;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tJ"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_Jpti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "tJpti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_pit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vpit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_ptt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vptt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_tiiiptt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vtiiiptt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOPPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOPPPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOPPPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOSI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOSI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOSII;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOSII"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Ji;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jipp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_Jbip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pJbip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_Jp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_t_tt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOSI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOSI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "SJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_N_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "NJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JON;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJON"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_P_JOIS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "PJOIS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_JOSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "SJOSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_JOPxAT_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iJOP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOPxAT_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_I_JOIPxAT_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "IJOIP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_JOb;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vJOb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pttttt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipttttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_c_pttt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "cpttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pttttiti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppttttiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ptl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iptl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_ptt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "pptt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_p_pp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_ttl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_pttl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "lpttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_v_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "vt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_i3i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ii3i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_ibi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "iibi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_l_lttl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "llttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_pip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_i_piS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "ipiS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void*)pcf_S_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, string_from_literal(interp, "Si"), temp_pmc);


    }

    b = VTABLE_get_pmc_keyed_str(interp, HashPointer, signature);

    if (b && b->vtable->base_type == enum_class_UnManagedStruct)
        return F2DPTR(PMC_data(b));

    /*
      These three lines have been added to aid debugging. I want to be able to
      see which signature has an unknown type. I am sure someone can come up
      with a neater way to do this.
     */
    ns = string_make(interp, " is an unknown signature type", 29, "ascii", 0);
    message = string_concat(interp, signature, ns, 0);

#if defined(CAN_BUILD_CALL_FRAMES)
    ns = string_make(interp, ".\nCAN_BUILD_CALL_FRAMES is enabled, this should not happen", 58, "ascii", 0);
#else
    ns = string_make(interp, ".\nCAN_BUILD_CALL_FRAMES is disabled, add the signature to src/call_list.txt", 75, "ascii", 0);
#endif
    message = string_concat(interp, message, ns, 0);

    /*
     * I think there may be memory issues with this but if we get to here we are
     * aborting.
     */
    c = string_to_cstring(interp, message);
    PANIC(interp, c);
}


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
